Unit BPDef;

{ BP Package Main Structures Definition }
{ Corrected 24-12-98 }
{ Corrected 12-09-98 }
{ Added     30-09-98 }
{ Added     22-11-01 }
{ Modified  08-07-02 }
{ Modified  06-08-02 }
{ Rewritten 12-01-03 }

Interface

Uses Windows,Messages,Graphics;

Type
      TReservedType=Packed Array[0..231] of Byte;
      TVeryShortString=String[15];
      TLinkShortString=String[24];

      { Formating Algorithm }
      TBPFormatAlg=(fa_Min,fa_Max,fa_Sqrt,fa_Sum,fa_Width,fa_Height);
      TBPPgAlg=(pg_Min,pg_Middle,pg_Max);

      { Structure for QRep }
      TBPInfoBlock=packed record
       UsedAt:String;
       ModelName:String;
       Author:String;
       DateTime:TDateTime;
       Revision:DWORD;
       levelsCount:Integer;
       Pages:Array[0..6000] of Integer;
       LevelsID:Array[0..6000] of ShortString;
       Captions:Array[0..6000] of ShortString;
       Comments:Array[0..6000] of ShortString;
      end;

      { Insert to Lesha }
      PBPEntryArray=^TBPEntryArray;
      TBPEntryArray=record
       NodeIndex:Array[0..100] of Integer;
       NodesIndexCount:Integer;
      end;

      PBPCheckGraphArray=^TBPCheckGraphArray;
      TBPCheckGraphArray=record
       NodeIndex:Array[0..100] of Integer;
       NodesGraph:Array[0..100] of Integer;
       NodeLevel:Array[0..100] of Integer;
       LinkIndex:Array[0..600] of Integer;
       LinksGraph:Array[0..600] of Integer;
       NodesCount:Integer;
       LinksCount:Integer;
      end;

      { Insert to Lesha }

      TBPMultipleMask=(bpmm_None,bpmm_From,bpmm_To,bpmm_FromTo);
      TBPOrdinate=Array[0..9] of Integer;
      TBPAcceptPos=Array[0..9] of Boolean;


      { Node definition }
      PBPNode=^TBPNode;
      TBPNode=packed record
        ssCaption:ShortString;  {  㧫 }
        dwNodeNumber:DWORD;     {  㧫  痢 }
        ssNodeNumber:TVeryShortString; { 㥬  㧫 }
        fABCValue:Double;
        dwNodeIndex:DWORD;
        Left:TBPOrdinate;
        Top:TBPOrdinate;
        AcceptPosition:TBPAcceptPos;
        ssComment:ShortString;
      end;

      PBPSpamNode=^TBPSpamNode;
      TBPSpamNode=packed record
        ssCaption:ShortString;  {  㧫 }
        dwNodeNumber:DWORD;     {  㧫  痢 }
        ssNodeNumber:TVeryShortString; { 㥬  㧫 }
        fABCValue:Double;
        dwNodeIndex:DWORD;
        Left:TBPOrdinate;
        Top:TBPOrdinate;
        AcceptPosition:TBPAcceptPos;
        ssComment:ShortString;
        LeftLinksCount:Integer;
        TopLinksCount:Integer;
        BottomLinksCount:Integer;
        ResultLinkNumber:Array[0..50,0..1] of Integer;
      end;

      PBPDNode=^TBPDNode;
      TBPDNode=packed record
        ssCaption:ShortString;
        dwNodeNumber:DWORD;
        ssNodeNumber:TVeryShortString; { 㥬  㧫 }
        fABCValue:Double;
        dwNodeIndex:DWORD;
        Left:TBPOrdinate;
        Top:TBPOrdinate;
        AcceptPosition:TBPAcceptPos;
        ssComment:ShortString;
        next:PBPDNode;
      end;

      { Link definition }
      TLinkType=(lt_Left,lt_Right,lt_Top,lt_Bottom);

{      TLinkDirection=(ld_None,ld_Dir,ld_BiDi);}

      PBPLink=^TBPLink;
      TBPLink=packed record
        ssFromCaption:ShortString;       {  裡  室  }
        ssToCaption:ShortString;         {  裡  室 }
        ssGlobalCaption:TVeryShortString;
                                         {   室-室 }
        dwFromNodeNumber:DWORD;          {  㧫  }
        dwToNodeNumber:DWORD;            {  㧥  }
        dwFlags:DWORD;                   {  ⠭ 䫠 裡 }
        dwFromLinkNumber:DWORD;          {  裡 室騩 }
        dwToLinkNumber:DWORD;            {  裡 室騩 }
        dwLinkIndex:DWORD;
        FromLeft:TBPOrdinate;
        FromTop:TBPOrdinate;
        FromAcceptPosition:TBPAcceptPos;
        ToLeft:TBPOrdinate;
        ToTop:TBPOrdinate;
        ToAcceptPosition:TBPAcceptPos;
        DNodeLeft:Integer;
        DNodeTop:Integer;
        DNodeAcceptPosition:Boolean;
        ssFromPath:ShortString;
        ssToPath:ShortString;
{        dwLinkDirectional:TLinkDirection;}
      end;

      PBPDLink=^TBPDLink;
      TBPDLink=packed record
        ssFromCaption:ShortString;       {  裡  室  }
        ssToCaption:ShortString;         {  裡  室 }
        ssGlobalCaption:TVeryShortString;
                                         {   室-室 }
        dwFromNodeNumber:DWORD;          {  㧫  }
        dwToNodeNumber:DWORD;            {  㧥  }
        dwFlags:DWORD;                   {  ⠭ 䫠 裡 }
        dwFromLinkNumber:DWORD;          {  裡 室騩 }
        dwToLinkNumber:DWORD;            {  裡 室騩 }
        dwLinkIndex:DWORD;
        FromLeft:TBPOrdinate;
        FromTop:TBPOrdinate;
        FromAcceptPosition:TBPAcceptPos;
        ToLeft:TBPOrdinate;
        ToTop:TBPOrdinate;
        ToAcceptPosition:TBPAcceptPos;
        DNodeLeft:Integer;
        DNodeTop:Integer;
        DNodeAcceptPosition:Boolean;
{        dwLinkDirectional:TLinkDirection;}
        ssFromPath:ShortString;
        ssToPath:ShortString;
        next:PBPDLink;
      end;

      PBPNodeTypes=^TBPNodeTypes;
      TBPNodeTypes=packed record
        dwNodeIndex:DWORD;
        dwID:DWORD;
        dwParent:DWORD;
        ssCaption:String[64];
        dwFontColor:TColor;
        dwPaintColor:TColor;
        dwDrawColor:TColor;
        dwShadowColor:TColor;
        dwShadowStyle:DWORD;
        dwRectStyle:DWORD;
      end;


      PBPLinkTypes=^TBPLinkTypes;
      TBPLinkTypes=packed record
        dwLinkIndex:DWORD;
        dwID:DWORD;
        dwParent:DWORD;
        ssCaption:String[64];
        dwColor:TColor;
        dwPenStyle:TPenStyle;
        dbShowLinkType:Boolean;
      end;


   {  BPD File structure:
          Header
          NodesTypesInfo
          LinksTypesInfo
          Tree
          Data1
          Data2
          Data3
          Data4
          .....
          OperTree
          OpData1
          OpData2
          OpData3
          ......  }


    PBPHeader = ^TBPHeader;
    TBPHeader = packed record
      ssModel:ShortString;    { Model name }
      ssCompany:ShortString;  { Company name }
      ssAuthor:ShortString;   { Author }
      dfDateTime:TDateTime;   { Date and Time creating model }
      dwRevision:DWORD;       { Document revision }
      dwNodesTypesCount:DWORD;
      dwLinksTypesCount:DWORD;
      dwOpEntries:DWORD;
{@@@}
      dwIPEntries:DWORD;
{/@@@}
    end;

    TDraftStatusModes = (dsWorking,dsDraft,dsRecomended,dsPublication);
    TDraftStatus = set of TDraftStatusModes;

    PBPOpDetail=^TBPOpDetail;
    TBPOpDetail= packed record
      ssCaption:ShortString;
    end;

    PBPOPTree=^TBPOpTree;
    TBPOpTree= packed record
      dwDataOffset:DWORD;
      dwLevel:Integer;
      dwParent:Integer;
      ssCaption:ShortString;
      dwOpDetailCount:DWORD;
      dwNodeIndex:DWORD;
      lpOpDetail:PBPOpDetail;
      next:PBPOpTree;
    end;

    PBPTree =^TBPTree;
    TBPTree = packed record
      dwDataOffset:DWORD;
      dwLevel:Integer;          { Opened level e.q. 123 = 1.2.3,
                                   10  ন !,
                                 砫  -1 }
      dwParent:Integer;       { Parent level  }
      ssLevel:String[64];     { level in string 11.21.12.1 }
      ssCaption:ShortString;  { Level Caption }
      ssNotes:ShortString;
      dwRevision:DWORD;       { Shit Revision }
      dwNodesCount:DWORD;     { Nodes count   }
      dwLinksCount:DWORD;     { Links count   }
      dwStatus:TDraftStatus;  { Draft status  }
      dwPageNumber:DWORD;     { Page Number   }
      dwNodesMemRequired:DWORD;
      dwLinksMemRequired:DWORD;
      lpNodes:PBPNode;
      lpLinks:PBPLink;
      {NEW }
      dwNodesFontSize:Integer;
      dbOverrideNodesFS:Boolean;
      dwDNodesFontSize:Integer;
      dbOverrideDNodesFS:Boolean;
      dwDProjectionFontSize:Integer;
      dwInProcessFontSize:Integer;
      dbOverrideInProcessFS:Boolean;
      dwLabelsFontSize:Integer;
      dbOverrideLabelsFS:Boolean;
      {END NEW}
      ssReserved:TReservedType;
      next:PBPTree;           { next item }
    end;

    PBPInfo =^TBPInfo;
    TBPInfo = packed record
      dwLevel:Integer;
      ssLevel:ShortString;
      ssCaption:ShortString;
    end;

{@@@}
    PBPInProcessNode=^TBPInProcessNode;
    TBPInProcessNode= packed record
      dwNodeNumber:Integer;
      ssCaption:ShortString;
      dwNodeIndex:Integer;
      Left:TBPOrdinate;
      Top:TBPOrdinate;
      AcceptPosition:TBPAcceptPos;
      ssComment:ShortString;
      ssPath:ShortString;
      ssMech:ShortString; { New Mech String }
      ssUpr:ShortString;  { New Upr String }
    end;
{/@@@}

    PByte=^Byte;

    PBPNodeRenameStructure=^TBPNodeRenameStructure;
    TBPNodeRenameStructure=packed record
      dwNodeNumber:DWORD;
      ssNodeNumber:TVeryShortString;
      LinksLeft:DWORD;
      LinksRight:DWORD;
      LinksTop:DWORD;
      LinksBottom:DWORD;
      next:PBPNodeRenameStructure;
    end;

    PBPLinkRenameStructure=^TBPLinkRenameStructure;
    TBPLinkRenameStructure=packed record
      link:PBPLink;
      linkRenamedFrom:Boolean;
      linkRenamedTo:Boolean;
      FromLinkNumber:DWORD;
      ToLinkNumber:DWORD;
      next:PBPLinkRenameStructure;
    end;

Const  BPGlobalLeftNodeNumber    = $10000000;
       BPGlobalRightNodeNumber   = $20000000;
       BPGlobalTopNodeNumber     = $40000000;
       BPGlobalBottomNodeNumber  = $80000000;
{@@@}  BPGlobalMask              = $FC000000; {/@@@}
       BPFrameGlobalMask         = $F4000000; 
       BPGlobalNotOpMask         = $F0000000;
{@@@}  BPUnreachedNodeNumber     = $03FFFFFF; {/@@@}
{@@@}  BPNotGlobalMask           = $03FFFFFF; {/@@@}
       BPGlobalNodeLeft          = $10000000;
       BPGlobalNodeRight         = $20000000;
       BPGlobalNodeTop           = $40000000;
       BPGlobalNodeBottom        = $80000000;
       BPGlobalNodeOperation     = $08000000;
{@@@}  BPGlobalNodeInProcess     = $04000000; {/@@@}

 

       BP_IPNODE_LEFT   =     $00000001;
       BP_IPNODE_RIGHT  =     $00000002;
       BP_IPNODE_TOP    =     $00000004;
       BP_IPNODE_BOTTOM =     $00000008;

  { Links dwFlags constant }
       BP_FROMNODE_LEFT =     $00000001; { From node - left side }
       BP_FROMNODE_RIGHT =    $00000002; { From node - right side }
       BP_FROMNODE_TOP =      $00000004; { From node - top side }
       BP_FROMNODE_BOTTOM =   $00000008; { From node - bottom side }
       BP_FROMMASK =          $0000000F; { From node side Mask }
       BP_FROMMASK_INVERT =   $FFFFFFF0;
       BP_TONODE_LEFT =       $00000010; { To node - left side }
       BP_TONODE_RIGHT =      $00000020; { To node - right side }
       BP_TONODE_TOP =        $00000040; { To node - top side }
       BP_TONODE_BOTTOM =     $00000080; { To node - bottom side }
       BP_TOMASK =            $000000F0; { To node side mask }
       BP_TOMASK_INVERT =     $FFFFFF0F;
       { From -> To both mask }
       BP_FROMTOMASK  =       $000000FF; { Both from & to sides mask }
       BP_FROMTOMASK_INVERT=  $FFFFFF00;
       BP_LEFT_LEFT =         $00000011;
       BP_LEFT_RIGHT =        $00000021;
       BP_LEFT_TOP =          $00000041;
       BP_LEFT_BOTTOM =       $00000081;
       BP_RIGHT_LEFT =        $00000012;
       BP_RIGHT_RIGHT =       $00000022;
       BP_RIGHT_TOP =         $00000042;
       BP_RIGHT_BOTTOM =      $00000082;
       BP_TOP_LEFT =          $00000014;
       BP_TOP_RIGHT =         $00000024;
       BP_TOP_TOP =           $00000044;
       BP_TOP_BOTTOM =        $00000084;
       BP_BOTTOM_LEFT =       $00000018;
       BP_BOTTOM_RIGHT =      $00000028;
       BP_BOTTOM_TOP =        $00000048;
       BP_BOTTOM_BOTTOM =     $00000088;
       BP_SHOW_FROMCAPTION =  $00000100; { Show from node link caption }
      BP_DONTSHOW_FROMCAPTION=$FFFFFEFF;
      BP_DONTSHOW_TOCAPTION=  $FFFFFDFF;
       BP_SHOW_TOCAPTION =    $00000200; { Show to node link caption }
       BP_SHOW_GLOBALCAPTION= $00000400; { Show global caption  }
       BP_HAS_FROMPATH      = $00001000;
       BP_HAS_TOPATH        = $00002000;
       BP_DATALINK_DOCUMENT=  $20000000; { Show circle on link }
       BP_NOTUSED_NOW       = $C0000000; { Unused link - posible damaged }
       BP_NOTUSED_FROM   =    $40000000;
       BP_NOTUSED_TO       =  $80000000;

      { Level constant }
       BP_LEVEL_NONE         = -2;
       BP_LEVEL_MODEL        = -1;
       BP_LEVEL_MODELDECOMP  =  0;

       BP_MINFONT_SIZE       =  7; {pt.}

Const WM_UNSELECTALL = WM_USER + 2;
      crMyCursor = 5;


Implementation

end.