unit NodeTypeDlgUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, fcColorCombo, fcLabel, fcCombo, fctreecombo,
  fcFontCombo, Dialogs, ComCtrls,BPDef;

type
  TNodeTypeDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    ColorDialog1: TColorDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    NTTreeView: TTreeView;
    fcLabel2: TfcLabel;
    FontColor: TfcColorCombo;
    fcLabel3: TfcLabel;
    PaintColor: TfcColorCombo;
    fcLabel4: TfcLabel;
    DrawColor: TfcColorCombo;
    fcLabel5: TfcLabel;
    ShadowColor: TfcColorCombo;
    Label1: TLabel;
    sNone: TSpeedButton;
    sLeftFramed: TSpeedButton;
    sRightFramed: TSpeedButton;
    sBottom: TSpeedButton;
    sLeftBoxed: TSpeedButton;
    sRightBoxed: TSpeedButton;
    sTop: TSpeedButton;
    sInverse: TSpeedButton;
    Label2: TLabel;
    rNone: TSpeedButton;
    r1x: TSpeedButton;
    r2x: TSpeedButton;
    r3x: TSpeedButton;
    r4x: TSpeedButton;
    r2x3: TSpeedButton;
    r2x4: TSpeedButton;
    r2x5: TSpeedButton;
    r3x2: TSpeedButton;
    r4x2: TSpeedButton;
    r5x2: TSpeedButton;
    TabSheet2: TTabSheet;
    LTTreeView: TTreeView;
    Label3: TLabel;
    LTColor: TfcColorCombo;
    ShowLinkStream: TCheckBox;
    fcLabel11: TfcLabel;
    lsSolid: TSpeedButton;
    lsDot: TSpeedButton;
    lsDashDot: TSpeedButton;
    procedure NTTreeViewEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure NTTreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure FontColorChange(Sender: TObject);
    procedure PaintColorChange(Sender: TObject);
    procedure DrawColorChange(Sender: TObject);
    procedure ShadowColorChange(Sender: TObject);
    procedure ShadowTypeClick(Sender: TObject);
    procedure RectStyleClick(Sender: TObject);
    procedure LTTreeViewEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure LTTreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure LTColorChange(Sender: TObject);
    procedure LineStyleChange(Sender: TObject);
    procedure ShowLinkStreamClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure PrepareDlg;
  end;

var
  NodeTypeDlg: TNodeTypeDlg;

implementation

uses MainUnit;

{$R *.DFM}

procedure TNodeTypeDlg.PrepareDlg;
Var tmpN,tmpN1:PBPNodeTypes;
    nc:Integer;
    i:Integer;
    node,node1:TTreeNode;
    tmpL,tmpL1:PBPLinkTypes;
    lc:Integer;
 begin
    NTTreeView.Items.Clear;
    nc:=BPViewMainForm.BPFrame.BPGraph.Header.dwNodesTypesCount;
    tmpN:=BPViewMainForm.BPFrame.BPGraph.NTTree;
    for i:=0 to (nc-1) do
      begin
        if tmpN^.dwParent=0 then
         begin
          node:=NTTreeView.Items.GetFirstNode;
          node:=NTTreeView.Items.Add(node,tmpN^.ssCaption);
         end
        else
         begin
          tmpN1:=PBPNodeTypes(node.Data);
          if (tmpN1^.dwID=tmpN^.dwParent) then
           node:=NTTreeView.Items.AddChild(node,tmpN^.ssCaption)
          else
           node:=NTTreeView.Items.Add(node,tmpN^.ssCaption);
         end;
        node.Data:=Pointer(tmpN);
        inc(tmpN);
        if (i=0) then node1:=node;
      end;
   NTTreeView.Selected:=node1;
   LTTreeView.Items.Clear;
    lc:=BPViewMainForm.BPFrame.BPGraph.Header.dwLinksTypesCount;
    tmpL:=BPViewMainForm.BPFrame.BPGraph.LTTree;
    for i:=0 to (lc-1) do
      begin
        if tmpL^.dwParent=0 then
         begin
           node:=LTTreeView.Items.GetFirstNode;
           node:=LTTreeView.Items.Add(node,tmpL^.ssCaption);
         end
        else
         begin
           tmpL1:=PBPLinkTypes(node.Data);
           if (tmpL1^.dwID=tmpL^.dwParent) then
            node:=LTTreeView.Items.AddChild(node,tmpL^.ssCaption)
           else
            node:=LTTreeView.Items.Add(node,tmpL^.ssCaption);
         end;
        node.Data:=Pointer(tmpL);
        inc(tmpL);
        if (i=0) then node1:=node;
      end;
   LTTreeView.Selected:=node1;
   PageControl1.ActivePage:=TabSheet1;
 end;


procedure TNodeTypeDlg.NTTreeViewEditing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
  AllowEdit:=False
end;

procedure TNodeTypeDlg.NTTreeViewChange(Sender: TObject; Node: TTreeNode);
Var tmpN:PBPNodeTypes;
begin
  if (Node=nil) then Exit;
  tmpN:=PBPNodeTypes(node.data);
  FontColor.SelectedColor:=tmpN^.dwFontColor;
  PaintColor.SelectedColor:=tmpN^.dwPaintColor;
  DrawColor.SelectedColor:=tmpN^.dwDrawColor;
  ShadowColor.SelectedColor:=tmpN^.dwShadowColor;
 case (tmpN^.dwShadowStyle) of
   0: sNone.Down:=True;
   1: sLeftBoxed.Down:=True;
   2: sLeftFramed.Down:=True;
   3: sTop.Down:=True;
   4: sInverse.Down:=True;
   5: sRightBoxed.Down:=True;
   6: sRightFramed.Down:=True;
   7: sBottom.Down:=True;
 end;
 case (tmpN^.dwRectStyle) of
   0:  rNone.Down:=True;
   1:  r1x.Down:=True;
   2:  r2x.Down:=True;
   3:  r3x.Down:=True;
   4:  r4x.Down:=True;
   5:  r2x3.Down:=True;
   6:  r3x2.Down:=True;
   7:  r2x4.Down:=True;
   8:  r4x2.Down:=True;
   9:  r2x5.Down:=True;
  10:  r5x2.Down:=True;
 end;
end;

procedure TNodeTypeDlg.FontColorChange(Sender: TObject);
Var tmpN:PBPNodeTypes;
begin
 if NTTreeView.Selected=nil then Exit;
 tmpN:=PBPNodeTypes(NTTreeView.Selected.Data);
 tmpN^.dwFontColor:=FontColor.SelectedColor;
end;

procedure TNodeTypeDlg.PaintColorChange(Sender: TObject);
Var tmpN:PBPNodeTypes;
begin
 if NTTreeView.Selected=nil then Exit;
 tmpN:=PBPNodeTypes(NTTreeView.Selected.Data);
 tmpN^.dwPaintColor:=PaintColor.SelectedColor;
end;

procedure TNodeTypeDlg.DrawColorChange(Sender: TObject);
Var tmpN:PBPNodeTypes;
begin
 if NTTreeView.Selected=nil then Exit;
 tmpN:=PBPNodeTypes(NTTreeView.Selected.Data);
 tmpN^.dwDrawColor:=DrawColor.SelectedColor;
end;

procedure TNodeTypeDlg.ShadowColorChange(Sender: TObject);
Var tmpN:PBPNodeTypes;
begin
 if NTTreeView.Selected=nil then Exit;
 tmpN:=PBPNodeTypes(NTTreeView.Selected.Data);
 tmpN^.dwShadowColor:=ShadowColor.SelectedColor;
end;

procedure TNodeTypeDlg.ShadowTypeClick(Sender: TObject);
Var tmpN:PBPNodeTypes;
begin
 if NTTreeView.Selected=nil then Exit;
 tmpN:=PBPNodeTypes(NTTreeView.Selected.Data);
 tmpN^.dwShadowStyle:=(Sender as TSpeedButton).Tag-1;
end;

procedure TNodeTypeDlg.RectStyleClick(Sender: TObject);
Var tmpN:PBPNodeTypes;
begin
 if NTTreeView.Selected=nil then Exit;
 tmpN:=PBPNodeTypes(NTTreeView.Selected.Data);
 tmpN^.dwRectStyle:=(Sender as TSpeedButton).Tag-1;
end;

procedure TNodeTypeDlg.LTTreeViewEditing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
 AllowEdit:=False;
end;

procedure TNodeTypeDlg.LTTreeViewChange(Sender: TObject; Node: TTreeNode);
Var tmpL:PBPLinkTypes;
begin
  if (Node=nil) then Exit;
  tmpL:=PBPLinkTypes(Node.Data);
  LTColor.SelectedColor:=tmpL^.dwColor;
  case (tmpL^.dwPenStyle) of
    psSolid:   lsSolid.Down:=True;
    psDot:     lsDot.Down:=True;
    psDashDot: lsDashDot.Down:=True;
    else       lsSolid.Down:=True;
  end;
  ShowLinkStream.Enabled:=(tmpL^.dwParent=0);
  ShowLinkStream.Checked:=tmpl^.dbShowLinkType;
end;

procedure TNodeTypeDlg.LTColorChange(Sender: TObject);
Var tmpL:PBPLinkTypes;
begin
 if LTTreeView.Selected=nil then Exit;
 tmpL:=PBPLinkTypes(LTTreeView.Selected.Data);
 tmpL^.dwColor:=LTColor.SelectedColor;
end;

procedure TNodeTypeDlg.LineStyleChange(Sender: TObject);
Var tmpL:PBPLinkTypes;
       i:Integer;
begin
  if LTTreeView.Selected=nil then Exit;
  tmpL:=PBPLinkTypes(LTTreeView.Selected.Data);
  i:=(Sender as TSpeedButton).Tag-1;
 case i of
  0: tmpL^.dwPenStyle:=psSolid;
  1: tmpL^.dwPenStyle:=psDot;
  2: tmpL^.dwPenStyle:=psDashDot;
 end;
end;

procedure TNodeTypeDlg.ShowLinkStreamClick(Sender: TObject);
Var tmpL:PBPLinkTypes;
    i,j:Integer;
    node:TTreeNode;
    id,parent:DWORD;
begin
  if LTTreeView.Selected=nil then Exit;
  i:=LTTreeView.Selected.AbsoluteIndex;
  tmpL:=PBPLinkTypes(LTTreeView.Selected.Data);
  tmpL^.dbShowLinkType:=ShowLinkStream.Checked;
  id:=tmpL^.dwID;
  parent:=id;
  j:=i+1;
  while ((j<LTTreeView.Items.Count) and (id=parent)) do
   begin
    node:=LTTreeView.Items.Item[j];
    tmpL:=PBPLinkTypes(node.Data);
    parent:=tmpL^.dwParent;
    if (parent=id) then
       tmpL^.dbShowLinkType:=ShowLinkStream.Checked;
    inc(j);
   end;
end;

end.
