unit OrgChart;

{$A-}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Printers,QRPrntr,Langs;

Const EM_FORMATRANGE                      = WM_USER + 57;

type

  TVAlignment =(taTopJustify,taVCenter,taBottomJustify);

  TDSStrategyType = (stHTree,stVTree,stVLRTree,stVLR2Tree);

  TDSShadowType = (shNone,shLeftBoxed,shLeftFramed,shTopPerspective,
   shInversePerspective,shRightBoxed,shRightFramed,shBottomPerspective);

  TDSRectStyle = (reNone,re1x,re2x,re3x,re4x,re2x3,re3x2,re2x4,re4x2,
                  re2x5,re5x2);
    { None        0
      1x          1
      2x          2
      3x          3
      4x          4
      2x3         2 reSpace 3
        }

{ TBPDGraphNode definition }
  TBPDGraphNode = class(TGraphicControl)
  private
    { Private declarations }
    FUpdating:Boolean;
    FText:String;                  {   ॢ  }
    FProjection:String;            { Projection text        }
      { Drawing Options }
    FPaintColor:TColor;   {    }
    FDrawColor:TColor;    {   }
    FShadowType:TDSShadowType; {   }
    FShadowColor:TColor;   {   }
    FShadowDepth:Integer;  {   }
    FRectStyle:TDSRectStyle; {  }
    FLineStyle:TPenStyle;    {     ;) }
    FLineWidth:Integer;      {    }
    FLineColor:TColor;
     {New options }
    FDefWidth:Integer;       {    }
    FDefHeight:Integer;      {    }
    FMaxWidth:Integer;
    FMaxHeight:Integer;
    FAutoHeight:Boolean;     {     }
    FAutoWidth:Boolean;      {     }
    FHSpacing:Integer;       {       }
    FVSpacing:Integer;       {       }
    FHAlign:TAlignment;      {    }
    FVAlign:TVAlignment;     {    -    FAutoHeight=False}
    {Internal variables}
    FIntervalLeft:Integer;
    FIntervalRight:Integer;
    FIntervalTop:Integer;
    FIntervalBottom:Integer;
    FShadowLeft:Integer;
    FShadowRight:Integer;
    FShadowTop:Integer;
    FShadowBottom:Integer;
    {}
    FHInterval:Integer;
    FVInterval:Integer;
    {}
    FFontDPI:Integer;
    {}
    FPrjFont:TFont;
    { New !!! }
    {procedures & functions for Draw }
    procedure SetUpRect(r: TRect; SubLine:Boolean; SubY:Integer); { Draw Frame with RectStyle}
    procedure DrawRect(r:TRect;val1,val2:Integer; SubLine:Boolean; SubY:Integer); {Internal Subroutine}
    function  GetRectSize:TRect; { fucking calculation function }
    function  GetProjRectSize(left,top:Integer):TRect;
    function  GetFont:TFont;
    procedure SetFont(Font:TFont);
    function  GetPrjFont:TFont;
    procedure SetPrjFont(Font:TFont);
    procedure SetText(Value: String);
    function  GetText:String;
    procedure SetProjection(Value: String);
    function  GetProjection:String;
    procedure SetRectStyle(Value: TDSRectStyle);
    procedure SetRectInterval(Value: Integer); {Internal function}
    procedure SetDrawColor(Value: TColor);
    procedure SetLineStyle(Value: TPenStyle);
    procedure SetLineWidth(Value: Integer);
    procedure SetPaintColor(Value: TColor);
    procedure SetShadowColor(Value: TColor);
    procedure SetShadowType(Value: TDSShadowType);
    procedure SetShadowInterval(Left,Right,Top,Bottom:Integer); { Internal function}
    procedure SetShadowDepth(Value: Integer);
    procedure DrawShadow;
    procedure DrawShadowLeft(Diagonal:Boolean); {Internal function }
    procedure DrawShadowRight(Diagonal:Boolean);{Internal function }
    procedure DrawShadowTop; {Internal function }
    procedure DrawShadowBottom(Diagonal:Boolean;Orient:Integer); {Internal function }
    procedure SetDefWidth(Value: Integer);
    procedure SetDefHeight(Value: Integer);
    procedure SetAutoHeight(Value: Boolean);
    procedure SetAutoWidth(Value: Boolean);
    procedure SetHAlign(Value: TAlignment);
    procedure SetVAlign(Value: TVAlignment);
    procedure SetVSpacing(Value: Integer);
    procedure SetHSpacing(Value: Integer);
    { Procedures for tree }
    function  GetSpaces(Count: Integer):String;
    procedure SetNode(lleft,ltop:Integer);
    {}
    procedure SetLineColor(Value: TColor);
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
    procedure   SetFontCharset(ch:TFontCharset);
    constructor Create(AOwner: TComponent);  override; { Create empty node }
    destructor  Destroy; override;             { Call only for root entry }
    procedure  SetTreeColor(Value:TColor);
    procedure  SetFontDPI1(Handle:HDC);
    procedure  SetFontDPI(NewDPI:Integer);
    procedure  RestoreFontDPI;
  published
    { Published declarations }
    property Text:String read GetText write SetText;
    property Projection:String read GetProjection write SetProjection;
    property LineWidth:Integer read FLineWidth write SetLineWidth default 1;
    property LineColor:TColor read FLineColor write SetLineColor default clBlack;
    property RectLineStyle:TPenStyle read FLineStyle write SetLineStyle;
    property RectColor:TColor read FDrawColor write SetDrawColor default clWindowText;
    property PaintColor:TColor read FPaintColor write SetPaintColor default clWindow;
    property ShadowColor:TColor read FShadowColor write SetShadowColor default clWindowText;
    property ShadowType:TDSShadowType read FShadowType write SetShadowType;
    property ShadowDepth:Integer read FShadowDepth write SetShadowDepth default 4;
    property Color default clWhite;
    property RectStyle:TDSRectStyle read FRectStyle write SetRectStyle;
    property Font:TFont read getFont write SetFont;
    property PrjFont:TFont read getPrjFont write SetPrjFont;
    property Height default 30;
    property Width  default 50;
    property Visible;
    property DragCursor;
    property DragMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property Hint;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property HInterval:Integer read FHInterval write FHInterval default 10;
    property VInterval:Integer read FVInterval write FVInterval default 10;
    { New propeties }
    property DefWidth:Integer read FDefWidth write SetDefWidth default 100;
    property DefHeight:Integer read FDefHeight write SetDefHeight default 100;
    property AutoHeight:Boolean read FAutoHeight write SetAutoHeight default True;
    property AutoWidth:Boolean read FAutoWidth write SetAutoWidth default True;
    property HSpacing:Integer read FHSpacing write SetHSpacing default 8;
    property VSpacing:Integer read FVSpacing write SetVSpacing default 8;
    property HAlign:TAlignment read FHAlign write SetHAlign default taCenter;
    property VAlign:TVAlignment read FVAlign write SetVAlign default taVCenter;
    property MaxWidth:Integer read FMaxWidth default 0;
    property MaxHeight:Integer read FMaxHeight default 0;
    property Parent;
  end;


Const reSpace=2;

implementation

Uses PBarDlgUnit;

{ TBPDGraphNode }

procedure   TBPDGraphNode.SetFontCharset(ch:TFontCharset);
begin
 Font.Charset:=ch;
end;


procedure  TBPDGraphNode.SetTreeColor(Value:TColor);
begin
 color:=Value;
end;

procedure TBPDGraphNode.SetProjection(Value: String);
Var s:String;
 begin
   s:=Value;
   s:=TrimLeft(s);
   FProjection:=s;
   if not(FUpdating) then Paint;
 end;

function  TBPDGraphNode.GetProjection:String;
 begin
   Result:=FProjection;
 end;

constructor TBPDGraphNode.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FUpdating:=False;
   Color:=clWhite;
   FPaintColor:=clWindow;
   FDrawColor:=clWindowText;
   FShadowType:=shNone;
   FShadowDepth:=4;
   FLineStyle:=psSolid;
   FLineWidth:=1;
   FIntervalLeft:=2*FLineWidth;
   FIntervalTop:=2*FLineWidth;
   FIntervalBottom:=2*FLineWidth;
   FIntervalRight:=2*FLineWidth;
   FShadowLeft:=0;
   FShadowRight:=0;
   FShadowTop:=0;
   FShadowBottom:=0;
   FRectStyle:=re2x;
   FText:='';
   FProjection:='';
   FShadowColor:=clWindowText;
   FHInterval:=10;
   FVInterval:=10;
   FDefWidth:=100;
   FDefHeight:=100;
   FAutoHeight:=True;
   FAutoWidth:=True;
   FHSpacing:=8;
   FVSpacing:=8;
   FHAlign:=taCenter;
   FVAlign:=taVCenter;
   FWarning:=False;
   FMaxWidth:=0;
   FMaxHeight:=0;
   FFontDPI:=0;
   FLineColor:=clBlack;
   FPrjFont:=TFont.Create;
   FPrjFont.Assign(Font);
   Parent:=AOwner as TCustomOrgChart; {???}
end;

destructor  TBPDGraphNode.Destroy;
begin
 if (FPrjFont<>nil) then
   begin
     FPrjFont.Free;
     FPrjFont:=nil;
   end;
 if length(FProjection)>0 then
  begin
    FProjection:='';
  end;
 Parent:=nil;
 inherited Destroy;
end;

procedure TBPDGraphNode.SetLineColor(Value: TColor);
begin
 FLineColor:=Value;
 if not(FUpdating) then Paint;
end;


function   TBPDGraphNode.GetSpaces(Count: Integer):String;
Var i:Integer;
begin
  Result:='';
  i:=0;
  while (i<=Count) do
   begin
    Inc(i);
    Result:=Result+' ';
   end;
end;


procedure TBPDGraphNode.SetFontDPI(NewDPI:Integer);
begin
 FFontDPI:=Canvas.Font.PixelsPerInch;
 Canvas.Font.PixelsPerInch:=NewDPI;
 FPrjFont.PixelsPerInch:=NewDPI;
end;

procedure   TBPDGraphNode.SetFontDPI1(Handle:HDC);
begin
 FFontDPI:=Canvas.Font.PixelsPerInch;
 Canvas.Font.PixelsPerInch:=GetDeviceCaps(Handle,LOGPIXELSX);
 FPrjFont.PixelsPerInch:=GetDeviceCaps(Handle,LOGPIXELSX);
end;

procedure   TBPDGraphNode.RestoreFontDPI;
begin
 Canvas.Font.PixelsPerInch:=FFontDPI;
 FPrjFont.PixelsPerInch:=FFontDPI;
end;

function  TBPDGraphNode.GetProjRectSize(left,top:Integer):TRect;
Var r:TRect;
    ht:Integer;
    uf:UINT;
    mw:Integer;
    CFont:TFont;
 begin
 {  Left & Top to Real Starting Values,
  Right & Bottom to ClipRectangle }
 r.Left:=left+FIntervalLeft;
 r.Top:=top;
 r.Right:=r.Left+FDefWidth;
 r.Bottom:=Parent.ClientRect.Bottom;
{     }
 uf:=DT_WORDBREAK or DT_CALCRECT or DT_LEFT;
 CFont:=TFont.Create;
 CFont.Assign(Canvas.Font);
 Canvas.Font.Assign(FPrjFont);
 ht:=DrawText(Canvas.Handle,Pchar(FProjection),length(FProjection),r,uf);
 Canvas.Font.Assign(CFont);
 CFont.Free;
 r.Bottom:=ht+r.Top+FIntervalTop{+FIntervalBottom}+FVSpacing{+FPrjFont.Height+FIntervalTop+FVSpacing};   { New FIntervalTop+FVSpacing}
 r.Right:=r.Right+2*FHSpacing;
 mw:=r.Right-r.Left;
 if (mw>FMaxWidth) then FMaxWidth:=mw;
 result:=r;
 end;

procedure   TBPDGraphNode.Paint;
Var r,r1:TRect;
    oldColor:TColor;
    uf:UINT;
    th:Integer;
    lenP:Integer;
    SubY:Integer;
    CFont:TFont;
    tmp:Integer;
begin
 if FUpdating then Exit;
 FMaxHeight:=0;
 FMaxWidth:=0;
 FWarning:=False;
 r:=GetRectSize; { Get Caption rect }
 lenP:=length(FProjection);
 if (lenP<>0) then
  begin
   r1:=GetProjRectSize(r.Left,r.Bottom);
   r.Bottom:=r1.Bottom;
  end else
   begin
    r1.Top:=0;
    r1.Bottom:=0;
    r1.Left:=0;
    r1.Right:=0;
   end;
 if FAutoHeight then
  begin
   th:=FVSpacing;
   r.Bottom:=r.Bottom+2*FVSpacing;
  end
 else
  begin
  th:=r.Bottom-r.Top;
  if th > (FDefHeight) then th:=FDefHeight;
  r.Bottom:=r.Top+FDefHeight+r1.Bottom-r1.Top+2*FVSpacing;
  case FVAlign of
   taTopJustify: th:=FVSpacing;
   taVCenter:    th:=FVSpacing+(FDefHeight-th) div 2;
   taBottomJustify: th:= FVSpacing+FDefHeight-th;
  end;
 end;
 r.Left:=FShadowLeft;
 r.Top:=FShadowTop;
 r.Bottom:=r.Bottom+FIntervalBottom;
 r.Right:=r.Right+FIntervalRight;
 oldColor:=Canvas.Brush.Color;
 Canvas.Brush.Color:=FPaintColor;
 Canvas.FillRect(r);    { Fill with PaintColor }
 if FAutoHeight then SubY:=r1.Top else SubY:=r.Top+FDefHeight+FHSpacing+FShadowTop+FIntervalTop+FIntervalBottom;
 SetUpRect(r,(lenP>0),SubY);          { Draw Frame with DrawColor }
 width:=r.Right+FShadowRight+1;
 Height:=r.Bottom+FShadowBottom+1;
 r.Left:=FIntervalLeft+FShadowLeft+FHSpacing;
 r.Top:=FIntervalTop+FShadowTop+th;
 tmp:=r1.Top;
 r1.Top:=SubY+FIntervalTop{-(FPrjFont.Height div 2)};
 r1.Bottom:=r1.Bottom-tmp+SubY+FIntervalTop-(FPrjFont.Height div 2);
 r.Bottom:=r.Bottom-FIntervalBottom-FVSpacing;
 r.Right:=r.Right-FIntervalRight-FHSpacing;
 { Draw Caption }
 uf:=DT_WORDBREAK;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 if length(FProjection)<>0 then
  begin
   uf:=DT_WORDBREAK or DT_LEFT;
   {r1.Top:=SubY+FIntervalTop+FHSpacing;
   r1.Bottom:=r.Bottom;
   r1.Left:=r1.Left+FIntervalLeft;}
   CFont:=TFont.Create;
   CFont.Assign(Canvas.Font);
   Canvas.Font.Assign(FPrjFont);
   DrawText(Canvas.Handle,Pchar(FProjection),length(FProjection),r1,uf);
   Canvas.Font.Assign(CFont);
   CFont.Free;
  end;
{ DT_SINGLELINE or DT_WORDBREAK ); }
 DrawShadow;
 Canvas.Brush.Color:=oldColor;
end;

procedure   TBPDGraphNode.DrawRect(r:TRect;val1,val2:Integer; SubLine:Boolean; SubY:Integer);
Var i,j:Integer;
begin
 with Canvas do
  begin
   for j:=0 to Val1 do
    begin
      if (j<Val2) or (j>(Val2+reSpace-1)) then
        Pen.Color:=FDrawColor else Pen.Color:=FPaintColor;
     for i:=0 to (FLineWidth-1) do
      begin
       MoveTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
       LineTo(r.Right-i-j*FLineWidth,r.Top+i+j*FLineWidth);
       LineTo(r.Right-i-j*FLineWidth,r.Bottom-i-j*FLineWidth);
       LineTo(r.Left+i+j*FLineWidth,r.Bottom-i-j*FLineWidth);
       LineTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
       if SubLine then
         begin
           MoveTo(r.Left+i+j*FLineWidth,SubY+i+j*FLineWidth);
           LineTo(r.Right-i-j*FLineWidth,SubY+i+j*FLineWidth);
         end;
      end;
     end;
   end;
end;

procedure   TBPDGraphNode.SetUpRect(r: TRect; SubLine:Boolean; SubY:Integer);
Var oldColor:TColor;
begin
{     }
 with Canvas do
  begin
   oldColor:=Pen.Color;
   Pen.Color:=FDrawColor;
   Pen.Style:=FLineStyle;
   case FRectStyle of
    reNone: begin end;
    re1x: DrawRect(r,0,1,SubLine,SubY);
    re2x: DrawRect(r,1,2,SubLine,SubY);
    re3x: DrawRect(r,2,3,SubLine,SubY);
    re4x: DrawRect(r,3,4,SubLine,SubY);
    re2x3: DrawRect(r,4+reSpace,2,SubLine,SubY);
    re3x2: DrawRect(r,4+reSpace,3,SubLine,SubY);
    re2x4: DrawRect(r,5+reSpace,2,SubLine,SubY);
    re4x2: DrawRect(r,5+reSpace,4,SubLine,SubY);
    re2x5: DrawRect(r,6+reSpace,2,SubLine,SubY);
    re5x2: DrawRect(r,6+reSpace,5,SubLine,SubY);
   end;
   Pen.Color:=oldColor;
  end;
end;

function   TBPDGraphNode.GetRectSize:TRect;
Var r:TRect;
    ht:Integer;
    uf:UINT;
begin
 {  Left & Top to Real Starting Values,
  Right & Bottom to ClipRectangle }
 r.Left:=FIntervalLeft+FShadowLeft;
 r.Top:=FIntervalTop+FShadowTop;
 r.Right:=r.Left+FDefWidth;
 r.Bottom:=Parent.ClientRect.Bottom;
{     }
 uf:=DT_WORDBREAK or DT_CALCRECT;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 ht:=DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 r.Bottom:=ht+r.Top;
 FMaxWidth:=r.Right-r.Left;
 FMaxHeight:=r.Bottom-r.Top;
 if not(FAutoWidth) then
   begin
     if (r.Right>r.Left+FDefWidth) then FWarning:=True;
     r.Right:=r.Left+FDefWidth;
   end;
 if not(FAutoHeight) then
   begin
    if (r.Bottom > r.Top + FDefHeight) then FWarning:=True;
   end;
 r.Right:=r.Right+2*FHSpacing;
 result:=r;
end;

function  TBPDGraphNode.GetPrjFont:TFont;
 begin
   result:=FPrjFont;
 end;

procedure TBPDGraphNode.SetPrjFont(Font:TFont);
 begin
   FPrjFont:=Font;
   if not(FUpdating) then Paint;
 end;

function  TBPDGraphNode.GetFont:TFont;
begin
 result:=Canvas.Font;
end;

procedure TBPDGraphNode.SetFont(Font:TFont);
begin
 Canvas.Font:=Font; {Changed 15.03.98 }
 if not(FUpdating) then Paint;
end;

function  TBPDGraphNode.GetText:String;
begin
 Result:=FText;
end;

procedure TBPDGraphNode.SetText(Value: String);
Var s:String;
begin
 s:=Value;
 s:=TrimLeft(s);
 FText:=s;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetRectInterval(Value: Integer);
begin
 FIntervalLeft:=FLineWidth*Value;
 FIntervalRight:=FLineWidth*Value;
 FIntervalTop:=FLineWidth*Value;
 FIntervalBottom:=FLineWidth*Value;
end;

procedure TBPDGraphNode.SetRectStyle(Value: TDSRectStyle);
begin
 case Value of
  reNone:     SetRectInterval(0);
  re1x:       SetRectInterval(1);
  re2x:       SetRectInterval(2);
  re3x:       SetRectInterval(3);
  re4x:       SetRectInterval(4);
  re2x3,re3x2: SetRectInterval(5+reSpace);
  re2x4,re4x2: SetRectInterval(6+reSpace);
  re2x5,re5x2: SetRectInterval(7+reSpace);
 end;
 FRectStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetDrawColor(Value: TColor);
begin
 FDrawColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetLineStyle(Value: TPenStyle);
begin
 FLineStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetLineWidth(Value: Integer);
begin
 FLineWidth:=Value;
 SetRectStyle(FRectStyle);
end;

procedure TBPDGraphNode.SetPaintColor(Value: TColor);
begin
 FPaintColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetShadowColor(Value: TColor);
begin
 FShadowColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetShadowInterval(Left,Right,Top,Bottom:Integer);
begin
 FShadowLeft:=FLineWidth*Left;
 FShadowRight:=FLineWidth*Right;
 FShadowTop:=FLineWidth*Top;
 FShadowBottom:=FLineWidth*Bottom;
end;

procedure TBPDGraphNode.SetShadowType(Value: TDSShadowType);
begin
 FShadowType:=Value;
 case Value of
  shNone:                 SetShadowInterval(0,0,0,0);
  shLeftBoxed:            SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shLeftFramed:           SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shTopPerspective:       SetShadowInterval(0,0,0,FShadowDepth);
  shInversePerspective:   SetShadowInterval(FShadowDepth,FShadowDepth,0,FShadowDepth);
  shRightBoxed:           SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shRightFramed:          SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shBottomPerspective:    SetShadowInterval(0,0,FShadowDepth,0);
 end;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetShadowDepth(Value: Integer);
begin
 FShadowDepth:=Value;
 SetShadowType(FShadowType);
end;

procedure TBPDGraphNode.DrawShadowBottom(Diagonal:Boolean;Orient:Integer);
Var r:TRect;
    h,w:Integer;
    i:Integer;
begin
{ Orient 0  - Left
         1  - Center
         2  - Right }
 with Canvas do
  Begin
   h:=self.Height;
   w:=self.Width;
   r.Left:=FShadowLeft;
   r.Top:=h-FShadowBottom;
   r.Right:=w-FShadowRight;
   r.Bottom:=h;
   Brush.Color:=self.Color;
   FillRect(r);
   Pen.Color:=FShadowColor;
    if Diagonal then
       begin
        {Diagonal}
         case Orient of
          0: {Left}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowLeft,h-i);
                   LineTo(w-FShadowLeft+i,h-i);
                 end;
              end;
          1: {Center}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowBottom-i,h-i);
                   LineTo(w-FShadowBottom+i,h-i);
                 end;
              end;
          2: {Right}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowRight-i,h-i);
                   LineTo(w-FShadowRight,h-i);
                 end;
              end;
         end;
       end
     else
       begin
         case Orient of
          0: {Left}
              begin
               r.Right:=w-FShadowLeft;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          1: {Center}
              begin
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          2: {Right}
              begin
               r.Left:=FShadowRight;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
         end;
       end;
  end;
end;

procedure TBPDGraphNode.DrawShadowTop;
Var r:TRect;
    i:Integer;
    w:Integer;
begin
{}
 with Canvas do
  begin
   w:=self.Width;
   r.Left:=0;
   r.Top:=0;
   r.Right:=w;
   r.Bottom:=FShadowTop;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
    for i:=0 to (FShadowTop) do
       begin
         MoveTo(FShadowTop-i,i);
         LineTo(w-FShadowTop+i,i);
       end;
  end;
end;

procedure TBPDGraphNode.DrawShadowLeft(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h:Integer;
begin
 with Canvas do
 begin
   h:=self.Height;
   r.Left:=0;
   r.Top:=0;
   r.Right:=FShadowLeft;
   r.Bottom:=self.Height;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
 if Diagonal then
  begin
   {Left Diagonal Shadow}
    for i:=0 to (FShadowLeft-1) do
     begin
      MoveTo(i,FShadowLeft-i);
      LineTo(i,h);
     end;
  end
 else
  begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
  end;
 end;
end;

procedure TBPDGraphNode.DrawShadowRight(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h,w:Integer;
begin
 with Canvas do
 begin
    w:=self.width;
    h:=self.Height;
    r.Left:=w-FShadowRight;
    r.Top:=0;
    r.Right:=w;
    r.Bottom:=self.Height;
    Brush.Color:=self.Color;
    Pen.Color:=FShadowColor;
    FillRect(r);
 if Diagonal then
  begin
   {Right Diagonal Shadow}
    for i:=0 to (FShadowRight-1) do
     begin
      MoveTo(w-FShadowRight+i,i);
      LineTo(w-FShadowRight+i,h);
     end;
  end
 else
   begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
   end;
 end;
end;

procedure TBPDGraphNode.DrawShadow;
Var oldColor,oldColor1:TColor;
    penStyle:TPenStyle;
begin
{}
 with Canvas do
 begin
 oldColor:=Brush.Color;
 oldColor1:=Pen.Color;
 penStyle:=Pen.Style;
 Pen.Style:=psSolid;
 case FShadowType of
  shNone:                 begin end;
  shLeftBoxed:            begin
                            DrawShadowLeft(True);
                            DrawShadowBottom(True,0);
                          end;
  shLeftFramed:           begin
                            DrawShadowLeft(False);
                            DrawShadowBottom(False,0);
                          end;
  shTopPerspective:       DrawShadowBottom(True,1);
  shInversePerspective:   begin
                           DrawShadowLeft(True);
                           DrawShadowRight(True);
                           DrawShadowBottom(False,1);
                          end;
  shRightBoxed:           begin
                           DrawShadowRight(True);
                           DrawShadowBottom(True,2);
                          end;
  shRightFramed:          begin
                           DrawShadowRight(False);
                           DrawShadowBottom(False,2);
                          end;
  shBottomPerspective:    DrawShadowTop;

 end;
  Pen.Style:=penStyle;
  Pen.Color:=oldColor1;
  Brush.Color:=oldColor;
 end;
end;

procedure TBPDGraphNode.SetDefWidth(Value: Integer);
begin
 FDefWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetDefHeight(Value: Integer);
begin
 FDefHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetAutoHeight(Value: Boolean);
begin
 FAutoHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetAutoWidth(Value: Boolean);
begin
 FAutoWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetHAlign(Value: TAlignment);
begin
 FHAlign:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPDGraphNode.SetVAlign(Value: TVAlignment);
begin
 FVAlign:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetVSpacing(Value: Integer);
begin
 FVSpacing:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPDGraphNode.SetHSpacing(Value: Integer);
begin
 FHSpacing:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetNode(lleft,ltop:Integer);
begin
 FUpdating:=True;
 Left:=lleft;
 Top:= ltop;
 FUpdating:=False;
 if not(FUpdating) then Paint;
end;

end.
