unit MemDebug;

interface

var
  OldMemMgr: TMemoryManager;
  HeapAllocated: LongInt;

function NewGetMem(Size: Integer): Pointer;
function NewFreeMem(P: Pointer): Integer;
function NewReallocMem(P: Pointer; Size: Integer): Pointer;

const
  NewMemMgr: TMemoryManager = (
  GetMem: NewGetMem;
  FreeMem: NewFreeMem;
  ReallocMem: NewReallocMem);


procedure SetDebugMemMgr;
procedure RestoreMemMgr;

implementation

function NewGetMem(Size: Integer): Pointer;
begin
  Result := OldMemMgr.GetMem(Size);
  if (Result<>nil) then HeapAllocated:=HeapAllocated+Size;
end;

function NewFreeMem(P: Pointer): Integer;
begin
  HeapAllocated:=HeapAllocated-SizeOf(P^);
  Result := OldMemMgr.FreeMem(P);
end;

function NewReallocMem(P: Pointer; Size: Integer): Pointer;
begin
  HeapAllocated:=HeapAllocated-SizeOf(P^);
  Result := OldMemMgr.ReallocMem(P, Size);
  HeapAllocated:=HeapAllocated+Size;
end;

procedure SetDebugMemMgr;
begin
  GetMemoryManager(OldMemMgr);
  HeapAllocated:=0;
  SetMemoryManager(NewMemMgr);
end;

procedure RestoreMemMgr;
begin
  SetMemoryManager(OldMemMgr);
end;

initialization
 { Your initialization code goes here }
  SetDebugMemMgr;
finalization
 { Your finalization code goes here }
  RestoreMemMgr;
end.
