unit PageParamFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TPageParamForm = class(TForm)
    GroupBox1: TGroupBox;
    OKButton: TButton;
    CancelButton: TButton;
    DefButton: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    TopSpinButton: TSpinButton;
    BottomSpinButton: TSpinButton;
    LeftSpinButton: TSpinButton;
    RightSpinButton: TSpinButton;
    TopMEdit: TEdit;
    BottomMEdit: TEdit;
    LeftMEdit: TEdit;
    RightMEdit: TEdit;
    procedure TopSpinButtonUpClick(Sender: TObject);
    procedure TopSpinButtonDownClick(Sender: TObject);
    procedure BottomSpinButtonUpClick(Sender: TObject);
    procedure BottomSpinButtonDownClick(Sender: TObject);
    procedure LeftSpinButtonUpClick(Sender: TObject);
    procedure LeftSpinButtonDownClick(Sender: TObject);
    procedure RightSpinButtonUpClick(Sender: TObject);
    procedure RightSpinButtonDownClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure DefButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PageParamForm: TPageParamForm;

const incValue = 0.1; { 1 mm }
      defTop = 1.5;
      defBottom = 1.5;
      defLeft = 2.5;
      defRight = 1.5;

implementation

uses MasterOFormUnit, DebugUnit;

{$R *.DFM}


procedure TPageParamForm.TopSpinButtonUpClick(Sender: TObject);
begin
 try
 TopMEdit.Text:=FloatToStr(StrToFloat(TopMEdit.Text)+ incValue);
 except
  on E:Exception do  WriteLog('PageParamForm:TopSpinButtonUpClick',E);
 end;
end;

procedure TPageParamForm.TopSpinButtonDownClick(Sender: TObject);
begin
 try
 if StrToFloat(TopMEdit.Text) > incValue then
 TopMEdit.Text:=FloatToStr(StrToFloat(TopMEdit.Text)-0.1)
 else TopMEdit.Text:=FloatToStr(0);
 except
   on E:Exception do WriteLog('PageParamForm:TopSpinButtonDownClick',E);
 end;
end;

procedure TPageParamForm.BottomSpinButtonUpClick(Sender: TObject);
begin
 try
 BottomMEdit.Text:=FloatToStr(StrToFloat(BottomMEdit.Text)+ incValue);
 except
   on E:Exception do WriteLog('PageParamForm:BottomSpinButtonUpClick',E);
 end;
end;

procedure TPageParamForm.BottomSpinButtonDownClick(Sender: TObject);
begin
 try
 if StrToFloat(BottomMEdit.Text) > incValue then
 BottomMEdit.Text:=FloatToStr(StrToFloat(BottomMEdit.Text)-0.1)
 else BottomMEdit.Text:=FloatToStr(0);
 except
   on E:Exception do WriteLog('PageParamForm:BottomSpinButtonDownClick',E);
 end;
end;

procedure TPageParamForm.LeftSpinButtonUpClick(Sender: TObject);
begin
 try
 LeftMEdit.Text:=FloatToStr(StrToFloat(LeftMEdit.Text)+ incValue);
 except
   on E:Exception do WriteLog('PageParamForm:LeftSpinButtonUpClick',E);
 end;
end;

procedure TPageParamForm.LeftSpinButtonDownClick(Sender: TObject);
begin
 try
 if StrToFloat(LeftMEdit.Text) > incValue then
 LeftMEdit.Text:=FloatToStr(StrToFloat(LeftMEdit.Text)-0.1)
 else LeftMEdit.Text:=FloatToStr(0);
 except
   on E:Exception do WriteLog('PageParamForm:LeftSpinButtonDownClick',E);
 end;
end;

procedure TPageParamForm.RightSpinButtonUpClick(Sender: TObject);
begin
 try
 RightMEdit.Text:=FloatToStr(StrToFloat(RightMEdit.Text)+ incValue);
 except
   on E:Exception do WriteLog('PageParamForm:RightSpinButtonUpClick',E);
 end;
end;

procedure TPageParamForm.RightSpinButtonDownClick(Sender: TObject);
begin
 try
 if StrToFloat(RightMEdit.Text) > incValue then
 RightMEdit.Text:=FloatToStr(StrToFloat(RightMEdit.Text)-0.1)
 else RightMEdit.Text:=FloatToStr(0);
 except
   on E:Exception do WriteLog('PageParamForm:RightSpinButtonDownClick',E);
 end;
end;

procedure TPageParamForm.CancelButtonClick(Sender: TObject);
begin
 try
 Hide;
 except
   on E:Exception do WriteLog('PageParamForm:CancelButtonClick',E);
 end;
end;

procedure TPageParamForm.OKButtonClick(Sender: TObject);
begin
  try
  Hide;
 except
   on E:Exception do WriteLog('PageParamForm:OKButtonClick',E);
 end;
end;

procedure TPageParamForm.DefButtonClick(Sender: TObject);
begin
  try
  TopMEdit.Text:=FloatToStr(defTop);
  BottomMEdit.Text:=FloatToStr(defBottom);
  RightMEdit.Text:=FloatToStr(defRight);
  LeftMEdit.Text:=FloatToStr(defLeft);
  except
    on E:Exception do WriteLog('PageParamForm:DefButtonClick',E);
  end;
end;

end.
