unit PreviewFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, qrprntr;

type
  TPreviewForm = class(TForm)
    Label1: TLabel;
    Image1: TImage;
    QRPreview: TQRPreview;
    CorrectTimer: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure QRPreviewPageAvailable(Sender: TObject; PageNum: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure CorrectTimerTimer(Sender: TObject);
  private
    { Private declarations }
{    Gauge : TQRGauge;}
  public
    { Public declarations }
  end;

var
  PreviewForm: TPreviewForm;

implementation

uses MasterOFormUnit, DebugUnit;

{$R *.DFM}


procedure TPreviewForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 try
 try
 CorrectTimer.Enabled:=False;
 MasterForm.QuitButton.Enabled:=True;
 MasterForm.QuitItem.Enabled:=True;
 MasterForm.PrinterSetupItem.Enabled:=False;
 MasterForm.PageParamButton.Enabled:=True;
 MasterForm.PageParamItem.Enabled:=True;
 MasterForm.PreviewGroupItem.Enabled:=False;
 MasterForm.PreviewToolbar.Visible:=False;
 MasterForm.PageControl.Visible:=True;
 MasterForm.PreviewButton.Enabled:=True;
 MasterForm.PreviewItem.Enabled:=True;
 MasterForm.AFSetupButton.Enabled:=True;
 MasterForm.AFSetupItem.Enabled:=True;
 MasterForm.FormatButton.Enabled:=True;
 MasterForm.AutoFormatItem.Enabled:=True;
 Action:=caFree;
 finally
  Action:=caFree;
 end;
 except
    on E:Exception do WriteLog('PreviewForm:FormClose',E);
 end;
end;

procedure TPreviewForm.QRPreviewPageAvailable(Sender: TObject;
  PageNum: Integer);
begin
 try
  MasterForm.APageEdit.Text:=IntToStr(QRPreview.QRPrinter.AvailablePages);
  MasterForm.ZoomFactor.Text:=IntToStr(QRPreview.Zoom);
 except
   on E:Exception do WriteLog('PreviewForm:QRPreviewPageAvailable',E);
 end;
end;

procedure TPreviewForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   try
   case Key of
    VK_Next : if Shift=[ssCtrl] then
                 QRPreview.PageNumber := QRPreview.QRPrinter.PageCount
              else
                 QRPreview.PageNumber := QRPreview.PageNumber + 1;
    VK_Prior : if Shift=[ssCtrl] then
                 QRPreview.PageNumber := 1
               else
                 QRPreview.PageNumber := QRPreview.PageNumber - 1;
    VK_Home : QRPreview.PageNumber := 1;
    VK_End : QRPreview.PageNumber := QRPreview.QRPrinter.PageCount;
  end;
 except
  on E:Exception do WriteLog('PreviewForm:FormKeyDown',E);
 end;
end;

procedure TPreviewForm.FormCreate(Sender: TObject);
begin
 if MasterForm.RType=rtPln then  QRPreview.OnPageAvailable:=nil
 else QRPreview.OnPageAvailable:=QRPreviewPageAvailable;
 CorrectTimer.Enabled:=True;
end;

procedure TPreviewForm.CorrectTimerTimer(Sender: TObject);
begin
 MasterForm.APageEdit.Text:=IntToStr(QRPreview.QRPrinter.AvailablePages);
 MasterForm.ZoomFactor.Text:=IntToStr(QRPreview.Zoom);
 MasterForm.PreviewButton.Enabled:=False;
end;

end.
