unit PreviewFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  qrprntr, ExtCtrls, StdCtrls;

type
  TPreviewForm = class(TForm)
    QRPreview: TQRPreview;
    Image1: TImage;
    UpdateTimer: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure QRPreviewPageAvailable(Sender: TObject; PageNum: Integer);
    procedure UpdateTimerTimer(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PreviewForm: TPreviewForm;

implementation

uses MainFormUnit, DebugUnit;

{$R *.DFM}

procedure TPreviewForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
  Action:=MainForm.FPreviewCAction;
  if Action=caNone then Exit;
  MainForm.PreviewButton.Enabled:=MainFormUnit.HasPrn;
  MainForm.PreviewItem.Enabled:=MainFormUnit.HasPrn;
  MainForm.PreviewToolbar.Visible:=False;
  MainForm.ReportToolbar.Visible:=True;
  MainForm.ExitButton.Enabled:=True;
  MainForm.ExitItem.Enabled:=True;
  MainForm.OCPanel.Visible:=True;
  MainForm.PreviewOpen:=False;
  except
   on E:Exception do WriteLog('TPreviewForm:FormClose',E);
  end;
end;

procedure TPreviewForm.FormCreate(Sender: TObject);
begin
 try
 QRPReview.PageNumber:=1;
 QRPreview.ZoomToFit;
{ MainForm.PreviewZoom.Text:=IntToStr(QRPReview.Zoom);}
  except
   on E:Exception do WriteLog('TPreviewForm:FormCreate',E);
  end;
end;

procedure TPreviewForm.QRPreviewPageAvailable(Sender: TObject;
  PageNum: Integer);
begin
  try
   MainForm.PreviewZoom.Text:=IntToStr(QRPReview.Zoom);
   if (PageNum=QRPreview.QRPrinter.AvailablePages-1) then QRPreview.ZoomToFit;
  except
   on E:Exception do WriteLog('TPreviewForm:QRPreviewPageAvailable',E);
  end;
end;

procedure TPreviewForm.UpdateTimerTimer(Sender: TObject);
begin
   UpdateTimer.Enabled:=False;
   QRPreview.Zoom:=40;
  // QRPreview.ZoomToFit;
   MainForm.PreviewZoom.Text:='40';
end;

procedure TPreviewForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var zoom:Integer;
begin
  case Key of
    VK_HOME:  begin
                MainForm.PageEdit.ReadOnly:=False;
                MainForm.PageEdit.Text:=IntToStr(1);
                QRPreview.PageNumber:=1;
                MainForm.PageEdit.ReadOnly:=True;
              end;
    VK_PRIOR:  begin
                 MainForm.PageEdit.ReadOnly:=False;
                 if (QRPreview.PageNumber > 1) then
                   begin
                    QRPreview.PageNumber:=QRPreview.PageNumber-1;
                    MainForm.PageEdit.Text:=IntToStr(QRPreview.PageNumber);
                   end;
                 MainForm.PageEdit.ReadOnly:=True;
              end;
    VK_NEXT:  begin
                 MainForm.PageEdit.ReadOnly:=False;
                 if (QRPreview.PageNumber < QRPreview.QRPrinter.AvailablePages) then
                  begin
                   QRPreview.PageNumber:=QRPreview.PageNumber+1;
                   MainForm.PageEdit.Text:=IntToStr(QRPreview.PageNumber);
                  end;
                 MainForm.PageEdit.ReadOnly:=True;
              end;
    VK_END:   begin
                MainForm.PageEdit.ReadOnly:=False;
                QRPreview.PageNumber:=QRPreview.QRPrinter.AvailablePages;
                MainForm.PageEdit.Text:=IntToStr(QRPreview.QRPrinter.AvailablePages);
                MainForm.PageEdit.ReadOnly:=True;
              end;
    VK_INSERT: begin
                zoom:=QRPreview.Zoom;
                if zoom<400 then
                begin
                 zoom:=zoom+10;
                 QRPreview.Zoom:=zoom;
                 MainForm.PreviewZoom.Text:=IntToStr(zoom);
                end;
               end;
    VK_DELETE: begin
                zoom:=QRPreview.Zoom;
                if zoom>10 then
                 begin
                  zoom:=zoom-10;
                  QRPreview.Zoom:=zoom;
                  MainForm.PreviewZoom.Text:=IntToStr(zoom);
                 end;
               end;
    VK_ESCAPE: MainForm.ClosePreviewTimer.Enabled:=True;
  end;
end;

end.
