unit BitEdit;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids;

type
  TBitEdit = class(TDrawGrid)
  private
    { Private declarations }
    Fvalue:dword;
    FBitCount:byte;
    fFixed1,ffixed0:dword;
    fOnChange:TNotifyEvent;
  protected
    { Protected declarations }
    procedure setvalue(val:dword);
    procedure setbitcount(bc:byte);
    procedure setones(val:dword);
    procedure setzeroes(val:dword);
    procedure DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState);override;
    procedure Click;override;
    procedure loaded;override;
    procedure resize;override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;

  public
    { Public declarations }
    constructor create(AOwner:TComponent);override;
  published
    { Published declarations }
    property value:dword read fvalue write setvalue;
    property BitCount:byte read fbitcount write setbitcount;
    property Ones:dword read ffixed1 write setones;
    property Zeroes:dword read ffixed0 write setzeroes;
    property enabled;
    property OnChange:TNotifyEvent read fonchange write fonchange;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TBitEdit]);
end;
procedure TBitEdit.setvalue(val:dword);
begin
fvalue:=val;
if visible then repaint;
end;
procedure TBitEdit.setbitcount(bc:byte);
begin
fbitcount:=bc;
colcount:=bc;
//width:=fbitcount*6+2;

if visible then repaint;
end;
procedure TBitEdit.DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState);
begin
 if ((fvalue and (1 shl acol))<>0) then
 if enabled then
 case acol mod 4 of
 0:canvas.brush.color:=clNavy;
 1:canvas.brush.color:=clTeal;
 2:canvas.brush.color:=clOlive;
 3:canvas.brush.color:=clGreen;
 end
            else canvas.brush.color:=clInactiveBorder
            else  canvas.brush.color:=color;
canvas.fillrect(arect);
end;
procedure tBitEdit.Click;
begin
inherited click;
fvalue:=fvalue xor (1 shl (col));
fvalue:=fvalue or ffixed1;
fvalue:=fvalue and not ffixed0;
if visible then repaint;
if assigned(fonchange) then fonchange(self);
end;
constructor TBitEdit.create(AOwner:TComponent);
begin
inherited create(AOwner);
fbitcount:=16;
fvalue:=0;
ffixed1:=0;
ffixed0:=0;
defaultcolwidth:=5;
defaultrowheight:=15;
fixedcols:=0 ;
fixedrows:=0;
rowcount:=1;
end;
procedure TBitEdit.loaded;
var i:integer;
begin
inherited loaded;
defaultcolwidth:=(width-2) div colcount-1;
colcount:=1;
colcount:=fbitcount;
for i:=0 to fbitcount-1 do
 colwidths[i]:=defaultcolwidth;

defaultrowheight:=15;
fixedcols:=0 ;
fixedrows:=0;
rowcount:=1;
height:=17;
//clientwidth:=(defaultcolwidth+1)*colcount;
width:=(defaultcolwidth+1)*colcount+3;
fvalue:=fvalue or ffixed1;
fvalue:=fvalue and not ffixed0;
end;
procedure TBitEdit.setones(val:dword);
begin
ffixed1:=val;
ffixed0:=ffixed0 and not val;
fvalue:=fvalue or ffixed1;
if visible then repaint;
end;
procedure TBitEdit.setzeroes(val:dword);
begin
val:=val and not ffixed1;
ffixed0:=val;
fvalue:=fvalue and not ffixed0;
if visible then repaint;
end;
procedure TBitEdit.resize;
begin
inherited resize;
//defaultcolwidth:=clientwidth div colcount -1;
defaultrowheight:=clientheight;
end;
procedure TBitEdit.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var i,r:integer;
begin
if button=mbRight then
begin
mousetocell(x,y,i,r);
if i=-1 then exit;
if col=i then click;
col:=i;
for i:= 0 to col do
fvalue:=fvalue xor (1 shl (i));
fvalue:=fvalue xor (1 shl (col));
fvalue:=fvalue or ffixed1;
fvalue:=fvalue and not ffixed0;
if visible then repaint;
if assigned(fonchange) then fonchange(self);
end
else
inherited  MouseUp(Button,Shift,X,Y);
end;
end.
