Unit BPInt;
{
(c) .  1997,2006
}
{$INCLUDE Compmode.inc}
{---------------------------------------------------------------------------}
{ Project: BP | Module BPInt - interface class for writing *.bpd files      }
{---------------------------------------------------------------------------}

 { Corrected 24.12.98 }
 { Rewritten 14-09-98 }
 { Rewritten 30-09-98 }

Interface

Uses Windows, Messages, SysUtils, Classes, Graphics,BPDef,BPStream,BPRename,DB,otherLists;

Type     TBPList = class(TComponent)
          private
            FModel,FNBP:word;
            FTree:TList;
            FHeader:TBPHeader;
            FLTTree:TList;
            FNTTree:TList;
            FOPTree:TList;     { New: Operation Tree List }
            FNodes:TList;
            FLinks:TList;
            FIPNode:TList;  {@@@}
            FWNodes:TList;
            FWLinks:TList;
            FFileStream:TBPFileStream;
            FEditLevel:Boolean;
            FLevel:Integer;
            FParentLevel:Integer; { Parent Level }
            FNodesCount,FLinksCount:Integer;
            fonsavelevel:TLevelEvent;
            fopcodes:TList;
            fNNList,fNN2List,fIPList,fNNresList:TIntList;
            function getNN(linkNum:int64;IPNum:integer):integer;
            procedure   RenameLinksNumbers;
            procedure   Copy;
            procedure   StoreEditingResults(wLevel:integer);
            procedure   RecreateNodesAndLinks;
            procedure   ClearNodes;
            procedure   ClearLinks;
          public
            function addnextopcode(opcode:int64):DWORD;
            constructor CreateID(AOwner:TComponent;Model,NBP:word);  
            destructor  Destroy; override;

            procedure   SetFileHeader(sModel,sCompany,sAuthor:ShortString;
                                      wDateTime:TDateTime;
                                      wRev:DWORD); { Set file header data }
            procedure   StartNewLevel(wDepth,wLevel,wParent,wID:Integer;sLevel,sCaption,sNotes:ShortString;
                                      wRev:DWORD;wStatus:TDraftStatus); { Start new level}
            function    SetCurrentLevel(wLevel:Integer):Boolean; { Query existing level,True if level exist }
            { New }
            procedure   ClearLinksTypes;
            procedure   ClearNodesTypes;
            procedure   ClearOperationTree; { New }
{@@@}
            procedure   ClearIPNode;
{/@@@}

            function   AddNodeType(id,parent,index:DWORD;Caption:String):PBPNodeTypes;
            function   AddLinkType(id,parent,index:DWORD;Caption:String):PBPLinkTypes;
            procedure   AddOpNode(id,parent:DWORD;Caption:String;NodeIndex:DWORD;Detail:String;isRead:boolean);
            procedure   AddIPNode(NodeCaption:ShortString;NodeNumber:DWORD;NodeIndex:DWORD;NodeControl,NodeMechanism:string);
            { New }
            procedure   ClearAll; { Clear all tree structure }
            procedure   ClearCurrent; { Clear current nodes & links lists }
            procedure   AddNode(NodeCaption:ShortString;NodeNumber:DWORD;
                             NodeNumberCaption:TVeryShortString;ABCValue:Double;
                             NodeIndex:DWORD;Comment:ShortString); { Add node }
            procedure   IntAddLink(UMFrom,UMTo,LinkFromCaption,LinkToCaption:ShortString;LinkGlobalCaption:TVeryShortString;
                                FromNode,ToNode:DWORD;
                                FromIP,ToIP:DWORD;
                                Flags:DWORD;
                                FromNumber,ToNumber:int64;LinkIndex:DWORD;
                                FromPath,ToPath:ShortString); { Add Link }
            procedure   AddLink(UMFrom,UMTo,LinkFromCaption,LinkToCaption:ShortString;LinkGlobalCaption:TVeryShortString;
                                FromNode,ToNode:DWORD;
                                FromIP,ToIP:DWORD;
                                FromLinkType,ToLinkType:TLinkType;
                                FromNumber,ToNumber:int64;LinkIndex:DWORD;
                                usedFROM,usedTO:boolean;
                                FromPath,ToPath:ShortString); { Add link }
            procedure   SaveToFile(FileName:String;mask:word); { Save result to file }
            procedure   LoadSettingsFromFile(FileName:String);
            procedure   updateSettingstable(Config:TDataSet);
            procedure   LoadSettingsFromTable(Config:TDataSet); 
            property    OnSavelevel:TLevelEvent read fonsavelevel write fonsavelevel;
           published
          property NodesCount:integer read FNodesCount default 0;
          property LinksCount:integer read FLinksCount default 0;
         end;

procedure Register;


Implementation

 { Internal subroutines }

uses dialogs,debug,variants,utils;
 procedure   TBPList.RenameLinksNumbers;
 Var tmpRename:TBPRename;
  begin
    tmpRename:=TBPRename.Create(FTree,FOpTree);
    tmpRename.RenameLinks;
    tmpRename.Destroy;
  end;
 procedure   TBPList.ClearIPNode;
 var i:integer;
  begin
   for i:=0 to FIPNode.count-1 do
    FreeMEm(PBPInProcessNode(FIPNode[i]));
  FIPNode.clear;    
  end;

 procedure   TBPList.StoreEditingResults(wLevel:integer);
 Var tmpTree:PBPTree;
     flag:Boolean;
     i:integer;
  begin
    { Store editing results in tree }
    Flag:=True;
    for i:=0 to ftree.count-1 do
     begin
         tmpTree:=PBPTree(FTree[i]);
       if (tmpTree^.dwLevel=wLevel) then
         begin
            Flag:=False;
            FEditLevel:=False;
            self.Copy;
            tmpTree^.dwNodesCount:=FWNodes.count;
            tmpTree^.dwLinksCount:=FWLinks.Count;
            tmpTree^.dwNodesMemRequired:=FWNodes.Count*sizeof(TBPNode);
            tmpTree^.dwLinksMemRequired:=FWLinks.Count*sizeof(TBPLink);
            tmpTree^.lpNodes:=FWNodes;
            tmpTree^.lpLinks:=FWLinks;
            ClearCurrent;
            //FWNodes:=nil;
            //FWLinks:=nil;
           end;
     end;
  end;

 procedure   TBPList.ClearNodes;
 Var  i:integer;
  begin
  for i:=0 to FNodes.count-1 do
  FreeMem(PBPNode(FNodes[i]));
  FNodes.clear;
  end;

 procedure   TBPList.ClearLinks;
  Var  i:integer;
  begin
  for i:=0 to FLinks.count-1 do
  FreeMem(PBPDLink(FLinks[i]));
  FLinks.clear;
  {fNNList.Clear;
   fNN2List.Clear;
   fIPList.Clear;
   fNNresList.Clear;}
  end;

procedure   TBPList.ClearOperationTree;
  Var  i:integer;
  begin
  for i:=0 to FOpTree.count-1 do
  begin
  PBPOpTree(FOpTree[i])^.lpOpDetail.free;
  FreeMem(PBPOpTree(FOpTree[i]));
  end;
  FOpTree.clear;
  FHeader.dwOpEntries:=0;
  end;
procedure   TBPList.ClearLinksTypes;
  Var  i:integer;
  begin
  for i:=0 to FLTTree.count-1 do
  FreeMem(PBPLinkTypes(FLTTree[i]));
  FLTTree.clear;
  FHeader.dwLinksTypesCount:=0;
  end;

procedure   TBPList.ClearNodesTypes;
  Var  i:integer;
  begin
  for i:=0 to FNTTree.count-1 do
  FreeMem(PBPNodeTypes(FNTTree[i]));
  FNTTree.clear;
  FHeader.dwNodesTypesCount:=0;
  end;

procedure   TBPList.AddOpNode(id,parent:DWORD;Caption:String;NodeIndex:DWORD;Detail:String;isRead:boolean);
Var tmpTree1:PBPOpTree;
    i,pos:Integer;
 begin
 i:=1;
 for i:=0 to FOpTree.count-1 do
 if  PBPOpTree(FOpTree[i])^.dwLevel=id then break;
 if i>=FOpTree.count then
 begin
      tmpTree1:=PBPOpTree(AllocMem(sizeof(TBPOpTree)));
      tmpTree1^.dwLevel:=id;
      tmpTree1^.dwDataOffset:=0;
      tmpTree1^.lpOpDetail:=TStringList.create;
      FOpTree.add(tmpTree1);
          inc(FHeader.dwOpEntries);
 end
 else tmpTree1:=PBPOpTree(FOpTree[i]);
      tmpTree1^.dwParent:=parent;
      tmpTree1^.ssCaption:=caption;
      if isRead then
      tmpTree1^.btFlags:=tmpTree1^.btFlags or 1
      else
      tmpTree1^.btFlags:=tmpTree1^.btFlags or 2;
      tmpTree1^.dwNodeIndex:=NodeIndex;
      if detail<>'' then
      begin
      pos:=tmpTree1^.lpOpDetail.IndexOf(detail);
      if pos=-1 then
      begin
      pos:=tmpTree1^.lpOpDetail.add(Detail);
       inc(tmpTree1^.dwOpDetailCount);
      end;
      if isread then
       tmpTree1^.lpOpDetail.Objects[pos]:=TObject(integer(tmpTree1^.lpOpDetail.Objects[pos]) or 1)
       else
       tmpTree1^.lpOpDetail.Objects[pos]:=TObject(integer(tmpTree1^.lpOpDetail.Objects[pos]) or 2)
      end;
   end;

function   TBPList.AddNodeType(id,parent,index:DWORD;Caption:String):PBPNodeTypes;
Var tmpPtr:PBPNodeTypes;
    i:Integer;
 begin
  {}
  tmpPtr:=nil;
  for i:=0 to FNTTree.count-1 do
  if PBPNodeTypes(FNTTree[i])^.dwnodeindex=index then  begin tmpPtr:=PBPNodeTypes(FNTTree[i]); result:=tmpPtr;break;end;
  if (tmpPtr=nil) then
    begin
      tmpPtr:=PBPNodeTypes(AllocMem(sizeof(TBPNodeTypes)));
      tmpPtr^.dwNodeIndex:=index;
      tmpPtr^.dwID:=id;
      tmpPtr^.dwParent:=parent;
      tmpPtr^.dwFontColor:=clBlack;
      tmpPtr^.dwPaintColor:=clWhite;
      tmpPtr^.dwDrawColor:=clBlack;
      tmpPtr^.dwShadowColor:=clBlack;
      if index =$FFFF then
      tmpPtr^.dwShadowStyle:=0
      else
      tmpPtr^.dwShadowStyle:=6;
      tmpPtr^.dwRectStyle:=2;
      FNTTree.add(tmpPtr);
       result:=tmpPtr;
      inc(FHeader.dwNodesTypesCount);
    end;
      tmpPtr^.ssCaption:=Caption;

 end;

function   TBPList.AddLinkType(id,parent,index:DWORD;Caption:String):PBPLinkTypes;
Var tmpPtr:PBPLinkTypes;
    i:Integer;
 begin
  {}
  tmpPtr:=nil;
  for i:=0 to FLTTree.count-1 do
  if PBPLinkTypes(FLTTree[i])^.dwLinkindex=index then  begin tmpPtr:=PBPLinkTypes(FLTTree[i]); result:=tmpPtr;break;end;
  if (tmpPtr=nil) then
    begin
      tmpPtr:=PBPLinkTypes(AllocMem(sizeof(TBPLinkTypes)));
      tmpPtr^.dwLinkIndex:=index;
      tmpPtr^.dwID:=id;
      tmpPtr^.dwParent:=Parent;
      result:=tmpPtr;
      if index and $8000=$8000 then
      begin
      tmpPtr^.dwPenStyle:=psDot;
      tmpPtr^.dwColor:=clDkGray;
      end
      else
      begin
      tmpPtr^.dwPenStyle:=psSolid;
      tmpPtr^.dwColor:=clBlack;
      end;
      tmpPtr^.dbShowLinkType:=True;
      FLTTree.add(tmpPtr);
      inc(FHeader.dwLinksTypesCount);
    end;
      tmpPtr^.ssCaption:=Caption;

 end;
 procedure   TBPList.RecreateNodesAndLinks;
 Var nodeP,oldNodeP:PBPDNode;
     nodeW:PBPNode;
     linkP,oldLinkP:PBPDLink;
     linkW:PBPLink;
     i:Integer;
  begin
   { Create FNodes and FLinks from FWNodes and FWLinks }
    if (FWNodes=nil) and (FWLinks=nil) then Exit;
    if (FNodes<>nil) then ClearNodes;
    if (FLinks<>nil) then ClearLinks;
    OldNodeP:=nil;
    OldLinkP:=nil;
    for i:=0 to (FWNodes.Count-1) do
     begin
    nodeW:=PBPNode(FWNodes[i]);
       nodeP:=PBPDNode(AllocMem(sizeof(TBPDNode)));
       nodeP^.ssCaption:=nodeW^.ssCaption;
       nodeP^.dwNodeNumber:=nodeW^.dwNodeNumber;
       nodeP^.ssNodeNumber:=nodeW^.ssNodeNumber;
       nodeP^.fABCValue:=NodeW^.fABCValue;
       nodeP^.dwNodeIndex:=NodeW^.dwNodeIndex;
       nodeP^.Left[0]:=NodeW^.Left[0];
       nodeP^.Top[0]:=NodeW^.Top[0];
       nodeP^.AcceptPosition[0]:=False;
       nodeP^.Left[1]:=NodeW^.Left[1];
       nodeP^.Top[1]:=NodeW^.Top[1];
       nodeP^.AcceptPosition[1]:=False;
       nodeP^.ssComment:=nodeW^.ssComment;
       FNodes.add(NodeP);
     end;
    for i:=0 to (FWLinks.Count-1) do
     begin
        linkW:=PBPLink(FWLinks[i]);
       linkP:=PBPDLink(AllocMem(sizeof(TBPDLink)));
       linkP^.ssFromCaption:=linkW^.ssFromCaption;
       linkP^.ssToCaption:=linkW^.ssToCaption;
       linkP^.ssUnMovedFrom:=linkW^.ssUnMovedFrom;
       linkP^.ssUnMovedTo:=linkW^.ssUnMovedTo;

       linkP^.ssGlobalCaption:=linkW^.ssGlobalCaption;
       linkP^.dwFromNodeNumber:=linkW^.dwFromNodeNumber;
       linkP^.dwToNodeNumber:=linkW^.dwToNodeNumber;
       linkP^.dwFlags:=linkW^.dwFlags;
       linkP^.dwFromLinkNumber:=linkW^.dwFromLinkNumber;
       linkP^.dwToLinkNumber:=linkW^.dwToLinkNumber;
       linkP^.dwLinkIndex:=linkW^.dwLinkIndex;
       linkP^.FromLeft[0]:=linkW^.FromLeft[0];
       linkP^.FromTop[0]:=linkW^.FromTop[0];
       linkP^.FromAcceptPosition[0]:=False;
       linkP^.ToLeft[0]:=linkW^.ToLeft[0];
       linkP^.ToTop[0]:=linkW^.ToTop[0];
       linkP^.ToAcceptPosition[0]:=False;
       linkP^.FromLeft[1]:=linkW^.FromLeft[1];
       linkP^.FromTop[1]:=linkW^.FromTop[1];
       linkP^.FromAcceptPosition[1]:=False;
       linkP^.ToLeft[1]:=linkW^.ToLeft[1];
       linkP^.ToTop[1]:=linkW^.ToTop[1];
       linkP^.ToAcceptPosition[1]:=False;
       linkP^.IP_SRC:=linkW^.IP_SRC;
       linkP^.IP_DST:=linkW^.IP_DST;
       linkP^.DNodeAcceptPosition:=False;
       linkP^.ssFromPath:=linkW^.ssFromPath;
       linkP^.ssToPath:=linkW^.ssToPath;
       FLinks.add(LinkP);
     end;
  end;

 procedure   TBPList.Copy;
 Var nodeP:PBPDNode;
     nodeW:PBPNode;
     linkP:PBPDLink;
     linkW:PBPLink;
     i,j:Integer;
  begin
  if FWNodes=nil then exit;
   { Create FWNodes and FWLinks from FNodes and FLinks }
   for i:=0 to FWNodes.Count-1 do
    FreeMem(PBPNode(FWNodes[i]));
    FWNodes.clear;
   for i:=0 to FWLinks.Count-1 do
    FreeMem(PBPLink(FWLinks[i]));
    FWLinks.clear;
    for i:=0 to (FNodes.Count-1) do
     begin
     NodeP:=PBPDNode(FNodes[i]);
     nodeW:=PBPNode(AllocMem(Sizeof(TBPNode)));
      nodeW^.ssCaption:=nodeP^.ssCaption;
      nodeW^.dwNodeNumber:=nodeP^.dwNodeNumber;
      nodeW^.ssNodeNumber:=nodeP^.ssNodeNumber;
      nodeW^.fABCValue:=nodeP^.fABCValue;
      nodeW^.dwNodeIndex:=NodeP^.dwNodeIndex;
      nodeW^.Left[0]:=NodeP^.Left[0];
      nodeW^.Top[0]:=NodeP^.Top[0];
      nodeW^.AcceptPosition[0]:=False;
      nodeW^.Left[1]:=NodeP^.Left[1];
      nodeW^.Top[1]:=NodeP^.Top[1];
      nodeW^.AcceptPosition[1]:=False;
      nodeW^.ssComment:=nodeP^.ssComment;
      for j:=2 to 9 do
      begin
      nodeW^.Left[j]:=0;
      nodeW^.Top[j]:=0;
      nodeW^.AcceptPosition[j]:=False;
      end;
      FWNodes.add(NodeW);
     end;
    for i:=0 to (FLinks.Count-1) do
     begin
     LinkP:=PBPDLink(FLinks[i]);
     LinkW:=PBPLink(AllocMem(Sizeof(TBPLink)));
      linkW^.ssFromCaption:=linkP^.ssFromCaption;
      linkW^.ssToCaption:=linkP^.ssToCaption;
      linkW^.ssGlobalCaption:=linkP^.ssGlobalCaption;
      linkW^.dwFromNodeNumber:=linkP^.dwFromNodeNumber;
      linkW^.ssUnMovedFrom:=linkP^.ssUnMovedFrom;
      linkW^.ssUnMovedTo:=linkP^.ssUnMovedTo;
      linkW^.dwToNodeNumber:=linkP^.dwToNodeNumber;
      linkW^.dwFlags:=linkP^.dwFlags;
      linkW^.dwFromLinkNumber:=linkP^.dwFromLinkNumber;
      linkW^.dwToLinkNumber:=linkP^.dwToLinkNumber;
      linkW^.dwLinkIndex:=linkP^.dwLinkIndex;
      linkW^.FromLeft[0]:=linkP^.FromLeft[0];
      linkW^.FromTop[0]:=linkP^.FromTop[0];
      linkW^.FromAcceptPosition[0]:=False;
      linkW^.ToLeft[0]:=linkP^.ToLeft[0];
      linkW^.ToTop[0]:=linkP^.ToTop[0];
      linkW^.ToAcceptPosition[0]:=False;
      linkW^.FromLeft[1]:=linkP^.FromLeft[1];
      linkW^.FromTop[1]:=linkP^.FromTop[1];
      linkW^.FromAcceptPosition[1]:=False;
      linkW^.ToLeft[1]:=linkP^.ToLeft[1];
      linkW^.ToTop[1]:=linkP^.ToTop[1];
      linkW^.ToAcceptPosition[1]:=False;
      linkW^.IP_SRC:=linkP^.IP_SRC;
      linkW^.IP_DST:=linkP^.IP_DST;
      linkW^.DNodeAcceptPosition:=False;
      LinkW^.ssFromPath:=LinkP^.ssFromPath;
      LinkW^.ssToPath:=LinkW^.ssToPath;
      for j:=2 to 9 do
      begin
      linkW^.FromLeft[j]:=0;
      linkW^.FromTop[j]:=0;
      linkW^.FromAcceptPosition[j]:=False;
      linkW^.ToLeft[j]:=0;
      linkW^.ToTop[j]:=0;
      linkW^.ToAcceptPosition[j]:=False;
      end;
      FWLinks.add(LinkW);
     end;
  end;

 constructor TBPList.CreateID(AOwner:TComponent;Model,NBP:word);
  begin
   inherited Create(AOwner);
   FFileStream:=TBPFileStream.Create;
   FModel:=Model;
   FNBP:=NBP;
   FNodes:=TList.create;
   FLinks:=TList.create;
   FTree:=TList.create;
   fopcodes:=TList.create;
   FNTTree:=TList.create;
   FLTTree:=TList.create;
   FOpTree:=TList.create;
   FIPNode:=TList.create;
   FHeader.dwNodesTypesCount:=0;
   FHeader.dwLinksTypesCount:=0;
   FHeader.dwOpEntries:=0;
   FEditLevel:=False;
   FLevel:=-1;
   FParentLevel:=-2;
   fNNList:=TIntList.Create;
   fNN2List:=TIntList.Create;
   fIPList:=TIntList.Create;
   fNNresList:=TIntList.Create;
  end;

 destructor  TBPList.Destroy;
 var i:integer;
  begin
   FFileStream.Destroy;
   ClearCurrent;
   ClearAll;

   FTree.free;
   for i:=0 to fopcodes.count-1 do
    freemem(fopcodes[i],sizeof(int64));
   fopcodes.Free;
   FNTTree.free;
   FLTTree.free;
   FOpTree.free;
   fNodes.free;
   FLinks.free;
   FIPNode.free;
   fNNList.Free;
   fNN2List.free;
   fIPList.free;
   fNNresList.free;
   inherited Destroy;
  end;

 procedure   TBPList.SetFileHeader(sModel,sCompany,sAuthor:ShortString;
                                      wDateTime:TDateTime;
                                      wRev:DWORD);
  begin
    FHeader.ssModel:=sModel;
    FHeader.ssCompany:=sCompany;
    FHeader.ssAuthor:=sAuthor;
    FHeader.dfDateTime:=wDateTime;
    FHeader.dwRevision:=wRev;
  end;
procedure   TBPList.AddIPNode(NodeCaption:ShortString;NodeNumber:DWORD;NodeIndex:DWORD;NodeControl,NodeMechanism:string);
Var nodeP:PBPInProcessNode;
               i:Integer;
 begin
      FHeader.dwIPEntries:=FHeader.dwIPEntries+1;
      nodeP:=PBPInProcessNode(AllocMem(sizeof(TBPInProcessNode)));
      FIPNode.add(nodeP);
      nodeP^.dwNodeNumber:=NodeNumber;
      nodeP^.ssCaption:=NodeCaption;
      nodeP^.dwNodeIndex:=NodeIndex;
      nodeP^.ssControl:=NodeControl;
      nodeP^.ssMechanism:=NodeMechanism;
      for i:=0 to 9 do
       begin
        nodeP^.Left[i]:=0;
        nodeP^.Top[i]:=0;
        nodeP^.AcceptPosition[i]:=False;
       end;
      nodeP^.ssComment:='';
      nodeP^.ssPath:='';
 end;
{/@@@}

 procedure   TBPList.StartNewLevel(wDepth,wLevel,wParent,wID:Integer;sLevel,sCaption,sNotes:ShortString;
                           wRev:DWORD;wStatus:TDraftStatus);
 Var tmpTree:PBPTree;
  begin
   if (FEditLevel) then
      begin
        StoreEditingResults(FLevel);
      end;
    tmpTree:=PBPTree(AllocMem(sizeof(TBPTree)));
    FTree.add(tmpTree);
    tmpTree^.dwDataOffset:=0;
    tmpTree^.dwLevel:=wLevel;
    tmpTree^.dwParent:=wParent;
    tmptree^.dwID:=wID;
    if (length(slevel)>0)and(slevel[1]='A') then delete(slevel,1,1);
    tmpTree^.ssLevel:=sLevel;
    tmpTree^.dwDepth:=wDepth;
    tmpTree^.ssCaption:=sCaption;
    tmpTree^.ssNotes:=sNotes;
    tmpTree^.dwRevision:=wRev;
    tmpTree^.dwNodesCount:=0;
    tmpTree^.dwLinksCount:=0;
    if wStatus=[] then
    tmpTree^.dwStatus:=[dsWorking]
    else
    tmpTree^.dwStatus:=wStatus;
    tmpTree^.dwPageNumber:=0;
    tmpTree^.dwNodesMemRequired:=0;
    tmpTree^.dwLinksMemRequired:=0;
    tmpTree^.lpNodes:=TList.create;
    tmpTree^.lpLinks:=TList.create;
    FWNodes:=tmpTree^.lpNodes;
    FWLinks:=tmpTree^.lpLinks;
    FEditLevel:=True;
    FLevel:=wLevel;
    FParentLevel:=wParent;
    ClearCurrent;
  end;

 function    TBPList.SetCurrentLevel(wLevel:Integer):Boolean;
 Var tmpTree:PBPTree;
     flag:Boolean;
     i:integer;
  begin
    Result:=False;
    if (FEditLevel) then
      begin
        StoreEditingResults(FLevel);
      end;
    Flag:=True;
    for i:=0 to Ftree.count-1 do
     begin
     tmpTree:=PBPTree(FTree[i]);
      if (tmpTree^.dwLevel=wLevel) then
       begin
        Flag:=False;
        Result:=True;
        { Some action to set current level }
        ClearCurrent; { Clear FNodes,FLinks,FWNodes,FWLinks }
        FWNodes:=tmpTree^.lpNodes;
        FWLinks:=tmpTree^.lpLinks;
        FNodesCount:=tmpTree^.lpNodes.Count;
        FLinksCount:=tmpTree^.lpLinks.Count;
        FParentLevel:=tmpTree^.dwParent;
        RecreateNodesAndLinks; { Create FNodes and FLinks from FWNodes and FWLinks}
        FEditLevel:=True; { Set editing level to True }
        FLevel:=wLevel;
        break;
       end;
     end;
  end;

 procedure   TBPList.ClearAll; { Clear all tree structure }
 Var treeP:PBPTree;
    i,j:integer;
  begin
    if (FEditLevel) then
      begin
        StoreEditingResults(FLevel);
      end;
        for i:=0 to FTree.count-1 do
         begin
         TreeP:=PBPTree(FTree[i]);
          for j:=0 to treeP^.lpNodes.count-1 do
           FreeMem(PBPDNode(treeP^.lpNodes[j]));
           treeP^.lpnodes.add(nil);
          treeP^.lpNodes.clear;
          treeP^.lpNodes.free;
          for j:=0 to treeP^.lpLinks.count-1 do
           FreeMem(PBPDLink(treeP^.lpLinks[j]));
          treeP^.lpLinks.clear;
          treeP^.lpLinks.free;
          FreeMem(treeP);
         end;
    FTree.clear;
    for i:=0 to fopcodes.count-1 do
    freemem(fopcodes[i],sizeof(int64));
    fopcodes.clear;
    FLevel:=-1;
    FEditLevel:=False;
    clearlinkstypes;
    ClearNodesTypes;
    ClearOperationTree;
    ClearIPNode;
  end;

 { Clear nodes & links lists }
 procedure   TBPList.ClearCurrent;
 Var i:integer;
  begin
  for i:=0 to FNodes.count-1 do
   FreeMem(PBPDNode(FNodes[i]));
        FNodesCount:=0;
        FNodes.Clear;
  for i:=0 to FLinks.count-1 do
   FreeMem(PBPDLink(FLinks[i]));
        FLinksCount:=0;
        FLinks.Clear;
end;

 { Add a node }

 procedure   TBPList.AddNode(NodeCaption:ShortString;NodeNumber:DWORD;
NodeNumberCaption:TVeryShortString;ABCValue:Double;NodeIndex:DWORD;Comment:ShortString);
 Var nodeP:PBPDNode;
  begin
       nodeP:=PBPDNode(AllocMem(sizeof(TBPDNode)));
       nodeP^.ssCaption:=NodeCaption;
       nodeP^.dwNodeNumber:=NodeNumber;
       nodeP^.ssNodeNumber:=NodeNumberCaption;
       nodeP^.fABCValue:=ABCValue;
       nodeP^.dwFlags:=NodeIndex and $1000;
       if nodeP^.dwFlags and $1000=$1000 then
        nodeP^.ssCaption:='<* '+nodeP^.ssCaption+' *>';
       nodeP^.dwNodeIndex:=NodeIndex and $FFF;
       nodeP^.ssComment:=Comment;
{       if nodeP^.ssNodeNumber='' then
          nodeP^.ssNodeNumber:='A'+TVeryShortString(IntToStr(NodeNumber));}
       if (pos('A',nodeP^.ssNodeNUMBER)=0) then nodeP^.ssNodeNumber:='A'+nodeP^.ssNodeNumber;
       FNodes.add(nodeP);
       inc(FNodesCount);
  end;

 { Add a link }

 procedure   TBPList.IntAddLink(UMFrom,UMTo,LinkFromCaption,LinkToCaption:ShortString;LinkGlobalCaption:TVeryShortString;
                                FromNode,ToNode:DWORD;
                                FromIP,ToIP:DWORD;
                                Flags:DWORD;
                                FromNumber,ToNumber:int64;
                                LinkIndex:DWORD;
                                FromPath,ToPath:ShortString); { Add Link }
 Var linkP:PBPDLink;
     i:integer;
  begin
      linkP:=PBPDLink(AllocMem(sizeof(TBPDLink)));
      if (FromIP=0)and(ToIP>0)and(LinkFromCaption='') then
       LinkFromCaption:=LinkToCaption;
      if (FromIP>0)and(ToIP=0)and(LinkToCaption='') then
       LinkToCaption:=LinkFromCaption;
      if FromIP=0 then
      linkP^.ssFromCaption:=LinkFromCaption
      else
      begin
      LinkP^.ssFromCaption:='';
      end;
      if ToIP=0 then
      linkP^.ssToCaption:=LinkToCaption
      else
      LinkP^.ssToCaption:='';
      linkP^.ssUnMovedFrom:=UMFrom;
      linkP^.ssUnMovedTo:=UMTo;
      linkP^.ssGlobalCaption:=LinkGlobalCaption;
      linkP^.dwFromNodeNumber:=FromNode;
      linkP^.dwToNodeNumber:=ToNode;
      linkP^.dwFlags:=Flags;
      linkP^.dwLinkIndex:=LinkIndex;
      linkP^.ssFromPath:=FromPath;
      linkP^.ssToPath:=ToPath;
      if ((FromNode and BPGlobalMask)<>0) then
       begin
         linkP^.dwFlags:=linkP^.dwFlags and BP_FROMMASK_INVERT;
         case (FromNode and BPGlobalMask) of
           BPGlobalNodeLeft:  linkP^.dwFlags:=linkP^.dwFlags or BP_FROMNODE_RIGHT;
           BPGlobalNodeRight: linkP^.dwFlags:=linkP^.dwFlags or BP_FROMNODE_LEFT;
           BPGlobalNodeTop:   linkP^.dwFlags:=linkP^.dwFlags or BP_FROMNODE_BOTTOM;
           BPGlobalNodeBottom:linkP^.dwFlags:=linkP^.dwFlags or BP_FROMNODE_TOP;
           BPGlobalNodeOperation: linkP^.dwFlags:=linkP^.dwFlags or BP_FROMNODE_TOP;
//           BPGlobalNodeInProcess:  linkP^.dwFlags:=linkP^.dwFlags or BP_FROMNODE_RIGHT;
         end;
       end;
      if ((ToNode and BPGlobalMask)<>0) then
       begin
         linkP^.dwFlags:=linkP^.dwFlags and BP_TOMASK_INVERT;
         case (ToNode and BPGlobalMask) of
           BPGlobalNodeLeft:  linkP^.dwFlags:=linkP^.dwFlags or BP_TONODE_RIGHT;
           BPGlobalNodeRight: linkP^.dwFlags:=linkP^.dwFlags or BP_TONODE_LEFT;
           BPGlobalNodeTop:   linkP^.dwFlags:=linkP^.dwFlags or BP_TONODE_BOTTOM;
           BPGlobalNodeBottom:linkP^.dwFlags:=linkP^.dwFlags or BP_TONODE_TOP;
           BPGlobalNodeOperation: linkP^.dwFlags:=linkP^.dwFlags or BP_TONODE_TOP;
//           BPGlobalNodeInProcess: linkP^.dwFlags:=linkP^.dwFlags or BP_TONODE_LEFT;
         end;
       end;
      linkP^.dwFromLinkNumber:=GetNN(FromNumber,fromIP);
      linkP^.dwToLinkNumber:=GetNN(ToNumber,toIP);
      linkP^.IP_SRC:=fromIP{ and $FFFF};
      linkP^.IP_DST:=toIP{ and $ffff};

      i:=flinks.count;
      for i:=0 to flinks.count-1 do
      if (PBPDLink(flinks[i])^.dwFromNodeNumber=linkP^.dwFromNodeNumber)and
         (PBPDLink(flinks[i])^.dwToNodeNumber=linkP^.dwToNodeNumber)and
         (PBPDLink(flinks[i])^.dwFlags=linkP^.dwFlags)and
         (PBPDLink(flinks[i])^.dwFromLinkNumber=linkP^.dwFromLinkNumber)and
         (PBPDLink(flinks[i])^.dwToLinkNumber=linkP^.dwToLinkNumber)and
         (PBPDLink(flinks[i])^.dwLinkIndex=linkP^.dwLinkIndex)
      then
      with PBPDLink(flinks[i])^ do
      begin
      {ssFromCaption:=ssFromCaption+','+linkfromCaption;
      ssToCaption:=ssFromCaption+','+linkToCaption;}
        break;
      end;
      if i>=flinks.count then
      begin
      FLinks.add(linkP);
      inc(FLinksCount);
      end
      else freemem(linkP);
  end;

 { Save results to file }
 procedure   TBPList.SaveToFile(FileName:String;mask:word);
  begin
    {}
    if (FEditLevel) then
      begin
        StoreEditingResults(FLevel);
      end;
    RenameLinksNumbers; { Rename links numbers }
    FFileStream.OpenStream(FileName,stWrite);
    FFileStream.WriteBP(FHeader,FTree,FNTTree,FLTTree,FOPTree,FIPNode,FModel,FNBP,mask);
    FFileStream.CloseStream;
    WriteTree(FTree,FIPNode,FOpTree,FLTTRee,FNTTree,fonsavelevel);
  end;


 procedure   TBPList.AddLink(UMFrom,UMto,LinkFromCaption,LinkToCaption:ShortString;LinkGlobalCaption:TVeryShortString;
                              FromNode,ToNode:DWORD;
                              FromIP,ToIP:DWORD;
                              FromLinkType,ToLinkType:TLinkType;
                              FromNumber,ToNumber:int64;LinkIndex:DWORD;usedFROM,usedTO:boolean;
                              FromPath,ToPath:ShortString);
  Var Flags:DWORD;
  begin
  case fromNode and BPGlobalMask of
  0:LinkGlobalCaption:='';
       BPGlobalLeftNodeNumber:LinkGlobalCaption:='I';
       BPGlobalRightNodeNumber:LinkGlobalCaption:='E!';
       BPGlobalTopNodeNumber:LinkGlobalCaption:='C';
       BPGlobalBottomNodeNumber:LinkGlobalCaption:='M';
       BPGlobalNodeOperation:LinkGlobalCaption:='';
   end;
  case toNode and BPGlobalMask of
  0:;
       BPGlobalLeftNodeNumber:LinkGlobalCaption:='E!';
       BPGlobalRightNodeNumber:LinkGlobalCaption:='O';
       BPGlobalTopNodeNumber:LinkGlobalCaption:='E!';
       BPGlobalBottomNodeNumber:LinkGlobalCaption:='E!';
       BPGlobalNodeOperation:LinkGlobalCaption:='';
   end;

    Flags:=0;
    case FromLinkType of
     lt_Left:  Flags:=BP_FROMNODE_LEFT;
     lt_Right: Flags:=BP_FROMNODE_RIGHT;
     lt_Top:   Flags:=BP_FROMNODE_TOP;
     lt_Bottom:Flags:=BP_FROMNODE_BOTTOM;
    end;
    case ToLinkType of
     lt_Left:  Flags:=Flags or BP_TONODE_LEFT;
     lt_Right: Flags:=Flags or BP_TONODE_RIGHT;
     lt_Top:   Flags:=Flags or BP_TONODE_TOP;
     lt_Bottom:Flags:=Flags or BP_TONODE_BOTTOM;
    end;
    if Length(LinkFromCaption)>0 then  Flags:=Flags or BP_SHOW_FROMCAPTION;
    if Length(LinkToCaption)>0 then  Flags:=Flags or BP_SHOW_TOCAPTION;
    if Length(LinkGlobalCaption)>0 then  Flags:=Flags or BP_SHOW_GLOBALCAPTION;
{    else
     begin
      if (((FromNode and BPGlobalMask)<>0) or
         ((ToNode and BPGlobalMask)<>0)) and
         (FLevel<>-1) then
          Flags:=Flags or BP_NOTUSED_NOW;
     end;}
    if not usedFROM then
    FLAGS:=flags or BP_NOTUSED_FROM;
    if not usedTO then
    FLAGS:=flags or BP_NOTUSED_TO;
//    FLAGS:=flags or BP_DATALINK_DOCUMENT;
    if Length(FromPath)>0 then Flags:=Flags or BP_HAS_FROMPATH;
    if Length(ToPath)>0 then Flags:=Flags or BP_HAS_TOPATH; 

    IntAddLink(UMFrom,UMTo,LinkFromCaption,LinkToCaption,LinkGlobalCaption,FromNode,ToNode,FromIP,ToIP,
            Flags,FromNumber,ToNumber,LinkIndex,FromPath,ToPath);
  end;

function TBPList.addnextopcode(opcode:int64):DWORD;
var i,j:integer;
    newcode:^int64;
begin
i:=-1;
for j:=0 to fopcodes.Count-1 do
if Int64(fopcodes[j]^)=opcode then
 begin
 i:=j;
 break;
 end;
if i>=0 then result:=i+1
        else
        begin
        getmem(newcode,sizeof(int64));
        newcode^:=opcode;
        result:=fopcodes.add(newcode)+1;
        end;
end;
procedure   TBPList.LoadSettingsFromFile(FileName:String);
begin
    FFileStream.OpenStream(FileName,stRead);
    try
    FFileStream.ReadBP(FHeader,FNTTree,FLTTree,FTree);
    finally
    FFileStream.CloseStream;
    end;
end;
procedure   TBPList.updateSettingstable(Config:TDataSet);
var i:integer;
    lt:PBPLinkTypes;
    nt:PBPNodeTypes;
begin
Config.Open;
for i:=0 to FNTTree.Count-1 do
begin
nt:=PBPNodeTypes(FNTTree[i]);
if not Config.Locate('ID;Type',vararrayof([nt^.dwID,0]),[]) then
begin
config.Append;
config.FieldByName('ID').asInteger:=nt^.dwID;
config.FieldByName('Type').asInteger:=0;
end
else Config.edit;
config.FieldByName('FontColor').asInteger:=nt^.dwFontColor;
config.FieldByName('BackColor').asInteger:=nt^.dwPaintColor;
config.FieldByName('LineColor').asInteger:=nt^.dwDrawColor;
config.FieldByName('ShadowColor').asInteger:=nt^.dwShadowColor;
config.FieldByName('ShadowType').asInteger:=Integer(nt^.dwShadowStyle);
config.FieldByName('LineType').asInteger:=Integer(nt^.dwRectStyle);
config.post;
end;

for i:=0 to FLTTree.Count-1 do
begin
lt:=PBPLinkTypes(FLTTree[i]);
if not Config.Locate('ID;Type',vararrayof([lt^.dwID,1]),[]) then
begin
config.Append;
config.FieldByName('ID').asInteger:=lt^.dwID;
config.FieldByName('Type').asInteger:=1;
end
else Config.edit;
config.FieldByName('LineColor').asInteger:=lt^.dwColor;
config.FieldByName('LineType').asInteger:=Integer(lt^.dwPenStyle);
config.post;
end;
Config.Close;
end;
procedure   TBPList.LoadSettingsFromTable(Config:TDataSet);
var i:integer;
    lt:PBPLinkTypes;
    nt:PBPNodeTypes;
begin
config.Open;
for i:=0 to FNTTree.Count-1 do
begin
nt:=PBPNodeTypes(FNTTree[i]);
if  Config.Locate('ID;Type',vararrayof([nt^.dwID,0]),[]) then
begin
nt^.dwFontColor:=config.FieldByName('FontColor').asInteger;
nt^.dwPaintColor:=config.FieldByName('BackColor').asInteger;
if nt^.dwPaintColor=clNone then
 nt^.dwPaintColor:=clWhite;
nt^.dwDrawColor:=config.FieldByName('LineColor').asInteger;
nt^.dwShadowColor:=config.FieldByName('ShadowColor').asInteger;
nt^.dwShadowStyle:=config.FieldByName('ShadowType').asInteger;
nt^.dwRectStyle:=config.FieldByName('LineType').asInteger;
if nt^.dwID=$FFFF then nt^.dwShadowStyle:=0;
end;
end;
for i:=0 to FLTTree.Count-1 do
begin
lt:=PBPLinkTypes(FLTTree[i]);
if Config.Locate('ID;Type',vararrayof([lt^.dwID,1]),[]) then
begin
lt^.dwColor:=config.FieldByName('LineColor').asInteger;
lt^.dwPenStyle:=TPenstyle(config.FieldByName('LineType').asInteger);
end;
end;
config.Close;
end;
function TBPList.getNN(linkNum:int64;IPNum:integer):integer;
var i:integer;
    ll,lh:integer;
begin
ll:=LinkNum and $FFFFFFFF;
lh:=(linkNum shr 32)and $FFFFFFFF;
for i:=0 to fNNList.count-1 do
if (fNNList[i]=ll)and(fNN2List[i]=lh)and(fIPList[i]=IPNum) then
begin
 result:=i+1;
 exit;
end;
fNNList.add(ll);
fNN2List.add(lh);
fIPList.add(IPNum);
result:=fNNList.count;
end;
procedure Register;
begin
  RegisterComponents('DeadSouls', [TBPList]);
end;

end.

