unit ExcelTemplateReport;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface
uses ExcelBands,Classes,Types,DB,ExcelRpt,items,inifiles,gauges;
type
TExcelTemplateReport=class;
TExcelTemplateSheet=class
private
 fowner:TExcelTemplateReport;
  fRowStructure:TOMItems;
  fBands:TEXLReportBands;
  fResultSheet,fTemplateSheet:TExcelSheet;
  fTitleRect,fFooterRect:array[1..64] of TRect;
  fFooter:TRect;
  ftitlecount,fblockcount:integer;
  fcurrentTitle,foldtitle:integer;
  fPageBreaks:array[1..64] of integer;
  BreakCount:integer;
  fRow:integer;
  fExcelRow:integer;
  nCols:integer;
  fRowTemplate:array[1..64] of TRect;
  RowStart,rowEnd,newstart,lastStart,constStart,rowlevel:TColArray;
  CellConst:Array[1..256] of String;
  levelIntersects:array[1..64,1..10,1..10] of boolean;
  sublevelIntersects:array[0..16,0..16] of boolean;
  sublevelColumns:array[0..16] of TColArray;
  levelcolumns:array[1..64,1..10] of TColArray;

  aFitStart,aFitEnd:integer;
  fusedCols,fcurcols:TColSet;
  fusedBands:TList;
  lastBandStart:integer;
  fOldBands:array[1..10] of TEXLReportBand;
  fBandLevel:integer;
  fOldBand:TEXLReportBand;
protected
  procedure SetBorders(index:integer;Row:integer;startCol,endCol:integer);
  procedure PrepareAutoFit(row:integer);
  procedure MakeAutoFit;
  procedure DrawTemplate(Band:TEXLReportBand;row:integer);
  Function FillBands:integer;
  Function FillBandsNew:integer;
  procedure PushOldBand;
  procedure PopOldBand;
  procedure OutPutTitle(var startRow:integer;title:TRect);
  function OutputRow(isfirst:boolean;pos,level,startRow:integer; var Endrow:integer;var colList:TColArray):boolean;
  procedure OutputLevel(var Band:TEXLReportBand; root,level:integer;var colList:TColArray;start_row,start_row2:integer;var end_row:integer);
  procedure CalcInterSection;
  procedure CalcSubInterSection(TableN:integer);
  procedure AppendEmpty(RootBand:TEXLReportBand;endrow:integer);
  property OldBand:TEXLReportBand read fOldBand write foldBand;
public
  constructor Create(Owner:TExcelTemplateReport);
  destructor Destroy;override;
  property Rows:TOMItems read fRowStructure;
  procedure MakeSheet(ResultSheet:TExcelSheet);
end;
 TExcelTemplateReport=class
 private
  fRowDetailSet:TDataSet;
  fReportRows:TOMItems;
  fExcel:TExcelReport;
  fTemplateBook,fResultBook:TExcelBook;
  fTemplateName:string;
  fTitle:string;
  fFileName:string;
  NameConversion:TMemIniFile;
  fProgress:TGauge;
  fSheets:TList;
  fMissedBands,
  ferrorstrings:TStrings;
 protected
  procedure ProcessConstSheet(sheet:TExcelSheet);
  procedure PrepareDataSheet(TemplateSheet:TExcelSheet);
  function getSheet(i:integer):TExcelTemplateSheet;
 public
  constructor Create(progress:TGauge);
  destructor Destroy;override;
  function TranslateField(FieldName:string):string;
  procedure MakeReport;
  property Rows:TOMItems read fReportRows write fReportRows;
  property RowData:TDataSet read fRowDetailSet write fRowDetailSet;
  property TempLate:string read fTemplateName write fTemplateName;
  property Title:string read ftitle write fTitle;
  property FileName:string read ffilename write ffilename;
  property Sheets[index:integer]:TExcelTemplateSheet read getSheet;
  function SheetCount:integer;
 end;
implementation
uses sysutils, utils, fileutil, appconst,xlserrors, itUtils,logs,variants,dialogs;
constructor TExcelTemplateReport.Create(progress:TGauge);
begin
inherited Create;
fprogress:=progress;
fexcel:=TexcelReport.Create(false);
fexcel.Progress:=fProgress;
ferrorstrings:=TStringList.create;
fMissedBands:=TStringList.Create;
fsheets:=TList.Create;
end;
destructor TExcelTemplateReport.Destroy;
var i:integer;
begin
fexcel.ScreenUpdating:=true;
 fexcel.Free;
 ferrorstrings.free;
 fMissedBands.Free;
 for i:=0 to fsheets.Count-1 do
  TExcelTemplateSheet(fsheets[i]).free;
 fsheets.Free;
 inherited Destroy;
end;
constructor TExcelTemplateSheet.Create(owner:TExcelTemplateReport);
begin
inherited Create;
fowner:=owner;
fBands:=TEXLReportBands.Create(owner.TranslateField);
fRowStructure:=TOMItems.Create;
end;
destructor TExcelTemplateSheet.Destroy;
begin
 fBands.Free;
 fRowStructure.free;
 inherited Destroy;
end;

function TExcelTemplateSheet.FillBands:integer;
var i,j,p:integer;
    startcolumn:integer;
    cell:string;
    bandName:string;
    bandLevel:integer;
    FieldName:string;
    curBand:TExlReportBand;
    curBandLevel:TEXLReportBandLevel;
    currenttop,currentbottom:integer;
    curblockname:string;
    curblock:integer;
    emptyRow:boolean;
    nRows:integer;
    MRect:TRect;
begin
fblockCount:=0;
 for i:=1 to 64 do
 begin
 ftitlerect[i]:=rect(-1,-1,-1,-1);
 ffooterrect[i]:=rect(-1,-1,-1,-1);
 end;
 ffooter:=rect(-1,-1,-1,-1);
 i:=1;
 nCols:=Col2Number(fTemplateSheet.CellValue(1,1));

  if nCols=-1 then
  begin
   result:=FillBandsNew;
   exit;
  end;
logs.startproc('Excel','ExcelTemplateReport','FillBands','',5);
 NRows:=strTointDef(fTemplateSheet.CellValue(1,2),-1);
 if (NRows<=0)or(NCols<=0) then exit;
   currenttop:=1;
   currentbottom:=NRows+1;
 startcolumn:=2;

 repeat
 fTitleRect[i].top:=currenttop+i-ftitlecount;
 fTitleRect[i].Left:=1;
 fTitleRect[i].Right:=Col2Number(fTemplateSheet.CellValue(1,startcolumn+1));
 fTitleRect[i].Bottom:=strTointDef(fTemplateSheet.CellValue(1,startcolumn+2),2);

 fFooterRect[i].Left:=1;
 fFooterRect[i].Top:=currentbottom;
 fFooterRect[i].Right:=Col2Number(fTemplateSheet.CellValue(1,startcolumn+3));
 fFooterRect[i].Bottom:=strTointDef(fTemplateSheet.CellValue(1,startcolumn+4),fFooterRect[i].Top);
 if fFooterRect[i].Bottom<currentBottom then fFooterRect[i].Bottom:=CurrentBottom;
 currentBottom:=fFooterRect[i].Bottom+1;
 if i>ftitlecount then
 begin
 for j:=ftitlecount+1 to i-1 do
 begin
 frowtemplate[j]:=Rect(1,currenttop+j-ftitlecount,ncols,currenttop+j-ftitlecount);
 fTemplateSheet.WrapText:=false;
 fTemplateSheet.HorizontalAlignment:=xlHAlignLeft;
// fTemplateSheet.indent:=0;
 ftemplateSheet.FormatRange(fRowTemplate[j].Top,fRowTemplate[j].Left,fRowTemplate[j].Bottom,fRowTemplate[j].Right,frWrapText);
 fFooterRect[j]:=Rect(-1,-1,-1,-1);
 fTitleRect[j]:=Rect(-1,-1,-1,-1);
 end;
 ftitlecount:=i;
 end;
 frowtemplate[i]:=Rect(1,fTitleRect[ftitlecount].Bottom+1,ncols,fTitleRect[ftitlecount].Bottom+1);
fTemplateSheet.WrapText:=false;
 fTemplateSheet.HorizontalAlignment:=xlHAlignLeft;
// fTemplateSheet.indent:=0;
 ftemplateSheet.FormatRange(fRowTemplate[i].Top,fRowTemplate[i].Left,fRowTemplate[i].Bottom,fRowTemplate[i].Right,frWrapText);
  currenttop:=fTitleRect[i].Bottom+1;
 i:=strTointDef(fTemplateSheet.CellValue(1,startcolumn+5),0);
 startcolumn:=startcolumn+5;

 until i=0;
 result:=0;
 if (NRows<=0)or(NCols<=0) then exit;

 for i:=fTitleRect[ftitlecount].Bottom+2 to NRows do
 begin
 emptyrow:=true;
 fTemplateSheet.setTextWrap(i,1,1,ncols,false);
  for j:=1 to nCols do
  begin
  cell:=ClearSpaces(fTemplateSheet.CellValue(i,j));
//  mrect:=fexcel.Sheet[1].getMergeArea(i,j);
  if cell='' then continue;
  emptyrow:=false;
  BandName:=copy(cell,1,pos('.',cell)-1);
  p:=pos(':',BandName);
  if p>0 then
  begin
  BandLevel:=strToIntDef(Copy(BandName,p+1,length(Bandname)),1);
  BandName:=copy(bandName,1,p-1);
  end
  else
  BandLevel:=0;
  if pos('_',BandName)=0 then
  curblockname:=BandName
  else
  curblockname:=copy(bandname,1,pos('_',bandname)-1);

  curblock:=strtointdef(copy(curblockName,2,length(curblockName)),1);
  if fblockcount<curblock then fblockcount:=curblock;
  FieldName:=ClearSpaces(copy(cell,pos('.',cell)+1,length(cell)));
  curBand:=fBands.ensureBandExists(BandName);
  curBandLevel:=curBand.EnsureLevelExists(BandLevel);
  MRect:=fTemplateSheet.MergeRectangle(i,j);
  curBandLevel.GetVariantByRow(i).AddCell(MRect.Left,MRect.Right,FieldName);
  end;
  if emptyrow then
  begin
  inc(ftitlecount);
  frowtemplate[ftitlecount]:=Rect(1,i,ncols,i);
  fTitleRect[ftitleCount]:=Rect(-1,-1,-1,-1);
  fFooterRect[ftitleCount]:=Rect(-1,-1,-1,-1);
  end;
 end;
 result:=fBands.Count;
end;
procedure TExcelTemplateSheet.OutputLevel(var Band:TEXLReportBand;root,level:integer;var colList:TColArray;start_row,start_row2:integer;var end_row:integer);
var i,j,k,pos:integer;
    curpRow,curpend:integer;
    lastrow,lrCand:integer;
    isfirst:boolean;
    cf:array[1..256] of boolean;
    clevel:integer;
    lasType:smallInt;
    oldBand,subBand:TEXLReportBand;

begin
if root=0 then exit;
if Band=nil then exit;
logs.startproc('Excel','ExcelTemplateReport','Outputlevel',inttostr(root)+'>'+Band.Name,8);
isfirst:=true;
curprow:=start_row;
end_row:=start_row;
lastrow:=start_row;
curpend:=lastrow;
pos:=root;
clevel:=frowStructure[pos].WParam;
lastype:=-1;
if isfirst then
 for i:=1 to NCols do
 if levelcolumns[frowStructure[pos].interval,clevel,i]=1 then
 begin
 cf[i]:=true;
if Band.MergedCols.indexof(i)=-1 then
  if (rowstart[i]>0)and(start_row-rowstart[i]>2)and(rowend[i]>rowstart[i]) then
    fResultSheet.MergeAllCells(rowstart[i],i,rowend[i],i);
 end;
pusholdband;
try
while pos>0 do
begin
if frowstructure[pos].deleted=0 then
begin
if not isfirst and (frowStructure[pos].itype<>lasType) then
  AppendEmpty(Band,lastRow-1);
lasType:=frowStructure[pos].itype;

clevel:=frowStructure[pos].WParam;
if isfirst then
begin
  if (levelIntersects[frowStructure[pos].interval,level,clevel]){or(clevel=1)} then
   curprow:=start_row2
   else
   curprow:=start_row;
end;
if (clevel=1)and(frowStructure[pos].interval<>fcurrenttitle)and(ftitlecount>1) then
begin
isfirst:=true;
for i:=1 to NCols do Rowend[i]:=curprow-1;

for i:=1 to NCols do
if Band.MergedCols.indexof(i)=-1 then
  if {(levelcolumns[1,i]=1)and}(rowstart[i]<rowend[i])and(rowstart[i]>0) then
  fResultSheet.MergeAllCells(rowstart[i],i,rowend[i],i);
OutputTitle(curprow,fFooterRect[fcurrentTitle]);
foldtitle:=fcurrentTitle;
fcurrenttitle:=frowstructure[pos].interval;
OutPutTitle(curprow,FTitleRect[fcurrenttitle]);

for i:=1 to NCols do
begin
Rowend[i]:=-1;
if rowstart[i]>0 then
laststart[i]:=rowstart[i];
 rowstart[i]:=-1;
 end;
start_row:=curprow;
start_row2:=curprow;
end;
if (clevel=1) and ((Band=nil)or(Band.Name<>'*'+inttostr(frowStructure[pos].interval))) then
begin
oldBand:=Band;
Band:=fbands.ensureBandExists('*'+inttostr(frowStructure[pos].interval));
if (Band=nil)and(fowner.fMissedBands.IndexOf('*'+inttostr(frowStructure[pos].interval))=-1) then
fowner.fMissedBands.add('*'+inttostr(frowStructure[pos].interval));
//CalcSubInterSection(Band.Part);
if (FTitleRect[frowstructure[pos].interval].Left=-1)and not fusedCols.intersectList(Band.UsedCols) then
begin
curprow:=lastBandStart;
curPend:=lastBandStart;
start_row:=curprow;
start_row2:=curprow;
fusedcols.AppendList(Band.UsedCols);
fusedBands.Add(Band);
end
else
begin
{for i:=1 to NCols do Rowend[i]:=end_row;
 for i:=1 to NCols do
  if (laststart[i]<rowend[i])and(laststart[i]>0) then
  begin
   setBorders(fcurrenttitle,rowend[i],i,i);
  fResultSheet.MergeAllCells(laststart[i],i,rowend[i],i);
  end;}
  for i:=0 to fusedBands.count-1 do
  begin
  oldBand:=TEXLReportBand(fusedBands[i]);
while oldBand<>nil do
begin
 AppendEmpty(oldBand,end_row);
 oldBand:=oldBand.Parent;
end;
end;
fusedcols.Clear;
fusedBands.clear;
fusedcols.AppendList(Band.UsedCols);
fusedBands.add(Band);
lastBandStart:=curpRow;
end;
end;
foldtitle:=fcurrenttitle;
if fExcelRow<curProw then
begin
 DrawTemplate(Band,curpRow);
 fExcelRow:=curProw;
end;
CurPend:=curProw;
 if fowner.fprogress<>nil then
 begin
  fowner.fprogress.Progress:=pos;
 end;
if not OutPutRow(isfirst,pos,clevel,curPRow,CurPend,collist) then
begin
dec(CurPend);
end
 else
 begin
  isfirst:=false;
if band<>nil then
for j:=0 to Band.Columns.Count-1 do
begin
i:=Band.Columns[j];
if (newstart[i]>0) then
begin
if Band.MergedCols.indexof(i)=-1 then
 if (rowstart[i]>0)and(rowstart[i]<rowend[i]) then
 fResultSheet.MergeAllCells(rowstart[i],i,rowend[i],i);
 if rowstart[i]>0 then 
 laststart[i]:=rowstart[i];
 rowstart[i]:=newstart[i];
 rowend[i]:=newstart[i];
 newstart[i]:=-1;
end;
end;
 if end_row<curProw then
 end_row:=curProw;
 {for i:=1 to NCols do
 begin
 lok:=false;
 for j:=level to 10 do
  if (levelcolumns[j,i]=1) then begin lok:=true; break; end;
 if lok and(rowend[i]<curprow)and(rowend[i]>0)and(newstart[i]=-1) then
 begin
   if (rowstart[i]>0)and(rowend[i]>0)and(rowend[i]-rowstart[i]>0) then
     fResultSheet.MergeAllCells(rowstart[i],i,rowend[i],i);
  if cf[i] then
  rowstart[i]:=curprow;
  cf[i]:=false;
  rowend[i]:=curprow;
  end;
 end;}
 end;
if frowstructure[pos].firstchild>0 then
begin
 for i:=1 to NCols do if collist[i]>clevel then collist[i]:=0;
 j:=frowstructure[pos].firstchild;
  lrCand:=-1;
 lastRow:=0;
 if levelintersects[frowStructure[pos].interval,clevel,frowstructure[frowstructure[pos].firstchild].WParam] then
 begin
 inc(curpEnd);
 inc(curPRow);
 end;

 while j>0 do
 begin
 if frowstructure[j].firstchild>0 then
 begin
 k:=frowstructure[j].firstchild;
 subBand:=fBands.ensureBandExists('*'+frowstructure[k].s);
 if (subband=nil)and(fowner.fMissedBands.IndexOf('*'+frowstructure[k].s)=-1) then
 fowner.fMissedBands.Add('*'+frowstructure[k].s);
 if (SubBand<>nil) then
 Outputlevel(subBand,k,clevel,collist,curprow,CurPend,lrCand);
 if lrcand>lastrow then lastrow:=lrCand;
 end;
 j:=frowStructure[j].nextitem;
 end;
  if lastrow<curpend then lastrow:=curpend;
  j:=frowstructure[pos].firstchild;
 while j>0 do
 begin
  AppendEmpty(fBands.BandByName('*'+frowstructure[j].s),lastRow);

 j:=frowStructure[j].nextitem;
 end;
 if end_row<lastrow then
 end_row:=lastrow;
 isfirst:=false;
 if not levelintersects[frowStructure[pos].interval,clevel,frowstructure[frowstructure[pos].firstchild].WParam] then
if (Band<>nil)and(curPend<lastrow) then
 for k:=0 to Band.Columns.Count-1 do
  begin
 i:=Band.columns[k];
 if Band.MergedCols.indexof(i)>=0 then continue;
 fResultSheet.Clear(curpend+1,i,lastrow,i,true,false,false);
 for j:=curpend+1 to lastrow do
 begin
 SetBorders(foldTitle,j,i,i);
 end;
     fResultSheet.MergeAllCells(curpend,i,lastrow,i);
 end;
   curprow:=lastrow+1;
   curpend:=lastrow;
end
else
begin
CurPRow:=CurPEnd+1;
end;
LASTROW:=CURPROW;
end;
if end_row<curpend then
end_row:=curpend;
pos:=frowstructure[pos].nextitem;

end;
finally
popoldband;
end;
end;
function TExcelTemplateSheet.OutputRow(isfirst:boolean;pos,level,startRow:integer; var Endrow:integer;var colList:TColArray):boolean;
var i,j,k:integer;
    rd:TRowData;
    curBand:TExlReportBandLevel;
    curVariant:TExlReportBandVariant;
    currentRect:TRect;
    hasany:boolean;
    onerow:boolean;
    s:string;
procedure TerminateChildren(RootBand:TEXLReportBand);
var i,j:integer;
    col:integer;
    band:TEXLReportBand;
begin
for i:=0 to RootBand.ChildrenCount-1 do
begin
band:=RootBand.ChildBands[i];
TerminateChildren(band);
for j:=0 to Band.Columns.Count-1 do
 begin
 col:=Band.columns[j];
 rowstart[col]:=-1;
 end;
end;
end;
procedure TerminateParent(band:TEXLReportBand;row:Integer);
var i,c:integer;
begin
if band=nil then exit;
if Not Band.terminated and fBands.DirectInterSects(Band,curband.Band) then
begin
 for i:=0 to Band.columns.count-1 do
 begin
 c:=Band.columns[i];
 if (rowlevel[c]<=Band.Level)and (curband.Band.Columns.IndexOf(c)=-1) then
 begin
 if rowstart[c]<row then
  RowStart[c]:=row;
  if rowend[c]<row then
  RowEnd[c]:=row;
  newstart[c]:=-1;
 end;
 end;
 Band.terMinated:=true;
end;
TerminateParent(band.Parent,row);
end;
procedure ResetColumns(band:TExlReportBand;reset:boolean);
var i,j:integer;
begin
if reset then
begin
{for i:=0 to Band.Columns.Count-1 do
begin
j:=Band.Columns[i];
fResultSheet.Cells[StartRow,j]:=Band.Name;
end;
inc(Band.currentRow);
}
 for i:=0 to band.Columns.Count-1 do
 begin
 {if rowstart[band.Columns[i]]>0 then
  laststart[band.Columns[i]]:=rowstart[band.Columns[i]];
  rowstart[band.Columns[i]]:=band.CurrentRow;}
  collist[band.Columns[i]]:=band.Level;
 end;
end; 
 for i:=0 to band.childrenCount-1 do
 if not intersect(band.Columns,band.ChildBands[i].Columns) then
  ResetColumns(band.ChildBands[i],true)
  else
  ResetColumns(band.ChildBands[i],reset)
end;
begin
 result:=true;
  logs.startproc('Excel','ExcelTemplateReport','OutputRow',inttostr(pos),5);
 rd:=TRowData.Create;
 hasany:=false;
 EndRow:=StartRow;
 try
 fbands.FillRow(frowstructure[pos].idloaded,fowner.frowDetailSet);
 if fbands.UsedCount=0 then exit;
 result:=false;
 if fBands.TotalRowSpan then exit;
 result:=true;
 for i:=0 to fbands.usedCount-1 do
 begin
 curband:=fbands.UsedBands[i];
 terminateChildren(curband.Band);
 if curband.Band.RowData.isTotalRS then continue;
 curband.Band.CurrentRow:=startRow;
  TerminateParent(curband.Band.Parent,curband.Band.CurrentRow);
 isfirst:=isfirst or (curband.Band<>oldBand);
 oldBand:=curband.Band;
  resetColumns(curband.Band,isfirst);

 curVariant:= curband.FindAppropriateVariant;
 onerow:=curVariant<>nil;
 if (curvariant=nil){and(level=1)} then
 curvariant:=curband.FindNextVariant;
 curBand.Band.terminated:=false;
 while curVariant<>nil do
 begin
 currentRect.Left:=-1;
 currentRect.Right:=-1;
 hasany:=true;
  for j:=0 to curvariant.Count-1 do
 begin
  currentRect.Top:=curvariant.fTempLateRow;
  currentRect.Bottom:=currentRect.Top;
 curvariant.cells[j].CalcDataString(isfirst,curband.Band.CurrentRow);
  for k:=curvariant.Cells[j].fTemplateColStart to curvariant.Cells[j].fTemplateColEnd do
  begin
   curband.Band.ColTerminated[k]:=false;
   rowlevel[k]:=curband.Band.Level;
  end;
 if not curvariant.cells[j].RSFlag then
 begin
  fTemplateSheet.cells[curvariant.Cells[j].fTemplateRow,curvariant.Cells[j].fTemplateColStart]:=curvariant.cells[j].DataString;
  for k:=curvariant.Cells[j].fTemplateColStart to curvariant.Cells[j].fTemplateColEnd do
  newstart[k]:=curband.Band.CurrentRow;
  curband.Band.OldData[curvariant.Cells[j].fTemplateColStart]:=curvariant.cells[j].DataString;
 end
 else
 begin
  if not curband.Band.ColTerminated[curvariant.Cells[j].fTemplateColStart] then
  fTemplateSheet.cells[curvariant.Cells[j].fTemplateRow,curvariant.Cells[j].fTemplateColStart]:=''
  else
  fTemplateSheet.cells[curvariant.Cells[j].fTemplateRow,curvariant.Cells[j].fTemplateColStart]:=curband.Band.OldData[curvariant.Cells[j].fTemplateColStart];
    for k:=curvariant.Cells[j].fTemplateColStart to curvariant.Cells[j].fTemplateColEnd do
  rowend[k]:=curband.Band.CurrentRow;

 end;
 if curvariant.Cells[j].fTemplateColStart>currentRect.Right+1 then
 begin
 if  currentRect.left>0 then
 begin
 fResultSheet.CopyCells(fTemplateSheet,currentrect,Point(currentrect.left,curband.Band.CurrentRow));
 SetBorders(foldtitle,curBand.Band.CurrentRow,CurrentRect.Left,currentRect.Right);
 end;
 currentRect.left:=curvariant.Cells[j].fTemplateColStart;
 currentRect.Right:=curvariant.Cells[j].fTemplateColEnd;

   collist[curvariant.Cells[j].fTemplateColStart]:=level;

 end
 else currentRect.Right:=curvariant.Cells[j].fTemplateColEnd;
 end;
 fResultSheet.CopyCells(fTemplateSheet,currentrect,Point(currentrect.left,curband.Band.CurrentRow));
  SetBorders(foldTitle,curBand.Band.CurrentRow,CurrentRect.Left,currentRect.Right);
for j:=0 to curvariant.Count-1 do
 begin
   if  curvariant.Cells[j].UnionEnabled and curvariant.Cells[j].ConstString  then
 begin
    if (ClearSpaces(curvariant.cells[j].DataString)=cellconst[curvariant.Cells[j].fTemplateColStart]) then
    begin
    fResultSheet.Cells[curband.Band.CurrentRow,curvariant.Cells[j].fTemplateColStart]:='';
    fResultSheet.MergeAllCells(constStart[curvariant.Cells[j].fTemplateColStart],curvariant.Cells[j].fTemplateColStart,curband.Band.CurrentRow,curvariant.Cells[j].fTemplateColEnd);
    end
    else
    begin
    cellconst[curvariant.Cells[j].fTemplateColStart]:=ClearSpaces(curvariant.cells[j].DataString);
    constStart[curvariant.Cells[j].fTemplateColStart]:=curband.Band.CurrentRow;
    end;
    rowstart[curvariant.Cells[j].fTemplateColStart]:=constStart[curvariant.Cells[j].fTemplateColStart];
    rowend[curvariant.Cells[j].fTemplateColStart]:=curband.band.CurrentRow;
 end
 else
 cellconst[curvariant.Cells[j].fTemplateColStart]:=' ';
 end;

 if EndRow<curband.Band.CurrentRow then
 EndRow:=curband.Band.CurrentRow;
 //fTemplateSheet.setTextWrap(currentRect.Top,1,1,NCols);
 //fResultSheet.SetRowHeight(curBand.Band.CurrentRow,fTemplateSheet.getRowHeight(currentRect.Top));
 PrepareAutoFit(curband.Band.CurrentRow);
 fTemplateSheet.Clear(currentRect.Top,1,currentRect.Top,NCols,true);
 curband.Band.CurrentRow:=curband.Band.CurrentRow+1;
// FResultSheet.SetRowHeight(curBand.Band.CurrentRow,max(FResultSheet.getRowHeight(curBand.Band.CurrentRow),FTemplateSheet.getRowHeight(curvariant.fTempLateRow)));
 if not onerow then
 curvariant:=curband.FindNextVariant
 else
 curvariant:=nil;
 end;
 s:=curband.Band.unProcessed;
 if s<>'' then
 fowner.ferrorstrings.add(curband.Band.Name+'{'+s+'}');

 end;

{ else if ferrorstrings<>nil then
 begin
 ferrorstrings.Add(curband.toString)
 end;}
 result:=hasany;
 finally
  rd.Free;
 end;
end;
procedure TExcelTemplateSheet.OutPutTitle(var startRow:integer;title:TRect);
var i,j:integer;
    s:string;
    isempty:boolean;
begin

if title.Top=-1 then exit;
if title.left=-1 then exit;
if title.right=-1 then exit;
if title.Bottom=-1 then exit;
isempty:=true;
logs.startproc('Excel','ExcelTemplateReport','outputtitle','',5);
for i:=1 to 256 do
begin
cellconst[i]:=' ';
end;
for i:=Title.Top to Title.Bottom do
  for j:=1 to Title.Right do
  begin
   s:=fTemplateSheet.CellValue(i,j);
   if s<>'' then isempty:=false;
   if s='#DATE' then fTemplateSheet.Cells[i,j]:=DateToStr(Now)
 else
  if s='#TIME' then fTemplateSheet.Cells[i,j]:=TimeToStr(Now)
 else
  if s='#DATETIME' then fTemplateSheet.Cells[i,j]:=DateTimeToStr(Now)
 else
   if s='#REPORT' then fTemplateSheet.Cells[i,j]:=fowner.ftitle
 else
   if s='#TOP' then fTemplateSheet.Cells[i,j]:=frowstructure[frowstructure.root].s;
 end;
 for i:=Title.Top to Title.Bottom do
 fResultSheet.SetRowHeight(i-1,fTemplateSheet.getRowHeight(i));
 {for i:=Title.Left to Title.Right do
 fResultSheet.SetColumnWidth(i,fTemplateSheet.getColumnWidth(i));}

 fResultSheet.CopyCells(fTemplateSheet,Title,Point(1,startrow));
 for i:=1 to BreakCount do
  if (fPageBreaks[i]>=Title.Top)and(fPageBreaks[i]<=Title.Bottom) then
  begin
   fresultsheet.SetHPageBreaks([startrow+fPageBreaks[i]-Title.Top]);
  end;
 { if not isempty then}
 inc(startrow,Title.bottom-Title.top+1);

end;
procedure TExcelTemplateReport.MakeReport;
var
    i,j:integer;
    ftempname:string;
    pbcnt:integer;
    a:integer;
begin
 ftempname:='temp.xls';
  ferrorstrings.Clear;
 excelBands.textexcel:=TStringList.Create;
try
fileutil.CopyFile(fTemplateName,ffileName,nil);
fResultBook:=fexcel.AddBook(ffilename);
fTemplateBook:=fexcel.AddBook(fTemplateName);
if fprogress<>nil then
 begin
 fprogress.Progress:=0;
 fprogress.MinValue:=0;
 fprogress.MaxValue:=fReportRows.Count;
 end;
{fexcel.ScreenUpdating:=true;
fexcel.Visible:=true;
fexcel.FApp.UserControl:=true;}

if (fprogress=nil)or(logs.MainLog.GetDebug>25) then
 fexcel.visible:=true;
NameConversion:=TMemIniFile.Create('DOTS\EXCEL\Translate.ini');
try
for i:=1 to fTemplateBook.SheetCount do
begin
{ pbcnt:=ftemplateBook.Sheet[i].getHPageBreakCount;
 for j:=1 to pbcnt do
 a:=ftemplateBook.Sheet[i].getHPageBreak(j);}
 PrepareDataSheet(ftemplateBook.Sheet[i]);
end;
finally
NameConversion.free;
end;
frowDetailSet.First;
//fexcel.ScreenUpdating:=false;
for i:=0 to SheetCount-1 do
 Sheets[i].MakeSheet(fresultBook.Sheet[i+1]);
sleep(0); 
 fExcel.Visible:=true;
for i:=0 to SheetCount-1 do
fResultBook.Sheet[i+1].ApplyMergeAreas;
 textexcel.SaveToFile('table.txt');
 ftemplateBook.close;
  if fprogress<>nil then
 begin
 fprogress.Progress:=0;
 end;

 if (ferrorstrings.Count>0)or(fMissedBands.Count>0) then
 begin
   ExcelErrors:=TExcelErrors.Create(nil);
   try
   ExcelErrors.Memo1.Lines.Clear;
   if (fMissedBands.Count>0) then
   begin
   ExcelErrors.Memo1.Lines.add('   :');
   ExcelErrors.Memo1.Lines.addStrings(fMissedBands);
   end;

   if (ferrorstrings.Count>0) then
   begin
   ExcelErrors.Memo1.Lines.add('      :');
   ExcelErrors.Memo1.Lines.addStrings(ferrorstrings);
   end;
   ExcelErrors.showmodal;
   finally
   ExcelErrors.free;
   end;
 end;
finally
excelBands.textexcel.free;
end;
 fexcel.setusercontrol;
// fresultBook.SaveAs(ffilename);
end;
procedure TExcelTemplateSheet.makeSheet(ResultSheet:TExcelSheet);
var startrow,endrow:integer;
    ExcelColumns:TColArray;
    CurBand,oldBand:TEXLReportBand;
    i:integer;
begin
  startRow:=1;
  endrow:=1;
 fresultSheet:=ResultSheet;
  fcurrentTitle:=1;
 foldtitle:=1;
 if fBands.count>0 then
 begin //1
 fresultSheet.DeleteRows(1,1);
 fresultSheet.ClearAll;
 fresultsheet.ResetAllPageBreaks;
 fusedcols:=TColSet.Create;
 fcurCols:=TColSet.Create;
 fusedBands:=TList.Create;
 fbands.CalcInterSection;
{ for i:=0 to fbands.Count-1 do
  fbands.Bands[i].CalcChildrenIntersection;}
 try   //2
try    //3
curBand:=fBands.firstBandByName;
if (frowstructure.root>0)and(curBand<>nil) then
begin    //4
for i:=1 to NCols do ExcelColumns[i]:=1;
 for i:=1 to NCols do
 begin //2
  if rowstart[i]>0 then  laststart[i]:=rowstart[i]; RowStart[i]:=-1; rowend[i]:=-1; newstart[i]:=-1;
 end; //2
 fExcelRow:=0;
 aFitStart:=0;
 aFitEnd:=0;
fcurrentTitle:=StrToIntDef(copy(curBand.Name,2,length(curband.Name)),1);
 OutPutTitle(startrow,fTitleRect[fcurrentTitle]);
 endrow:=startRow;

fResultSheet.CopyCells(fTemplateSheet,frowtemplate[fcurrenttitle],Point(1,StartRow));
 lastBandStart:=startRow+1;
 fBandLevel:=0;
  fusedcols.AppendList(curband.UsedCols);
  fusedBands.Add(curBand);
  //CalcSubInterSection(CurBand.Part);
  for i:=1 to 256 do
  begin
   cellconst[i]:=' ';
   constStart[i]:=startRow;
  end; 
 OutputLevel(CurBand, fRowStructure.root,1,ExcelColumns,startrow,StartRow+1,endrow);
  for i:=0 to fusedBands.count-1 do
  begin  //5
  oldBand:=TEXLReportBand(fusedBands[i]);
while oldBand<>nil do
begin     //6
 AppendEmpty(oldBand,endrow);
 oldBand:=oldBand.Parent;
end;      //6
end;      //5
end;      //4
except
fowner.fexcel.visible:=true;
end;      //3
 for i:=1 to NCols do Rowend[i]:=endrow;
{try
 for i:=1 to NCols do
  if (laststart[i]<rowend[i])and(laststart[i]>0) then
  begin
  setBorders(fcurrenttitle,rowend[i],i,i);
  fResultSheet.MergeAllCells(laststart[i],i,rowend[i],i);
  end;

except
fexcel.visible:=true;
end;}
inc(endrow);
try          //3
  if fFooterRect[fcurrentTitle].Top>0 then
 OutputTitle(endrow,fFooterRect[fCurrentTitle])
 else
 OutputTitle(endrow,fFooterRect[fTitleCount]);
 OutPutTitle(endrow,fFooter);
except
fowner.fexcel.visible:=true;
end;         //3
MakeAutoFit;
 if (fowner.fprogress<>nil) then
 fowner.fexcel.visible:=true;
 fowner.fexcel.ScreenUpdating:=true;
fResultSheet.MakeActive;
finally
fusedcols.Free;
fcurcols.free;
fusedBands.Free;
end;          //2
end;          //1
end;
procedure TExcelTemplateSheet.CalcSubInterSection(TableN:integer);
var i,j,k,l,m,ii:integer;
    curcolumns:Array[1..256] of Boolean;
begin
logs.startproc('Excel','ExcelTemplateReport','','calcsubintersection',5);
   for j:=0 to 16 do
    for k:=1 to 256 do
   SublevelColumns[j,k]:=0;
   for j:=0 to 16 do
    for k:=0 to 16 do
    sublevelIntersects[j,k]:=false;
 for i:=0 to fbands.Count-1 do
   if (fBands.Bands[i].Part=TableN)and(fbands.Bands[i].Level=1) then
      for j:=0 to fbands.Bands[i].Count-1 do
        for k:=0 to fbands.bands[i].Levels[j].Count-1 do
         for l:=0 to fBands.Bands[i].Levels[j].Variants[k].Count-1 do
          for m:=fBands.Bands[i].Levels[j].Variants[k].Cells[l].fTemplateColStart to
                 fBands.Bands[i].Levels[j].Variants[k].Cells[l].fTemplateColEnd do
         SubLevelColumns[fbands.Bands[i].Levels[j].Level,m]:=1;
  for j:=0 to 15 do
  begin
   for k:=1 to 256 do
   if sublevelcolumns[j,k]=1 then
    CurColumns[k]:=true
    else
    curcolumns[k]:=false;
   for l:=j+1 to 16 do
    for k:=1 to 256 do
     if curcolumns[k] and (sublevelcolumns[l,k]=1) then
     begin
      sublevelIntersects[j,l]:=true;
      sublevelIntersects[l,j]:=true;
      break;
     end;
  end;
end;
procedure TExcelTemplateSheet.CalcInterSection;
var i,j,k,l,m:integer;
    curcolumns:Array[1..256] of boolean;
    p:TEXLReportBand;
begin
logs.startproc('Excel','ExcelTemplateReport','','calcsubintersection',5);
for i:=0 to fBands.Count-1 do
fBands.CheckParent(fBands.Bands[i]);
for k:=1 to fBlockcount do
for i:=1 to 10 do
 for j:=1 TO 256 do
  levelcolumns[k,i,j]:=0;
for k:=1 to fBlockcount do
for i:=1 to 10 do
 for j:=1 to 10 do
  levelIntersects[k,i,j]:=false;
for k:=1 to fBlockcount do
for l:=1 to 10 do
begin
 for i:=1 to 256 do curcolumns[i]:=false;
 for i:=0 to fbands.Count-1 do
 if (fbands.Bands[i].Level=l)and(fbands.Bands[i].part=k) then
 begin
   for j:=0 to fbands.Bands[i].Columns.Count-1 do
     begin
     curcolumns[fbands.Bands[i].columns[j]]:=true;
     levelcolumns[k,l,fbands.Bands[i].columns[j]]:=1;
     p:=fbands.Bands[i];
     while p<>nil do
     begin
     p.UsedCols.AppendCol(fbands.Bands[i].columns[j]);
     p:=p.Parent;
     end;
     end;
  end;
i:=1;     
 for i:=0 to fbands.Count-1 do
 if (fbands.Bands[i].Level>l)and(fbands.Bands[i].part=k) then
 begin
   for j:=0 to fbands.Bands[i].Columns.count-1 do
      if curcolumns[fbands.Bands[i].columns[j]] then
      begin
       levelIntersects[k,l,fbands.Bands[i].Level]:=true;
       levelIntersects[k,fbands.Bands[i].Level,l]:=true;
      end;
 end;

end;
for k:=1 to fBlockCount do
 for i:=1 to 10 do
  for j:=i+2 to 10 do
   if levelIntersects[k,i,j] then
   begin
    l:=j-1;
    while (l>i)and not levelIntersects[k,j,l] do dec(l);
    if l<j-1 then levelIntersects[k,i,l+1]:=true;
   end;
end;
function cutLevelID(s:string):string;
begin
result:=ClearSpaces(s);
if result='' then exit;
if copy(result,1,3)='%%L' then result:=copy(result,pos(' ',result)+1,length(result));
end;
procedure TExcelTemplateReport.ProcessConstSheet(sheet:TExcelSheet);
var i,j,
    maxC,maxR:integer;
    s:string;
begin
maxc:=Sheet.RightColumn;
maxr:=Sheet.BottomRow;
for i:=1 to maxr do
 for j:=1 to maxc do
 begin
 s:=sheet.CellValue(i,j);
 if s='#DATE' then Sheet.Cells[i,j]:=DateToStr(Now)
 else
  if s='#TIME' then Sheet.Cells[i,j]:=TimeToStr(Now)
 else
  if s='#DATETIME' then Sheet.Cells[i,j]:=DateTimeToStr(Now)
 else
   if s='#REPORT' then Sheet.Cells[i,j]:=ftitle
 else
   if s='#TOP' then Sheet.Cells[i,j]:=CutLevelID(fReportRows[fReportRows.root].s);
 end;
end;
procedure TExcelTemplateSheet.AppendEmpty(RootBand:TEXLReportBand;endrow:integer);
var i,j:integer;
begin
if RootBand=nil then exit;
if RootBand.isEmpty then exit;
logs.startproc('Excel','ExcelTemplateReport','AppendEmpty',inttostr(endrow)+'>'+RootBand.Name,5);
 for i:=0 to RootBand.Columns.Count-1 do
 begin
 j:=rootBand.columns[i];
  if RootBand.MergedCols.indexof(j)>=0 then continue;
 SetBorders(foldTitle,endrow,j,j);
  if (rowstart[j]<endrow)and(rowstart[j]>0) then
  fresultSheet.MergeAllCells(rowstart[j],j,endrow,j);
  if rowstart[j]>0 then 
  laststart[j]:=rowstart[j];
 rowend[j]:=endrow;
 //rowstart[j]:=-1;
 rowend[j]:=-1;
 end;
 RootBand.CurrentRow:=endrow+1;
 for i:=0 to RootBand.ChildrenCount-1 do
  AppendEmpty(RootBand.ChildBands[i],endrow);
 end;
function TExcelTemplateSheet.FillBandsNew:integer;
var i,j,pbrow:integer;
    nrows:integer;
    tn:integer;
    istitlerow:boolean;
    BandName:string;
    p,curblock:integer;
    BandLevel:integer;
    startblock:integer;
    curStart,curEnd:integer;
    curRect,curTemplate:TRect;
    cell:string;
    curBlockName,FieldName:string;
    curBand:TExlReportBand;
    curBandLevel:TEXLReportBandLevel;
    swapMode,oldtitlerow:boolean;
    MRect:TRect;
    shabframe:variant;
begin
logs.startproc('Excel','ExcelTemplateReport','fillbandsnew','',5);
  NRows:=strTointDef(fTemplateSheet.CellValue(1,3),-1)+1;
  nCols:=Col2Number(fTemplateSheet.CellValue(1,2));
  tn:=0;
  startblock:=1000;
  curstart:=2;
  curend:=-1;
  swapmode:=false;
  istitlerow:=true;
  //shabframe:=VarArrayCreate([1,2,ncols,NRows+1],varOleStr);
  fTemplateSheet.GetText(shabframe,[1,2,ncols,NRows+1]);

  for i:=2 to nRows+1 do
  begin
  oldtitlerow:=isTitlerow;
  istitlerow:=true;
  curend:=i-1;
  for j:=1 to nCols do
  begin
  cell:=ClearSpaces(shabframe[i-1,j]);
//  mrect:=fexcel.Sheet[1].getMergeArea(i,j);
  if cell='' then continue;
  if (cell[1]<>'*')or(length(cell)<4)or not(cell[2] in ['1'..'9']) then
  begin
  istitleRow:=true;
  break;
  end;
  istitlerow:=false;
  BandName:=copy(cell,1,pos('.',cell)-1);
  p:=pos(':',BandName);
  if p>0 then
  begin
  BandLevel:=strToIntDef(Copy(BandName,p+1,length(Bandname)),1);
  BandName:=copy(bandName,1,p-1);
  end
  else
  BandLevel:=0;
  if pos('_',BandName)=0 then
  curblockname:=BandName
  else
  curblockname:=copy(bandname,1,pos('_',bandname)-1);

  curblock:=strtointdef(copy(curblockName,2,length(curblockName)),1);
  if curblock<startblock then startBlock:=curblock;
  if fblockcount<curblock then fblockcount:=curblock;
   fTemplateSheet.setTextWrap(i,j,1,1,false);
  FieldName:=ClearSpaces(copy(cell,pos('.',cell)+1,length(cell)));
  curBand:=fBands.ensureBandExists(BandName);
  curBandLevel:=curBand.EnsureLevelExists(BandLevel);
  MRect:=fTemplateSheet.MergeRectangle(i,j);
  curBandLevel.GetVariantByRow(i).AddCell(MRect.Left,MRect.Right,FieldName);
  end;
  swapmode:=istitlerow<>oldtitlerow;
  if isTitleRow and swapMode then
   begin curstart:=i; startblock:=100;end
   else
  if not istitlerow and swapMode then
  begin
    if curend>curstart then
  begin
  curRect:=Rect(1,Curstart,ncols,curEnd-1);
  curTemplate:=Rect(1,Curend,ncols,curend);
  end
  else if curend=curstart then
  begin
  curRect:=Rect(-1,-1,-1,-1);
  curTemplate:=Rect(1,Curend,ncols,curend);
  end;

  if (fblockCount>0)and(startBlock<1000) then
  begin
   for j:=startBlock to fblockCount do
   begin
   fRowTemplate[j]:=curTemplate;
   fTitleRect[j]:=rect(-1,-1,-1,-1);
   fFooterRect[j]:=rect(-1,-1,-1,-1);
   end;
 fTemplateSheet.WrapText:=false;
 fTemplateSheet.HorizontalAlignment:=xlHAlignLeft;
// fTemplateSheet.indent:=0;
 ftemplateSheet.FormatRange(curTemplate.Top,curTemplate.Left,curTemplate.Bottom,curTemplate.Right,frWrapText);
   fTitleRect[startBlock]:=curRect;
   curRect:=Rect(-1,-1,-1,-1);
  end;
  end
  else if not isTitleRow then
  begin
  fRowTemplate[j]:=curTemplate;
  startBlock:=1000;
  end;
  curend:=i;
  swapmode:=false;
  end;
  if fblockCount>0 then
  begin
   fFooter:=Rect(1,curstart,ncols,nrows+1);
   end;
   ftitleCount:=fblockCount;
   for i:=fblockcount downto 2 do
    if fRowTemplate[i].top=0 then
    begin
    j:=i-1;
    while (j>0)and(fRowTemplate[j].Top=0) do dec(j);
    fRowTemplate[i]:=fRowTemplate[j];
    end;
BreakCount:=ftemplatesheet.getHPageBreakCount;
  j:=0;
  for i:=1 to min(BreakCount,64) do
  begin
  try
  pbrow:=ftemplatesheet.getHPageBreak(i);
  if pbrow>0 then
  begin
  inc(j);
  fPageBreaks[j]:=pbrow;
  end;
  except
  BreakCount:=j;
  break;
  end;
  end;

end;
procedure TExcelTemplateSheet.SetBorders(index:integer;Row:integer;startCol,endCol:integer);
begin
// fResultSheet.CopyBorders(fTemplateSheet,Rect(startCol,fRowTemplate[index].Top,endcol,fRowTemplate[index].Bottom),Point(startCol,row));
end;
procedure TExcelTemplateSheet.PrepareAutoFit(row:integer);
begin
logs.startproc('Excel','ExcelTemplateReport','PrepareAutofit',inttostr(row),5);
if aFitStart=0 then
begin
 aFitStart:=row;
 aFitEnd:=row;
end
else if (row>=aFitStart)and(row<=aFitEnd) then exit
else if row=aFitStart-1 then aFitStart:=row
else if row=aFitEnd+1 then aFitEnd:=row
else begin MakeAutoFit;  aFitStart:=row; aFitEnd:=row; end;
end;
procedure TExcelTemplateSheet.MakeAutoFit;
begin
logs.startproc('Excel','ExcelTemplateReport','MakeAutofit','',5);
if (aFitStart<=AfitEnd)and(aFitStart>0) then
begin
 fresultSheet.AddAutoFitArea(afitstart,1,afitend,NCols);
end;
aFitStart:=0;
aFitEnd:=0;
end;
procedure TExcelTemplateSheet.DrawTemplate(Band:TEXLReportBand;row:integer);
var i:integer;
begin
logs.startproc('Excel','ExcelTemplateReport','DrawTemplate',inttostr(row)+':'+inttostr(fcurrenttitle),5);
fResultSheet.CopyCells(fTemplateSheet,frowtemplate[fcurrentTitle],Point(1,Row));
//fResultSheet.setTextWrap(Row,1,1,NCols,false);
{ for i:=0 to Band.UsedCols.Count-1 do
     fResultSheet.CopyCell(fTemplateSheet,Point(Band.UsedCols[i],frowtemplate[fcurrentTitle].Top),Point(Band.UsedCols[i],Row));}
end;
function TExcelTemplateReport.TranslateField(FieldName:string):string;
var i:integer;
    TRPartEnd:integer;
    FixedPart,TransPart:string;
begin
 result:=FieldName;
 if FieldName='' then exit;
 TRPartEnd:=-1;
 for i:=length(FieldName) downto 1 do
  if not (FieldName[i] in ['0'..'9']) then
  begin
  TRPartEnd:=i;
  break
  end;
 if TRPartEnd>0 then
 begin
 fixedPart:=copy(FieldName,TRPartEnd+1,length(FieldName));
 TransPart:=copy(FieldName,1,TRPartEnd);
 result:=NameConversion.ReadString('FIELDNAMES',TransPart,TransPart)+FixedPart;
 end;
end; 
procedure TExcelTemplateSheet.PushOldBand;
begin
inc(fBandLevel);
fOldBands[fBandLevel]:=fOldBand;
fOldBand:=nil;
end;
procedure TExcelTemplateSheet.PopOldBand;
begin
fOldBand:=fOldBands[fBandLevel];
dec(fBandLevel);
end;
procedure TExcelTemplateReport.PrepareDataSheet(TemplateSheet:TExcelSheet);
var newSheet:TExcelTemplateSheet;
    i,j,id:integer;
    temp:TOMItems;
    band:TEXLReportBand;
procedure SetIDL(Dst:TOMItems;dstParent:integer;Src:TOMItems;SrcRoot:integer);
var i,j:integer;
    newitem:TOMItem;
begin
newitem:=DST.ADDChildItem(dstParent,src[srcroot].s);
newitem.assigndata(src[srcroot]);
newitem.idloaded:=SrcRoot;
newitem.wparam:=src[srcroot].wparam;
 j:=Src[SrcRoot].firstchild;
 While j>0 do
 begin
 if SRC[j].deleted=0 then
 begin
  SetIDL(Dst,newitem.pos,Src,j);
 end;
 j:=Src[j].nextitem;
 end;
end;
begin
 newSheet:=TExcelTemplateSheet.Create(self);
 fsheets.Add(newsheet);
 newsheet.fTemplateSheet:=TemplateSheet;
 newSheet.FillBands;

 newsheet.fbands.ResolveMasterDetail;
 newsheet.CalcInterSection;
 i:=fReportRows.Root;
 while i>0 do
 begin
 if freportRows[i].deleted=0 then
 begin
  Band:=newsheet.fbands.BandByName('*'+inttostr(freportRows[i].interval));
  if Band<>nil then
  begin
   SetIDL(newSheet.frowStructure,0,freportRows,i);
  end
 end;
 i:=freportRows[i].nextitem;
 end;
end;
function TExcelTemplateReport.getSheet(i:integer):TExcelTemplateSheet;
begin
 result:=TExcelTemplateSheet(fsheets[i]);
end;
function TExcelTemplateReport.SheetCount:integer;
begin
 result:=fSheets.count;
end;
end.
