unit FindUnit;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, ComCtrls, ColoredGrid,items;

type
  TFindMode=(fmGrid,fmTree,fmList,fmCombo);
  TFind = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Panel1: TPanel;
    FindText: TComboBox;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    RadioGroup1: TRadioGroup;
    IsCase: TCheckBox;
    IsWord: TCheckBox;
    GoFwd: TRadioButton;
    GoBack: TRadioButton;
    GroupBox2: TGroupBox;
    FromCurr: TRadioButton;
    FromTop: TRadioButton;
    MarkFound: TButton;
    Mark1: TButton;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure MarkFoundClick(Sender: TObject);
    procedure Mark1Click(Sender: TObject);
  private
    { Private declarations }
    fmode:TFindMode;
    fGrid:TColoredGrid;
    fTree:TTreeView;
    fList:TListView;
    fCombo:TComboBox;
    lastitem:TOMItem;
    function is_number(s:string):boolean;
  public
    { Public declarations }
    function showmodalGrid(Grid:TColoredGrid):integer;
    function ShowModalTree(Tree:TTreeView):integer;
    function ShowModalList(List:TListView):integer;
    function ShowModalCombo(Combo:TComboBox):integer;
    function FitReport(data:TOMItems;report:TStrings;UseNumbers:boolean):boolean;
  end;

var
  Find: TFind;

implementation

uses Main,finds,dialogs,utils, FindUnit2, Umessages, appConst,strutils;

{$R *.DFM}


function TFind.is_number(s:string):boolean;
var p:integer;
    subs:string;
begin
result:=false;
while s<>'' do
begin
p:=system.pos('.',s);
if p=0 then exit;
subs:=copy(s,1,p-1);
delete(s,1,p);
if strToIntDef(subs,-1)=-1 then exit;
end;
result:=true;
end;

procedure TFind.OKBtnClick(Sender: TObject);
var pos,i,j:integer;
    findresult:boolean;
    findStr:TStringList;
    subword:string;
    subCommand:TSearchCommand;
    tofind:string;
    cand:string;
begin
findresult:=false;
findtext.Items.Add(findtext.text);
Replace.findtext.Items.Add(findtext.text);
findStr:=TStringList.create;
try
if system.pos('AND(',findtext.Text)=1 then
begin
 subword:='';
 for i:=5 to length(findtext.Text)-1 do
  if findtext.Text[i]<>',' then subword:=subword+findtext.Text[i]
  else
  begin
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  end;
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  subCommand:=scAnd;
end
else
if system.pos('OR(',findtext.Text)=1 then
begin
 subword:='';
 for i:=4 to length(findtext.Text)-1 do
  if findtext.Text[i]<>',' then subword:=subword+findtext.Text[i]
  else
  begin
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  end;
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  subCommand:=scOr;
end
else
if system.pos('NOT(',findtext.Text)=1 then
begin
 subword:='';
 for i:=5 to length(findtext.Text)-1 do
  if findtext.Text[i]<>',' then subword:=subword+findtext.Text[i]
  else
  begin
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  end;
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  subCommand:=scNOT;
end
else
if system.pos('XOR(',findtext.Text)=1 then
begin
 subword:='';
 for i:=5 to length(findtext.Text)-1 do
  if findtext.Text[i]<>',' then subword:=subword+findtext.Text[i]
  else
  begin
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  end;
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  subCommand:=scXOR;
end
else
begin
subword:=ClearSpaces(findtext.Text);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  subCommand:=scAND;
end;

case fMode of
fmGrid:
begin
if FGrid=nil then begin ModalResult:=mrOK; exit; end;
if is_Number(FindText.text) then
with fGrid do
begin
for i:=1 to insource.count do
if (insource[i].deleted=0)and(insource.getfullnumber(i,0)=findtext.text) then
begin
if not fGrid.insource.isvisible(i) then
begin
fGrid.insource.makevisible(i);
if assigned(fgrid.onrebuild) then
fGrid.Onrebuild(fGrid)
else
fGrid.Rebuild(false,true);
end;
if disprow[i]>0 then
begin
row:=disprow[i];
findresult:=true;
Mark1.Enabled:=true;
lastitem:=insource[i];
end
else
begin
showmessage(' '+findtext.text+'  .');
fromtop.checked:=true;
gofwd.Checked:=true;
exit;
end;

ModalResult:=mrOk;
exit;
end;
showmessage(' '+findtext.text+umessages.IsNotFound);
exit;
end;
if fromtop.checked then
begin
if utils.isfind(findStr,subCommand,fGrid.insource[fGrid.insource.root].s,isword.checked,iscase.checked)and
  (fGrid.insource[fGrid.insource.root].deleted=0)   then
 pos:=fGrid.insource.root
else
 pos:= fGrid.insource.findbyname(fGrid.insource.root,findStr,subCommand,true,iscase.checked,isword.checked)
end
else
pos:= fGrid.insource.findbyname(fGrid.selectedindex,findStr,subCommand,gofwd.checked,iscase.checked,isword.checked);
if pos<>0 then
begin
fGrid.insource.makevisible(pos);
fGrid.rebuild(false,true);
if fGrid.disprow[pos]>0 then
begin
fGrid.row:=fGrid.disprow[pos];
lastitem:=fgrid.insource[pos];
mark1.Enabled:=true;
end
else
begin
showmessage(' '+findtext.text+'  .');
fromtop.checked:=true;
gofwd.Checked:=true;
exit;
end;
caption:=':  - '+fGrid.insource.getfullnumber(pos,0)+' '+fGrid.insource[pos].s;
FromCurr.checked:=true;
end
else
begin
showmessage(' '+findtext.text+'  .');
fromtop.checked:=true;
gofwd.Checked:=true;
end;
end;
fmTree:
begin
if (fromTop.Checked)or(ftree.selected=nil) then if gofwd.Checked then i:=-1
                                                                 else i:=+1
                   else i:=fTree.Selected.AbsoluteIndex;
findresult:=false;

if gofwd.Checked then
begin
 for j:=i+1 to fTree.Items.Count-1 do
   if utils.isfind(findStr,subCommand,fTree.Items[j].Text,isword.checked,iscase.checked) then
   begin
    ftree.Items[j].MakeVisible;
    ftree.Selected:=ftree.Items[j];
    findresult:=true;
    break;
   end;
end
else
if GoBack.Checked then
begin
 for j:=i-1 downto 0 do
   if utils.isfind(findStr,subCommand,fTree.Items[j].Text,isword.checked,iscase.checked) then
   begin
    ftree.Items[j].MakeVisible;
    ftree.Selected:=ftree.Items[j];
    findresult:=true;
    break;
   end;
end;
if findresult then
begin
caption:=':  - '+GetFullNodePath(fTree.Selected);
fromcurr.Checked:=true;

fTree.TopItem:=ftree.selected;
end
else
begin
showmessage(' '+findtext.text+'  .');
fromtop.checked:=true;
gofwd.Checked:=true;
end;
end;
fmList:
begin
if (fromTop.Checked)or(fList.selected=nil) then if gofwd.Checked then i:=-1 else i:=+1
                   else i:=fList.Selected.Index;
findresult:=false;

if gofwd.Checked then
begin
 for j:=i+1 to fList.Items.Count-1 do
   if utils.isfind(findStr,subCommand,fList.Items[j].Caption,isword.checked,iscase.checked) then
   begin
    fList.Selected:=fList.Items[j];
    flist.selected.MakeVisible(false);
    flist.SetFocus;
    findresult:=true;
    break;
   end;
end
else
if goBack.Checked then
begin
 for j:=i-1 downto 0 do
   if utils.isfind(findStr,subCommand,fList.Items[j].Caption,isword.checked,iscase.checked) then
   begin
    fList.Selected:=fList.Items[j];
    flist.selected.MakeVisible(false);
    findresult:=true;
    flist.SetFocus;
    //flist.TopItem:=flist.selected;
    break;
   end;
end;
if findresult then
begin
caption:=':  - '+fList.Selected.Caption;
fromcurr.Checked:=true;
end
else
begin
showmessage(' '+findtext.text+'  .');
fromtop.checked:=true;
gofwd.Checked:=true;
end;

end;
fmCombo:
begin
if (fromTop.Checked)or(fCombo.ItemIndex<0) then if gofwd.Checked then i:=-1 else i:=+1
                   else i:=fCombo.ItemIndex;
findresult:=false;
if gofwd.Checked then
begin
 for j:=i+1 to fCombo.Items.Count-1 do
   if utils.isfind(findStr,subCommand,fCombo.Items[j],isword.checked,iscase.checked) then
   begin
    fCombo.Itemindex:=j;
    fCombo.SetFocus;
    findresult:=true;
    break;
   end;
end
else
if gofwd.Checked then
begin
 for j:=i-1 downto 0 do
   if utils.isfind(findStr,subCommand,fCombo.Items[j],isword.checked,iscase.checked) then
   begin
    fCombo.itemindex:=j;
    fCombo.SetFocus;
    findresult:=true;
    break;
   end;
end;
if findresult then
begin
caption:=':  - '+fCombo.Items[fcombo.itemindex];
fromcurr.Checked:=true;
end
else
begin
showmessage(' '+findtext.text+'  .');
fromtop.checked:=true;
gofwd.Checked:=true;
end;


end;
end;
finally
findStr.free;
end;

 end;
procedure TFind.FormActivate(Sender: TObject);
begin
FindText.SetFocus;
FindText.font.charset:=204;
caption:='';
Mark1.Enabled:=false;
lastitem:=nil;
end;

procedure TFind.MarkFoundClick(Sender: TObject);
var i:integer;
    tofind:string;
    curstr:string;
    found:boolean;
    findStr:TStringList;
    subWord:string;
    subCommand:TSearchCommand;
begin
tofind:=FindText.text;
findStr:=TStringList.create;
try
if system.pos('AND(',findtext.Text)=1 then
begin
 subword:='';
 for i:=5 to length(tofind)-1 do
  if tofind[i]<>',' then subword:=subword+tofind[i]
  else
  begin
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  end;
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  subCommand:=scAnd;
end
else
if system.pos('OR(',findtext.Text)=1 then
begin
 subword:='';
 for i:=4 to length(tofind)-1 do
  if tofind[i]<>',' then subword:=subword+tofind[i]
  else
  begin
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  end;
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  subCommand:=scOr;
end
else
if system.pos('NOT(',findtext.Text)=1 then
begin
 subword:='';
 for i:=5 to length(tofind)-1 do
  if tofind[i]<>',' then subword:=subword+tofind[i]
  else
  begin
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  end;
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  subCommand:=scNOT;
end
else
if system.pos('XOR(',findtext.Text)=1 then
begin
 subword:='';
 for i:=5 to length(tofind)-1 do
  if tofind[i]<>',' then subword:=subword+tofind[i]
  else
  begin
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  end;
  subword:=ClearSpaces(subword);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  subCommand:=scXOR;
end
else
begin
subword:=ClearSpaces(tofind);
  if isCase.checked then
  findStr.add(subword)
  else
  findStr.add(ANSIUPPERCASE(subword));
  subword:='';
  subCommand:=scAND;
end;

if not IsCase.checked then tofind:=ANSIUpperCase(tofind);
with fGrid do
begin
 for i:=1 to insource.count do
 if insource[i].deleted=0 then
   begin
   curstr:=insource[i].s;
   if utils.isfind(findStr,subCommand,curStr,isword.Checked,isCase.checked)then
   insource[i].marked:=insource[i].marked or $1;
   end;
end;
finally
findStr.free;
end;
fGrid.repaint;

end;
function TFind.showmodalGrid(Grid:TColoredGrid):integer;
begin
fgrid:=grid;
ftree:=nil;
flist:=nil;
fcombo:=nil;
fmode:=fmGrid;
fromTop.enabled:=fgrid<>nil;
fromCurr.enabled:=fgrid<>nil;
goFWD.enabled:=fgrid<>nil;
goBack.enabled:=fgrid<>nil;
MarkFound.enabled:=fgrid<>nil;
MarkFound.enabled:=true;
Mark1.Enabled:=true;
if fGrid<>nil then
OKBtn.ModalResult:=mrNone
else
OKBtn.ModalResult:=mrOk;
result:=inherited showmodal;
end;
function TFind.ShowModalTree(Tree:TTreeView):integer;
begin
fgrid:=nil;
ftree:=tree;
flist:=nil;
fcombo:=nil;
fmode:=fmTree;
MarkFound.enabled:=false;
Mark1.Enabled:=false;
OKBtn.ModalResult:=mrNone;
result:=inherited showmodal;
end;

function TFind.ShowModalList(List:TListView):integer;
begin
fgrid:=nil;
ftree:=nil;
flist:=List;
fcombo:=nil;
fmode:=fmList;
MarkFound.enabled:=false;
Mark1.Enabled:=false;
OKBtn.ModalResult:=mrNone;
result:=inherited showmodal;
end;

function TFind.ShowModalCombo(Combo:TComboBox):integer;
begin
fgrid:=nil;
ftree:=nil;
flist:=nil;
fcombo:=combo;
fmode:=fmCombo;
MarkFound.enabled:=false;
Mark1.Enabled:=false;
OKBtn.ModalResult:=mrNone;
result:=inherited showmodal;
end;

function TFind.FitReport(data:TOMItems;report:TStrings;UseNumbers:boolean):boolean;
var textToFind:string;
function ReportLevel(root:integer;findNumbers:boolean):boolean;
var i,j:integer;
    s:string;
    matchOK:boolean;
    parsed:TStringList;
    firstcom:boolean;
begin
i:=root;
result:=false;
while i>0 do
begin
if data[i].deleted=0 then
begin
 if findNumbers then
 begin
 s:=data.getfullnumber(i,0);
 if s=textToFind then
 begin
 result:=true;
 Report.Add(s+' '+data[i].s);
 exit;
 end
 else if not data[i].Closed then
 begin
  result:=ReportLevel(data[i].firstchild,findNumbers);
  if result then exit;
 end;
 end
 else
 begin
 s:=data[i].s;
 if not isCase.Checked then s:=ANSIUpperCase(s);
 if isword.Checked then matchOK:=AnsiContainsStr(s,textToFind)
           else matchOK:=(s=textToFind);
  if matchOK then
   if UseNumbers then
   Report.add(data.getfullnumber(i,0)+' '+data[i].s)
   else
   Report.add('## '+ data[i].s)
  else
  begin
  s:=data[i].comment;
  if not isCase.Checked then s:=ANSIUpperCase(s);
  if  AnsiContainsStr(s,TextToFind) then
  begin
  firstcom:=true;
  s:=data[i].comment;
   if not isCase.Checked then s:=ANSIUpperCase(s);
   if isword.Checked then
    matchOK:=AnsiContainsStr(s,textToFind)
    else
    matchOK:=s=textToFind;
    if MatchOK then
    begin
     if firstcom then
      if UseNumbers then
      Report.add(data.getfullnumber(i,0)+' '+data[i].s)
      else
      Report.add('%%L'+inttostr(data[i].level+1)+' '+ data[i].s);
      Report.add('(* '+data[i].comment+' *)')
    end;
  end;
  end;
   result:=result or MatchOK;
   if Not Data[i].closed then
   MatchOK:=reportLevel(data[i].firstchild,findNumbers);
   result:=result or  MatchOK;
 end;

end;
i:=data[i].nextitem;
end;
end;
begin
textToFind:=FindText.Text;
if not isCase.Checked then texttoFind:=AnsiUpperCase(texttofind);
 result:=reportLevel(data.Root,is_number(textToFind));
end;
procedure TFind.Mark1Click(Sender: TObject);
begin
if lastitem<>nil then
begin
 lastitem.marked:=1;
 fgrid.repaint;
end;
end;

end.
