unit GV;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, TeeProcs, TeEngine, Chart, Series, ComCtrls, ToolWin, StdCtrls,
  Mask, ToolEdit, ExtDlgs, HTTPApp, HTTPProd, ImgList, Menus;

type
  TGraphForm = class(TForm)
    GView: TChart;
    ToolBar1: TToolBar;
    Exit: TToolButton;
    ToolButton2: TToolButton;
    ZoomIn: TToolButton;
    ZoomOut: TToolButton;
    Zoom100: TToolButton;
    GStart: TDateEdit;
    GFinish: TDateEdit;
    ToolButton1: TToolButton;
    ImageList1: TImageList;
    ImageList2: TImageList;
    toBMP: TToolButton;
    SavePictureDialog1: TSavePictureDialog;
    ToolButton4: TToolButton;
    ToHTML: TToolButton;
    PageProducer1: TPageProducer;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N1001: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    procedure FormDeactivate(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure ZoomInClick(Sender: TObject);
    procedure ZoomOutClick(Sender: TObject);
    procedure Zoom100Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure GStartAcceptDate(Sender: TObject; var Date: TDateTime;
      var Action: Boolean);
    procedure GFinishAcceptDate(Sender: TObject; var Date: TDateTime;
      var Action: Boolean);
    procedure toBMPClick(Sender: TObject);
    procedure ToHTMLClick(Sender: TObject);
    procedure PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure SavePictureDialog1TypeChange(Sender: TObject);
  private
    { Private declarations }
      repname:string;
  public
    { Public declarations }
    mindate,maxdate:TDateTime;
  end;

var
  GraphForm: TGraphForm;

implementation

uses utils, Logs, RxGif, appConst,filectrl, Umessages;

{$R *.DFM}

procedure TGraphForm.FormDeactivate(Sender: TObject);
var i:integer;
    s:TChartSeries;
begin
for i:=0 to gview.SeriesCount-1 do
begin
 s:=gview.series[0];
 gview.RemoveSeries(s);
 s.free;
end;
end;

procedure TGraphForm.ExitClick(Sender: TObject);
begin
close;
end;

procedure TGraphForm.ZoomInClick(Sender: TObject);
begin
userlog(sender,'','');
Gstart.date:=GStart.Date+Trunc((GFinish.Date-GStart.Date)/5);
GFinish.date:=GFinish.Date-Trunc((GFinish.Date-GStart.Date)/5);
GView.BottomAxis.SetMinMax(gstart.date,gfinish.date);
end;

procedure TGraphForm.ZoomOutClick(Sender: TObject);
begin
userlog(sender,'','');
Gstart.date:=GStart.Date-Trunc((GFinish.Date-GStart.Date)/4);
GFinish.date:=GFinish.Date+Trunc((GFinish.Date-GStart.Date)/4);
GView.BottomAxis.SetMinMax(gstart.date,gfinish.date);
end;

procedure TGraphForm.Zoom100Click(Sender: TObject);
begin
userlog(sender,'','');
GStart.Date:=mindate;
GFinish.date:=maxDate;
GView.BottomAxis.SetMinMax(mindate,maxdate);
end;

procedure TGraphForm.FormActivate(Sender: TObject);
begin
GStart.Date:=mindate;
GFinish.date:=maxDate;
GView.legend.font.charset:=204;
GView.BottomAxis.SetMinMax(mindate,maxdate);
{if Gview.ChartWidth<Gview.width div 16 then Gview.View3D:=false
                                      else Gview.View3D:=true;}
end;

procedure TGraphForm.GStartAcceptDate(Sender: TObject; var Date: TDateTime;
  var Action: Boolean);
begin
GView.BottomAxis.SetMinMax(date,gfinish.date);
end;

procedure TGraphForm.GFinishAcceptDate(Sender: TObject;
  var Date: TDateTime; var Action: Boolean);
begin
GView.BottomAxis.SetMinMax(gstart.date,date);
end;

procedure TGraphForm.toBMPClick(Sender: TObject);
begin
if savepicturedialog1.Execute then
begin
userlog(Sender,'','');
if extractfileExt(SavePictureDialog1.filename)='.bmp' then
GView.SaveToBitmapFile(SavePictureDialog1.filename)
else
if extractfileExt(SavePictureDialog1.filename)='.wmf' then
GView.SaveToMetafile(SavePictureDialog1.filename)
else
if extractfileExt(SavePictureDialog1.filename)='.emf' then
GView.SaveToMetafileEnh(SavePictureDialog1.filename)
else
GView.SaveToBitmapFile(cutfileext(SavePictureDialog1.filename)+'.bmp');
end;
setcurrentdir(appconst.sysinfo.datadir);
end;

procedure TGraphForm.ToHTMLClick(Sender: TObject);
var gi:TGifImage;
    l:TStringList;
    s:TSTringList;
begin
if dialogs.InputQuery('  WEB',' ',repname) then
begin
gi:=TGifImage.create;
l:=TStringList.create;
try
GView.SaveToBitmapFile('temp.bmp');
gi.AddFrame(nil);
gi.Frames[0].Bitmap.LoadFromFile('temp.bmp');
gi.Frames[0].Bitmap.PixelFormat:=pf24bit;
gi.EncodeAllFrames;
setcurrentdir(appconst.sysinfo.datadir);
if not directoryexists(appconst.sysinfo.publicationDir+'\'+appconst.sysinfo.ModelName) then
 CreateDir(appconst.sysinfo.publicationDir+'\'+appconst.sysinfo.ModelName);
gi.SaveToFile(appconst.sysinfo.publicationDir+'\'+appconst.sysinfo.ModelName+'\'+repname+'.gif');

setcurrentdir(appconst.sysinfo.datadir);
{l[5]:='<meta name="Author" content="'+(appconst.sysinfo.defAvtor)+'">';
l[8]:=('Resource Load Diagram: '+(repname));
l[13]:=(' '+repname);
l[17]:=''+( appconst.sysinfo.defavtor);
l[15]:='<img SRC="/struct/'+utils.EncodeString(appconst.sysinfo.ModelName+'/'+repname)+'.gif">';}
s:=TStringlist.create;
s.text:=PageProducer1.Content;
s.savetofile(appconst.sysinfo.publicationDir+'\'+appconst.sysinfo.ModelName+'\'+repname+'.htm');
s.free;
showmessage(umessages.diagSaved);
finally
l.free;
gi.free;
end;
end;
end;

procedure TGraphForm.PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
  const TagString: String; TagParams: TStrings; var ReplaceText: String);
begin
if TagString='AUTHOR' then replacetext:='<meta name="Author" content="'+(appconst.sysinfo.defAvtor)+'">'
else
if tagstring='TITLE' then replacetext:=(' : '+(repname))
else
if tagstring='PICTURENAME' then   replacetext:=(' '+repname)
else
if tagstring='PICTUREFILE' then   replacetext:='<img SRC="'+repname{utils.EncodeString(repname)}+'.gif">'
else
if tagstring='DAUTHOR' then replacetext:=( appconst.sysinfo.defavtor);
end;


procedure TGraphForm.SavePictureDialog1TypeChange(Sender: TObject);
begin
case SavePictureDialog1.FilterIndex of
0: SavePictureDialog1.DefaultExt:='bmp';
1: SavePictureDialog1.DefaultExt:='emf';
2: SavePictureDialog1.DefaultExt:='wmf';
end;
end;

end.
