unit MatrixProjection;
{
(c) . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids,ColoredGrid,items,FileUtil,mylists;
Const
 MAXNAMECOUNT={$IFNDEF ED}20{$ELSE}10{$ENDIF};
type
 TCelldata=class
               col,row:integer;
                value00:integer;
                names00,names01,names10,names11:string;
                namec: array[1..MAXNAMECOUNT] of integer;
                names:array[1..MAXNAMECOUNT] of TOMItems;
                ABC:TStrings;
                nn:byte;
                flag:word;
                comment:string;
                isNP:boolean;
               constructor Create(c,r:integer);
               destructor destroy;override;
               end;


 TMatrixViewStyle   = (mvsNames,mvsNamesFull,mvsABCFull,mvsCross);
  TMatrixProjection = class(TStringGrid)
  private
    { Private declarations }
    FSrc,Fdst: TColoredGrid;
    fcelllist:TList;
    fviewstyle:TMatrixViewStyle;
    fupdating:boolean;
    FCurCol,FCurRow:integer;
    foldhintpos:TPoint;
    fLinkIndex:integer;
  protected
    { Protected declarations }
procedure Click;override;
procedure DrawCell(ACol,ARow:LongInt;ARect:TRect;AState:TGridDrawState);override;
function SelectCell(ACol,ARow:LongInt):boolean;override;
procedure clearcelllist;
procedure KeyDown(var Key: Word; Shift: TShiftState); override;
procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
  public
    { Public declarations }
    stateinv:boolean;
    colvalues,rowvalues:TList;
    {$IFNDEF ED}
    links_array:array[1..32] of TLiteLinks;
    {$ELSE}
    links_array:array[1..10] of TLiteLinks;
    {$ENDIF}
    lcount:integer;
    makeFictive:boolean;
    ROOT:TOMItems;
    readOnly:Boolean;
    ViewMask:set of 1..16;
//     Middle:Array[1..32] of TColoredGrid;
  property ViewStyle:TMatrixViewStyle read fviewstyle write fviewstyle;
  property Updating: boolean read fupdating;
    procedure Rebuild(acol,arow:integer;Links_Index:integer);
    Procedure ADDLinks(l:TLiteLinks);
    Procedure ClearLinks;
    function totalheight:integer;
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    function GetCellData(acol,arow:integer):TCellData;
    procedure filterClsLeft(rootindex:integer);
    procedure filterClsRight(rootindex:integer);
    function CanShow(link:TOMLink):boolean;
    function startIndex:integer;
    function endIndex:integer;
    property LinksIndex:integer read fLinkIndex;

  published
    { Published declarations }
    property Source:TColoredGrid read Fsrc write Fsrc;
    property Detail:TColoredGrid read Fdst write Fdst;
  end;

procedure Register;

implementation
uses utils,logs,itutils,appconst;

procedure Register;
begin
  RegisterComponents('Additional', [TMatrixProjection]);
end;
procedure TMatrixProjection.Rebuild(acol,arow:integer;Links_Index:integer);
var i,l,c,r:LongInt;
    max:integer;
    cd:TCelldata;
    j:integer;
    isfound:boolean;
    cellstr:string;
    namestr,ABCStr,Fstr:string;
    v:pextended;
    FNames:TOMItems;
    links:TLiteLinks;
    lstart,lend:integer;
    curlink:TOMLink;
    link_value:integer;
procedure proceed1link(li:TOMLink;ints,intd,lnum:integer;flags:word;recursive:boolean);
var j,k,c,r,ro,co:integer;
    ai:integer;
    lvalue:integer;
    cd:TCellData;
begin
if (intd<=0)or(ints<=0) then exit;
  c:=Detail.disprow[intd];
  r:=Source.disprow[ints];
  if (FNames<>nil)and(fnames.diriD<>0)and(lnum<>0)and
  not fnames.canshow(lnum,fnames.viewMode and 7) then exit;
  if (c>0)and(r>0) then
  begin
  ro:=Source.smap[r];
  co:=Detail.smap[c];
  //if ((ro<>ints)or(co<>intd)) then exit;
isfound:=false;
j:=0;
  if  fcelllist.count>0 then
  begin
  for j:=0 to fcelllist.count-1 do
   if (TCellData(fcelllist.items[j]).row=r)and(TCellData(fcelllist.items[j]).col=c) then begin isfound:=true; break; end;
  end
  else j:=0;
 if not isfound then
   begin
    cd:=TCellData.Create(c,r);
    fcelllist.add(cd);
       case li.owner.prjType of
    ptLRN:case flags and 3  of
          0:cd.flag:=cd.flag or 64;
          1:cd.flag:=cd.flag or 128;
          2,3:cd.flag:=cd.flag or 256;
          end;
    ptIOC:case flags and 3  of
          0:cd.flag:=cd.flag or 1;
          1:cd.flag:=cd.flag or 2;
          2,3:cd.flag:=cd.flag or 4;
         end;
    ptM:cd.flag:=cd.flag or 8;
    ptC:cd.flag:=cd.flag or 4;
    ptIOM:case flags and 3  of
          0:cd.flag:=cd.flag or 1;
          1:cd.flag:=cd.flag or 2;
          2,3:cd.flag:=cd.flag or 8;
         end;
    end;
    cd.comment:='';
    end
   else cd:=TCellData(fcelllist[j]);
   if li.linkcomment<>'' then
   cd.comment:=cd.comment+' '+li.linkcomment;
       case li.owner.prjType of
    ptIOC:case flags and 7  of
          0:cd.flag:=cd.flag or 1;
          1:cd.flag:=cd.flag or 2;
          2,3:cd.flag:=cd.flag or 4;
          4,5:cd.flag:=cd.flag or 4;
          end;
    ptM:cd.flag:=cd.flag or 8;
    ptC:cd.flag:=cd.flag or 4;
    ptIOM:case flags and 7  of
          0:cd.flag:=cd.flag or 1;
          1:cd.flag:=cd.flag or 2;
          2,3:cd.flag:=cd.flag or 8;
          4,5:cd.flag:=cd.flag or 8;
          end;
    end;
    ai:=LI.ABC;
    IF (AI>0)AND(CD.abc.IndexOf(links.ABCMap[ai].s)=-1) then
    cd.ABC.Add(links.ABCName(ai));
   if lnum<>0 then
   begin
   lnum:=fnames.getUp(lnum);
   isfound:=false;
    k:=lnum;
    while (k<>0)and not isfound do
    begin
        for j:=1 to cd.nn do
    if (cd.namec[j]=k)and(cd.names[j]=fnames) then
                       begin
                       isfound:=true;
                       break;
                       end;
  k:=fnames[k].intparent;
    end;

    if not isfound and(cd.nn<MAXNAMECOUNT) then
    begin
     inc(cd.nn);
     cd.namec[cd.nn]:=lnum;
     cd.names[cd.nn]:=fnames;
    end;
   end;
   lvalue:=1;
   cd.value00:=cd.value00+lvalue;
  pextended(rowvalues[r-1])^:=pextended(rowvalues[r-1])^+lvalue;
  pextended(colvalues[c-1])^:=pextended(colvalues[c-1])^+lvalue;
  if (li.owner.PRC<>nil)and(li.owner.PRC.dirid>0)and
  ((li.procN=0)or(li.procN2=0)) then cd.isNP:=true;
   end;
  end;
begin
 logs.startproc('mp','rebuild','start','',7);
 fupdating:=true;
 flinkIndex:=Links_Index;
if (fsrc=nil)or(fdst=nil) then exit;
for i:=0 to fcelllist.Count-1 do
begin
cd:=TCellData(fcelllist[i]);
cells[cd.col+2,cd.row]:='';
objects[cd.col+2,cd.row]:=nil;
end;

for i:=0 to colvalues.count-1 do
 dispose(Pextended(colvalues[i]));
colvalues.clear;
for i:=0 to rowvalues.count-1 do
 dispose(Pextended(rowvalues[i]));
rowvalues.clear;
rowcount:=fsrc.rowcount;
colcount:=fdst.rowcount+2;
{colcount:=fixedcols+1;
rowcount:=fixedrows+1;}
{for j:=0 to rowcount-1 do
for i:=0 to colcount-1 do
cells[i,j]:='';}

max:=0;
canvas.font.assign(Font);
for i:=1 to Fsrc.Rowcount-1 do
 begin
 cells[0,i]:=FSrc.cells[0,i];
 cells[1,i]:=FSrc.cells[FSrc.namecol,i];
 new(v);
 v^:=0;
 rowvalues.add(v);
 if canvas.textwidth(cells[1,i])>max then max:=canvas.textwidth(cells[1,i]);
 end;
if (max+10)<300 then
 colwidths[1]:=max+10
 else
 colwidths[1]:=300;

for i:=1 to Fdst.Rowcount-1 do
begin
 cells[i+2,0]:=Fdst.cells[0,i];
colwidths[i+2]:=canvas.TextWidth(cells[i+2,0])+7;
new(v);
v^:=0;
colvalues.add(v);
end;
clearcelllist;
 logs.startproc('mp','rebuild','continue','',8);
if linksIndex<=0 then
begin
lstart:=1;
lend:=lcount
end
else
begin
lstart:=Links_Index;
lend:=Links_Index;
end;
for l:=lstart to lend do
begin
links:=links_array[l];
fnames:=links.middle;
if (links<>nil) then
begin
links.sort(lsFull);
 for i:=1 to links.size do
 begin
 if not canshow(links[i]) then continue;
 asm
   fInit;
 end;
 curlink:=links[i];
  // if not((links[i].tbegin<=links.dend)and((links[i].tend>=links.dbegin)or(links[i].tend=0)))then continue;
  if  itutils.ApplyProcFilter1(links[i].procN,fsrc.Process,appconst.sysinfo.showprs0,links.prc)and
      itutils.ApplyProcFilter1(links[i].procN2,fdst.Process,appconst.sysinfo.showprs0,links.prc)then
proceed1link(links[i],links[i].ints,links[i].intd,links[i].lnum,links[i].flags,false);
if makeFictive and links.mirrorenabled then
begin
if (fsrc.insource.dirid=fdst.insource.dirid){and(links[i].ints<>links[i].intd)} then
  if  itutils.ApplyProcFilter1(links[i].procN2,fsrc.Process,appconst.sysinfo.showprs0,links.prc)and
      itutils.ApplyProcFilter1(links[i].procN,fdst.Process,appconst.sysinfo.showprs0,links.prc)then
proceed1link(links[i],links[i].intd,links[i].ints,links[i].lnum,links[i].flags xor 1,false);
if (fnames<>nil)and(fsrc.insource.dirid=fnames.dirid)then
  if  itutils.ApplyProcFilter1(links[i].procN2,fsrc.Process,appconst.sysinfo.showprs0,links.prc)and
      itutils.ApplyProcFilter1(links[i].procN,fdst.Process,appconst.sysinfo.showprs0,links.prc)then
proceed1link(links[i],links[i].lnum,links[i].intd,links[i].ints,links[i].flags xor 1,false);
if (fnames<>nil)and(fnames.dirid=fdst.insource.dirid) then
  if  itutils.ApplyProcFilter1(links[i].procN,fsrc.Process,appconst.sysinfo.showprs0,links.prc)and
      itutils.ApplyProcFilter1(links[i].procN2,fdst.Process,appconst.sysinfo.showprs0,links.prc)then
proceed1link(links[i],links[i].ints,links[i].lnum,links[i].intd,links[i].flags,false);
end;
end;
end;
end;
 logs.startproc('mp','rebuild','3',inttostr(fcelllist.count),8);
for i:=0 to fcelllist.count-1 do
begin
cd:=TCellData(fcelllist[i]);
c:=cd.col+1;
r:=cd.row;
Objects[c+1,r]:=cd;
cellstr:='';
link_value:=cd.value00;
fstr:=utils.FloatOut(link_value);
namestr:='';
if (cd.nn>0) then
begin
itutils.groupselsort(cd.namec,cd.names,cd.nn);
if cd.nn>0 then
if fviewStyle=mvsNames then
namestr:=namestr+Abbreveation(cd.names[1][cd.namec[1]].s)
else if fviewStyle=mvsNamesFull then
begin
namestr:=namestr+utils.getShort(cd.names[1][cd.namec[1]].s);
end;
if fviewStyle=mvsNames then
for j:=2 to cd.nn do
namestr:=namestr+','+Abbreveation(cd.names[j][cd.namec[j]].s)
else if fviewStyle=mvsNamesFull then
begin
for j:=2 to cd.nn do
namestr:=namestr+', '+cd.names[j][cd.namec[j]].s;
end;
end;
if (fviewStyle=mvsNamesFull)and (cd.comment<>'') then namestr:=namestr+'/'+cd.comment;
abcStr:='';
if fviewstyle=mvsABCFull then
begin
abcstr:=cd.ABC.DelimitedText;
end;
abcstr:=ClearSpaces(abcstr);
if ABCStr='' then ABCSTR:='*';
if namestr='' then namestr:='-';
case fviewstyle of
mvsNames,mvsNamesFull: cells[c+1,r]:=cells[c+1,r]+namestr;
mvsABCFull:                cells[c+1,r]:=cells[c+1,r]+abcStr;
mvsCross:begin
 if cd.flag and $1000=$1000 then  cells[c+1,r]:=cells[c+1,r]+' ';
 for j:=0 to 8 do
  if ((cd.flag and (1 shl j))<>0) then  cells[c+1,r]:=cells[c+1,r]+ltStrings[j];
 end;
end;
if canvas.TextWidth(cells[c+1,r])+7>colwidths[c+1] then colwidths[c+1]:=canvas.TextWidth(cells[c+1,r])+7;
end;
colwidths[0]:=canvas.TextWidth('9. ')+7;
for i:=1 to rowcount-1 do
if canvas.TextWidth(cells[0,i])+7>colwidths[0] then colwidths[0]:=canvas.TextWidth(cells[0,i])+7;
for i:=0 to rowvalues.count-1 do
 cells[2,i+1]:=floatout(pextended(rowvalues[i])^);


 logs.startproc('mp','rebuild','finished','',6);
col:=Fdst.Row+2;
row:=fsrc.row;
FCurCol:=col;
FCurRow:=row;
fupdating:=false;
enabled:=true;
if assigned(FSrc.onclick) then  FSRC.OnClick(FSRC);

Repaint;
end;

function TMatrixprojection.totalheight:integer;
var i:integer;
begin;
result:=gridlinewidth+5;
for i:=0 to rowcount-1 do
result:=result+gridlinewidth + rowheights[i];
end;
constructor TMatrixProjection.Create(AOwner:TComponent);
begin
inherited create(Aowner);
 fcelllist:=TList.create;
 colvalues:=TList.create;
 rowvalues:=TList.create;
 fviewstyle:=mvsCross;
 makefictive:=true;
 readonly:=false;
end;
destructor TMatrixProjection.Destroy;
var i:integer;
begin
clearcelllist;
fcelllist.free;
for i:=0 to colvalues.count-1 do
 dispose(Pextended(colvalues[i]));
for i:=0 to rowvalues.count-1 do
 dispose(Pextended(rowvalues[i]));
colvalues.clear;
rowvalues.clear;
colvalues.free;
rowvalues.free;
 inherited destroy;
end;

function TMatrixProjection.GetCellData(acol,arow:integer):TCellData;
begin
result:=TCellData(Objects[acol,arow]);
end;
procedure TMatrixProjection.clearcelllist;
var i:integer;
begin
 for i:=0 to fcelllist.count-1  do
  TCellData(fcelllist.items[i]).Free;
  fcelllist.clear;
end;
procedure TMatrixProjection.DrawCell(ACol,ARow:LongInt;ARect:TRect;AState:TGridDrawState);
var si,di:integer;
s:string;
 rv:extended;
 cd:TCellData;
begin
if fupdating then exit;
 canvas.brush.color:=color;
canvas.FillRect(ARect);
cd:=nil;
if (source=nil)or(detail=nil) then exit;
if (source.insource=nil)or(detail.insource=nil) then exit;
if arow >0 then si:=Source.smap[arow]
           else si:=0;
if acol>2 then di:=Detail.smap[acol-2]
           else di:=0;
if (si>0)and not assigned(source.insource[si]) then exit;
if (di>0)and not assigned(detail.insource[di]) then exit;
try
if gdfixed in AState then
begin
if (FCurCol=ACol)or(FCurRow=ARow) then
 canvas.brush.color:=clWhite
else
 if (di>0)and(Detail.insource[di].marked and $1<>0)or
    (si>0)and(Source.insource[si].marked and $1<>0) then
 canvas.brush.color:=clInfoBk
else
canvas.brush.color:=FixedColor;
canvas.font.color:=font.color;
if (acol=2)and(arow>0)and(arow<=rowvalues.count) then
begin
rv:=pextended(rowvalues[arow-1])^;
if rv=0 then
 canvas.font.color:=clRed
else if rv>0 then
canvas.font.color:=clGreen
else
canvas.font.color:=clBlue
end;
canvas.FillRect(ARect);
canvas.TextRect(ARect,Arect.left+(arect.right-arect.left-canvas.textwidth(cells[col,row])div 2)
,Arect.top+(ARect.Bottom-ARect.top-canvas.textHeight('A'))div 2,cells[col,row]);
end
else
begin
 canvas.brush.color:=color;
canvas.FillRect(ARect);

s:=cells[Acol,Arow];
{if gdfocused in state then
canvas.font.color:=clwhite
else}
if s<>'' then
begin

cd:=getcellData(acol,arow);
if cd<>nil then
begin
if cd.value00>0 then
canvas.font.color:=clGreen
else
if cd.value00=0 then
canvas.font.color:=clMaroon
else
canvas.font.color:=clBlue;


end;
end;
if s<>'' then
begin
canvas.TextRect(ARect,Arect.left+(ARect.right-Arect.left-canvas.textWidth(s)) div 2,
 Arect.top+(ARect.Bottom-ARect.top-canvas.textHeight('A'))div 2,s);
end;

end;
inherited;
if si>0 then
begin
canvas.Pen.Color:=clRed;
if Source.insource[si].deleted<>0 then
canvas.Polyline([Point(Arect.left,(arect.Top+ARect.Bottom)div 2),Point(arect.right,(arect.Top+aRect.Bottom)div 2)]);
end;
if di>0 then
begin
canvas.Pen.Color:=clRed;
if Detail.insource[di].deleted<>0 then
canvas.Polyline([Point((ARect.left+arect.right)div 2,Arect.top),Point((aRect.left+Arect.right)div 2,arect.bottom)]);
end;
canvas.pen.color:=clBlack;
if (FCurCol=ACol) then
 begin
 canvas.pen.Width:=1;
  canvas.polyline([point(arect.left,Arect.Top),point(arect.left,Arect.bottom)]);
 canvas.polyline([point(arect.right-1,arect.top),point(arect.right-1,arect.bottom)]);
 end;
if (FCurRow=ARow) then
 begin
 canvas.pen.Width:=1;
 canvas.polyline([point(arect.left,Arect.top),point(arect.right,Arect.top)]);
 canvas.polyline([point(arect.left,arect.bottom-1),point(arect.right,arect.bottom-1)]);
 end;
if (cd<>nil)and(cd.flag and $1000=$1000) then
begin
canvas.Brush.Style:=bsSolid;
canvas.Brush.Color:=clAqua;
canvas.Pen.Color:=color;
canvas.Rectangle(ARect);
Canvas.TextRect(ARect, ARect.Left+2, ARect.Top+2, Cells[ACol, ARow]);
//canvas.FloodFill(arect.Left+2,arect.Top+2,Canvas.Pen.Color,fsBorder);
canvas.Brush.Style:=bsSolid;
canvas.Brush.Color:=color;
end;
if (cd<>nil)and(cd.isNP) then
begin
canvas.Brush.Style:=bsFDiagonal;
canvas.Brush.Color:=clDkGray;
canvas.Pen.Color:=color;
canvas.Rectangle(ARect);
//canvas.FloodFill(arect.Left+2,arect.Top+2,Canvas.Pen.Color,fsBorder);
canvas.Brush.Style:=bsClear;
Canvas.TextRect(ARect, ARect.Left+2, ARect.Top+2, Cells[ACol, ARow]);
canvas.Brush.Style:=bsSolid;
canvas.Brush.Color:=color;
end;

except
showmessage('col:'+inttostr(col)+' row:'+inttostr(row));
end;
end;
procedure TMatrixProjection.Click;
begin
if not enabled then exit;
if fupdating then exit;
fupdating:=true;
if fsrc<>nil then fsrc.row:=row;
if fdst<>nil then fdst.row:=col-2;
fupdating:=false;
inherited click;
//repaint;
end;
Procedure TMatrixProjection.ADDLinks(l:TLiteLinks);
begin
inc(lcount);
links_array[lcount]:=l;
end;
Procedure TMatrixProjection.ClearLinks;
begin
lcount:=0;
fLinkIndex:=0;
end;
procedure TMatrixProjection.KeyDown(var Key: Word; Shift: TShiftState);
var i:integer;
begin
//if ssCtrl in shift then showmessage(inttohex(key,2));
if (ssAlt in Shift) and (key in [$25,$26,$27,$28]) then
begin

case key of
 $25:begin
      for i:=col-1 downto fixedcols do
       if cells[i,row]<>'' then break;
       if i>=fixedcols then col:=i;
     end;
 $26:begin
      for i:=row-1 downto 1 do
       if cells[col,i]<>'' then break;
      if i>0 then row:=i;
     end;
 $27:begin
      for i:=col+1 to colcount-1 do
       if cells[i,row]<>'' then break;
       if i<colcount then col:=i;
     end;
 $28:begin
      for i:=row+1 to rowcount-1 do
       if cells[col,i]<>'' then break;
      if i<rowcount then row:=i;
     end;
end;
key:=0;
end
else inherited KeyDown(key,Shift);
//showmessage(inttostr(integer(editormode))+':'+chr(key)+'#'+inttohex(key,2));
end;
function TMatrixProjection.SelectCell(ACol,ARow:LongInt):boolean;
var i:integer;
begin
result:=inherited SelectCell(Acol,Arow);
if fupdating then exit;
if not result then exit;
FCurCol:=Acol;
FCurRow:=Arow;
 if ACol<>col then
 begin
    for i:=0 to FixedRows-1 do
  begin
  InvalidateCell(Col,i);
  InvalidateCell(ACol,i);
  end;

   for i:=TopRow to min(rowcount-1,toprow+visibleRowcount) do
  begin
  InvalidateCell(Col,i);
  InvalidateCell(ACol,i);
  end;
 end;
 if ARow<>row then
 begin
    for i:=0 to Fixedcols-1 do
  begin
  InvalidateCell(i,row);
  InvalidateCell(i,arow);
  end;

   for i:=leftcol to min(colcount-1,leftcol+visiblecolcount) do
  begin
  InvalidateCell(i,row);
  InvalidateCell(i,arow);
  end;
 end;
end;
procedure TMatrixProjection.filterClsLeft(rootindex:integer);
var i,j:integer;
    hasLinks:boolean;
    curp:TLiteLinks;
    p:integer;
begin
for i:=1 to Source.insource.Count do
begin
 Source.Filtered[i]:=false;
end;
p:=Detail.insource[rootindex].intparent;
haslinks:=false;
while (p>0)and not  haslinks do
begin
 for i:=1 to lcount do
 begin
  curP:=links_array[i];
  for j:=1 to curP.size do
   if (curP[j].intd=p) then
   begin
    hasLinks:=true;
    Source.Filtered[curP[j].ints]:=true;
   end;
 end;
 p:=Detail.insource[p].intparent;
end;
if not  hasLinks then
for i:=1 to Source.insource.Count do
begin
 Source.Filtered[i]:=true;
end;
end;
procedure TMatrixProjection.filterClsRight(rootindex:integer);
var i,j:integer;
    hasLinks:boolean;
    curp:TLiteLinks;
    p:integer;
begin
for i:=1 to Detail.insource.Count do
begin
 Detail.Filtered[i]:=false;
end;
p:=Source.insource[rootindex].intparent;
haslinks:=false;
while (p>0)and not  haslinks do
begin
 for i:=1 to lcount do
 begin
  curP:=links_array[i];
  for j:=1 to curP.size do
   if (curP[j].ints=p) then
   begin
    hasLinks:=true;
    Detail.Filtered[curP[j].intd]:=true;
   end;
 end;
 p:=Source.insource[p].intparent;
end;
if not  hasLinks then
for i:=1 to Detail.insource.Count do
begin
 Detail.Filtered[i]:=true;
end;
end;
procedure TMatrixProjection.MouseMove(Shift: TShiftState; X, Y: Integer);
var cc,cr:integer;
    s:string;
begin
MouseToCell(X,Y,cc,cr);

if (cc<0)or(cr<0)or(cc>=colcount)or(cr>=rowcount) then
begin
 application.CancelHint;
 foldhintpos:=point(-1,-1);
 exit;
end;
if (cc=foldhintpos.X)and(cr=foldhintpos.Y) then exit;
foldhintpos:=point(cc,cr);
application.CancelHint;
if cr>0 then
s:=utils.getShort(Cells[1,cr]);
if cc>2 then s:=s+#13#10+utils.getShort(detail.cells[detail.NameCol,cc-2]);
s:=ClearSpaces(s);
if s='' then
begin
  foldhintpos:=point(-1,-1);
 exit;
end
else
begin
hint:=s;
application.ActivateHint(Point(x,y));
end;

end;
function TMatrixProjection.CanShow(link:TOMLink):boolean;
begin
result:=false;
if link=nil then exit;
if link.owner=nil then exit;
case link.owner.PrjType of
ptLRN:result:=true;
ptIOC:result:=(link.flags and 2=0)and(1 in ViewMask)or(link.flags and 2=2)and(2 in ViewMask);
ptM:result:=3 in ViewMask;
ptC:result:=2 in ViewMask;
ptIOM:result:=(link.flags and 2=0)and(1 in ViewMask)or(link.flags and 2=2)and(3 in ViewMask);
end;
end;
constructor TCellData.Create(c,r:integer);
begin
inherited Create;
ABC:=TStringList.create;
row:=r;
col:=c;
isNP:=false;
value00:=0;
NN:=0;
flag:=0;
end;
destructor TCellData.destroy;
begin
ABC.free;
inherited Destroy;
end;
function TMatrixProjection.startIndex:integer;
begin
 if fLinkIndex>0 then
 result:=fLinkIndex
 else
 result:=1;
end;
function TMatrixProjection.endIndex:integer;
begin
 if fLinkIndex>0 then
 result:=fLinkIndex
 else
 result:=lCount;
end;
end.
