unit RepTypes;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface
uses  comctrls, graphics,items,classes,dcommon,mylists,otherlists;
type
TItemInfo=record pnodeid,sprId,itemid:integer;end;
TLinkInfo=record linkid:integer; flag:byte; end;
TProViewType=(pvInverse,pvStructure,pvDirect,pvHeaders,pvNone);
TLevelTop=(lt1,ltMarked,lTLiteLinks);
TOMReportNode=packed class
private
fcaption,flcCaption:string;
fTreeNode:TTreeNode;
public
 mode:boolean;
 kind:(kDir,kName);
 list,prslist:TOMItems;
 links,TopLinks:TLiteLinks;
 sprNum,ProNum:integer;
 Comment:String;
 proComment:String;
//---------
  markmode:byte;
  lastlevel,
  linksdetail:shortint;
  prodetail1,
  prodetailc,
  strDetailc,
  strdetail1:word;
//-------------------
  linksdesc,linkarray,IndexArray:TList;
  linksmarkmode:byte;
//------------------
  invisible,
  doubled,
  linkdir,
  ShowPRS,
  linkABC,
  CommentAll,
  CommentRecord,
  hidenames,
  raiselinks:boolean;
  PRSFilter,IndexFilter:byte;
  LinksFromMarked:boolean;
  UpLimited,noUpLimited:boolean;
  dirmask,bpMask:byte;
  viewtype:TProviewType;
  showName:boolean;
  ShortNameKind:byte;
  numbertype:byte;
  expandnumber:boolean;
  linksfromUp,linksFromUpRight:boolean;
  dOnly:Shortint;
  useDonlyUpLevels:boolean;
  xlstemplate:smallint;
  LevelsTop:TLevelTop;
  keepTonnel:boolean;
  procedure AssignNode(Node:TTreeNode);
  procedure setNodeImage;
  property Caption:string read fCaption write fCaption;
  property lcCaption:string read flcCaption write flcCaption;
  property TreeNode:TTreeNode read fTreeNode;
procedure SaveToStream(s:TStream);
procedure LoadFromStream(s:TStream);
procedure Assign(Source:TOMReportNode);
constructor Create;
destructor Destroy;override;
end;
TUpStack=Class
         private
          fsize:integer;
          fstkpos:integer;
          intd,lnum:array[1..32] of TIntList;
          public
          procN:array[1..32] of integer;
          dirids,lids,prcIDs,pos:array[1..32] of integer;
          ParentLink:array[1..32] of TRepLines;
          function GetDepth_D(dirId:integer):integer;
          function GetDepth_L(dirId:integer):integer;
          function GetClosest(dirid:integer):TIntList;
          procedure AddItem(d,l:integer);
          procedure Push;
          procedure Pop;
          Constructor Create;
          Destructor Destroy;
          function LastD:TIntList;
          function LastL:TIntList;
          function D(index:integer):TIntList;
          function L(index:integer):TIntList;
          property size:integer read fsize;
          property stkpos:integer read fstkpos write fstkpos;
end;
Tproinfo=record
          proN:integer;
          first,second:integer;
         end;
TReportGenerator=function(t:TTreeNode;name:string):boolean;
function LoadReportStructure(ms:TStream;MA:TModelArray;clsList,proList:TStringList):integer;
implementation
uses sysutils,dialogs,appconst,utils;
procedure TOMReportNode.SaveToStream(s:TStream);
var w:word;
begin
w:=self.sprNum;
s.Write(w,sizeof(w));
w:=self.ProNum;
s.Write(w,sizeof(w));
w:=(integer(self.mode) shl 0)or
   (integer(self.invisible) shl 1)or
   (integer(not self.doubled) shl 2)or
   (integer(self.linkdir) shl 3)or
   (integer(self.ShowPRS) shl 4)or
   (integer(self.linkABC) shl 5)or
   (integer(self.CommentAll) shl 6)or
   (integer(self.CommentRecord) shl 7)or
   (integer(not self.hidenames) shl 8)or
   (integer(not self.raiselinks) shl 9)or
   (integer(self.LinksFromMarked) shl 10)or
   (integer(self.UpLimited) shl 11)or
   (integer(self.noUpLimited) shl 12)or
   (integer(not self.showName) shl 13)or
   (integer(self.expandnumber) shl 14)or
   (integer(self.linksfromUp) shl 15);

s.Write(w,sizeof(w));
w:=(integer(self.useDonlyUpLevels) shl 0)or
   (integer(self.keepTonnel) shl 1)or
   ((self.markmode and $F)shl 2)or
   ((self.linksmarkmode and $7) shl 6)or
   ((self.PRSFilter and 7)shl 9)or
   ((self.IndexFilter and 7)shl 12);
s.Write(w,sizeof(w));
w:=self.lastlevel or
   (integer(self.linksFromUpRight) shl 7)or
   self.linksdetail shl 8;
s.Write(w,sizeof(w));
w:=self.prodetail1;
s.Write(w,sizeof(w));
w:=self.prodetailc;
s.Write(w,sizeof(w));
w:=self.strdetail1;
s.Write(w,sizeof(w));
w:=self.strdetailc;
s.Write(w,sizeof(w));
w:=self.dirmask or
   self.bpMask shl 8;
s.Write(w,sizeof(w));
w:=self.ShortNameKind or
   self.numbertype shl 8;
s.Write(w,sizeof(w));
w:=self.dOnly or
   (integer(self.viewtype)and $F) shl 8 or
   (integer(self.LevelsTop) and $7) shl 12;
s.Write(w,sizeof(w));
w:=self.xlstemplate;
s.Write(w,sizeof(w));
utils.SaveString(s,self.fcaption);
utils.SaveString(s,self.flcCaption);
w:=0;
s.Write(w,sizeof(w));
end;
procedure TOMReportNode.LoadFromStream(s:TStream);
var w:word;
begin
s.Read(w,sizeof(w));
SprNum:=w;
s.Read(w,sizeof(w));
self.ProNum:=smallint(w);

s.Read(w,sizeof(w));
mode:=w and 1=1;
invisible:=w and 2=2;
doubled:=w and 4=0;
linkdir:=w and 8=8;
ShowPRS:=w and 16=16;
LinkABC:=w and 32=32;
CommentAll:=w and 64=64;
CommentRecord:=w and 128=128;
hidenames:=w and 256=0;
raiselinks:=w and 512=0;
LinksFromMarked:=w and 1024=1024;
UpLimited:=w and 2048=2048;
noUpLimited:=w and 4096=4096;
showName:=w and 8192=0;
expandnumber:=w and 16384=16384;
linksfromup:=w and 32768=32768;
linksfromupright:=w and 65536=65536;
s.Read(w,sizeof(w));
useDonlyUpLevels:=w and 1=1;
keepTonnel:= w and 2=2;
markMode:= (w shr 2)and $F;
linksmarkMode:=(w shr 6)and 7;
PRSFilter:=(w shr 9) and 7;
IndexFilter:=(w shr 12) and 7;
s.Read(w,sizeof(w));
lastlevel:=w and $FF;
linksdetail:=(w shr 8) and $7F;
LinksFromUpRight:=w and $80<>0;
s.Read(w,sizeof(w));
prodetail1:=w;
s.Read(w,sizeof(w));
prodetailc:=w or 1;
s.Read(w,sizeof(w));
strdetail1:=w;
s.Read(w,sizeof(w));
strdetailc:=w or 1;
s.Read(w,sizeof(w));
dirmask:= w and $FF;
bpmask:=(w shr 8) and $FF;
s.Read(w,sizeof(w));
ShortNameKind:= w and $F;
numbertype:=(w shr 8)and $F;
s.Read(w,sizeof(w));
dOnly:=w and $FF;
viewType:=TProViewType((w shr 8)and $F);
LevelsTop:=TLevelTop((w shr 12)and 7);
s.Read(w,sizeof(w));
xlstemplate:=w;
fcaption:=utils.LoadString(s);
flcCaption:=utils.LoadString(s);
s.Read(w,sizeof(w));
s.Seek(w,soFromCurrent);
end;

constructor TOMReportNode.Create;
begin
inherited create;
mode:=true;
BPMask:=15;
list:=TOMItems.create;
prslist:=TOMItems.create;
links:=TLiteLinks.create(prslist);
topLinks:=TLiteLinks.create(prslist);
linksDesc:=TList.create;
linkarray:=TList.create;
IndexArray:=TList.Create;
Comment:='';
ProComment:='';
fCaption:='';
flcCaption:='';
dirmask:=0;
showname:=true;
ShortNameKind:=0;
LevelsTop:=lt1;
raiselinks:=true;
hidenames:=true;
prodetail1:=0;
prodetailc:=1;
strdetail1:=0;
strdetailc:=1;
doubled:=true;
KeepTonnel:=false;
pronum:=0;
sprNum:=0;
end;
destructor TOMReportNode.Destroy;
var i:integer;
begin
List.free;
prslist.free;
Links.free;
TopLinks.free;
for i:=0 to LinksDesc.count-1 do
TOMItems(linksDesc[i]).free;
for i:=0 to linkArray.count-1 do
TLiteLinks(linkArray[i]).free;
for i:=0 to IndexArray.count-1 do
TOMItems(IndexArray[i]).free;
LinksDesc.clear;
LinksDesc.free;
LinkArray.Free;
IndexArray.Free;
inherited Destroy;
end;
procedure TOMReportNode.AssignNode(Node:TTreeNode);
begin
 ftreeNode:=Node;
end;
procedure TOMReportNode.setNodeImage;
begin
if sprNum<>0 then
  begin
  if Kind=kName then
  fTreeNode.ImageIndex:=9
  else
    if xlstemplate<>0 then
  fTreeNode.ImageIndex:=12
  else
  fTreeNode.ImageIndex:=0
  end
  else
  if pronum=-1 then
  fTreeNode.ImageIndex:=4
  else if xlstemplate<>0 then
  fTreeNode.ImageIndex:=12
  else
  fTreeNode.ImageIndex:=7;
  fTreeNode.SelectedIndex:=fTreeNode.ImageIndex;
end;
procedure TOMReportNode.Assign(Source:TOMReportNode);
begin
if Source=nil then exit;
fcaption:=Source.fcaption;
flcCaption:=Source.flcCaption;
 mode:=Source.Mode;
 kind:=Source.Kind;
 sprNum:=Source.SprNum;
 ProNum:=Source.ProNum;
//---------
  markmode:=Source.markMode;
  lastlevel:=Source.lastlevel;
  linksdetail:=Source.linksDetail;
  prodetail1:=Source.prodetail1;
  prodetailc:=Source.prodetailc;
  strDetailc:=Source.StrDetailc;
  strdetail1:=Source.strDetail1;
  linksmarkmode:=Source.linksmarkmode;
//------------------
  invisible:=Source.invisible;
  doubled:=Source.doubled;
  linkdir:=Source.linkdir;
  ShowPRS:=Source.ShowPRS;
  linkABC:=Source.LinkABC;
  CommentAll:=Source.CommentAll;
  CommentRecord:=Source.CommentRecord;
  hidenames:=Source.hideNames;
  raiselinks:=Source.raiselinks;
  PRSFilter:=Source.PRSFilter;
  IndexFilter:=Source.IndexFilter;
  LinksFromMarked:=Source.LinksFromMarked;
  UpLimited:=Source.UpLimited;
  noUpLimited:=Source.noUpLimited;
  dirmask:=Source.dirmask;
  bpMask:=Source.bpmask;
  viewtype:=Source.viewType;
  showName:=Source.ShowName;
  ShortNameKind:=Source.ShortNameKind;
  numbertype:=Source.numbertype;
  expandnumber:=Source.expandNumber;
  linksfromUp:=Source.linksfromUp;
  linksFromUpRight:=Source.linksFromUpRight;
  dOnly:=Source.dOnly;
  useDonlyUpLevels:=Source.useDOnlyUpLevels;
  xlstemplate:=Source.xlsTemplate;
  LevelsTop:=Source.LevelsTop;
  KeepTonnel:=Source.keepTonnel;
end;
function LoadReportStructure(ms:TStream;MA:TModelArray;clsList,proList:TStringList):integer;
var AbsN,ParN:integer;
    j:integer;
    prn:TOMReportNode;
    mo:PModelObject;
    s:string;
begin
ms.read(AbsN,sizeof(AbsN));
while (abs(absN)>0)and(ms.position<ms.size) do
begin
ms.read(parN,sizeof(parN));
s:=utils.LoadString(ms);
ms.read(j,sizeof(j));
  prn:=TOMReportNode.create;
  try
  prn.loadfromstream(ms);
  mo:=MA.getModelObjectByID(prn.sprNum);
  if (mo<>nil)and(clsList.IndexOfObject(TObject(mo))=-1) then
   clsList.AddObject(mo^.name,TObject(mo));
  mo:=MA.getModelObjectByID(prn.ProNum);
  if (mo<>nil)and(ProList.IndexOfObject(TObject(mo))=-1) then
   ProList.AddObject(mo^.name,TObject(mo));
  finally
  prn.free;
  end;
  ms.read(AbsN,sizeof(AbsN));
end;
ms.read(j,sizeof(integer));
ms.seek(j,soFromCurrent);
//ms.LoadFromStream(bs);
end;
function TUpStack.GetDepth_D(dirId:integer):integer;
var i:integer;
begin
 result:=0;
 for i:=fstkpos downto 1 do
 begin
  if self.dirids[i]=dirid then
  begin
   result:=i;
   exit;
  end;
 end;
end;
function TUpStack.GetDepth_L(dirId:integer):integer;
var i:integer;
begin
 result:=0;
 for i:=fstkpos downto 1 do
 begin
  if self.lids[i]=dirid then
  begin
   result:=i;
   exit;
  end;
 end;
end;

procedure TUpStack.AddItem(d,l:integer);
begin
intd[size].add(d);
lnum[size].add(l);
pos[size]:=intd[size].Count-1;
end;
procedure TUpStack.Push;
begin
inc(fsize);
intd[size]:=TIntList.create;
lnum[size]:=TIntList.create;
procN[size]:=procN[size-1];
dirids[size]:=dirids[size-1];
lids[size]:=lids[size-1];
pos[size]:=-1;
end;
procedure TUpStack.Pop;
begin
intd[size].free;
lnum[size].free;
dirids[size]:=0;
lids[size]:=0;
procN[size]:=0;
dec(fsize);
end;
Constructor TUpStack.Create;
begin
inherited Create;
fsize:=1;
intd[1]:=TIntList.create;
lnum[1]:=TIntList.create;
procN[1]:=0;
dirids[1]:=0;
lids[1]:=0;
end;
Destructor TUpStack.Destroy;
var i:integer;
begin
 for i:=1 to size do
 begin
 intd[i].free;
 lnum[i].free;
 end;
inherited destroy;
end;
function TUpStack.LastD:TIntList;
begin
 result:=intd[size];
end;
function TUpStack.LastL:TIntList;
begin
 result:=lnum[size];
end;
function TUpStack.D(index:integer):TIntList;
begin
 result:=Intd[index];
end;

function TUpStack.L(index:integer):TIntList;
begin
 result:=lnum[index];
end;
function TUpStack.GetClosest(dirid:integer):TIntList;
var ld,dd:integer;
begin
ld:=self.GetDepth_L(dirid);
dd:=self.GetDepth_D(dirid);
result:=nil;
if (dd=0)and(ld=0) then exit;
if dd>=ld then result:=intd[dd]
else result:=lnum[dd];
end;
end.
