unit utils;
{
(c) . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface
uses dbtables,db,sysutils,windows,comctrls,gauges,stdctrls,classes,inifiles,graphics,controls,Commctrl;
const
  nfonts=8;
  booleanStrings:array[boolean]of string=('false','true');
  Boolean10:array[boolean] of char=('0','1');
  binarymask:array[0..15] of word =(1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768);
type
 pint=^integer;
 pextended=^extended;
 setbyte=set of byte;
 CharSET=set of char;
 TSearchCommand=(scAND,scOR,scNOT,scXOR);
var precision:integer;
 function max(x,y:longint):longint;
 function min(x,y:longint):longint;
 function sign(x:integer):integer;
 function CutFileExt(FileName:string):string;
 function NormalFileName(FileName:string):string;
 function NormalFileName2(FileName:string):string;
 function ShortToLongFileName(const ShortName: string): string;
 function setindent(id:integer;s:char):string;
 function isfind(substr:TStrings;COMMAND:TSearchCommand; str:string;partial,casesence:boolean):boolean;
 function normal(s:string):string;
 function cutNumbers(s:string):string;
 function getNumbers(s:string):string;
 function GetComment(s:string):string;
 function concatlines(s:string):string;
 function daysinmonth(month,year:integer):integer;

 function enddate(d:TDateTime;interval,itype:smallint):TDateTime;
 procedure findOptimalInterval(start,finish:TDateTime;var interval,itype:integer);
 function flagOrder(f1,f2:word):boolean;
 function StrToFloatDef(s:string;default:real):real;
 function InRect(r:TRect;p:TPoint):boolean;
 function ExcludeDPoint(s:string):string;
 function FloatOut(f:extended):string;
 function WeekStartRU(d:TDateTime):TDateTime;
 function WindowsDir:string;
 function ExcelRect(r:TRect):string;
 procedure rotateNormal(state:word;var ints,intd,lnum:integer);
 function inttostr0(i:integer):string;
 function copySTRFile(filename:string;newfilename:string;G:TGauge):boolean;
 function EncodeString(s:string):string;
 function findnextname(n,dir:string):string;
 function cutdate(name:string):string;
 function abbreveation(s:string):string;
 function getShort(s:string):string;
 function getFull(s:string):string;
 function getGloss(s:string):string;
 procedure SelSort(var a:array of integer; n:integer);

 function Define_File_Time(name:string):TDateTime;
 function GetInt(i:integer;e:boolean):integer;
 function RemoveCR(s:string):string;
 function cutCR(s:string):string;
 function MakeCR(s:string):string;
 function intervaltostring(i_start,i_end:TDateTime):string;
 procedure setmemosize(memo:TMemo;canvas:integer;defwidth:integer);
 function checklevelmask(level1,levelc:integer;mask1,maskc:word):boolean;
 function fillBits(bc:byte):word;
 function oneline(memo:TStrings):string;
 function MakeLine(memo:TStrings):string;
 procedure convtoCR(s:string;sl:TStrings);
 function ReplaceCR(s:string):string;
 procedure addTR(s:TStrings);
 function droppoints(s:string):string;
 function pointercompare(Item1, Item2: Pointer): Integer;
 function CombineString(s1,s2,s3:string):string;
 function GetTmpFileName: String;
 function cdata(s:string):string;
 procedure ExecuteandWait(prog:string;wait:boolean);
 function StrContain(s:string;chartoseek :CharSET):boolean;
 function RemoveDuplicatedSlashes(s:string):string;
 function NormalRect(p1,p2:TPoint):TRect;
 function conv8bit(s:string):string;
 function FindString(tofind:string;values:array of string):integer;
 function BinaryLength(w:word):integer;
 procedure SaveString(Storage:TStream;s:string);
 function LoadString(Storage:TStream):string;
 procedure ClearFile(filename:string);
 function ScaleFileName(data:TTable):string;
 function GetAverageCharSize(Canvas: TCanvas): TPoint;
 function InputQueryUnSelected(const ACaption, APrompt: string;
   var Value: string): Boolean;
function InputQueryLong(const ACaption, APrompt: string;
   var Value: string): Boolean;
 function SelectFromList(const ACaption, APrompt: string;Choises:TStrings;
   var Value: integer): Boolean;
 function Translit(s:string):String;
 function ToXMLName(s:string):string;
 function checkExcel(s:string):string;
 function ParseString(Separators, WhiteSpace: TSysCharSet; Content: string; Strings: TStrings): Integer;
 function GetLevel(s:string):integer;
 function inSet(val:integer; IntSet:Array of Integer):boolean;
 procedure ShowBalloonTip(Control: TWinControl; Icon: integer; Title: pchar;
  Text: PWideChar;
  BackCL, TextCL: TColor);
 function DeleteInTrashBin(filename:string;UseBin:boolean):boolean;
 function LightCompare(s1,s2:string):boolean;
 procedure SwapListItems(li1,li2:TListItem);
 function ClearSpaces(s:string):string;
 function GetFullNodePath(node:TTreeNode):string;
 procedure ClearBitmap(bmp:TBitmap;Color:TColor);
{$IFOPT D-}
 function ISDP:integer;
{$ENDIF}
  {type
  TMyInifile=class(TIniFile)
 public
 function ReadInteger(const Section, Ident: String; Default: Longint): Longint;override;

 end;}
implementation
uses fileutil,logs,dialogs,forms,shellAPI,consts,messages,strutils,jpeg,appconst;
 function max(x,y:longint):longint;
 begin
  if x>y then max:=x
         else max:=y;
 end;
function min(x,y:longint):longint;
begin
 result:=x;
 if x>y then result:=y;
end;
function CutFileExt(FileName:string):string;
begin
 result:=ClearSpaces(System.copy(FileName,1,length(filename)-length(extractfileext(filename))));
end;
function sign(x:integer):integer;
begin
 result:=1;
 if x<0 then result:=-1
  else if x=0 then result:=0;

end;
function NormalFileName(FileName:string):string;
const invalidcharset=['\','/',':','*','?','<','>','|','"'];
      invalidstartchar=['.',' '];
Var i:integer;
begin
 result:='';
 filename:=ClearSpaces(filename);
 for i:=1 to length(filename) do
  if not (filename[i] in invalidcharset) then
  if (result<>'')or not(filename[i] in invalidstartchar) then
   result:=result+filename[i];
if extractfileext(result)<>'' then
result:=ClearSpaces(cutfileext(result))+ClearSpaces(extractfileext(result));
if result='' then result:=''
end;
function NormalFileName2(FileName:string):string;
const invalidcharset=['"'];
      invalidstartchar=['.',' '];
Var i:integer;
begin
 result:='';
 filename:=ClearSpaces(filename); 
 for i:=1 to length(filename) do
  if not (filename[i] in invalidcharset) then
  if (result<>'')or not(filename[i] in invalidstartchar) then
   result:=result+filename[i];
if extractfileext(result)<>'' then
result:=ClearSpaces(cutfileext(result))+ClearSpaces(extractfileext(result));    
if result='' then result:='noname'
end;

function setindent(id:integer;s:char):string;
begin
result:=stringofchar(s,id);
end;
 function isfind(substr:TStrings;COMMAND:TSearchCommand; str:string;partial,casesence:boolean):boolean;
 var i:integer;
     found:array[0..63] of boolean;
     allfound,anyfound:boolean;
begin
if not casesence then
 begin
  str:=ansiuppercase(str);
 end;
if (substr.Count>1) then
begin
for i:=0 to substr.Count-1 do
if partial and(system.pos(substr[i],str)<>0)or(substr[i]=str) then found[i]:=true
                                     else found[i]:=false;
case Command of
scAND:begin
      allfound:=true;
      for i:=0 to substr.count-1 do
       allfound:=allfound and found[i]
      end;
scOR:begin
      allfound:=false;
      for i:=0 to substr.count-1 do
       allfound:=allfound or found[i]
      end;
scNOT:begin
      allfound:=true;
      for i:=0 to substr.count-1 do
       allfound:=allfound and not found[i]
      end;
scXOR:begin
      allfound:=true;
      anyFound:=false;
      for i:=0 to substr.count-1 do
      begin
       allfound:=allfound and found[i];
       Anyfound:=anyFound or found[i];
      end;
      allfound:=anyfound and not allfound;
      end;
else
 allfound:=false;
 anyfound:=false;
end;
result:=AllFound;
end
else
result:=partial and (system.pos(substr[0],str)>0)or (str=substr[0]);
end;
function normal(s:string):string;
var i:integer;
begin
 result:='';
 for i:=1 to length(s) do
 if s[i]='"' then
  result:=result+'""'
 else
  result:=result+s[i];
end;
function concatLines(s:string):string;
begin
 result:=s;
 while pos(#13,result)<>0 do
  result:=copy(result,1,pos(#13,result)-1)+' '+copy(result,pos(#13,result)+2,length(result));
end;
function daysinmonth(month,year:integer):integer;
begin
 case month of
  2:if isleapyear(year) then result:=29
                       else result:=28;
 4,6,9,11:result:=30;
 else
 result:=31;
 end;

end;
function enddate(d:TDateTime;interval,itype:smallint):TDateTime;
var y,m,day:word;
begin
decodedate(d,y,m,day);
result:=d;
 case itype of
 0:result:=d;
 1:result:=d+interval-1;
 2:result:=d+interval*7-1;
 3:result:=encodedate(y+(m+interval-1)div 12,(m+interval-1)mod 12+1,
           min(day,daysinmonth((m+interval-1)mod 12+1,y+(m+interval-1)div 12)))-1;
 4:result:=encodedate(y+interval,m,min(day,daysinmonth(m,y+interval)))-1;
end;
end;
 function flagOrder(f1,f2:word):boolean;
 const fo:array[0..7] of integer=(7,7,5,6,3,4,1,2);

 begin
  result:=fo[f1]<fo[f2];
 end;
function StrToFloatDef(s:string;default:real):real;
begin
 result:=0;
 if s='' then exit;
 try
  result:=strtofloat(s);
  except
  result:=default;
 end;
end;
function InRect(r:TRect;p:TPoint):boolean;
begin
 result:=(p.x<=r.Right)and(p.x>=r.Left)and(p.y<=r.Bottom)and(p.y>=r.Top);
end;
procedure findOptimalInterval(start,finish:TDateTime;var interval,itype:integer);
var ms,ys,ds,mf,yf,df:word;
begin

 finish:=trunc(finish+1);
 start:=trunc(start);
// showmessage(datetostr(start)+':'+datetostr(finish));
 decodedate(start,ys,ms,ds);
 decodedate(finish,yf,mf,df);
 if trunc(finish-start) mod 7 =0 then
 begin
  itype:=2;
  interval:= trunc(finish-start) div 7
 end
 else if (ds=df)and(mf=ms) then
  begin
  itype:=4;
  interval:=yf-ys;
  end
 else if (ds=df) then
  begin
  itype:=3;
  interval:=(yf-ys)*12+(mf-ms);
  end
 else
 begin
  itype:=1;
  interval:=trunc(finish-start);
 end;
end;
function ExcludeDPoint(s:string):string;
var i:integer;
begin
result:=s;
i:= pos(' : ',result);
while i<>0 do
begin
 result:=copy(result,1,i-1)+': '+copy(result,i+3,length(result));
 i:= pos(' : ',result);
end;
end;
function FloatOut(f:extended):string;
var r:extended;
begin
r:= frac(f);
r:=round((r)*exp(ln(10)*precision))/exp(ln(10)*precision);

result:=floattostr(trunc(f)+r);
end;
function WeekStartRU(d:TDateTime):TDateTime;
begin
if dayofweek(d)<>1 then
result:=d-dayOfWeek(d)+2
else result:=d-6;
end;
function WindowsDir:string;
var s:PChar;
    len:DWORD;
begin
len:=MAX_PATH + 1;
s:=stralloc(len);
windows.getwindowsdirectory(s,len);
result:=string(s);
end;
function ExcelRect(r:TRect):string;
begin
 result:='R'+inttostr(r.top)+'C'+inttostr(r.left)+':'+'R'+inttostr(r.bottom)+'C'+inttostr(r.right);
end;
procedure rotateNormal(state:word;var ints,intd,lnum:integer);
var l,r,m:integer;
begin
 case state of
      $1b:begin l:=intd;r:=ints;m:=lnum;end;
      $1e:begin l:=lnum;r:=intd;m:=ints;end;
      $27:begin l:=ints;r:=lnum;m:=intd;end;
      $2d:begin l:=lnum;r:=ints;m:=intd;end;
      $36:begin l:=intd;r:=lnum;m:=ints;end;
      $39:begin l:=ints;r:=intd;m:=lnum;end;
      else begin l:=ints;r:=intd;m:=lnum;end;
  end;
ints:=l;
intd:=r;
lnum:=m;
end;
function inttostr0(i:integer):string;
begin
result:='';
if i<>0 then result:=inttostr(i);
end;
function copySTRFile(filename:string;newfilename:string;G:TGauge):boolean;
 begin
 filemode:=0;
 filename:=expandfilename(filename);
 newfilename:=expandfilename(newfilename);
 try
 logs.startproc('utils','copySTR',newfilename,filename,5);
//windows.copyFile(PChar(filename),PChar(newfilename),false);
if not fileutil.DeleteFiles(newfilename) then
logs.startproc('UTILS','CopySTRFile','Cannot delete file',newfilename,1);
fileutil.copyfile(filename,newfilename,G);
 if fileexists(cutfileext(filename)+MBEXT) then
 begin
  logs.startproc('utils','copySTR2',cutfileext(newfilename)+MBEXT,cutfileext(filename)+MBEXT,5);
// windows.copyfile(PChar(cutfileext(filename)+MBEXT),PChar(cutfileext(newfilename)+MBEXT),false);
 fileutil.copyfile(cutfileext(filename)+MBEXT,cutfileext(newfilename)+MBEXT,G);
logs.startproc('utils','copySTR2OK',cutfileext(newfilename)+MBEXT,cutfileext(filename)+MBEXT,5);
end;
if fileexists(cutfileext(filename)+'.SSD') then
 begin
// windows.copyfile(PChar(cutfileext(filename)+MBEXT),PChar(cutfileext(newfilename)+MBEXT),false);
 fileutil.copyfile(cutfileext(filename)+'.SSD',cutfileext(newfilename)+'.SSD',G);
logs.startproc('utils','copySTR3OK',cutfileext(newfilename)+'.SSD',cutfileext(filename)+'.SSD',5);
end
else
ClearFile(cutfileext(newfilename)+'.SSD');
 result:=true;
 except
on e:exception do begin
logs.OnException(nil,e);
 result:=false;
 end;
 end;
 logs.startproc('utils','copystr','finish',filename,20);
 filemode:=2; 
// showmessage(newfilename+'/'+cutfileext(newfilename)+MBEXT);
end;
function EncodeString(s:string):string;
var i:integer;
begin
result:='';
for i:=1 to length(s) do
if (ord(s[i])>32)and(ord(s[i])<128) then  begin
result:=result+s[i];
if s[i]='%' then result:=result+'%';
end
else result:=result+'%'+IntToHex(ord(s[i]),2);
end;
function findnextname(n,dir:string):string;
var pl,pr,i:integer;
    root:string;
begin
result:=cutfileext(n);
if not fileexists(dir+n) then exit;
root:=cutfileext(n);
pr:=pos(']',root);
pl:=0;
for i:=pr+1 to length(root) do
 if root[i]='.' then pl:=i;
if (pl>0)then root:=copy(n,1,pl-1);
i:=2;
while fileexists(dir+root+'.'+inttostr(i)+extractfileext(n)) do inc(i);

result:=root+'.'+inttostr(i);
end;
function cutdate(name:string):string;
var
i1,i2:integer;
docut:boolean;
begin
  result:=name;
  docut:=false;
  if result[length(result)]=']' then
  begin
  i2:=length(result);
  for i1:=i2-1 downto 1 do if result[i1]='[' then
  begin
   docut:=true;
   break;
  end;
  end;
  if docut then
   delete(result,i1,i2-i1+1);
end;
 function abbreveation(s:string):string;
 var i,pl,pr:integer;
     isinword:boolean;
 begin
 s:=ClearSpaces(s);
 pl:=pos('{',s);
 pr:=pos('}',s);
  if (pr>0)and(pl>0) and (pr-pl>1) and(pr-pl<6) then
  begin
   result:=copy(s,pl+1,pr-pl-1);
   exit;
  end;
 result:='';
 isinword:=false;
 for i:=1 to length(s) do
  if s[i] in [' ','"','(',')','.',',',':',';','[',']','&'] then begin isinword:=false;continue; end
  else
  begin
  if not isinword then result:=result+s[i];
  isinword:=true;
  end;
  result:=ANSIUpperCase(result);
 end;
procedure SelSort(var a:array of integer;n:integer);
var i,j:integer;
    d:integer;
begin
for i:= low(a) to low(a)+n-2 do
begin
 for j:=i+1 to low(a)+n-1 do
  if a[i]>a[j] then
   begin d:=a[i]; a[i]:=a[j]; a[j]:=d; end;
end;
end;
function Define_File_Time(name:string):TDateTime;
var hfile,creation:integer;
begin
hfile:=fileopen(name,fmOpenRead);
creation:= filegetDate(hfile);
fileclose(hfile);
if creation>0 then
result:=FileDateToDateTime(creation)
else
result:=0;
end;
function cutNumbers(s:string):string;
var i:integer;
begin
i:=1;
result:=s;
While (i<=length(s))and(s[i] in ['.','0'..'9']) do inc(i);
result:=ClearSpaces(copy(s,i,length(s)));
end;
function getNumbers(s:string):string;
var i:integer;
begin
i:=1;
result:=s;
While (i<=length(s))and(s[i] in ['.','0'..'9']) do inc(i);
result:=ClearSpaces(copy(s,1,i-1));
end;
function GetComment(s:string):string;
begin
result:='';
if ClearSpaces(s)='' then exit;
if pos('@',s)<>1 then
if  pos(#13+#10+'@',s)<>0 then
 result:=ClearSpaces(copy(s,1,pos(#13+#10+'@',s)-1))
 else result:=ClearSpaces(s)
else result:='';
end;
function GetInt(i:integer;e:boolean):integer;
begin
if e then result:=i
     else result:=0;
end;
function RemoveCR(s:string):string;
var i:integer;
begin
result:=s;
result:=ClearSpaces(result);
for i:=1 to length(result) do
if result[i]<' ' then result[i]:=' ';
result:=trim(result);
end;
 function intervaltostring(i_start,i_end:TDateTime):string;
 begin
result:=DateTostr(i_start)+' -- '+DateTostr(i_end);
 end;
procedure setmemosize(memo:Tmemo;canvas:integer;defwidth:integer);
 var i:integer;
     s:string;
     R:TRect;
     rline:TSize;
begin
if memo=nil then exit;

s:=ClearSpaces(memo.Lines.DelimitedText)+#13#10;
rline.cx:=0;
rline.cy:=0;
//isok:=Windows.GetTextExtentPoint(canvas, PChar(s), Length(s), rline);
R:=Rect(0,0,min(200,defwidth),100);
sleep(100);
for i:=1 to 5 do
begin
r.bottom:=Drawtext(canvas,PChar(s),length(s),r,DT_CALCRECT	or
                 DT_WORDBREAK	or
                 DT_CENTER);
end;
memo.clientWidth:=r.Right+5;
memo.clientHeight:=r.Bottom+5;
memo.Visible:=true;
memo.BringToFront;
end;
 function checklevelmask(level1,levelc:integer;mask1,maskc:word):boolean;
 begin
 result:= ((1 shl level1)and mask1<>0)or
          ((level1>15) and (mask1 and $8000 =$8000))or
          ((1 shl levelc) and maskc and (not 1)<>0);

 end;
function ReplaceCR(s:string):string;
var i:integer;
begin
result:='';
for i:=1 to length(s) do
 if s[i]=#13 then result:=result+#03
 else if s[i]>=#32 then result:=result+s[i];
 result:=trim(result);
end;
function MakeLine(memo:TStrings):string;
var i:integer;
begin
result:='';
for i:=0 to memo.count-1 do
result:=result+ClearSpaces(memo[i])+' ';
result:=ClearSpaces(result);
end;

function oneline(memo:TStrings):string;
var i:integer;
begin
result:='';
for i:=0 to memo.count-1 do
result:=result+ClearSpaces(memo[i])+#03;
result:=Trim(result);
end;
function fillBits(bc:byte):word;
var i:integer;
    c:word;
begin
result:=0;
c:=1;
for i:=1 to bc do
begin
result:=result or c;
c:=c shl 1;
end;
end;
procedure parseComment(comment:String;parsed:TStrings);
var i:integer;
begin
parsed.clear;
i:=system.pos(#2,comment);
while i>0 do
begin
parsed.add(copy(comment,1,i-1));
system.delete(comment,1,i);
i:=system.pos(#2,comment);
end;
parsed.Add(comment);
end;
function BuildComment(parsed:TStrings):string;
var i:integer;
    s:string;
begin
for i:=0 to parsed.count-2 do
s:=s+trim(parsed[i])+#02;
if parsed.count>0 then
s:=s+trim(parsed[parsed.count-1]);
result:=s;
end;
procedure addTR(s:TStrings);
var i:integer;
begin
for i:=0 to s.count-2 do s[i]:=s[i]+'<BR>';
end;
function GetShort(s:string):string;
var pl,pr:integer;
begin
pl:=pos('{',s);
pr:=pos('}',s);
if (pl>0)and(pr>0)and(pr>pl) then result:=system.copy(s,pl+1,pr-pl-1)
                             else result:=s;
end;
function getFull(s:string):string;
var pl,pr:integer;
begin
pl:=pos('{',s);
pr:=pos('}',s);
if (pl>0)and(pr>0)and(pr>pl) then result:=system.copy(s,1,pl-1)+system.copy(s,pr+1,length(s))
                             else result:=s;
end;
function getGloss(s:string):string;
var pl,pr:integer;
begin
pl:=pos('{',s);
pr:=pos('}',s);
if (pl>0)and(pr>0)and(pr>pl) then result:=system.copy(s,pl+1,pr-pl-1)+' - '+ system.copy(s,1,pl-1)+system.copy(s,pr+1,length(s))
                             else result:=s;
end;

function droppoints(s:string):string;
var i:integer;
begin
i:=1;
while (i<length(s))and(s[i]='.') do inc(i);
result:=copy(s,i,length(s));
end;
function ShortToLongFileName(const ShortName: string): string;
const pathdelimiter='\';
      tilde='~';
var f:TSearchrec;
    i:integer;
    parts:TStringList;
    cp:string;
    path:string;
begin
result:=ShortName;
if pos(tilde,result)=0 then exit;
parts:=tstringList.create;
for i:=1 to length(shortname) do
 if shortname[i]=pathdelimiter then
 begin
 parts.add(cp);
 cp:='';
 end
 else cp:=cp+shortname[i];
path:='';
result:='';
for i:=0 to parts.count-1 do
if pos(tilde,parts[i])<>0 then
begin
path:=path+parts[i];
findfirst(path,faAnyfile,f);
result:=result+f.name+pathdelimiter;
sysutils.findclose(f);
path:=path+pathdelimiter;
end
else
begin
result:=result+parts[i]+pathdelimiter;
path:=path+parts[i]+pathdelimiter;
end;
parts.free;
end;
 function pointercompare(Item1, Item2: Pointer): Integer;
 begin
 if integer(item1)<Integer(Item2) then result:=-1
 else if integer(item1)>integer(item2) then result:=1
 else result:=0;
 end;
function CombineString(s1,s2,s3:string):string;
begin
 if (s1<>'')and(s3<>'') then result:=s1+s2+s3
                        else result:=s1+s3;
end;
function GetTmpFileName: String;
var
  Dir: String;
  I: Integer;
begin
  SetLength(Dir, MAX_PATH);
  I := GetTempPath(MAX_PATH, PChar(Dir));
  if I > MAX_PATH then
  begin
    SetLength(Dir, I);
    I := GetTempPath(I, PChar(Dir));
  end;
  if I = 0 then
    {$IFDEF VCL6} RaiseLastOSError;
    {$ELSE} RaiseLastWin32Error; {$ENDIF}
  SetLength(Result, MAX_PATH);
  if GetTempFileName(PChar(Dir), 'EXR', 0, PChar(Result)) = 0 then
    {$IFDEF VCL6} RaiseLastOSError;
    {$ELSE} RaiseLastWin32Error; {$ENDIF}
  SetLength(Result, StrLen(PChar(Result)));
end;
function cdata(s:string):string;
var i:integer;
begin
result:='';
for i:=1 to length(s) do
if s[i]='<' then result:=result+'&lt;'
else
if s[i]='>' then result:=result+'&gt;'
else
if s[i]='&' then result:=result+'&amp;'
else
result:=result+s[i];

end;
procedure ExecuteandWait(prog:string;wait:boolean);
 var execinfo:PShellExecuteInfo;
     procinfo:TProcessInformation;
     sinfo:TStartupinfo;
     prg:PChar;
     cmdline:PChar;
     res:integer;
 begin
logs.startproc('utils','executeAndWait','1',prog,1 );
prog:=RemoveDuplicatedSlashes(prog);
logs.startproc('utils','executeAndWait','2',prog,1 );
 new(execinfo);
 execinfo^.cbSize:=sizeof(TShellExecuteInfoA);
 execinfo^.fMask:=SEE_MASK_FLAG_DDEWAIT or SEE_MASK_NOCLOSEPROCESS;
 execinfo^.Wnd:=0;
 execinfo^.lpVerb:='open';
 execinfo^.lpFile:=PChar(prog);
 execinfo^.lpParameters:=nil;
 execinfo^.lpDirectory:=nil;
 execinfo^.nShow:=SW_SHOWMAXIMIZED;
 fillchar(sinfo,sizeof(sinfo),0);
 sinfo.cb:=sizeof(sinfo);
 sinfo.lpReserved:=nil;
 sinfo.wShowWindow:=SW_SHOWMAXIMIZED;
 sinfo.dwFlags:=STARTF_USESHOWWINDOW;

// shellexecuteEx(execinfo);
prg:=StrAlloc(1000);
StrPCopy(prg,StringOfChar(' ',999));
cmdline:=StrAlloc(1000);
res:=findexecutable(PChar(prog),nil,Prg);
logs.startproc('utils','executeAndWait','findexecutable=',inttostr(res),1 );
if res<=32 then exit;
prog:=expandfilename(prog);
//showmessage(prog);
strPCopy(cmdline,Prg+' "'+Prog+'"');
//showmessage(cmdline);
logs.startproc('utils','executeAndWait',prog,cmdline,1 );
CreateProcess(nil,cmdline,nil,nil,false,
              NORMAL_PRIORITY_CLASS or CREATE_NEW_CONSOLE,
              nil,nil,sinfo,procinfo);
logs.startproc('utils','executeAndWait','Created',cmdline,1 );              
if wait then
 waitforsingleobject(procinfo.hProcess,INFINITE);
  dispose(execinfo);
  StrDispose(prg);
  StrDispose(cmdline);
 end;
procedure convtoCR(s:string;sl:TStrings);
var i:integer;
    part:string;
begin
 part:='';
 sl.clear;
 for i:=1 to length(s) do
  if s[i]=#03 then
  begin
  sl.add(part);
  part:=''
  end
  else
  part:=part+s[i];
  if part<>'' then sl.add(part);
end;
function MakeCR(s:string):string;
var i:integer;
begin
result:='';
for i:=1 to length(s) do
 if s[i]=#03 then result:=result+#13#10
                  else
 if s[i]>=#32 then
                  result:=result+s[i]
              else result:=result+' ';    
end;

function cutCR(s:string):string;
var i:integer;
begin
result:=s;
for i:=1 to length(result) do
 if result[i]=#03 then result[i]:=' ';
end;
{$IFOPT D-}
var
ISDePr:function:integer;
kernelhandle:integer;
 function ISDP:integer;
 var VINFO:TOSVersionInfo;
 begin
 VINFO.dwOSVersionInfoSize:=sizeof(VINFO);
  GetVersionEx(VINFO);
 { if assigned(@isdepr) then
  result:=IsDePr
  else }
  result:=0;
 end;
{$ENDIF}
function StrContain(s:string;chartoseek :CharSET):boolean;
var i:integer;
begin
 result:=false;
 for i:=1 to length(s) do
  if s[i] in chartoseek then begin result:=true; exit; end;
end;
 function RemoveDuplicatedSlashes(s:string):string;
var i:integer;
 begin
result:='';   
if s='' then exit;
result:=copy(s,1,1);
i:=2;
while i<=length(s) do
begin
result:=result+s[i];
if s[i]='\' then
begin
inc(i);
while (i<=length(s))and(s[i]='\') do
 inc(i);
end
else inc(i);
end;
end;
function NormalRect(p1,p2:TPoint):TRect;
begin
 if p1.X<p2.X then
  begin
   result.Left:=p1.X;
   result.Right:=p2.X;
  end
  else
  begin
   result.Left:=p2.X;
   result.Right:=p1.X;
  end;
  if p1.Y<p2.Y then
  begin
   result.Top:=p1.Y;
   result.Bottom:=p2.Y;
  end
  else
  begin
   result.Top:=p2.Y;
   result.Bottom:=p1.Y;
  end;
end;
function conv8bit(s:string):string;
var i:integer;
begin
result:='';
 for i:=1 to length(s) do
  if s[i]<#128 then
  if s[i] in ['"','''','-','*',':','\','_','{','|','}','~'] then
  result:=result+'\'+s[i]
  else
  result:=result+s[i]
               else result:=result+'\'''+inttohex(ord(s[i]),2);

end;
function FindString(tofind:string;values:array of string):integer;
var i:integer;
begin
 result:=-1;
 for i:=0 to high(values) do
  if values[i]=tofind then
   begin
    result:=i;
    exit;
   end;
end;
function BinaryLength(w:word):integer;
var i:integer;
 begin
 result:=0;
 for i:=0 to 15 do
 begin
   if w=0 then exit;
  result:=result+(W AND 1);
  W:=W shr 1;
 end;
 end;
procedure SaveString(Storage:TStream;s:string);
var i,j:word;
begin
i:=length(s);
Storage.Write(i,sizeof(i));
for j:=1 to i do
 Storage.write(s[j],sizeof(Char));
end;
function LoadString(Storage:TStream):string;
var i,j:word;
    c:Char;
begin
result:='';
Storage.Read(i,sizeof(i));
result:=StringOfChar(' ',i);
for j:=1 to i do
begin
 Storage.Read(c,sizeof(c));
 result[j]:=c;
end;
end;
procedure ClearFile(filename:string);
var f:File;
begin
 if filename='' then exit;
 if not fileexists(filename) then exit;
 assignFile(f,filename);
 rewrite(f);
 CloseFile(f);
end;
function ScaleFileName(data:TTable):string;
begin
 result:=cutfileext(Data.TableName)+'.ssd';
end;
function GetAverageCharSize(Canvas: TCanvas): TPoint;
var
  I: Integer;
  Buffer: array[0..51] of Char;
begin
  for I := 0 to 25 do Buffer[I] := Chr(I + Ord('A'));
  for I := 0 to 25 do Buffer[I + 26] := Chr(I + Ord('a'));
  GetTextExtentPoint(Canvas.Handle, Buffer, 52, TSize(Result));
  Result.X := Result.X div 52;
end;
 function SelectFromList(const ACaption, APrompt: string;Choises:TStrings;
   var Value: integer): Boolean;
var
  Form: TForm;
  Prompt: TLabel;
  Box1: TComboBox;
  DialogUnits: TPoint;
  ButtonTop, ButtonWidth, ButtonHeight: Integer;
begin
  Result := False;
  Form := TForm.Create(Application);
  with Form do
    try
      Canvas.Font := Font;
      DialogUnits := GetAverageCharSize(Canvas);
      BorderStyle := bsDialog;
      Caption := ACaption;
      Font.Size:=appconst.sysinfo.FontSize;
      ClientWidth := MulDiv(180, DialogUnits.X, 4);
      Position := poScreenCenter;
      Prompt := TLabel.Create(Form);
      with Prompt do
      begin
        Parent := Form;
        Caption := APrompt;
        Left := MulDiv(8, DialogUnits.X, 4);
        Top := MulDiv(8, DialogUnits.Y, 8);
        Constraints.MaxWidth := MulDiv(164, DialogUnits.X, 4);
        WordWrap := True;
      end;
      Box1 := TComboBox.Create(Form);
      with Box1 do
      begin
        Parent := Form;
        Left := Prompt.Left;
        Top := Prompt.Top + Prompt.Height + 5;
        Width := MulDiv(164, DialogUnits.X, 4);
        Style:=csDropDownList;
        Items.Assign(Choises);
        ItemIndex:=value;
      end;
      ButtonTop := Box1.Top + Box1.Height + 15;
      ButtonWidth := MulDiv(50, DialogUnits.X, 4);
      ButtonHeight := MulDiv(14, DialogUnits.Y, 8);
      with TButton.Create(Form) do
      begin
        Parent := Form;
        Caption := SMsgDlgOK;
        ModalResult := mrOk;
        Default := True;
        SetBounds(MulDiv(38, DialogUnits.X, 4), ButtonTop, ButtonWidth,
          ButtonHeight);
      end;
      with TButton.Create(Form) do
      begin
        Parent := Form;
        Caption := SMsgDlgCancel;
        ModalResult := mrCancel;
        Cancel := True;
        SetBounds(MulDiv(92, DialogUnits.X, 4), Box1.Top + Box1.Height + 15,
          ButtonWidth, ButtonHeight);
        Form.ClientHeight := Top + Height + 13;
      end;
      if ShowModal = mrOk then
      begin
        Value := Box1.ItemIndex;
        Result := True;
      end;
    finally
      Form.Free;
    end;
end;
function InputQueryLong(const ACaption, APrompt: string;
   var Value: string): Boolean;
var
  Form: TForm;
  Prompt: TLabel;
  LongText: TMemo;
  DialogUnits: TPoint;
  ButtonTop, ButtonWidth, ButtonHeight: Integer;
begin
  Result := False;
  Form := TForm.Create(Application);
  with Form do
    try
      Canvas.Font := Font;
      DialogUnits := GetAverageCharSize(Canvas);
      BorderStyle := bsDialog;
      Caption := ACaption;
      Font.Size:=appconst.sysinfo.FontSize;
      ClientWidth := MulDiv(300, DialogUnits.X, 4);
      ClientHeight:= MulDiv(60, DialogUnits.Y, 4);
      Position := poScreenCenter;
      Prompt := TLabel.Create(Form);
      with Prompt do
      begin
        Parent := Form;
        Caption := APrompt;
        Left := MulDiv(8, DialogUnits.X, 4);
        Top := MulDiv(8, DialogUnits.Y, 8);
        Constraints.MaxWidth := MulDiv(260, DialogUnits.X, 4);
        WordWrap := True;
      end;
      LongText := TMemo.Create(Form);
      with LongText do
      begin
        Parent := Form;
        Left := Prompt.Left;
        Top := Prompt.Top + Prompt.Height + 5;
        Width := MulDiv(280, DialogUnits.X, 4);
        Height:= MulDiv(40, DialogUnits.Y, 4);
        lines.Text := ClearSpaces(Value);
        WantReturns:=False;
        WantTabs:=false;
        WordWrap:=true;
        //SelectAll;
      end;
      ButtonTop := LongText.Top + LongText.Height + 15;
      ButtonWidth := MulDiv(50, DialogUnits.X, 4);
      ButtonHeight := MulDiv(14, DialogUnits.Y, 8);
      with TButton.Create(Form) do
      begin
        Parent := Form;
        Caption := SMsgDlgOK;
        ModalResult := mrOk;
        Default := True;
        SetBounds(MulDiv(73, DialogUnits.X, 4), ButtonTop, ButtonWidth,
          ButtonHeight);
      end;
      with TButton.Create(Form) do
      begin
        Parent := Form;
        Caption := SMsgDlgCancel;
        ModalResult := mrCancel;
        Cancel := True;
        SetBounds(MulDiv(177, DialogUnits.X, 4), LongText.Top + LongText.Height + 15,
          ButtonWidth, ButtonHeight);
        Form.ClientHeight := Top + Height + 13;
      end;
      LongText.SelStart:=length(value);
      if ShowModal = mrOk then
      begin
        Value := MakeLine(LongText.Lines);
        Result := True;
      end;
    finally
      Form.Free;
    end;
end;

function InputQueryUnSelected(const ACaption, APrompt: string;
  var Value: string): Boolean;
var
  Form: TForm;
  Prompt: TLabel;
  Edit: TEdit;
  DialogUnits: TPoint;
  ButtonTop, ButtonWidth, ButtonHeight: Integer;
begin
  Result := False;
  Form := TForm.Create(Application);
  with Form do
    try
      Canvas.Font := Font;
      DialogUnits := GetAverageCharSize(Canvas);
      BorderStyle := bsDialog;
      Caption := ACaption;
      Font.Size:=appconst.sysinfo.FontSize;
      ClientWidth := MulDiv(180, DialogUnits.X, 4);
      Position := poScreenCenter;
      Prompt := TLabel.Create(Form);
      with Prompt do
      begin
        Parent := Form;
        Caption := APrompt;
        Left := MulDiv(8, DialogUnits.X, 4);
        Top := MulDiv(8, DialogUnits.Y, 8);
        Constraints.MaxWidth := MulDiv(164, DialogUnits.X, 4);
        WordWrap := True;
      end;
      Edit := TEdit.Create(Form);
      with Edit do
      begin
        Parent := Form;
        Left := Prompt.Left;
        Top := Prompt.Top + Prompt.Height + 5;
        Width := MulDiv(164, DialogUnits.X, 4);
        MaxLength := 255;
        Text := Value;
        //SelectAll;
      end;
      ButtonTop := Edit.Top + Edit.Height + 15;
      ButtonWidth := MulDiv(50, DialogUnits.X, 4);
      ButtonHeight := MulDiv(14, DialogUnits.Y, 8);
      with TButton.Create(Form) do
      begin
        Parent := Form;
        Caption := SMsgDlgOK;
        ModalResult := mrOk;
        Default := True;
        SetBounds(MulDiv(38, DialogUnits.X, 4), ButtonTop, ButtonWidth,
          ButtonHeight);
      end;
      with TButton.Create(Form) do
      begin
        Parent := Form;
        Caption := SMsgDlgCancel;
        ModalResult := mrCancel;
        Cancel := True;
        SetBounds(MulDiv(92, DialogUnits.X, 4), Edit.Top + Edit.Height + 15,
          ButtonWidth, ButtonHeight);
        Form.ClientHeight := Top + Height + 13;
      end;
      Edit.AutoSelect:=false;
      Edit.SelStart:=length(value);
      if ShowModal = mrOk then
      begin
        Value := Edit.Text;
        Result := True;
      end;
    finally
      Form.Free;
    end;
end;
function ToXMLName(s:string):string;
var i:integer;
    lst:char;
begin
 result:=s;
 for i:=1 to length(result) do
  if not(ord(result[i]) in [Ord('_'),Ord('-'),Ord('.'),$30..$39,$41..$5A,$61..$7A,$A8,$B8,$C0..$FF]) then
   result[i]:='_';
s:=result;
result:='';
lst:='*';
for i:= 1 to length(s) do
begin
if (s[i]<>'_')or(lst<>'_') then result:=result+s[i];
lst:=s[i];
end;
if result<>'' then
 if not (ord(result[1]) in [$41..$5A,$61..$7A,$A8,$B8,$C0..$FF]) then result:='Name.'+result;
end;
function Translit(s:string):String;
const TranslitTable:array[0..127] of string=(
'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
'Yo','','','','','','','','','','I','i','','','','','yo','','','','j','S','s','',
'A','B','V','G','D','E','Zh','Z','I','J','K','L','M','N','O','P','R','S','T','U','F','H','C','Ch','Sh','Sch','-','Ii','-','Ae','Yu','Ya',
'a','b','v','g','d','e','zh','z','i','j','k','l','m','n','o','p','r','s','t','u','f','h','c','ch','sh','sch','-','ii','-','ae','yu','ya');
var i:integer;
begin
 result:='';

 for i:=1 to length(s) do
  if s[i] in [#32..#127] then result:=result+s[i]
  else if TranslitTable[ord(s[i])-128]<>'' then
   result:=result+TranslitTable[ord(s[i])-128]
   else result:=result+' ';
end;
 function checkExcel(s:string):string;
  begin
   result:='';
   if s='' then exit;
   if s[1]in ['=','-','@',''''] then result:=''''+s
             else result:=s;
  end;
function ParseString(Separators, WhiteSpace: TSysCharSet; Content: String; Strings: TStrings): Integer;
var i,Start:integer;
    inQuote:boolean;
    c,oldC:char;
    part:string;
begin
if (Content='')or(Strings=nil) then exit;
Strings.BeginUpdate;
try
inQuote:=false;
part:='';
oldC:=#0;
Start:=1;
for i:=1 to Length(Content) do
 if Content[i] in WhiteSpace then Start:=i
 else Break;
for i:=Start to length(Content) do
begin
 c:=Content[i];
 if (c='"')and not inQuote then inQuote:=true
 else if (c='"')and(oldC='"') then begin part:=part+c;oldc:=#0;end
 else if inQuote and (c='"') then oldC:='"'
 else if inQuote and (oldC='"') then begin inQuote:=false; oldc:=#0;end;
 if not inQuote and (c<>'"') then
 if c in Separators then
 begin
 Strings.Add(part);
 part:='';
 oldc:=#0;
 end
 else begin part:=part+c; oldc:=#0;end
 else if c<>'"' then begin part:=part+c; oldc:=#0; end;
end;
Strings.Add(part);
finally
Strings.EndUpdate;
end;
end;
function GetLevel(s:string):integer;
var i:integer;
begin
 result:=0;
 for i:=1 to Length(s) do
  if s[i]='.' then inc(result);
 if result>0 then dec(result);
end;
function inSet(val:integer; IntSet:Array of Integer):boolean;
var i:integer;
begin
 result:=false;
 for i:=low(IntSet) to High(IntSet) do
  if IntSet[i]=val then
  begin
   result:=true;
   exit;
  end;
end;
procedure ShowBalloonTip(Control: TWinControl; Icon: integer; Title: pchar;
  Text: PWideChar;
  BackCL, TextCL: TColor);
const
  TOOLTIPS_CLASS = 'tooltips_class32';
  TTS_ALWAYSTIP = $01;
  TTS_NOPREFIX = $02;
  TTS_BALLOON = $40;
  TTF_SUBCLASS = $0010;
  TTF_TRANSPARENT = $0100;
  TTF_CENTERTIP = $0000;
  TTM_ADDTOOL = $0400 + 50;
  TTM_SETTITLE = (WM_USER + 32);
  ICC_WIN95_CLASSES = $000000FF;
type
  TOOLINFO = packed record
    cbSize: Integer;
    uFlags: Integer;
    hwnd: THandle;
    uId: Integer;
    rect: TRect;
    hinst: THandle;
    lpszText: PWideChar;
    lParam: Integer;
  end;
var
  hWndTip: THandle;
  ti: TOOLINFO;
  hWnd: THandle;
begin
  hWnd := Control.Handle;
  hWndTip := CreateWindow(TOOLTIPS_CLASS, nil,
    WS_POPUP or TTS_NOPREFIX or TTS_BALLOON or TTS_ALWAYSTIP,
    0, 0, 0, 0, hWnd, 0, HInstance, nil);
  if hWndTip <> 0 then
  begin
    SetWindowPos(hWndTip, HWND_TOPMOST, 0, 0, 0, 0,
      SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
    ti.cbSize := SizeOf(ti);
    ti.uFlags := TTF_CENTERTIP or TTF_TRANSPARENT or TTF_SUBCLASS;
    ti.hwnd := hWnd;
    ti.lpszText := Text;
    Windows.GetClientRect(hWnd, ti.rect);
    SendMessage(hWndTip, TTM_SETTIPBKCOLOR, BackCL, 0);
    SendMessage(hWndTip, TTM_SETTIPTEXTCOLOR, TextCL, 0);
    SendMessage(hWndTip, TTM_ADDTOOL, 1, Integer(@ti));
    SendMessage(hWndTip, TTM_SETTITLE, Icon mod 4, Integer(Title));
  end;
end;
function DeleteInTrashBin(filename:string;UseBin:boolean):boolean;
Var
T:TSHFileOpStruct;
s:PChar;
n:integer;
begin
filename:=RemoveDuplicatedSlashes(filename);
n:=length(filename);
if filename[n]='\' then
begin
 dec(n);
 filename:=copy(filename,1,n);
end;
s:=stralloc(n+2);
try
zeromemory(s,n+2);
StrCopy(s,pchar(filename));

With T do
Begin
Wnd:=application.Handle;
wFunc:=FO_DELETE;
pFrom:=s;
fFlags:=FOF_SILENT or FOF_NOCONFIRMATION;
if UseBin then
fFlags:=fFlags or FOF_ALLOWUNDO;
pTo:=nil;
hNameMappings:=nil;
lpszProgressTitle:=nil;
End;
SHFileOperation(T);
result:=not T.fAnyOperationsAborted;
finally
strdispose(s);
end;
End;
function DeleteSimbols(s:string;Wrong:CharSet;ReplaceChar:Char):string;
var i:integer;
    lastwrong:boolean;
begin
lastwrong:=false;
result:='';
Wrong:=Wrong+[ReplaceChar];
for i:=1 to length(s) do
if s[i] in Wrong then
begin
if not lastwrong then result:=result+ReplaceChar;
lastwrong:=true
end
else
begin
 result:=result+s[i];
 lastwrong:=false;
end;
result:=ClearSpaces(result);
end;
function LightCompare(s1,s2:string):boolean;
begin
 s1:=ANSIUpperCase(deleteSimbols(ClearSpaces(s1),[',','.','"','(',')','[',']','{','}','*','#','_'],' '));
 s2:=ANSIUpperCase(deleteSimbols(ClearSpaces(s2),[',','.','"','(',')','[',']','{','}','*','#','_'],' '));
 result:=(s1=s2);
end;
procedure SwapListItems(li1,li2:TListItem);
var temp:TListItem;
begin
 temp:=TListItem.Create(li1.Owner);
 try
 temp.Assign(li1);
 li1.Assign(li2);
 li2.Assign(temp);
 finally
 temp.free;
 end;
end;
function ClearSpaces(s:string):string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and ((S[I] <= ' ')or(S[I]=#160)) do Inc(I);
  if I > L then Result := '' else
  begin
    while (S[L] <= ' ')or(S[I]=#160) do Dec(L);
    Result := Copy(S, I, L - I + 1);
    for i:=1 to length(result) do
     if (result[i]<' ')or(result[i]=#160) then result[i]:=' ';
  end;
end;
function GetFullNodePath(node:TTreeNode):string;
begin
 result:='';
 if node=nil then exit;
 result:=node.Text;
 node:=Node.Parent;
 while node<>nil do
 begin
  result:=result+'\'+node.Text;
  node:=Node.Parent;
 end;
end;
procedure ClearBitmap(bmp:TBitmap;Color:TColor);
begin
bmp.Canvas.Brush.Color:=Color;
bmp.Canvas.Pen.Color:=Color;
bmp.Canvas.Rectangle(0,0,bmp.Width,bmp.Height);
end;
initialization
precision:=2;
finalization
end.
