unit XLSPrepare;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}

interface
uses classes, DB, Items;
type
TReportRow=class
private
 oldband,oldlevel:string;
 bandstack,levelstack:array[1..20] of string;
 olddepth:integer;
 ftemptypes,ftempvalues,
 flasttypes,flastvalues,
 ftypes,fvalues:TStringList;
 fObjects,fLastObjects,fTempObjects:TList;
 fLastStack,fCurStack:TList;
public
 constructor Create;
 destructor Destroy;override;
 procedure Push;
 Procedure Pop;
 procedure Clear;
 procedure ClearStack;
 procedure ClearLast;
 procedure AddCell(celltype,cellvalue:string;CellID:TObject;cellLevel:byte);
 procedure AddCellTemp(celltype,cellvalue:string;CellID:TObject;cellLevel:byte);
 //procedure AddCellLast(celltype:string);
 procedure LoadTemp;
 procedure toDataset(dataset:TDataset;row:integer;band,level:string;needcaption:boolean;depth:integer;nodelevel:integer);
 function HasCells:boolean;
end;

function PopDB(tree:TOMItems;root:integer;Dataset:TDataSet):integer;
implementation
uses utils,logs,sysutils;
constructor TReportRow.Create;
begin
 inherited create;
 flasttypes:=TStringList.create;
 flastvalues:=TStringList.create;
 ftemptypes:=TStringList.create;
 ftempvalues:=TStringList.create;
 ftypes:=TStringList.create;
 fvalues:=TStringList.create;
 fLastStack:=TList.create;
 fCurStack:=TList.Create;
 fObjects:=TList.Create;
 fLastObjects:=TList.Create;
 fTempObjects:=TList.Create;
end;
destructor TReportRow.Destroy;
begin
ftypes.free;
fvalues.free;
flasttypes.free;
flastvalues.free;
ftemptypes.free;
ftempvalues.free;
fObjects.Free;
flastobjects.free;
fTempObjects.free;
ClearStack;
flastStack.free;
fcurStack.free;
inherited destroy;
end;
procedure TReportRow.ClearLast;
begin
flasttypes.clear;
fLastValues.clear;
flastObjects.clear;
end;
procedure TReportRow.Clear;
begin
ftypes.clear;
fvalues.clear;
fObjects.clear;
end;
procedure TReportRow.AddCell(celltype,cellvalue:string;CellID:TObject; cellLevel:byte);
var j:integer;
begin
cellvalue:=RemoveCR(cellvalue);
if cellvalue<>'' then
begin
for j:=0 to flastTypes.Count-1 do
 if integer(flastTypes.Objects[j])>cellLevel then
 flastvalues[j]:='';
 j:=flasttypes.IndexOf(celltype);
 ftypes.addObject(celltype,TObject(cellLevel));
 fobjects.add(cellID);
 if j<0 then
 begin
 fvalues.addObject((cellvalue),TObject(false));
 end
 else
 begin
 if (flastObjects[j]=cellID)and(fLastValues[j]=cellvalue) then
 fvalues.addObject((cellvalue),TObject(true))
 else
 fvalues.addObject((cellvalue),TObject(false))
 end;
end
end;
procedure TReportRow.AddCellTemp(celltype,cellvalue:string;CellID:TObject; cellLevel:byte);
var j:integer;
begin
cellvalue:=RemoveCR(cellvalue);
if cellvalue<>'' then
begin
fTempTypes.AddObject(celltype,TObject(cellLevel));
fTempValues.Add(cellValue);
fTempObjects.add(cellID);
end
end;

procedure TReportRow.toDataset(dataset:TDataset;row:integer;band,level:string;needcaption:boolean;depth:integer;nodelevel:integer);
var i:integer;
    bandRS:boolean;
begin
if ftypes.count=0 then exit;
if depth<olddepth then begin oldband:=bandstack[depth]; oldlevel:=levelstack[depth]; end
else begin bandstack[olddepth]:=oldband; levelstack[olddepth]:=oldlevel; end;
bandstack[depth]:=band;
levelstack[depth]:=level;
olddepth:=depth;
 if ((oldband=band)and(oldlevel=level))and(oldband<>'') then bandRS:=true
 else begin oldband:=band; oldlevel:=level; bandRS:=false; end;
 {if (band<>'')and(needcaption) then
 begin
 ftypes.addObject('CAPTION',TObject(bandRS));
 fvalues.add(band);
 end;}
 for i:=0 to ftypes.count-1 do
  begin
   dataset.Append;
   dataset.FieldByName('ROWID').asInteger:=row;
   dataset.FieldByName('CELLBAND').asString:=band;
   dataset.FieldByName('CELLLEVEL').asString:=level;
   dataset.FieldByName('NODELEVEL').asInteger:=nodelevel;
   dataset.FieldByName('CELLTYPE').asString:=ftypes[i];
   dataset.FieldByName('CELLVALUE').asString:=fvalues[i];
   dataset.FieldByName('RSFLAG').asInteger:=integer(fvalues.Objects[i]);
   dataset.post;
   logs.startproc('ExcelBands:ToDataset',inttostr(row),band+'/'+level+':'+ftypes[i],fvalues[i],25);
  end;

  flasttypes.Clear;
  flastvalues.Clear;
  fLastObjects.Clear;
  flasttypes.AddStrings(ftypes);
  flastvalues.AddStrings(fvalues);
  flastObjects.Assign(fObjects);
  Clear;
end;
function PopDB(tree:TOMItems;root:integer;Dataset:TDataSet):integer;
begin
Dataset.Last;
while not dataset.Bof do
begin
 if tree.isParent(root,Dataset.FieldByName('').asInteger) then
    Dataset.Delete
  else break;
end;
Tree.deleteTail(root);
end;
procedure TReportRow.Push;
begin
{flastTypes.Assign(ftypes);
flastvalues.Assign(fvalues);}
 flastStack.Add(fLastTypes);
 flastStack.Add(flastValues);
 fLastStack.add(fLastObjects);
 fCurStack.add(fTypes);
 fCurStack.add(fvalues);
 fCurStack.Add(fObjects);
  fCurStack.add(fTempTypes);
 fCurStack.add(fTempvalues);
 fCurStack.Add(fTempObjects);

 flastTypes:=TStringList.Create;
 flastValues:=TStringList.Create;
 fLastObjects:=TList.Create;
 fTempTypes:=TStringList.Create;
 fTempValues:=TStringList.Create;
 fTempObjects:=TList.Create;

 ftypes:=TStringList.Create;
 fvalues:=TStringList.Create;
 fObjects:=TList.Create;
end;
procedure TReportRow.Pop;
begin
 flastTypes.Free;
 flastValues.Free;
 fLastObjects.Free;
 ftypes.free;
 fvalues.free;
 fObjects.Free;
 fTempTypes.free;
 fTempValues.free;
 fTempObjects.free;
  fTempObjects:=TList(fcurStack[fcurStack.Count-1]);
  fcurStack.delete(fcurStack.Count-1);
 fTempValues:=TStringList(fcurStack[fcurStack.Count-1]);
  fcurStack.delete(fcurStack.Count-1);
 fTempTypes:=TStringList(fcurStack[fcurStack.Count-1]);
 fcurStack.delete(fcurStack.Count-1);
 fObjects:=TList(fCurStack[fCurStack.Count-1]);
  fCurStack.delete(fCurStack.Count-1);
 fValues:=TStringList(fCurStack[fCurStack.Count-1]);
  fCurStack.delete(fCurStack.Count-1);
 fTypes:=TStringList(fCurStack[fCurStack.Count-1]);
 fCurStack.delete(fCurStack.Count-1);

 fLastObjects:=TList(flastStack[flastStack.Count-1]);
  fLastStack.delete(flastStack.Count-1);
 fLastValues:=TStringList(flastStack[flastStack.Count-1]);
  fLastStack.delete(flastStack.Count-1);
 fLastTypes:=TStringList(flastStack[flastStack.Count-1]);
 fLastStack.delete(flastStack.Count-1);
end;
procedure TReportRow.ClearStack;
var i:integer;
begin
 for i:=0 to fLastStack.Count-1 do
  TStringList(fLastStack[i]).Free;
 fLastStack.clear;
for i:=0 to fCurStack.Count-1 do
  TStringList(fCurStack[i]).Free;
 fCurStack.clear;
end;
function TReportRow.HasCells:boolean;
begin
 result:=ftypes.count>0;
end;
procedure TReportRow.LoadTemp;
var i:integer;
begin
 Clear;
 for i:=0 to fTempTypes.Count-1 do
  AddCell(fTempTypes[i],fTempValues[i],fTempObjects[i],integer(fTempTypes.Objects[i]));
ftemptypes.clear;
ftempvalues.Clear;
fTempObjects.Clear;
end;
end.
