unit edtOps;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface
uses comctrls,items;
type TEditOps=(eoCut,eoCopy,eoPaste,eoChangeItem,eoInsert,eoDelete,eoImport,eoDragDrop,eoSort);
     PUndos=^TUndos;
     Tundos=record
      op:TEditOps;
      node,parent,next:integer;
      tocut,tocopy:integer;
     nodes:TOMItems;
      textbefore,textafter:string;
      prev:PUNDOS;
      ID:byte;
     end;
     TProUndo=record
     links:array[1..32] of TLiteLinks;
     id:integer;
     end;
procedure ClearUNDO;
procedure Sort(lNode:integer);
procedure copy(lnode:integer);
procedure cut(lnode:integer);
procedure paste(lnode:integer);
procedure pasteSame(lnode:integer);
procedure Insertop(lnode:integer);
procedure Deleteop(lnode:integer);
procedure DragNode(lnode,newp:integer);
//procedure beginedit(s:string);
procedure SetItem(lnode:integer;itemold:TOMItem);
procedure ImportOp(lnode:integer);
procedure undo;
procedure redo;
function CanUNDO:boolean;
function synch:boolean;
procedure SynchLevel(src:TOMItems;root:integer);
procedure SynchPos(src:TOMItems;root:integer);
procedure saveProUNDO(l:TLiteLinks);
procedure SaveProGroupUNDO(l:Array of TLiteLinks;count:integer);
function GetProUndo(l:Array of TLiteLinks):boolean;
procedure ClearProUndo;
procedure finishOp;
var
beforeedit:string;
oldtext:string;
copytext:string;
lastUNDO:PUNDOS;
curundoID,lastUndoId:byte;
ProUNDO:array[1..20] of TProUndo;
ProReadIndex,ProWriteIndex,proUndoSize:integer;
implementation
uses utils,compops,main,logs,sysutils,dialogs;
var nodetocut:integer;
    nodetocopy:integer;
    undoCount,undoNum:integer;
function appendUNDO:PUNDOS;
var p:PUNDOS;
begin
logs.startproc('appendUndo','TOTAL:'+inttostr(undocount),'ID:'+inttostr(curUndoID),'Count:'+inttostr(undoNum),18);
new(p);
p^.prev:=lastUndo;
p^.nodes:=TOMItems.Create;
lastundo:=p;
lastUndo^.parent:=0;
lastUndo^.node:=0;
lastUndo^.next:=0;
lastUndo^.tocut:=0;
lastUndo^.tocopy:=0;
lastUndo^.textbefore:='';
lastUndo^.textAfter:='';
lastUndo^.tocut:=nodetocut;
lastUndo^.tocopy:=nodetocopy;
lastUndo^.ID:=curUNDOID;
result:=p;
inc(undoNum);
{$IFNDEF VIEW}
OrgMasterMain.UndoBtn.enabled:=true;
OrgMasterMain.UndoPMnt.Enabled:=true;
OrgMasterMain.UndoMnt.Enabled:=true;
{$ENDIF}
inc(undoCount);
end;
function RemoveUNDO:PUNDOS;
var p:PUNDOS;
begin
logs.startproc('RemoveUndo',inttostr(undocount),'','',18);
p:=lastUNDO;
result:=nil;
if p=nil then exit;
lastUNDO:=p^.prev;
p^.nodes.free;
DISPOSE(p);
result:=LastUndo;
dec(undocount);
{$IFNDEF VIEW}
if (result=nil)and(OrgMasterMain<>nil) then
begin
OrgMasterMain.UndoBtn.enabled:=false;
OrgMasterMain.UndoPMnt.Enabled:=false;
OrgMasterMain.UndoMnt.Enabled:=false;
end;
{$ENDIF}
logs.startproc('RemoveUndo',inttostr(undocount),'','finished',18);
end;
procedure ClearUNDO;
begin
logs.startproc('ClearUndo',inttostr(undocount),'','',18);
while removeUNDO<>nil do;
undocount:=0;
undonum:=0;
{$IFNDEF VIEW}
if OrgMasterMain<>nil then
begin
OrgMasterMain.UndoBtn.enabled:=false;
OrgMasterMain.UndoPMnt.Enabled:=false;
OrgMasterMain.UndoMnt.Enabled:=false;
end;
{$ENDIF}
lastUnDOID:=0;
curUNDOID:=1;
lastUndo:=nil;
end;
procedure Sort(lNode:integer);
procedure SaveLevel(root:integer;from_cls,to_cls:TOMItems);
var i:integer;
    newitem:TOMItem;
begin
i:=root;
While i>0 do
begin
newitem:=TOMItem.Create(to_cls);
from_cls[i].assign(newitem);
to_cls[to_cls.ADD(newitem)].pos:=i;
if from_cls[i].expanded then
SaveLevel(from_cls[i].firstchild,from_Cls,to_cls);
i:=from_cls[i].nextitem;
end;
end;

begin
{$IFNDEF VIEW}
startproc('EdtOps','','sort',inttostr(lnode),3);
appendUndo;
FinishOp;
with OrgMasterMain.SourceList,OrgMasterMain,lastUndo^ do
begin
op:=eoSort;
tocopy:=insource[lnode].intparent;
if tocopy>0 then
tocut:=insource[tocopy].firstchild
else
tocut:=insource.root;
nodes.clear;
SaveLevel(tocut,insource,nodes);

nodetocut:=0;
nodetocopy:=0;
end;
{$ENDIF}
end;
procedure copy(lnode:integer);
begin
{$IFNDEF VIEW}
startproc('EdtOps','','copy',inttostr(lnode),3);
appendUndo;
with OrgMasterMain.SourceList,OrgMasterMain,lastUndo^ do
begin
op:=eoCopy;
tocut:=nodetocut;
tocopy:=nodetocopy;
nodetocut:=0;
nodetocopy:=lnode;
end;
copyText:='';
{$ENDIF}
end;
procedure cut(lnode:integer);
begin
{$IFNDEF VIEW}
startproc('EdtOps','','copy',inttostr(lnode),3);
appendUndo;
with OrgMasterMain.SourceList,OrgMasterMain,lastUndo^ do
begin
op:=eoCut;
tocut:=nodetocut;
tocopy:=nodetocopy;
nodetocut:=lnode;
nodetocopy:=0;
if assigned(insource[lnode].samenode) then
    insource[lnode].samenode.delete;
insource.deletechildren(lnode,true);
node:=lnode;
end;
copytext:='';
{$ENDIF}
end;
procedure paste(lnode:integer);
begin
{$IFNDEF VIEW}
appendUndo;
finishOp;
with OrgMasterMain.SourceList,OrgMasterMain,lastUndo^ do
begin
op:=eoPaste;
tocut:=nodetocut;
tocopy:=nodetocopy;
if nodetocut<>0 then
begin
  node:=nodetocut;
  parent:=insource[node].intparent;
  next:=insource[node].nextitem;
  insource.cutfromlist(node);
  insource.insertitem(node,lnode,0);
  insource.restorechildren(node,true);
  if lnode<>0 then
  begin
  if insource[lnode].samenode <>nil then
  insource.exporttoTV(node,spview,insource[lnode].samenode,nil,true)
  end
  else
  insource.exporttoTV(node,spview,nil,nil,true);
  nodetocopy:=nodetocut;
  nodetocut:=0;
end
else
begin
node:=insource.CopyItems(nodetocopy,lnode,0,spview,nil).pos;
{  insource.exportItems(nodetocopy,true,nodes);
  insource.importItems(lnode,0,nodes,spview,node,false);}
  nodes.clear;
  next:=0;
  parent:=0;
end;
end;
{$ENDIF}
end;
procedure pasteSame(lnode:integer);
var p,n:integer;
    nn:TTreeNode;
begin
{$IFNDEF VIEW}
  p:=OrgMasterMain.SourceList.insource[lnode].intparent;
  n:=OrgMasterMain.SourceList.insource[lnode].nextitem;

if lnode=0 then exit;
appendUndo;
finishOp;
with OrgMasterMain.SourceList,OrgMasterMain,lastUndo^ do
begin
op:=eoPaste;
tocut:=nodetocut;
tocopy:=nodetocopy;
  nn:=nil;
  while (n<>0)and(insource[n].samenode=nil) do
     begin nn:=insource[n].samenode;n:=insource[n].nextitem;end;
if nodetocut<>0 then
begin
  node:=nodetocut;
  parent:=insource[node].intparent;
  next:=insource[node].nextitem;
  insource.cutfromlist(node);
  insource.insertitem(node,p,n);
  insource.restorechildren(node,true);
  if p<>0 then
  begin
  if insource[p].samenode<>nil then
  insource.exporttoTV(node,spview,insource[p].samenode,nn,true)
  end
  else
  insource.exporttoTV(node,spview,nil,nn,true);
  nodetocopy:=nodetocut;
  nodetocut:=0;
end
else if nodetocopy>0 then
begin
node:=insource.CopyItems(nodetocopy,p,n,spview,nil).pos;
{  insource.exportItems(nodetocopy,true,nodes);
  insource.importItems(p,n,nodes,spview,node,false);}
    nodes.clear;
  next:=0;
  parent:=0;
end;
end;
{$ENDIF}
end;
procedure Insertop(lnode:integer);
begin
{$IFNDEF VIEW}
startproc('EdtOps','','InsertOp',inttostr(lnode),3);
appendUndo;
finishOp;
with OrgMasterMain.SourceList,OrgMasterMain,lastUndo^ do
begin
op:=eoInsert;
tocut:=nodetocut;
tocopy:=nodetocopy;
node:=lnode;
next:=0;
parent:=0;
end;
{$ENDIF}
end;

procedure DeleteOp(lnode:integer);
begin
{$IFNDEF VIEW}
startproc('EdtOps','','deleteOp',inttostr(lnode),3);
appendUndo;
with OrgMasterMain.SourceList,OrgMasterMain,lastUndo^ do
begin
op:=eoDelete;
node:=lnode;
next:=0;
parent:=0;
end;
{$ENDIF}
end;
procedure beginEdit(s:string);
begin
logs.startproc('edtOps','BeginEdit',s,'',10);
oldtext:=s;
end;
procedure SetItem(lnode:integer;itemOld:TOMItem);
var newi:TOMItem;
begin
logs.startproc('edtOps','SetText','',inttostr(lnode),10);
appendUndo;
with OrgMasterMain.SourceList,OrgMasterMain,lastUndo^ do
begin
IsModify:=true;
op:=eoChangeItem;
newi:=TOMItem.Create(nodes);
newi.assignData(itemOld);
nodes.add(newi);
node:=lnode;
end;
end;
procedure undo1Step;
var i,j:integer;
    pn,nn:TTreeNode;
    TrOnCol,TrOnExp:TTVExpandedEvent ;
begin
if lastUNDO=nil then exit;
logs.startProc('edtOps','UNDO1',inttostr(integer(lastUNDo^.op)),inttostr(lastUndo^.ID),10);
with OrgMasterMain.SourceList,OrgMasterMain,lastUNDO^ do
begin
if parent<>0 then
pn:=insource[parent].samenode
else
pn:=nil;
if next<>0 then
begin
 nn:=insource[next].samenode;
 i:=insource[next].nextitem;
 while (nn=nil)and(i<>0) do
 begin
 nn:=insource[i].samenode;
 i:=insource[i].nextitem;
 end;
end
else
nn:=nil;
TrOnCol:=Spview.OnCollapsed;
TrOnExp:=Spview.OnExpanded;
SpView.OnExpanded:=nil;
SpView.OnCollapsed:=nil;

    PasteSameBtn.Enabled:= (tocut<>0)or(tocopy<>0);;
    PasteLPMnt.Enabled:= PasteSameBtn.Enabled;
    PastePMnt.Enabled:= PasteSameBtn.Enabled;
    PasteMnt.Enabled:= PasteSameBtn.Enabled;
    PasteChild.Enabled:= PasteSameBtn.Enabled;
nodetocut:=tocut;
nodetocopy:=tocopy;
logs.startProc('edtOps','UNDO1','','case',10);
 case op of
 eoCut:
    begin
    insource.restoreChildren(node,true);
    insource.exporttoTV(node,spview,pn,nn,true);
    end;
 eoPaste:if nodetocut<>0 then
          begin
           if insource[node].samenode <>nil then
           insource[node].samenode.delete;
           insource.cutfromlist(node);
           insource.Deletechildren(node,true);
           insource.insertitem(node,parent,next);
          end
          else if nodetocopy<>0 then
          begin
          if insource[node].samenode <>nil then
          insource[node].samenode.delete;
          insource.Deletechildren(node,true);
          insource.cutfromlist(node);
          end;
eoInsert: begin
          if insource[node].samenode <>nil then
          insource[node].samenode.delete;
          insource.Deletechildren(node,true);
          insource.cutfromlist(node);
          end;
eoDelete:
 begin
    insource.restoreChildren(node,true);
    insource.exporttoTV(node,spview,pn,nn,true);
 end;
eoChangeItem:
 begin
    startproc('EdtOps','','Undo1(setitem)','',3);
  insource[node].assigndata(nodes[1]);
    startproc('EdtOps','','Undo1(setitem)',inttostr(node),3);
 end;
eoImport:
 begin
  startproc('EdtOps','','Undo1(import)','',3);
 if insource[node].samenode <>nil then
  insource[node].samenode.delete;
  insource.Deletechildren(node,true);
  insource.cutfromlist(node);
 end;
eoDragDrop:
 begin
      startproc('EdtOps','','Undo1(dragdrop)','',3);
      insource.cutfromlist(node);

      insource.insertitem(node,parent,next);
      if insource[node].samenode<>nil then
      if nn<>nil then
      insource[node].samenode.MoveTo(nn,naInsert)
      else
      insource[node].samenode.MoveTo(pn,naAddChild);
      insource.resetMarked(node);
 end;
 eoSort:
 begin
 for i:=1 to nodes.count do
 begin
 j:=nodes[i].pos;
 insource[j].firstchild:=nodes[i].firstchild;
 insource[j].nextitem:=nodes[i].nextitem;
 insource[j].previtem:=nodes[i].previtem;
 end;
 if tocopy>0 then insource[tocopy].firstchild:=tocut
             else insource.setRoot(tocut);
 spview.Items.Clear;            
 SourceList.Insource.buildTV(spview,nil,false,true,SourceList.showmarkedonly);
 end;

end;


SpView.OnCollapsed:=TrOnCol;
SpView.OnExpanded:=TrOnExp;
end;
logs.startProc('edtOps','UNDOFinished',inttostr(integer(lastUNDo^.op)),'',10);
removeUNDO;
end;
procedure Undo;
begin
logs.startproc('edtOps','Undo','ID:'+inttostr(lastUndoID),'',8);
if lastUNDo=nil then exit;
curUNDOID:=lastUNDo^.ID;
while (lastUndo<>nil)and(lastUNDo^.ID=curUnDOID) do undo1step;
if lastUNDo<>nil then
lastUNDOID:=lastUNDo^.id
else
lastUNDoID:=0;
end;

procedure redo;
begin
{if redosize=0 then exit ;
 undoc:=undoc mod 32 +1;
 with OrgMasterMain,OrgMasterMain.sourceList,ops[undoc] do
 case op of
  eoCut       : Cut(nodefrom,lfrom);
  eoPaste     : Paste(nodefrom,lfrom);
  eoDelete    :
  eoInsert    :
  eoImport    :
  eoChangeText:
 end;
dec(redosize);}
end;
procedure ImportOp(lnode:integer);
begin
{$IFNDEF VIEW}
     startproc('EdtOps','','Undo(cut)','inttostr(lnode)',3);
appendUndo;
with OrgMasterMain.SourceList,OrgMasterMain,lastUndo^ do
begin
op:=eoImport;
node:=lnode;
end;
{$ENDIF}
end;
//------------------------------------
procedure SynchLevel(src:TOMItems;root:integer);
var i:integer;
    doe:boolean;
begin
 i:=root;
 while i>0 do
 begin
 if src[i].samenode<>nil then
 begin
  doe:=src[i].expanded and not src[i].samenode.Cut;
  src[i].samenode.Expanded:=doe;
  //Src[i].marked:=src[i].marked;
  if {doe and }(src[i].firstchild>0) then
   SynchLevel(src,src[i].firstchild);
 end;
 i:=src[i].nextitem;
 end;
end;
procedure SynchPos(src:TOMItems;root:integer);
begin
end;
function synch:boolean;
var i:integer;
    TrOnCol,TrOnExp:TTVExpandedEvent ;
begin
 startproc('EdtOps','','synch','',2);
with OrgMasterMain,OrgMasterMain.SourceList do
begin
autoinsert:=true;
//spview.items.clear;
rebuild(false,true);
result:=true;
TrOnCol:=Spview.OnCollapsed;
TrOnExp:=Spview.OnExpanded;
Spview.OnCollapsed:=nil;
Spview.OnExpanded:=nil;


spview.items.beginupdate;
try
try
{for i:=0 to spview.Items.Count-1 do
 spview.items[i].expanded:=TOMItem(spview.items[i].data).expanded;
rebuild(false,true);}
SynchLevel(insource,insource.Root);
{for i:=1 to insource.Count do
 if (insource[i].samenode<>nil)then
 if not insource[i].samenode.cut then
  insource[i].samenode.expanded:=insource[i].expanded
  else
  insource[i].samenode.expanded:=false;}

//row:= TOMItem(Spview.selected.data).disprow;
SpView.selected:=(selecteditem.sameNode);
SpView.TopItem:=SourceList.RowItem(SourceList.TopRow).SameNode;
except
 spview.Items.Clear;
 SourceList.Insource.buildTV(spview,nil,false,true,SourceList.showmarkedOnly);
 Spview.selected:=SourceList.selecteditem.sameNode;
// raise Exception.Create('NO SYNC');
end;
finally
SpView.items.EndUpdate;
Spview.OnCollapsed:=TrOnCol;
Spview.OnExpanded:=TrOnExp;
autoinsert:=false;
end;
SourceList.OnClick(SourceList);
end;
//OrgMasterMain.spview.Repaint;
 startproc('EdtOps','','synch','end',2);
end;
procedure DragNode(lnode,newp:Integer);
begin
 startproc('EdtOps','','DragNode',inttostr(lnode)+','+inttostr(newp),3);
appendUndo;
with OrgMasterMain.SourceList,OrgMasterMain,lastUndo^ do
begin
node:=lnode;
parent:=insource[lnode].intparent;
next:=insource[lnode].nextItem;
op:=eoDragDrop;
tocut:=nodetocut;
tocopy:=nodetocopy;
end;
end;
function CanUNDO:boolean;
begin
result:=lastUNDO<>nil;
end;
procedure FinishOp;
begin
logs.startproc('EdtOps','FinishOp','ID:'+inttostr(curUndoID),'Count:'+inttostr(undoNum),8);
if undonum>0 then
begin
lastUNDOID:=curUNDOID;
inc(curUNDOID);
undonum:=0;
end;
end;
procedure SaveProGroupUNDO(l:Array of TLiteLinks;count:integer);
var i:integer;
begin
 inc(proWriteIndex);
 inc(proundosize);
 if proWriteIndex=21 then proWriteIndex:=1;
 if proundosize>20 then proundosize:=20;
 proReadIndex:=proWriteIndex;
  for i:=1 to 32 do FreeAndNil(proUndo[prowriteIndex].links[i]);
 for i:=0 to count-1 do
 if  (l[i]<>nil)and not (l[i].readonly) then
 begin
 proUndo[prowriteIndex].links[i-low(l)+1]:=TLiteLinks.Create(l[i].PRC);
 proUndo[prowriteIndex].links[i-low(l)+1].assignState(l[i]);
 end;
 proUndo[prowriteIndex].id:=high(l)-low(l)+1;
 OrgMasterMain.UndoBtn.Enabled:=true;
 OrgMasterMain.UndoMnt.Enabled:=true;
end;
procedure saveProUNDO(l:TLiteLinks);
var i:integer;
begin
if l=nil then exit;
 inc(proWriteIndex);
 inc(proundosize);
 if proWriteIndex=21 then proWriteIndex:=1;
 if proundosize>20 then proundosize:=20;
 proReadIndex:=proWriteIndex;
 for i:=1 to 32 do FreeAndNil(proUndo[prowriteIndex].links[i]);
 proUndo[prowriteIndex].links[1]:=TLiteLinks.Create(l.PRC);
 proUndo[prowriteIndex].links[1].assignState(l);
 proUndo[prowriteIndex].id:=1;
 OrgMasterMain.UndoBtn.Enabled:=true;
 OrgMasterMain.UndoMnt.Enabled:=true;
end;
function GetProUndo(l:array of TLiteLinks):boolean;
var i:integer;
begin
result:=false;
if proUndoSize=0 then exit;
if proundo[proreadindex].id=1 then
begin
for i:=low(l) to high(l) do
if not(l[i].readonly)and (proundo[proreadindex].links[1].proid=l[i].proid) then
begin
result:=true;
l[i].assignState(proundo[proreadindex].links[1]);
FreeAndNil(proundo[proreadindex].links[1]);
dec(proReadIndex);
if proreadindex=0 then
proreadindex:=20;
prowriteindex:=proreadindex;
dec(proUndoSize);
 OrgMasterMain.UndoBtn.Enabled:=proUndoSize>0;
 OrgMasterMain.UndoMnt.Enabled:=proUndoSize>0;
exit;
end;
end
else
begin
for i:=low(l) to high(l) do
if (l[i]<>nil)then
begin
if  not(l[i].readonly)and(proundo[proreadindex].links[i-low(l)+1].proid=l[i].proid) then
begin
result:=true;
l[i].assignState(proundo[proreadindex].links[i-low(l)+1]);
end;
FreeAndNil(proundo[proreadindex].links[i-low(l)+1]);
end;
dec(proReadIndex);
if proreadindex=0 then
proreadindex:=20;
prowriteindex:=proreadindex;
dec(proUndoSize);
 OrgMasterMain.UndoBtn.Enabled:=proUndoSize>0;
 OrgMasterMain.UndoMnt.Enabled:=proUndoSize>0;
exit;
end;

end;
procedure ClearProUndo;
var i,j:integer;
begin
proReadIndex:=0;
proWriteIndex:=0;
proUndoSize:=0;
for i:=1 to 20 do
begin
proundo[i].id:=0;
for j:=1 to 32 do
 freeandNil(proundo[i].links[j]);
end;
{$IFNDEF VIEW}
 OrgMasterMain.UndoBtn.Enabled:=false;
 OrgMasterMain.UndoMnt.Enabled:=false;
{$ENDIF}
end;

initialization
lastUndo:=nil;
undocount:=0;
undonum:=0;
lastUnDOID:=0;
curUNDOID:=1;
finalization
OrgMasterMain:=nil;
ClearUndo;
end.
