unit Logs;
{
(c) . .  1997,2006
}
interface
uses sysutils,SyncObjs,grids;
type
logtype=(ltUser, ltProc, ltError);
logrec = packed record
 t :logtype;
 unitName,methodname:string[30];
 objectname,parameters:string[100];
 level:integer;
 time:TDateTime;
 end;
TProgramLog=class
private
 logCache:array[1..100] of LogRec;
 LogCC:integer;
 log:file of logrec;
 lasterrorTime:TDateTime;
 lev:integer;
 islog:boolean;
 curdebug:integer;
 debug:integer;
 logCount:LongWord;
 logstep:longWord;
 ErrorCount:Word;
 LogFile:String;
 LogLock:TCriticalSection;
 logdepth:integer;
 fTraceWin:TStringGrid;
 fTraceLevel:integer;
public
 procedure startLog;
 procedure endlog;
 procedure startproc(un,obn,mn,p:string;l:integer);
 procedure endproc(s:string);
 procedure userlog(t:TObject;mn,p:string);
 procedure OnException(sender:TObject;e:Exception);
 procedure clearlog;
 procedure SetDebug(l:integer);
 function GetDebug:integer;
 constructor Create(logfilename:string='');
 destructor Destroy;override;
 property TraceWindow:TStringGrid read fTraceWin write fTraceWin;
 property TraceLevel:integer read fTraceLevel write fTraceLevel;
end;
procedure startproc(un,obn,mn,p:string;l:integer);
procedure userlog(t:TObject;mn,p:string);
procedure OnException(sender:TObject;e:Exception);
var MainLog:TProgramLog;
implementation
uses classes,controls,menus,stdctrls,windows,appconst;
procedure TProgramLog.startlog;
var r:logrec;
    gms:TMemorystatus;
begin
sleep(5);
lev:=0;
curdebug:=debug;
deletefile('bpd.txt');
LogCount:=0;
logstep:=0;
ErrorCount:=0;
logCC:=0;
try
 AssignFile(log,logfile);
 rewrite(log);
 r.t:=ltProc;
 r.level:=0;
 r.time:=now;
 r.methodname:='START:'+appconst.version;
 r.unitName:=paramstr(0);
 r.objectname:=paramstr(1);
 r.parameters:=paramstr(2);
 write(log,r);
 gms.dwLength:=sizeof(gms);
 globalmemorystatus(gms);
 startproc('MEMORY',inttostr(gms.dwTotalPhys)+'-'+inttostr(gms.dwAvailPhys),inttostr(gms.dwTotalPageFile)+'-'+inttostr(gms.dwAvailPageFile),inttostr(gms.dwMemoryLoad),0);
 islog:=true;
except
islog:=false;
end;
end;
procedure TProgramLog.endlog;
var r:logrec;
    gms:TMemoryStatus;
begin
sleep(5);
curdebug:=debug;
logCC:=0;
if islog then
try
begin
r.t:=ltProc;
 r.level:=0;
 r.time:=now;
 r.methodname:='FINISH'+appconst.version;
 r.unitName:=appconst.sysinfo.serial;
 r.objectname:=appconst.sysinfo.Company;
 r.parameters:=appconst.applicationname;
 write(log,r);
 gms.dwLength:=sizeof(gms);
 globalmemorystatus(gms);
 startproc('MEMORY',inttostr(gms.dwTotalPhys)+'-'+inttostr(gms.dwAvailPhys),inttostr(gms.dwTotalPageFile)+'-'+inttostr(gms.dwAvailPageFile),inttostr(gms.dwMemoryLoad),0);

closeFile(log);
end;
except
 islog:=false;
end;

islog:=false;
end;
procedure TProgramLog.startproc(un,obn,mn,p:string;l:integer);
var r:logrec;
    i:integer;
begin
 if (tracewindow<>nil)and(TraceLevel>=l) then
 begin
  i:=TraceWindow.RowCount-1;
  TraceWindow.cells[0,i]:=DateTimeToStr(Now);
  TraceWindow.cells[1,i]:=un;
  TraceWindow.cells[2,i]:=obn;
  TraceWindow.cells[3,i]:=mn;
  TraceWindow.cells[4,i]:=p;
  TraceWindow.RowCount:=i+2;
 end;
 if islog and (curdebug>=l) then
 begin
 LogLock.Enter;
 try
 inc(logdepth);
 inc(logCount);
 inc(logstep);
 r.t:=ltProc;
 r.unitName:=un;
 r.objectname:=obn;
 r.methodname:=mn;
 r.parameters:=p;
 r.level:=l;
 r.time:=now;
 write(log,r);
 if l<5 then
 sleep(0);
 finally
  dec(logdepth);
  loglock.leave;
  end;
 end
else
 begin
  while (logCC>0)and(logCache[logCC].level>=l) do dec(logCC);
  inc(logCC);
  if logcc>100 then exit;
  with logCache[logcc]   do
  begin
  t:=ltProc;
  unitName:=un;
  objectname:=obn;
  methodname:=mn;
  parameters:=p;
  level:=l;
  time:=now;
  end;

 end;

end;
procedure TProgramLog.userlog(t:TObject;mn,p:string);
var r:logrec;
    ma:TNotifyEvent;
    i:integer;
begin
if (logcount>8000)and(ErrorCount=0) then
begin
closefile(log);
 AssignFile(log,logfile);
 rewrite(log);
 logCount:=0;
end;
if (logstep>500)and(curdebug>20) then
  curdebug:=20
else
if (logstep>500)and(curdebug>5) then
  dec(curdebug)
else if curdebug<debug then curdebug:=debug;
logstep:=0;
if t <>nil then
 if t is TComponent then
  r.objectname:=t.ClassName+'\'+TComponent(t).Name
 else
  r.objectname:= t.ClassName
 else
  r.objectname:=':NIL:';
r.t:=ltUser;
r.level:=1;

 if (mn='')then
 if (t is TControl)  then
  begin
  ma:=TButton(t).Onclick;
  mn:=TControl(t).owner.MethodName(@ma);
  if (p='') then p:=TControl(t).hint;
  end
  else
  if (t is TMenuItem)  then
  begin
  ma:=TMenuItem(t).Onclick;
  mn:=TControl(t).owner.MethodName(@ma);
  if (p='') then p:=TMenuItem(t).Caption;
  end;
 r.unitName:='DBG_LVL:'+inttostr(curdebug);
 r.methodname:=mn;
 r.parameters:=copy(p,1,100);
 r.level:=0;
  r.time:=now;

 if (tracewindow<>nil)and(TraceLevel>0) then
 begin
  i:=TraceWindow.RowCount-1;
  TraceWindow.cells[0,i]:=DateTimeToStr(Now);
  TraceWindow.cells[1,i]:=r.unitName;
  TraceWindow.cells[2,i]:=r.objectname;
  TraceWindow.cells[3,i]:=r.methodname;
  TraceWindow.cells[4,i]:=r.parameters;
  TraceWindow.RowCount:=i+2;
 end;

if islog  and (curdebug>0) then
try
inc(logCount);
 write(log,r);
except
 islog:=false;
end;
sleep(0);
//application.processmessages;
end;

procedure TProgramLog.endproc(s:string);
begin
end;
procedure TProgramLog.OnException(sender:TObject;e:Exception);
 var r:logrec;
     gms:TMemoryStatus;
     i:integer;
 begin
sleep(5);
if sender <>nil then
 if sender is TComponent then
  r.objectname:=sender.ClassName+'\'+TComponent(sender).Name
 else
  r.objectname:= sender.ClassName
 else
  r.objectname:=':NIL:';
r.t:=ltError;
r.level:=0;
 r.unitName:='**'+e.ClassName;
 r.methodname:='OnException';
 r.parameters:=e.Message;
 r.level:=0;
 r.time:=now;

 if (tracewindow<>nil) then
 begin
  i:=TraceWindow.RowCount-1;
  TraceWindow.cells[0,i]:=DateTimeToStr(Now);
  TraceWindow.cells[1,i]:=r.unitName;
  TraceWindow.cells[2,i]:=r.objectname;
  TraceWindow.cells[3,i]:=r.methodname;
  TraceWindow.cells[4,i]:=r.parameters;
  TraceWindow.RowCount:=i+2;
 end;

if islog then
try
for i:=1 to logCC do
begin
write(log,logCache[i]);
end;
logCC:=0;
inc(logCount);
inc(errorCount);
 write(log,r);

if (now-lasterrortime<0.001)and(curdebug<40) then
inc(curdebug,5)
else if curdebug<40 then inc(curdebug);
lasterrortime:=now;

 gms.dwLength:=sizeof(gms);
 globalmemorystatus(gms);
 startproc('MEMORY',inttostr(gms.dwTotalPhys)+'-'+inttostr(gms.dwAvailPhys),inttostr(gms.dwTotalPageFile)+'-'+inttostr(gms.dwAvailPageFile),inttostr(gms.dwMemoryLoad),0);

  except
 islog:=false;
end;
 end;
procedure TProgramLog.clearlog;
begin
loglock.Enter;
 inc(logdepth);
try
logcount:=0;
curdebug:=debug;
if not islog then exit;
 rewrite(log);
finally
 dec(logdepth);
loglock.Leave;
end;
end;
procedure TProgramLog.SetDebug(l:integer);
begin
loglock.Enter;
try
 inc(logdepth);
 debug:=l;
 curdebug:=l;

finally
 dec(logdepth);
loglock.Leave;
end;
end;
function TProgramLog.GetDebug:integer;
begin
 result:=debug;
end;
constructor TProgramLog.Create(logfilename:string='');
begin
 inherited create;
 TraceWindow:=nil;
 TraceLevel:=0;
 logdepth:=0;
 LogLock:=TCriticalSection.Create;
 if logfilename='' then logfile:='user.$$$'
                   else logfile:=logfilename;
end;
destructor TProgramLog.Destroy;
begin
 endlog;
 logLock.Free;
 TraceWindow:=nil;
 inherited destroy;
end;
procedure startproc(un,obn,mn,p:string;l:integer);
begin
if MainLog<>nil then
 MainLog.startproc(un,obn,mn,p,l);
end;
procedure userlog(t:TObject;mn,p:string);
begin
if MainLog<>nil then
 Mainlog.userlog(t,mn,p);
end;
procedure OnException(sender:TObject;e:Exception);
begin
if MainLog<>nil then
 Mainlog.OnException(Sender,e);
end;

end.
