unit myLists;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface
uses classes,graphics, windows, db, controls, dbtables,fileutil,utils,mylisttypes,otherlistTypes, items,otherlists,dcommon;
type
TImportData=record oldid,newid:integer; dirid:integer;listcap:string end;
PImportData=^TImportData;

 TLines=class(TList)
         protected
          function getLine(index:integer):TPLine;
          procedure setLine(index:integer;l:TPLine);
         public
         function ADDLine:integer;
         procedure clearLines;
         property line[index:integer]:TPLine read getline write setLine; default;
        end;
TRepLines=class(Tlist)
         protected
          function getLine(index:integer):PRepLine;
          procedure setLine(index:integer;l:PRepLine);
         public
         function ADDLine:integer;
         procedure clearLines;
         function inlist(intd,lnum,flags:integer):boolean;
         function inPlist(intd,procN,defprocN:integer;prc:TOMItems):boolean;
         procedure sort(sorttype:boolean);
         constructor Create(idp:integer);
         constructor CreateEmpty;
         property line[index:integer]:PRepLine read getline write setLine; default;
        end;
TConnectList=class(TList)
         protected
          function getLine(index:integer):PLinksConnectInfo;
          procedure setLine(index:integer;l:PLinksConnectInfo);
         public
         function ADDLine:integer;
         procedure delete(i:integer);
         procedure clearLines;
        property line[index:integer]:PLinksConnectInfo read getline write setLine; default;

end;
TCache=class(TList)
         protected
         public
         function ADDLine(ints,intd,intln,lcn,linkid:integer):integer;
         procedure delete(i:integer);
         function find(ints,intd,intln,lcn:integer):integer;
         procedure clearLines;
end;
TIntervalList=class(TList)
         protected
          function getLine(index:integer):PIntervalInfo;
          procedure setLine(index:integer;l:PIntervalInfo);
         public
         function ADDLine:integer;
         procedure InsertLine(pos:integer);
         procedure clearLines;
        property line[index:integer]:PIntervalInfo read getline write setLine; default;

end;
TSprCache=class(TList)
public
 function Get(spr:TOMItems):boolean;
 procedure Put(spr:TOMItems);
 procedure doClear;
 destructor destroy;override;
end;
TProCache=class(TList)
public
 function Get(pro:TLiteLinks):boolean;
 procedure Put(pro:TLiteLinks);
 procedure doClear;
 destructor destroy;override;
end;


TLiteLinksSet=Class(TList)
protected
 function geTLiteLinks(index:integer):TLiteLinks;
public
 property Links[index:integer]:TLiteLinks read geTLiteLinks;default;
 function getPro(id:integer):TLiteLinks;
end;
TDirSet=Class(TList)
protected
 function getDir(index:integer):TOMItems;
public
 property Dirs[index:integer]:TOMItems read getDir;default;
 function getCls(ID:integer):TOMItems;
end;
TClsViewConfig=record
                  ShowLinked,
                  ShowComment:boolean;
                end;
TBPViewConfig=record
           clsLeft,
           clsRight:integer;
          end;
TNewBPInfo=Record
{$IFNDEF ED}
  bplink:array[1..64] of TLiteLinks;
  FM,FR:array[1..64] of TLiteLinks;
  lclass:array[1..64] of TOMItems;
  clsCfg:array[1..64] of TClsViewConfig;
  indexcls:array[1..64] of TOMItems;
{$ELSE}
  bplink:array[1..10] of TLiteLinks;
  FM,FR:array[1..10] of TLiteLinks;
  lclass:array[1..20] of TOMItems;
  clsCfg:array[1..20] of TClsViewConfig;
  indexcls:array[1..10] of TOMItems;
{$ENDIF}
  ID:integer;
  prc:TOMItems;
  activepro:TLiteLinks;
  nbp,nclass,ncomp,nabc:integer;
  Caption,Author,comment:string;
  prcLeft,prcRight:integer;
  dofilter:boolean;
end;

TDocOperCache=class(TStringList)
public
 procedure RemoveDocument(ID:integer);
 procedure AddDocument(FileName:string);
 procedure ProcessData(Mcont:TModelArray;ModelTable:TTable);
end;

implementation
uses dialogs,logs,sysUtils,appconst, itUtils;
function TLines.getLine(index:integer):TPLine;
begin
 result:=TPLine(items[index-1])
end;
procedure TLines.setLine(index:integer;l:TPLine);
begin
 items[index-1]:=l;
end;
function TLines.ADDLine:integer;
var pnewline:^TLine;
begin
new(pnewline);
result:=ADD(pnewline)+1;
end;
procedure TLines.clearLines;
var i:integer;
begin
  for i:=0 to count-1 do dispose(TPLine(items[i]));
  clear;
end;
function TRepLines.getLine(index:integer):PRepLine;
begin
 result:=PRepLine(items[index-1])
end;
procedure TRepLines.setLine(index:integer;l:PRepLine);
begin
 items[index-1]:=l;
end;
function TRepLines.ADDLine:integer;
var pnewRepLine:PRepLine;
begin
new(pnewRepLine);
result:=ADD(pnewRepLine)+1;
end;
procedure TRepLines.clearLines;
var i:integer;
begin
  for i:=0 to count-1 do dispose(PRepLine(items[i]));
  clear;
end;
function TRepLines.inlist(intd,lnum,flags:integer):boolean;
var i:integer;
begin
result:=false;
 for i:=0 to count-1 do
  if (PRepLine(items[i])^.intd=intd)and(PRepLine(items[i])^.lnum=lnum)and(PRepLine(items[i])^.flag=flags) then
   begin
   result:=true; exit;
   end;
end;
function TRepLines.inPlist(intd,procN,defprocN:integer;prc:TOMItems):boolean;
var i:integer;
begin
result:=false;
if (defprocN=0)and(prc<>nil) then
begin
 for i:=0 to count-1 do
  if (PRepLine(items[i])^.intd=intd)and(prc.isparent(PRepLine(items[i])^.ProcN,ProcN)or prc.isparent(ProcN,PRepLine(items[i])^.ProcN)) then
   begin
//   showmessage('ok'+inttostr(i));
   result:=true; exit;
   end;
end
else 
begin
 for i:=0 to count-1 do
  if (PRepLine(items[i])^.intd=intd)and
  ((prc=nil)or(prc.dirid=0)or
  (defprocN=ProcN)or(procN=0)or
  (prc<>nil)and(procN>0)and(prc.isparent(procN,defprocN)or prc.isparent(defprocN,procN))) then
   begin
//   showmessage('ok'+inttostr(i));
   result:=true; exit;
   end;
end

end;

constructor TRepLines.CreateEmpty;
begin
 inherited create;
end;
constructor TRepLines.Create(idp:integer);
begin
inherited create;
addline;
PRepLine(items[0])^.intd:=idp;
PRepLine(items[0])^.lnum:=0;
PRepLine(items[0])^.id:=0;
PRepLine(items[0])^.ProcN:=0;
end;
function RCompare(p1,p2:pointer):integer;far;
var r1,r2:TRepLine;
begin
r1:=TRepLine(p1^);
r2:=TRepLine(p2^);
if r1.flag<r2.flag then result:=-1
else if r1.flag>r2.flag then result:=+1
else if r1.lnum<r2.lnum then result:=-1
else if r1.lnum>r2.lnum then result:=+1
else if r1.intd<r2.intd then result:=-1
else if r1.intd>r2.intd then result:=+1
else result:=0;


end;
procedure TRepLines.sort(sorttype:boolean);
begin
inherited sort(RCompare);
end;
function TConnectList.getLine(index:integer):PLinksConnectInfo;
begin
 result:=PLinksConnectInfo(items[index-1])
end;
procedure TConnectList.setLine(index:integer;l:PLinksConnectInfo);
begin
 items[index-1]:=l;
end;
function TConnectList.ADDLine:integer;
var pnewline:PLinksConnectInfo;
begin
new(pnewline);
with pnewline^ do
begin
s:=0;
d:=0;
lnum:=0;
ints:=0;
intd:=0;
intlnum:=0;
lcn:=0;
intlcn:=0;
linkid:=0;
coeff:=1;
end;
result:=ADD(pnewline)+1;
end;
procedure TConnectList.clearLines;
var i:integer;
begin
  for i:=0 to count-1 do dispose(PLinksConnectInfo(items[i]));
  clear;
end;
procedure TConnectList.delete(i:integer);
begin
if i=0 then exit;
 dispose(PLinksConnectInfo(items[i-1]));
 inherited delete(i-1);
end;
function TCache.ADDLine(ints,intd,intln,lcn,linkid:integer):integer;
var p:PCacheRecord;
begin
new(p);
p^.ints:=ints;
p^.intd:=intd;
p^.intln:=intln;
p^.lcn:=lcn;
p^.linkid:=linkid;
result:=add(p);
end;
function TCache.find(ints,intd,intln,lcn:integer):integer;
var i:integer;
begin
result:=-1;
for i:=0 to count-1 do
 if (PCacheRecord(items[i])^.ints=ints)and(PCacheRecord(items[i])^.intd=intd)and
 (PCacheRecord(items[i])^.intln=intln)and(PCacheRecord(items[i])^.lcn=lcn) then
  begin
  result:=PCacheRecord(items[i])^.linkid;
  exit;
  end;
end;
procedure TCache.clearLines;
var i:integer;
begin
  for i:=0 to count-1 do dispose(PCacheRecord(items[i]));
  clear;
end;
procedure TCache.delete(i:integer);
begin
 dispose(PCacheRecord(items[i]));
 inherited delete(i);
end;
function TIntervalList.getLine(index:integer):PIntervalInfo;
begin
 result:=PIntervalInfo(items[index-1])
end;
procedure TIntervalList.setLine(index:integer;l:PIntervalInfo);
begin
 items[index-1]:=l;
end;
function TIntervalList.ADDLine:integer;
var pnewline:PIntervalInfo;
begin
new(pnewline);
result:=ADD(pnewline)+1;
end;
procedure TIntervalList.InsertLine(pos:integer);
var pnewline:PIntervalInfo;
begin
new(pnewline);
insert(pos-1,pnewline);
end;
procedure TIntervalList.clearLines;
var i:integer;
begin
  for i:=0 to count-1 do dispose(PIntervalInfo(items[i]));
  clear;
end;
function TSprCache.Get(spr:TOMItems):boolean;
var i:integer;
begin
result:=false;
{$IFNDEF ED}
if not appconst.sysinfo.cache_Enabled then exit;
for i:=count-1 downto 0 do
 if TOMItems(items[i]).dirid=spr.diriD then
 begin
  logs.startproc('myLists','SprCache','Get-OK',inttostr(spr.dirid),15);
  spr.assignTotal(TOMItems(items[i]));
  result:=true;
  exit;
 end;
{$ENDIF}
end;
procedure TSprCache.Put(spr:TOMItems);
var newG:TOMItems;
begin
{$IFNDEF ED}
if not appconst.sysinfo.cache_Enabled then exit;
 newG:=TOMItems.Create;
 newG.diriD:=spr.diriD;
 newG.assignTotal(spr);
 add(newG);
 logs.startproc('myLists','SprCache','Put-OK',inttostr(spr.dirid),15);
{$ENDIF}
end;
procedure TSprCache.DoClear;
var i:integer;
begin
 for i:=0 to Count-1 do
  TOMItems(items[i]).free;
 Clear;
 logs.startproc('myLists','SprCache','DoClear','',5);
end;
destructor TSprCache.destroy;
begin
 doclear;
 inherited destroy;
end;
function TProCache.Get(pro:TLiteLinks):boolean;
var i:integer;
begin
result:=false;
{$IFNDEF ED}
if not appconst.sysinfo.cache_Enabled then exit;
for i:=count-1 downto 0 do
 if TLiteLinks(items[i]).proid=pro.proid then
 begin
  logs.startproc('myLists','ProCache','Get-OK',inttostr(pro.proid),15);
  pro.AssignState(TLiteLinks(items[i]));
  result:=true;
  exit;
 end;
{$ENDIF}
end;
procedure TProCache.Put(pro:TLiteLinks);
var newG:TLiteLinks;
begin
{$IFNDEF ED}
if not appconst.sysinfo.cache_Enabled then exit;
 newG:=TLiteLinks.Create(pro.PRC);
 newG.proid:=pro.proid;
 newG.assignState(pro);
 add(newG);
logs.startproc('myLists','ProCache','Put-OK',inttostr(pro.proid),15);
{$ENDIF}
end;
procedure TProCache.DoClear;
var i:integer;
begin
 for i:=0 to Count-1 do
  TLiteLinks(items[i]).free;
 Clear;
 logs.startproc('myLists','ProCache','DoClear','',5); 
end;
destructor TProCache.destroy;
begin
 doclear;
 inherited destroy;
end;
function TLiteLinksSet.geTLiteLinks(index:integer):TLiteLinks;
begin
 result:=TLiteLinks(items[index]);
end;
function TDirSet.getDir(index:integer):TOMItems;
begin
 result:=TOMItems(items[index]);

end;
function TLiteLinksSet.getPro(id:integer):TLiteLinks;
var i:integer;
begin
 result:=nil;
 if id=0 then exit;
 for i:=0 to count-1 do
 if TLiteLinks(items[i]).proid=id then
 begin
  result:=TLiteLinks(items[i]);
  break;
 end;
end;
function TDirSet.getCls(ID:integer):TOMItems;
var i:integer;
begin
 result:=nil;
 if id=0 then exit;
 for i:=0 to count-1 do
 if TOMItems(items[i]).dirid=id then
 begin
  result:=TOMItems(items[i]);
  break;
 end;
end;
 procedure TDocOperCache.RemoveDocument(ID:integer);
 begin
 AddObject('',TObject(ID));
 end;
 procedure TDocOperCache.AddDocument(FileName:string);
 begin
 Add(FileName);
 end;
 procedure TDocOperCache.ProcessData(Mcont:TModelArray;ModelTable:TTable);
 begin
 end;

end.
