unit prnprv;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, Menus, TB97, RXCtrls, Db, DBTables,
  Execfile, TB97Ctls, TB97Tlbr, OleCtrls, SHDocVw, txthtml, SHDocVw_TLB;

type
  TPrintPreview = class(TForm)
    SaveRTFDialog: TSaveDialog;
    Dock971: TDock97;
    Toolbar971: TToolbar97;
    ToolbarSep973: TToolbarSep97;
    ExecFile1: TExecFile;
    QuitButton: TToolbarButton97;
    ToolbarButton975: TToolbarButton97;
    ToMaster: TToolbarButton97;
    ToOrgChart: TToolbarButton97;
    SaveDialog: TSaveDialog;
    OrgChart: TExecFile;
    MasterEXEC: TExecFile;
    Master: TExecFile;
    StyleExec: TExecFile;
    PrintButton: TToolbarButton97;
    SaveButton: TToolbarButton97;
    ToOldMaster: TToolbarButton97;
    RepWzdT: TTable;
    RepWzdTCod: TAutoIncField;
    RepWzdTCompany: TStringField;
    RepWzdTProject: TStringField;
    RepWzdTStatus: TStringField;
    RepWzdTAuthor: TStringField;
    RepWzdTAuthorRange: TStringField;
    RepWzdTReport: TStringField;
    RepWzdTFileName: TStringField;
    RepWzdTOtherRange: TStringField;
    RepWzdTGeneral: TStringField;
    RepWzdTGeneralCompany: TStringField;
    RepWzdTGeneralRange: TStringField;
    RepWzdTFormated: TBooleanField;
    RepWzdTPreambula: TMemoField;
    RepWzdTPostscriptum: TMemoField;
    RepWzdTIsPril: TBooleanField;
    RepWzdTPrilNumber: TStringField;
    StatusBar1: TStatusBar;
    TableEdit: TExecFile;
    back: TToolbarButton97;
    PreviewBtn: TToolbarButton97;
    WebBrowser1: TWebBrowser;
    SaveAsVariants: TPopupMenu;
    asTXT: TMenuItem;
    asRTF: TMenuItem;
    asHTML: TMenuItem;
    SaveMasterDialog: TSaveDialog;
    Panel1: TPanel;
    RepTitle: TEdit;
    Chapters: TComboBox;
    ToolbarSep971: TToolbarSep97;
    InternalLinks: TCheckBox;
    StyleEditButton: TToolbarButton97;
    procedure TOORGCHARTClick(Sender: TObject);
    procedure QuitButtonClick(Sender: TObject);
    procedure ToTextClick(Sender: TObject);
    procedure ToWebClick(Sender: TObject);
    procedure ToMasterClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure PrintButtonClick(Sender: TObject);
    procedure PageStupButtonClick(Sender: TObject);
    procedure ToOldMasterClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ChaptersClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure WebBrowser1StatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure PrintPreviewBtnClick(Sender: TObject);
    procedure backClick(Sender: TObject);
    procedure asRTFClick(Sender: TObject);
    procedure RepTitleChange(Sender: TObject);
    procedure InternalLinksClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure StyleEditButtonClick(Sender: TObject);
  private
    { Private declarations }
    title,modelName:string;
   FConverter:TTxtToHtmlConverter;
   varIn,varOut:OleVariant;
  public
  slines:TStringList;
  procedure clearParts;
  procedure setParts(n:integer);
  constructor Create(AOwner: TComponent);override;
  destructor Destroy;override;
  function Showmodal(rep:string):integer;
  property Converter:TTxtToHTmlConverter read FConverter;

    { Public declarations }

  end;

var
  PrintPreview: TPrintPreview;

implementation

uses Main, utils, filectrl, printers, appConst, shellapi,registry,grids,variants,
  multip, Logs, fileutil,activex, myLists, items, StrTab, StyleFormUnit;
function TPrintPreview.Showmodal(rep:string):integer;
begin
  title:=rep;
  reptitle.text:=rep;
//  caption:='title';
setcurrentdir(appconst.sysinfo.datadir);
if normalfilename(appconst.sysinfo.ModelName)<>'' then
begin
 if not directoryexists(appconst.sysinfo.sysdir+'Master\Reports\'+normalfilename(appconst.sysinfo.ModelName)) then
  createdir(appconst.sysinfo.sysdir+'\Master\Reports\'+normalfilename(appconst.sysinfo.ModelName));
ModelName:=appconst.sysinfo.ModelName;
SaveMasterDialog.InitialDir:=appconst.sysinfo.sysdir+'Master\Reports\'+normalfilename(appconst.sysinfo.ModelName);
end
else
  SaveMasterDialog.InitialDir:=appconst.sysinfo.sysdir+'Master\Reports';
//WebBrowSer1.navigate('about:blank');
FConverter.codepage:='WINDOWS-1251';
FConverter.rtflang:=inttostr($0419);
repTitle.font.charset:=204;
chapters.font.charset:=204;
FConverter.title:=title;
FConverter.company:=appconst.sysinfo.Company;
FConverter.author:=appconst.sysinfo.defAvtor;
FConverter.ModelName:=OrgMasterMain.curcompname;
FConverter.makeLinks:=InternalLinks.Checked;
FConverter.OpenStream(Slines,Chapters.Items,true,'preview.htm','');
application.processMessages;
inherited showmodal;
slines.Clear;
//newpreview.click;
//result:=  inherited ShowModal;
end;
{$R *.DFM}

constructor TPrintPreview.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
slines:=TStringList.create;
  FConverter:=TTxtToHtmlConverter.Create;
  FConverter.CSSFileName:=appconst.sysinfo.datadir+'\Master\temp.afm';
end;
destructor TPrintPreview.destroy;
begin
FConverter.Free;
slines.free;
inherited destroy;
end;
procedure TPrintPreview.clearParts;
begin
FConverter.ClearStyles;
end;
procedure TPrintPreview.setParts(n:integer);
begin
end;

procedure TPrintPreview.TOORGCHARTClick(Sender: TObject);
var nsl:TStringList;
    i,p:integer;
    s:string;
begin
setcurrentdir(appconst.sysinfo.datadir);
nsl:=TStringList.Create;
try
for i:=0 to slines.count -1 do
begin
s:=ClearSpaces(slines[i]);
if copy(s,1,10)='<##Style:=' then
begin
 p:=pos('##>',s);
 s:=copy(s,p+3,length(s));
end;
if copy(s,1,3)='%%L' then s:=copy(s,pos(' ',s)+1,length(s));
nsl.add(s);
end;
nsl.SaveTofile(SaveMasterDialog.InitialDir+'\'+Normalfilename(RepTitle.text)+'.rtf');
finally
nsl.free;
end;
      OrgChart.Parameters:='"'+SaveMasterDialog.InitialDir+'\'+Normalfilename(RepTitle.text)+'.rtf'+'"';
//showmessage(orgchart.parameters);
      OrgChart.execute;

end;
//Procedure DoPreview(caption:string;lines:TStrings;afmFile:TFileName);external 'preview.dll';
procedure TPrintPreview.QuitButtonClick(Sender: TObject);
begin
close;
end;

procedure TPrintPreview.ToTextClick(Sender: TObject);
var nsl:TStringList;
    i:integer;
    s:string;
begin
nsl:=TStringList.Create;
try
for i:=0 to slines.count -1 do
begin
s:=ClearSpaces(slines[i]);
if copy(s,1,3)='%%L' then s:=copy(s,pos(' ',s)+1,length(s));
nsl.add(s);
end;

nsl.SaveToFile('TEXT\'+Normalfilename(RepTitle.text)+'.txt');
finally
nsl.free;
end;
ExecuteAndWait('TEXT\'+Normalfilename(RepTitle.text)+'.txt',false);
end;

procedure TPrintPreview.ToWebClick(Sender: TObject);
begin
ExecuteAndWait(appconst.sysinfo.datadir+'preview.htm',false);
end;

procedure TPrintPreview.ToMasterClick(Sender: TObject);
begin
setcurrentdir(appconst.sysinfo.datadir);
      FConverter.makeLinks:=InternalLinks.Checked;
      FConverter.OpenStream(slines,nil,false,'MASTER\mp.htm','');
      FConverter.ConvertRTF('MASTER\PARTS\preview.rtf',false);
      FConverter.ConvertRTFFiles('MASTER\PARTS\preview',false);
      Master.Parameters:='204'+
                         ' '+inttostr($0419);
      Master.execute;

end;

procedure TPrintPreview.SaveButtonClick(Sender: TObject);
begin
Savedialog.filename:=Normalfilename(RepTitle.text)+'.htm';
  if SaveDialog.Execute then
    begin
      FConverter.makeLinks:=InternalLinks.Checked;
      FConverter.OpenStream(slines,nil,false,SaveDialog.FileNAme,'');
      ExecuteAndWait(SaveDialog.FileName,false);
    end;
SetCurrentDir(appconst.sysinfo.datadir);
end;

procedure TPrintPreview.PrintButtonClick(Sender: TObject);
begin
 if WebBrowser1.QueryStatusWB(OLECMDID_PRINT) and (OLECMDF_SUPPORTED or OLECMDF_ENABLED)=
                                                  (OLECMDF_SUPPORTED or OLECMDF_ENABLED) then
 WebBrowser1.ExecWB(OLECMDID_PRINT,OLECMDEXECOPT_DODEFAULT,varIn,varOut);
end;

procedure TPrintPreview.PageStupButtonClick(Sender: TObject);
begin
 if WebBrowser1.QueryStatusWB(OLECMDID_PAGESETUP) and (OLECMDF_SUPPORTED or OLECMDF_ENABLED)=
                                                  (OLECMDF_SUPPORTED or OLECMDF_ENABLED) then

 WebBrowser1.ExecWB(OLECMDID_PAGESETUP,OLECMDEXECOPT_DODEFAULT,varIn,varOut);
end;

procedure TPrintPreview.ToOldMasterClick(Sender: TObject);
begin
SaveMasterDialog.filename:=Normalfilename(RepTitle.text)+'.rtf';
if not SaveMasterDialog.execute then exit;
setcurrentdir(appconst.sysinfo.datadir);
FConverter.makeLinks:=InternalLinks.Checked;
FConverter.OpenStream(slines,Chapters.Items,true,'',SaveMasterDialog.fileName);
RepWzdT.Active:=true;
RepWzdT.edit;
if not RepWzdT.Locate('Project;Report',
          varArrayOf([ModelName,repTitle.text]),[]) then
begin
RepWzdT.Append;
//RepWzdT.Edit;
RepWzdTCompany.AsString:='';
RepWzdTProject.AsString:=ModelName;
RepWzdTReport.AsString:=repTitle.text;
RepWzdT.Post;
end;
RepWzdT.Edit;
RepWzdTFormated.AsBoolean:=false;
RepWzdTAuthor.AsString:='';
RepWzdTFileName.AsString:=SaveMasterDialog.FileName;
RepWzdT.Post;
RepWzdt.Active:=false;
setcurrentdir(appconst.sysinfo.datadir);
try
masterexec.Parameters:=#34+ ModelName+#34+' '+
                       #34+RepTitle.Text+#34+' '+
                       #34+SaveMasterDialog.FileName+#34;
MasterExec.Execute;
except
end;
setcurrentdir(appconst.sysinfo.datadir);

end;

procedure TPrintPreview.FormActivate(Sender: TObject);
begin
WEBBrowser1.navigate(appconst.sysinfo.datadir+'preview.htm');
WindowState:=wsMaximized;
end;

procedure TPrintPreview.ChaptersClick(Sender: TObject);
begin
if chapters.itemindex<0 then exit;
WebBrowser1.navigate(extractfilepath(application.exename)+'preview.htm'+
'#RAZDEL'+inttostr(integer(chapters.items.Objects[chapters.itemindex]))
);

end;

procedure TPrintPreview.FormCreate(Sender: TObject);
begin
WebBrowser1.DefaultInterface.Set_RegisterAsDropTarget(wordbool(true));
//activex.RegisterDragDrop(webbrowser1.HWND,webbrowser1.droptarget);
WebBrowser1.navigate('about:blank');
end;

procedure TPrintPreview.WebBrowser1StatusTextChange(Sender: TObject;
  const Text: WideString);
begin
StatusBar1.Panels[1].Text:=Text;
end;

procedure TPrintPreview.PrintPreviewBtnClick(Sender: TObject);
begin
if WebBrowser1.QueryStatusWB(OLECMDID_PRINTPREVIEW) and (OLECMDF_SUPPORTED or OLECMDF_ENABLED)=
                                                  (OLECMDF_SUPPORTED or OLECMDF_ENABLED) then

 WebBrowser1.ExecWB(OLECMDID_PRINTPREVIEW,OLECMDEXECOPT_DODEFAULT,varIn,varOut);
end;

procedure TPrintPreview.backClick(Sender: TObject);
begin
webbrowser1.goback;
end;

procedure TPrintPreview.asRTFClick(Sender: TObject);
begin
SaveRTFDialog.filename:=Normalfilename(RepTitle.text)+'.rtf';
  if SaveRTFDialog.Execute then
    begin
      FConverter.makeLinks:=InternalLinks.Checked;
      FConverter.OpenStream(slines,nil,false,'',SaveRTFDialog.FileName);
      ExecuteAndWait(SaveRTFDialog.FileName,false);
    end;
SetCurrentDir(appconst.sysinfo.datadir);

end;

procedure TPrintPreview.RepTitleChange(Sender: TObject);
begin
FConverter.Title:=RepTitle.Text;
end;

procedure TPrintPreview.InternalLinksClick(Sender: TObject);
begin
FConverter.makeLinks:=InternalLinks.Checked;
FConverter.OpenStream(slines,Chapters.Items,true,'preview.htm','');
WebBrowser1.Refresh;
end;

procedure TPrintPreview.FormHide(Sender: TObject);
begin
WebBrowSer1.navigate('about:blank');
end;
procedure TPrintPreview.StyleEditButtonClick(Sender: TObject);
begin
StyleForm:=TStyleForm.create(nil);
try
styleform.showmodal;
finally
styleform.free;
end;
FConverter.makeLinks:=InternalLinks.Checked;
FConverter.OpenStream(slines,Chapters.Items,true,'preview.htm','');
WebBrowser1.Refresh;
end;

end.
