unit rdiag;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Series, TeEngine, ExtCtrls, TeeProcs, Chart, StdCtrls, ComCtrls, ToolWin,
  ExtDlgs, HTTPApp, HTTPProd, ImgList;

type
  TRowDiagram = class(TForm)
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton6: TToolButton;
    DiagramType: TComboBox;
    RowChart: TChart;
    Series1: TPieSeries;
    Series2: TBarSeries;
    Series3: THorizBarSeries;
    ImageList1: TImageList;
    PageProducer1: TPageProducer;
    SavePictureDialog1: TSavePictureDialog;
    ToolButton5: TToolButton;
    PrintDialog1: TPrintDialog;
    procedure DiagramTypeClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure ToolButton5Click(Sender: TObject);
    procedure SavePictureDialog1TypeChange(Sender: TObject);
  private
    { Private declarations }
     repname:string;
  public
    { Public declarations }
  end;

var
  RowDiagram: TRowDiagram;

implementation

{$R *.DFM}
uses rxGif, Logs, utils, appConst,filectrl, Umessages;
procedure TRowDiagram.DiagramTypeClick(Sender: TObject);
var i:integer;
begin
 for i:=0 to rowchart.seriescount -1 do
  rowchart.series[i].active:=false;
i:=DiagramType.itemIndex;
if i<0 then i:=0;
rowchart.series[i].active:=true;
RowChart.ScaleLastPage:=true;
end;

procedure TRowDiagram.ToolButton1Click(Sender: TObject);
begin
close;
end;

procedure TRowDiagram.ToolButton2Click(Sender: TObject);
begin
if savepicturedialog1.Execute then
begin
userlog(Sender,'','');
if extractfileExt(SavePictureDialog1.filename)='.bmp' then
RowChart.SaveToBitmapFile(SavePictureDialog1.filename)
else
if extractfileExt(SavePictureDialog1.filename)='.wmf' then
RowChart.SaveToMetafile(SavePictureDialog1.filename)
else
if extractfileExt(SavePictureDialog1.filename)='.emf' then
RowChart.SaveToMetafileEnh(SavePictureDialog1.filename)
else
RowChart.SaveToBitmapFile(cutfileext(SavePictureDialog1.filename)+'.bmp');
end;
setcurrentdir(appconst.sysinfo.datadir);
end;

procedure TRowDiagram.ToolButton4Click(Sender: TObject);
var gi:TGifImage;
    l:TStringList;
    s:TSTringList;
begin
repname:=Copy(caption,length(': ')+1,length(caption));
if dialogs.InputQuery('  WEB',' ',repname) then
begin
gi:=TGifImage.create;
l:=TStringList.create;
try
RowChart.SaveToBitmapFile('temp.bmp');
gi.AddFrame(nil);
gi.Frames[0].Bitmap.LoadFromFile('temp.bmp');
gi.Frames[0].Bitmap.PixelFormat:=pf24bit;
gi.EncodeAllFrames;
setcurrentdir(appconst.sysinfo.datadir);
if not directoryexists(appconst.sysinfo.publicationDir+'\'+appconst.sysinfo.ModelName) then
 CreateDir(appconst.sysinfo.publicationDir+'\'+appconst.sysinfo.ModelName);
gi.SaveToFile(appconst.sysinfo.publicationDir+'\'+appconst.sysinfo.ModelName+'\'+repname+'.gif');

setcurrentdir(appconst.sysinfo.datadir);

s:=TStringlist.create;
s.text:=PageProducer1.Content;
s.savetofile(appconst.sysinfo.publicationDir+'\'+appconst.sysinfo.ModelName+'\'+repname+'.htm');
s.free;
showmessage(umessages.diagSaved);
finally
l.free;
gi.free;
end;
end;
end;
procedure TRowDiagram.PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
  const TagString: String; TagParams: TStrings; var ReplaceText: String);
begin
if TagString='AUTHOR' then replacetext:='<meta name="Author" content="'+(appconst.sysinfo.defAvtor)+'">'
else
if tagstring='TITLE' then replacetext:=(' : '+(repname))
else
if tagstring='PICTURENAME' then   replacetext:=(' '+repname)
else
if tagstring='PICTUREFILE' then   replacetext:='<img SRC="'+repname{utils.EncodeString(repname)}+'.gif">'
else
if tagstring='DAUTHOR' then replacetext:=( appconst.sysinfo.defavtor);
end;

procedure TRowDiagram.ToolButton5Click(Sender: TObject);
begin
if PrintDialog1.execute then
RowChart.Print;
end;

procedure TRowDiagram.SavePictureDialog1TypeChange(Sender: TObject);
begin
case SavePictureDialog1.FilterIndex of
0: SavePictureDialog1.DefaultExt:='bmp';
1: SavePictureDialog1.DefaultExt:='emf';
2: SavePictureDialog1.DefaultExt:='wmf';
end;
end;

end.
