Unit BPDfd;

{ DFD Diagram Module }
{ Modified  06-08-02 }

Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     Printers,QRPrntr,BPDef,BPNode,BPLabel,TFlatProgressBarUnit,stdctrls,MyUtils;

Type

  PDFDGraphNode=^TDFDGraphNode;
  TDFDGraphNode=record
    BPNode:TBPGraphNode;
    CorrectNode:Boolean;
    llNode:PBPNode;
    next:PDFDGraphNode;
  end;

  PDDFDGraphNode=^TDDFDGraphNode;
  TDDFDGraphNode=record
    BPDNode:TBPDGraphNode;
    CorrectNode:Boolean;
    TopBottom:Boolean;
    llNode:PBPOpTree;
    next:PDDFDGraphNode;
  end;

  PDFDGraphLink=^TDFDGraphLink;
  TDFDGraphLink=record
     BPFromLabel:TBPLabel; {TBPLabel}
     BPToLabel:TBPLabel; {TBPLabel}
     FromNodeNumber:DWORD;
     ToNodeNumber:DWORD;
     dwFlags:DWORD;
     FromLinkNumber:DWORD; { CurrentWork ! }
     ToLinkNumber:DWORD;   { CurrentWork ! }
     LineArrayX:Array[0..20] of Integer;
     LineArrayY:Array[0..20] of Integer;
     LinePointCount:DWORD;
     StartPoint:TPoint;
     EndPoint:TPoint;
     LinkFromCount:DWORD;
     LinkToCount:DWORD;
     LinkFromUpCount:DWORD;
     LinkFromDownCount:DWORD;
     LinkToUpCount:DWORD;
     LinkToDownCount:DWORD;
     MinimalXFrom:Integer;
     MinimalXTo:Integer;
     MinimalYFrom:Integer;
     MinimalYTo:Integer;
     Color:TColor;                          { T's LinkType }
     PenStyle:TPenStyle;                    { T's LinkType }
     llLink:PBPLink;                       { For comparing }
     next:PDFDGraphLink;
  end;

  TBPDFDFrame = class;

  TBPDFDGraph = class(TControl)
      private
        { Private declarations }
        FOwner:TBPDFDFrame;
        FNodes:PBPNode;
        FLinks:PBPLink;
        FTree:PBPTree;     { Tree for model   }
        FNTTree:PBPNodeTypes; { NodeTypes Tree }
        FLTTree:PBPLinkTypes; { LinkTypes Tree }
        FOPTree:PBPOpTree;    { Operation Tree } { CurrentWork ! }
        FHeader:TBPHeader; { Header for model }
        FLevel:Integer;      { Level for model, model must have level -1 }
        FSSLevel:ShortString; { New level for model in x.x.x.x format }
                              { CurrentWork ! }
        FLevelNotes:ShortString;
        FLevelRevision:DWORD;
        FLevelDraftStatus:TDraftStatus;
        FParentLevel:Integer;     { Parent level for model }
        FSSNodeNumber:ShortString; { Current node number entry }
        FNodeCaption:ShortString;

        FNodesCount:DWORD;
        FLinksCount:DWORD;
        FDNodesCount:DWORD;
        FDLinksCount:DWORD;
        FDTopNodesCount:DWORD;
        FDBottomNodesCount:DWORD;
        FGraphNodes:PDFDGraphNode;
        FDGraphNodes:PDDFDGraphNode;
        FDLastNode:PDDFDGraphNode;
        FGraphLinks:PDFDGraphLink;
        FMaxWidth:Integer;
        FMaxHeight:Integer;
        FDMaxWidth:Integer;
        FDMaxHeight:Integer;
        FDPrjMaxHeight:Integer;
        { Global page }
        FGlobalLeftSize:Integer;
        FGlobalRightSize:Integer;
        FGlobalTopSize:Integer;
        FGlobalBottomSize:Integer;
        { For printing and other }
        FDefWidth:Integer;
        FDefHeight:Integer;
        FPrinting:Boolean;
        FScreenFontName:TFontName;
        FPrinterFontName:TFontName;
        { Vars for mashtabing }
        FFontDPI:Integer;   { FontDPI }
        FFontSize:Integer;  { FontSize }
        FLabelFontSize:Integer;
        FMaxCh:Double;
         {lines mashtabing interval }
        FMinLineStep:Integer; { Line Step }
        FMinArcRadius:Integer;
        FMinLabelX:Integer;
        FMinLabelY:Integer;
        FMinLabelY1:Integer;
        FMinGlobalLabel:Integer;
        FMinLineEndPoint:Integer;
        { nodes mashtabing vars }
        FNodeLineWidth:Integer;
        FNodeDefWidth:Integer;
        FNodeDefHeight:Integer;
        FNodeHSpacing:Integer;
        FNodeVSpacing:Integer;
        FNodeShadowDepth:Integer;
        FNodeWidth:Integer;
        FNodeHeight:Integer;
        FCalcWidthHeight:Boolean;
          { Debug routines }
        FDebug:Boolean;
        FScaled:Boolean;             { Clip Windows to fit into ClipRect }
        FScaled2:Boolean;
        FScaled2Ratio:Extended;
        FDiscardDrags:Boolean;
        FRatioWC:Double;             { Ratio for recalc widthcoof }
        FRatioHC:Double;             { Ratio for recalc heightcoof }
        FModified:Boolean;
        FAcceptDragRect:TRect;       { Rect for Accept Drags & Drop }
        FLinksPosRelative:Boolean;
        { For printing and preview all }
        FActiveNodesList:TStringList;
        FMinYTop:Integer;
        FMinYBottom:Integer;
        { For optimum scaling }
        FMaxNodesCount:Integer;
        { Nodes and Labels }
        FReplaceNodes:Boolean;
        FReplaceLabels:Boolean;
        FMaxWordLength:Integer;
        FMaxWordCount:Integer;
        FMaxLabelLength:Integer;
        FPh:String;
        { Barahlo}
        FDoOverrideFS:Boolean;
        FNodesFontSize:Integer;
        FDNodesFontSize:Integer;
        FDProjectionFontSize:Integer;
        FInProcessFontSize:Integer;
        FLabelsFontSize:Integer;
        FOverrideNodesFS:Boolean;
        FOverrideDNodesFS:Boolean;
        FOverrideInProcessFS:Boolean;
        FOverrideLabelsFS:Boolean;
         {      }
        FMaxFontSize:Integer;
        FRealMaxFontSize:Integer;
        procedure SetMaxFontSize(Value:Integer);
        procedure UpdateMaxFontSize(Coof:Extended);
        procedure  AnalizeStringsFonts;
        procedure  CreateActiveNodesList;
        function   GetNTFromIndex(index:DWORD):TBPNodeTypes;
        function   GetLTFromIndex(index:DWORD):TBPLinkTypes;
        procedure  ClearGraphNodes;
        procedure  ClearDGraphNodes;
        procedure  ClearGraphLinks;
        procedure  CreateGraphNodes(wc,hc:Double);
        procedure  CreateGraphLinks(wc,hc:Double);
        procedure  CreateDGraphNodes(wc,hc:Double);
        procedure  SetFontSize(Value:Integer);
        procedure  SetScaled(Value:Boolean);
        procedure  SetScaled2(Value:Boolean);
        procedure  SetScaled2Ratio(Value:Extended);
        procedure  SetDiscardDrags(Value:Boolean);
        procedure  CalcMaxWidthHeight;
        procedure  CalcDNodesMaxWidthHeight;
        procedure  CalcLabelSizes; { Checked }
        function   GetLevelFromNodeNumber(NodeNum:ShortString):ShortString;
        function   GetDNode(num:DWORD):PBPOpTree;
        function   GetDGraphNumberedNode(num:DWORD;TopBottom:Boolean):PDDFDGraphNode;
        function   CreateDNodeFieldsList(dnode:PBPOpTree;EnTruncate:Boolean):ShortString;
        procedure  AddDNode(num:DWORD;Cap:String;Prj,HintPrj:String;sindex:DWORD;TopBottom:Boolean;ATop,ALeft:Integer;APos:Boolean;hc,wc:Double;ln:Integer;llnode:PBPOpTree;
                            fullcap,fullprj:String);
        { trace routines }
        procedure  TraceNodes;
        procedure  TraceLinksToNodeCounters;
        procedure  TraceLocalStartEndPoints; { Checked }
        procedure  TraceLinks;
        procedure  DrawLinks;
        procedure  DrawSS(sx,sy,dx,dy:Integer;color:TColor); { Checked }
        procedure  DrawArrowY(x,y:Integer;Positive:Boolean);
        procedure  MyNodeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
        procedure  MyLabelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
        procedure  UpdateNodesModel(X,Y:Integer;node:TBPGraphNode);
        procedure  UpdateDNodesModel(X,Y:Integer;node:TBPDGraphNode);
        procedure  UpdateLinksModel(X,Y:Integer;llabel:TBPLabel);
        procedure  CorrectLinksModel(delta:TPoint;NodeNum:DWORD;AcceptRect:TRect;DNode:Boolean);
       public
       { Public declarations }
        FLang:TFontCharset;
        procedure   SetMaxAll(BReplaceNodes,BReplaceLabels:Boolean;IMaxWordLength,IMaxWordCount,IMaxLabelLength:Integer);
        procedure   SetOverrideFonts(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean);
        procedure   SetOverrideFontsAll(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean;
                                        CNFS,CDNFS,CDPFS,CIPFS,CLFS,CONFS,CODFS,COIFS,COLFS:Boolean);
        constructor Create(AOwner: TComponent); override;
        destructor  Destroy; override;
        procedure   TraceRoute; { Main Tracing Procedure }
        procedure   AssignModel(Tree:PBPTree;NTTree:PBPNodeTypes;LTTree:PBPLinkTypes;
                                OPTree:PBPOpTree;Header:TBPHeader);
        procedure   ClearModel;
        procedure   OpenNode(NodeNum:ShortString);
        procedure   PresetupFrame(widthcoof,heightcoof:Double);
        { Scale }
        procedure  SetDefaultConstants;
        procedure  SetScaledConstants(ratiox,ratioy,ratio:Double;fontSizeRatio:Double;LabelFontSizeRatio:Double);
        function   GetMaxPagesCount:Integer;

        procedure  FillBPInfoBlock(Var InfoBlock:TBPInfoBlock);
        procedure  SetDNodeCaption(node:TBPDGraphNode;Text:String;items:TStrings);
        procedure  SetNodeCaption(node:TBPGraphNode;Text:ShortString);
        procedure  SetLinkCaption(mlabel:TBPLabel;Text:ShortString);
      published
       { Published declarations }
       property Parent:TBPDFDFrame read FOwner write FOwner;
       property FontDPI:Integer read FFontDPI write FFontDPI;
       property DefWidth:Integer read FDefWidth write FDefWidth;
       property DefHeight:Integer read FDefHeight write FDefHeight;
       property MaxWidth:Integer read FMaxWidth;
       property MaxHeight:Integer read FMaxHeight;
       property PrjMaxHeight:Integer read FDPrjMaxHeight;
       property NodeWidth:Integer read FNodeWidth;
       property NodeHeight:Integer read FNodeHeight;
       property Printing:Boolean read FPrinting write FPrinting;
       property MinLineStep:Integer read FMinLineStep write FMinLineStep default 6;
       property GlobalLeftSize:Integer read FGlobalLeftSize write FGlobalLeftSize default 80;
       property GlobalRightSize:Integer read FGlobalRightSize write FGlobalRightSize default 80;
       property GlobalTopSize:Integer read FGlobalTopSize write FGlobalTopSize default 80;
       property GlobalBottomSize:Integer read FGlobalBottomSize write FGlobalBottomSize default 80;

       property FontSize:Integer read FFontSize write SetFontSize;
       property NodesCount:DWORD read FNodesCount;
       property MinArcRadius:Integer read FMinArcRadius write FMinArcRadius;
       property MinLabelX:Integer read FMinLabelX write FMinLabelX;
       property MinLabelY:Integer read FMinLabelY write FMinLabelY;
       property MinLabelY1:Integer read FMinLabelY1 write FMinLabelY1;
       property MinGlobalLabel:Integer read FMinGlobalLabel write FMinGlobalLabel;
       property MinLineEndPoint:Integer read  FMinLineEndPoint write FMinLineEndPoint;
       property Level:Integer read FLevel;
       property SSLevel:ShortString read FSSLevel; { CurrentWork !}
       property SSNodeNumber:ShortString read FSSNodeNumber;
       property ParentLevel:Integer read FParentLevel;
       property ScreenFontName:TFontName read FScreenFontName write FScreenFontName;
       property PrinterFontName:TFontName read FPrinterFontName write FPrinterFontName;
       property Debug:Boolean read FDebug write FDebug;
       property Scaled:Boolean read FScaled write SetScaled;
       property Scaled2:Boolean read FScaled2 write SetScaled2;
       property Scaled2Ratio:Extended read FScaled2Ratio write SetScaled2Ratio;
       property Header:TBPHeader read FHeader;
       property NTTree:PBPNodeTypes read FNTTree;
       property LTTree:PBPLinkTypes read FLTTree;
       property DiscardDrags:Boolean read FDiscardDrags write SetDiscardDrags;
       property Modified:Boolean read FModified write FModified default False;
       property AcceptDragRect:TRect read FAcceptDragRect;
       property LinksPosRelative:Boolean read FLinksPosRelative write FLinksPosRelative default True;
       property ActiveNodesList:TStringList read FActiveNodesList;
       property OpenedNode:ShortString read FSSNodeNumber;
       property NodeCaption:ShortString read FNodeCaption;
       {New}
       property NodesFontSize:Integer read FNodesFontSize;
       property DNodesFontSize:Integer read FDNodesFontSize;
       property DProjectionFontSize:Integer read FDProjectionFontSize;
       property InProcessFontSize:Integer read FInProcessFontSize;
       property LabelsFontSize:Integer read FLabelsFontSize;
       property OverrideNodesFS:Boolean read FOverrideNodesFS;
       property OverrideDNodesFS:Boolean read FOverrideDNodesFS;
       property OverrideInProcessFS:Boolean read FOverrideInProcessFS;
       property OverrideLabelsFS:Boolean read FOverrideLabelsFS;
       property MaxFontSize:Integer read FMaxFontSize write SetMaxFontSize;
     end;

 { TBPDFDFrame definition }
  TBPDFDFrame = class(TScrollingWinControl)
  private
    { Private declarations }
    FBPDFDGraph:TBPDFDGraph;                         { _++-+ +- }
    FCanvas: TCanvas;
    { Page Param Options }
    FPageTop:Integer;
    FPageBottom:Integer;
    FPageLeft:Integer;
    FPageRight:Integer;
    FPrinter:TQRPrinter;
    FPrinting:Boolean;
    FPainting:Boolean; { So disable double insert in painting module }
    FAborting:Boolean;
    { Vars for scaling diagrams }
    FHorzPageCount:Integer;
    FVertPageCount:Integer;
    { Vars for scaling ramka font }
    FRamkaFontRatio:Extended;
    FPSizeH:Extended;
    FPSizeW:Extended;
    FRamkaH:Integer;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
  protected
    { Protected declarations }
    procedure Paint; virtual;
    procedure PaintWindow(DC: HDC); override;
    procedure PaintTo(DC: HDC; X, Y: Integer);
    procedure PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect);
    { printing routines }
    procedure  PrintStandartRectangle;
    procedure  PreviewStandartRectangle(pw,ph:Integer);
    function   CalcNewString(s:String;Const outCanvas:TCanvas;MaxWidth:Integer):String;
    procedure  PreviewPrintRect(left,right,top,bottom:Integer);
    procedure  PrintRect(left,right,top,bottom:Integer);
    procedure  ReadWrite(left,right,top,bottom:Integer);
    procedure  PreviewReadWrite(left,right,top,bottom:Integer);
    procedure  PrintReadWrite(left,right,top,bottom:Integer);
    procedure  MyDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure  MyDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure  DrawNode(l,t,w,h:Integer;Canvas:TCanvas;PaintColor,DrawColor:TColor);
    procedure  DrawLink(pl:PDFDGraphLink;Canvas:TCanvas;RatioX,RatioY:Double;Wpos,Hpos:Integer);
    function   GetCoof(rw,rh:Double;Alg:TBPFormatAlg):Double;
  public
    { Public declarations }
    FUpdatingNavigator:Boolean;
    FPreviewOrPrint:Boolean;
    FFontCoof:Double;
    FNodesValue:Array[0..1] of Integer; { Min Max }
    FFormatAlg:array[0..2] of TBPFormatAlg; { Min Middle Max }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetPageParam(Var PageTop,PageBottom,PageLeft,PageRight:Integer;ShowWarning:Boolean);
    procedure SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer);
    procedure Print;
    procedure CreateBitmap(var value:TBitmap;pf:TPixelFormat);
    procedure GetBitmapWithSize(value:TBitmap;iw,ih:Integer); { scaled bitmap }
    procedure CreateBitmapWithSize(var value:TBitmap;pf:TPixelFormat;iw,ih:Integer); { scaled bitmap }
    procedure CreateBitmapForOneShit(var value:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer);
    procedure CreatePreview;
    procedure PrintAll(pb:TFlatProgressBar;Lbl:TLabel;StartP,EndP:Integer);
    procedure CreatePreviewAll(pb:TFlatProgressBar;Lbl:TLabel);
  published
    { Published declarations }
    property BPDFDGraph:TBPDFDGraph read FBPDFDGraph;
    property HorzPages:Integer read FHorzPageCount write FHorzPageCount default 1;
    property VertPages:Integer read FVertPageCount write FVertPageCount default 1;
    property Align default alNone;
    property Width default 100;
    property Height default 100;
    property Enabled default True;
    property ShowHint;
    property Visible;
    property Ctl3D;
    property TabStop default True;
    property TabOrder;
    property Canvas:TCanvas read FCanvas;
    property QPrinter:TQRPrinter read FPrinter;
    property Printing:Boolean read FPrinting;
    property Aborting:Boolean read FAborting write FAborting;
    property OnKeyUp;
    property OnEnter;
    property OnExit;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
    property PopupMenu;
  end;

function SignedVector(Sign,Value:Integer):Integer;

procedure Register;

Const StartMinLineStep=6;
      StartMinLabelX=8;
      StartMinLabelY=4;
      StartMinLabelY1=12; { Try to change }
      StartMinArcRadius=8;
      NodeRatio=4/3;
      StartMinGlobalLabel=10;
      StartMinLineEndPoint=4;
      StartMaxLines=4;

      A3Width=16.5354;  { Inch }
      A3Height=11.6929; { Inch }
      DefMaxLabelFontSize=14;


Implementation

Uses MainUnit,AnalizeGraphUnit;

procedure TBPDFDGraph.SetLinkCaption(mlabel:TBPLabel;Text:ShortString);
Var tlink:PDFDGraphLink;
        i:Integer;
 begin
   if FGraphLinks=nil then Exit;
   tlink:=FGraphLinks;
   for i:=0 to (FDLinksCount-1) do
    begin
       if tlink^.BPFromLabel=mlabel then
         begin
           tLink^.llLink^.ssFromCaption:=Text;
           FModified:=True;
           Exit;
         end;
        if tlink^.BPToLabel=mlabel then
         begin
           tLink^.llLink^.ssToCaption:=Text;
           FModified:=True;
           Exit;
         end;
       tlink:=tlink^.next;
    end;
 end;

procedure TBPDFDGraph.SetNodeCaption(node:TBPGraphNode;Text:ShortString);
Var tnode:PDFDGraphNode;
        i:Integer;
     flag:Boolean;
       s:String;
       tmpTree:PBPTree;
 begin
   if FGraphNodes=nil then Exit;
   flag:=False;
   tnode:=FGraphNodes;
       if (tnode^.BPNode=node) then
          begin
            tNode^.llnode^.ssCaption:=Text;
            s:=Trim(tNode^.llNode^.ssNodeNumber);
            if length(s)>1 then Delete(s,1,1);
            flag:=True;
            FModified:=True;
          end;
  if flag then
    begin
      tmpTree:=FTree;
      while (tmpTree<>nil) do
        begin
          if (tmpTree^.ssLevel=s) then
            begin
              tmpTree^.ssCaption:=Text;
              Exit;
            end;
          tmpTree:=tmpTree^.next;
        end;
    end;
 end;


procedure TBPDFDGraph.SetDNodeCaption(node:TBPDGraphNode;Text:String;items:TStrings);
Var nodeP:PDDFDGraphNode;
      i,j:Integer;
    opDetail:PBPOpDetail;
 begin
   if FDGraphNodes=nil then Exit;
   nodeP:=FDGraphNodes;
   for i:=0 to (FDNodesCount-1) do
    begin
      if nodeP^.BPDNode=node then
        begin
          nodeP^.llNode^.ssCaption:=Text;
          FreeMem(nodeP^.llNode^.lpOpDetail,sizeof(TBPOpDetail)*nodeP^.llNode^.dwOpDetailCount);
          nodeP^.llNode^.lpOpDetail:=PBPOpDetail(AllocMem(sizeof(TBPOpDetail)*items.Count));
          nodeP^.llNode^.dwOpDetailCount:=items.Count;
          opDetail:=nodeP^.llNode^.lpOpDetail;
          for j:=0 to (items.Count-1) do
            begin
              opDetail^.ssCaption:=items.Strings[j];
              inc(opDetail);
            end;
          FModified:=True;
          Exit;  
        end;
      nodeP:=nodeP^.next;
    end;
 end;


procedure TBPDFDGraph.SetOverrideFontsAll(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean;
                                          CNFS,CDNFS,CDPFS,CIPFS,CLFS,CONFS,CODFS,COIFS,COLFS:Boolean);
Var tmptree:PBPTree;
 begin
  if CNFS then  FNodesFontSize:=NFS;
  if CDNFS then FDNodesFontSize:=DNFS;
  if CDPFS then FDProjectionFontSize:=DPFS;
  if CIPFS then FInProcessFontSize:=IPFS;
  if CLFS then FLabelsFontSize:=LFS;
  if CONFS then FOverrideNodesFS:=ONFS;
  if CODFS then FOverrideDNodesFS:=ODFS;
  if COIFS then FOverrideInProcessFS:=OIFS;
  if COLFS then FOverrideLabelsFS:=OLFS;
  if (FTree=nil) then Exit;
  tmpTree:=FTree;
  while (tmpTree<>nil) do
   begin
     if CNFS then tmpTree^.dwNodesFontSize:=NFS;
     if CONFS then tmpTree^.dbOverrideNodesFS:=ONFS;
     if CDNFS then  tmpTree^.dwDNodesFontSize:=DNFS;
     if CODFS then tmpTree^.dbOverrideDNodesFS:=ODFS;
     if CDPFS then tmpTree^.dwDProjectionFontSize:=DPFS;
     if CIPFS then tmpTree^.dwInProcessFontSize:=IPFS;
     if COIFS then tmpTree^.dbOverrideInProcessFS:=OIFS;
     if CLFS then  tmpTree^.dwLabelsFontSize:=LFS;
     if COLFS then tmpTree^.dbOverrideLabelsFS:=OLFS;
     FModified:=True;
     tmpTree:=tmpTree^.next;
   end;
 end;


procedure TBPDFDGraph.SetOverrideFonts(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean);
 begin
  FNodesFontSize:=NFS;
  FDNodesFontSize:=DNFS;
  FDProjectionFontSize:=DPFS;
  FInProcessFontSize:=IPFS;
  FLabelsFontSize:=LFS;
  FOverrideNodesFS:=ONFS;
  FOverrideDNodesFS:=ODFS;
  FOverrideInProcessFS:=OIFS;
  FOverrideLabelsFS:=OLFS;
 end;

procedure  TBPDFDGraph.AnalizeStringsFonts;
Var fs:Integer;
 begin
   if not(BPViewMainForm.EnableAnalizForm.Checked) then Exit;
   if (AnalizeGraphForm=nil) then Exit;
   if  FGraphNodes=nil then Exit;
   fs:=Round(FFontSize/FScaled2Ratio*100);
   if FOverrideNodesFS or FOverrideDNodesFS then Exit;
   with AnalizeGraphForm do
   begin
   if (fs<BP_MINFONT_SIZE) then
    begin
      ResultEditor.Clear;
      ResultEditor.Lines.Append('        -');
      ResultEditor.Lines.Append('   "  "  ""');
      ResultEditor.Lines.Append(' ');
      ResultEditor.Lines.Append(':    ( )');
      ResultEditor.Lines.Append(' ');
      ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
      ShowModal;
    end;
   end;
 end;

function SignedVector(Sign,Value:Integer):Integer;
 begin
   if Sign>0 then Result:=1 else
   if Sign<0 then Result:=-1 else Result:=0;
   Result:=Result*Value;
 end;

{ TBPDFDGraph }

procedure TBPDFDGraph.SetMaxAll(BReplaceNodes,BReplaceLabels:Boolean;IMaxWordLength,IMaxWordCount,IMaxLabelLength:Integer);
  begin
   FReplaceNodes:=BReplaceNodes;
   FReplaceLabels:=BReplaceLabels;
   FMaxWordLength:=IMaxWordLength;
   FMaxWordCount:=IMaxWordCount;
   FMaxLabelLength:=IMaxLabelLength;
   FOwner.Visible:=False;
   OpenNode(FSSNodeNumber);
   FOwner.Invalidate;
   FOwner.Visible:=True;
  end;


procedure  TBPDFDGraph.FillBPInfoBlock(Var InfoBlock:TBPInfoBlock);
Var count:Integer;
  tmpTree:PBPTree;
       nc:Integer;
    nodeP:PBPNode;
      i,j:Integer;
        nn:String;
 begin
  InfoBlock.levelsCount:=0;
  if (FTree=nil) then Exit;
  tmpTree:=FTree;
  count:=0;
  InfoBlock.levelsCount:=FActiveNodesList.Count;
  for i:=0 to (FActiveNodesList.Count-1) do
   begin
    nn:=FActiveNodesList.Names[i];
    tmpTree:=FTree;
     while (tmpTree<>nil) do
      begin
        nc:=TmpTree^.dwNodesCount;
        if (nc>0) then
         begin
           nodeP:=tmpTree^.lpNodes;
           for j:=0 to (nc-1) do
            begin
              if (nn=nodeP^.ssNodeNumber) then
                 begin
                   InfoBlock.Pages[count]:=count+1;
                   InfoBlock.LevelsID[count]:=nn;
                   InfoBlock.Captions[count]:=nodeP^.ssCaption;
                   InfoBlock.Comments[count]:=nodeP^.ssComment;
                   inc(count);
                 end;
              inc(nodeP);
            end;
         end;
        tmpTree:=tmpTree^.next;
      end; { while }
   end; { for }
 end;

procedure  TBPDFDGraph.DrawArrowY(x,y:Integer;Positive:Boolean);
Var d:Integer;
    k:Integer;
 begin
  {}
   d:=Round(MinLineEndPoint*0.57735);
   if (d=0) and (MinLineEndPoint=0) then Exit;
   if (d=0) then d:=1;
   for k:=0 to d do
    begin
     if Positive then
      begin
       FOwner.Canvas.MoveTo(x+k,y+MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
       FOwner.Canvas.MoveTo(x-k,y+MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
      end
     else
      begin
       FOwner.Canvas.MoveTo(x+k,y-MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
       FOwner.Canvas.MoveTo(x-k,y-MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
      end;
    end;
 end;

procedure  TBPDFDGraph.UpdateLinksModel(X,Y:Integer;llabel:TBPLabel);
Var xc,yc:Integer;
    i,j:Integer;
    link:PDFDGraphLink;
 begin
   if FDLinksCount=0 then Exit;
   if llabel=nil then Exit;
   if FRatioWC=0 then Exit;
   if FRatioHC=0 then Exit;
  { Recalc X and Y coord to not scaled model }
   if FScaled or FPrinting then
    begin
     xc:=Round(X/FRatioWC);
     yc:=Round(Y/FRatioHC);
    end
   else
    begin
     xc:=x;
     yc:=y;
    end;
    link:=FGraphLinks;
  { Update links model}
    for i:=0 to (FDLinksCount-1) do
      begin
        if (link^.BPFromLabel<>nil) then
          if (link^.BPFromLabel=llabel) then
            begin
              link^.llLink^.FromLeft[1]:=xc;
              link^.llLink^.FromTop[1]:=yc;
              link^.llLink^.FromAcceptPosition[1]:=True;
              FModified:=True;
            end;
        if (link^.BPToLabel<>nil) then
          if (link^.BPToLabel=llabel) then
            begin
              link^.llLink^.ToLeft[1]:=xc;
              link^.llLink^.ToTop[1]:=yc;
              link^.llLink^.ToAcceptPosition[1]:=True;
              FModified:=True;
            end;
        link:=link^.next;
      end;
 end;

procedure  TBPDFDGraph.CorrectLinksModel(delta:TPoint;NodeNum:DWORD;AcceptRect:TRect;DNode:Boolean);
Var p:PDFDGraphLink;
    i:Integer;
    cnt:Integer;
    x,y:Integer;
    x1,y1:Integer;
    dx,dy:Integer;
    flag:Boolean;
    f1:Boolean;
    ff,ft:Boolean;
 begin
   { Correct links coordinates }
   if (FDLinksCount=0) then Exit;
   cnt:=FDLinksCount-1;
   if FOwner.VertScrollBar.Visible then dy:=FOwner.VertScrollBar.Position else dy:=0;
   if FOwner.HorzScrollBar.Visible then dx:=FOwner.HorzScrollBar.Position else dx:=0;
   p:=FGraphLinks;
   for i:=0 to cnt do
     begin
       if DNode then
         begin
          f1:=(((p^.FromNodeNumber and BPGlobalNodeOperation)<>0) and
              ((p^.FromNodeNumber and BPNotGlobalMask)=NodeNum)) or
              (((p^.ToNodeNumber and BPGlobalNodeOperation)<>0) and
              ((p^.ToNodeNumber and BPNotGlobalMask)=NodeNum));
          ff:=(((p^.FromNodeNumber and BPGlobalNodeOperation)<>0) and
              ((p^.FromNodeNumber and BPNotGlobalMask)=NodeNum));
          ft:=(((p^.ToNodeNumber and BPGlobalNodeOperation)<>0) and
              ((p^.ToNodeNumber and BPNotGlobalMask)=NodeNum));
         end
       else
         begin
          f1:=((p^.FromNodeNumber=NodeNum) or (p^.ToNodeNumber=NodeNum));
          ff:=(p^.FromNodeNumber=NodeNum);
          ft:=(p^.ToNodeNumber=NodeNum);
         end;
       if (f1) then
          begin { Any link to this node }
            flag:=False; { !!! }
            if (p^.BPFromLabel<>nil) then
              if (p^.BPFromLabel.AcceptPosition) then
                 begin
                   if (ff) then Flag:=True;

                   x:=p^.BPFromLabel.LeftDragPos+delta.x;
                   if ((x+p^.BPFromLabel.Width)>AcceptRect.Right) then
                      x:=AcceptRect.Right-p^.BPFromLabel.Width;
                   if (x<AcceptRect.Left) then x:=AcceptRect.Left;

                   x1:=p^.BPFromLabel.Left+delta.x;
                   if ((x1+dx+p^.BPFromLabel.Width)>AcceptRect.Right) then
                      x1:=AcceptRect.Right-dx-p^.BPFromLabel.Width;
                   if ((x1+dx)<AcceptRect.Left) then
                      x1:=AcceptRect.Left-dx;

                   y:=p^.BPFromLabel.TopDragPos+delta.y;
                   if ((y+p^.BPFromLabel.Height)>AcceptRect.Bottom) then
                      y:=AcceptRect.Bottom-p^.BPFromLabel.Height;
                   if (y<AcceptRect.Top) then y:=AcceptRect.Top;

                   y1:=p^.BPFromLabel.Top+delta.y;
                   if ((y1+dy+p^.BPFromLabel.Height)>AcceptRect.Bottom) then
                      y1:=AcceptRect.Bottom-dy-p^.BPFromLabel.Height;
                   if ((y1+dy)<AcceptRect.Top) then
                      y1:=AcceptRect.Top-dy;
                   if Flag then
                   begin
                   p^.BPFromLabel.LeftDragPos:=x;
                   p^.BPFromLabel.TopDragPos:=y;
                   p^.BPFromLabel.Left:=x1;
                   p^.BPFromLabel.Top:=y1;
                   p^.BPFromLabel.AcceptPosition:=True;
                   UpdateLinksModel(x1+dx,y1+dy,p^.BPFromLabel);
                   Flag:=False;
                   end;
                 end;
            Flag:=False;
            if (p^.BPToLabel<>nil) then
              if (p^.BPToLabel.AcceptPosition) then
                 begin
                   if (ft) then Flag:=True;
                   x:=p^.BPToLabel.LeftDragPos+delta.x;
                   if ((x+p^.BPToLabel.Width)>AcceptRect.Right) then
                      x:=AcceptRect.Right-p^.BPToLabel.Width;
                   if (x<AcceptRect.Left) then x:=AcceptRect.Left;

                   x1:=p^.BPToLabel.Left+delta.x;
                   if ((x1+dx+p^.BPToLabel.Width)>AcceptRect.Right) then
                      x1:=AcceptRect.Right-dx-p^.BPToLabel.Width;
                   if ((x1+dx)<AcceptRect.Left) then
                      x1:=AcceptRect.Left-dx;
                   y:=p^.BPToLabel.TopDragPos+delta.y;
                   if ((y+p^.BPToLabel.Height)>AcceptRect.Bottom) then
                      y:=AcceptRect.Bottom-p^.BPToLabel.Height;
                   if (y<AcceptRect.Top) then y:=AcceptRect.Top;

                   y1:=p^.BPToLabel.Top+delta.y;
                   if ((y1+dy+p^.BPToLabel.Height)>AcceptRect.Bottom) then
                      y1:=AcceptRect.Bottom-dy-p^.BPToLabel.Height;
                   if ((y1+dy)<AcceptRect.Top) then
                      y1:=AcceptRect.Top-dy;
                   if Flag then
                   begin
                   p^.BPToLabel.LeftDragPos:=x;
                   p^.BPToLabel.TopDragPos:=y;
                   p^.BPToLabel.Left:=x1;
                   p^.BPToLabel.Top:=y1;
                   p^.BPToLabel.AcceptPosition:=True;
                   UpdateLinksModel(x1+dx,y1+dy,p^.BPToLabel);
                   Flag:=False;
                   end;
                 end;
          end;
        p:=p^.next;
     end;
 end;

procedure TBPDFDGraph.UpdateDNodesModel(X,Y:Integer;node:TBPDGraphNode);
Var xc,yc:Integer;
    linkPtr:PDFDGraphLink;
    i:Integer;
begin
   if FDLinksCount=0 then Exit;
   if node=nil then Exit;
   if FRatioWC=0 then Exit;
   if FRatioHC=0 then Exit;
  { Recalc X and Y coord to not scaled model }
   if FScaled or FPrinting then
    begin
     xc:=Round(X/FRatioWC);
     yc:=Round(Y/FRatioHC);
    end
   else
    begin
     xc:=x;
     yc:=y;
    end;
  { Update nodes model }
   linkPtr:=FGraphLinks;
   for i:=0 to (FDLinksCount-1) do
     begin
       if ((linkPtr^.FromNodeNumber and BPGlobalNodeOperation)<>0) and
          ((linkPtr^.FromNodeNumber and BPNotGlobalMask)=node.NodeNumber) and
          (linkPtr^.llLink^.dwFromLinkNumber=node.Tag) then
            begin
              linkPtr^.llLink^.DNodeLeft:=xc;
              linkPtr^.llLink^.DNodeTop:=yc;
              linkPtr^.llLink^.DNodeAcceptPosition:=True;
              FModified:=True;
            end;
       if ((linkPtr^.ToNodeNumber and BPGlobalNodeOperation)<>0) and
          ((linkPtr^.ToNodeNumber and BPNotGlobalMask)=node.NodeNumber) and
          (linkPtr^.llLink^.dwToLinkNumber=node.Tag) then
            begin
              linkPtr^.llLink^.DNodeLeft:=xc;
              linkPtr^.llLink^.DNodeTop:=yc;
              linkPtr^.llLink^.DNodeAcceptPosition:=True;
              FModified:=True;
            end;
       linkPtr:=linkPtr^.next;
     end;
end;

procedure TBPDFDGraph.UpdateNodesModel(X,Y:Integer;node:TBPGraphNode);
Var xc,yc:Integer;
    nodePtr:PBPNode;
    i:Integer;
 begin
   if FNodesCount=0 then Exit;
   if node=nil then Exit;
   if FRatioWC=0 then Exit;
   if FRatioHC=0 then Exit;
  { Recalc X and Y coord to not scaled model }
   if FScaled or FPrinting then
    begin
     xc:=Round(X/FRatioWC);
     yc:=Round(Y/FRatioHC);
    end
   else
    begin
     xc:=x;
     yc:=y;
    end;
  { Update nodes model }
   nodePtr:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       if (node.Caption=nodePtr^.ssCaption) and
          (node.NodeNumber=nodePtr^.dwNodeNumber) and
          (node.SNodeNumber=nodePtr^.ssNodeNumber) then
         begin
           nodePtr^.Left[1]:=xc;
           nodePtr^.Top[1]:=yc;
           nodePtr^.AcceptPosition[1]:=True;
           FModified:=True;
         end;
       inc(nodePtr);
     end;
 end;

procedure TBPDFDGraph.MyNodeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
 begin
  if (Sender is TBPGraphNode) and (Button=mbLeft) then
   (Sender as TBPGraphNode).BeginDrag(False);
  if (Sender is TBPDGraphNode) and (Button=mbLeft) then
   (Sender as TBPDGraphNode).BeginDrag(False);
 end;

procedure TBPDFDGraph.MyLabelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
 begin
   if (Sender is TBPLabel) and (Button=mbLeft) then
        (Sender as TBPLabel).BeginDrag(True);
 end;



 procedure  TBPDFDGraph.CreateActiveNodesList;
 Var tmpTree:PBPTree;
     lc,nc:Integer;
     tmpLink:PBPLink;
     tmpNode,tmpNode1:PBPNode;
     i,j:Integer;
     s,s1:ShortString;
     Flag:Boolean;
     c:Integer;
  begin
    FActiveNodesList.Clear;
    if FTree=nil then Exit;
    TmpTree:=FTree;
    while (tmpTree<>nil) do
      begin
        tmpNode:=tmpTree^.lpNodes;
        tmpLink:=tmpTree^.lpLinks;
        lc:=tmpTree^.dwLinksCount;
        nc:=tmpTree^.dwNodesCount;
        if (nc>0) and (lc>0) then
          begin
             for i:=0 to (lc-1) do
              begin
                if ((tmpLink^.dwFromNodeNumber and BPGlobalNodeOperation)<>0) then
                  begin
                    tmpNode1:=tmpNode;
                    for j:=0 to (nc-1) do
                     begin
                       if (tmpLink^.dwToNodeNumber=tmpNode1^.dwNodeNumber) then
                         begin
                           s:=Trim(tmpNode1^.ssNodeNumber);
                           if (FActiveNodesList.IndexOfName(s)=-1) then
                             begin
                               s:=s+'='+tmpNode1^.ssCaption;
                               FActiveNodesList.Append(s);
                             end;
                         end;
                       inc(tmpNode1);
                     end;
                  end;
                if ((tmpLink^.dwToNodeNumber and BPGlobalNodeOperation)<>0) then
                  begin
                    tmpNode1:=tmpNode;
                    for j:=0 to (nc-1) do
                     begin
                       if (tmpLink^.dwFromNodeNumber=tmpNode1^.dwNodeNumber) then
                         begin
                           s:=Trim(tmpNode1^.ssNodeNumber);
                           if (FActiveNodesList.IndexOfName(s)=-1) then
                            begin
                             s:=s+'='+tmpNode1^.ssCaption;
                             FActiveNodesList.Append(s);
                            end;
                         end;
                       inc(tmpNode1);
                     end;
                  end;
                inc(tmpLink);
              end;
          end;
        tmpTree:=tmpTree^.next;
      end;
     { Sorting List in accsending order }
     c:=FActiveNodesList.Count;
     Flag:=True;
     while Flag do
      begin
        Flag:=False;
        for i:=0 to (c-1) do
          for j:=i+1 to (c-2) do
           begin
             s:=Trim(FActiveNodesList.Names[i]);
             s1:=Trim(FActiveNodesList.Names[j]);
             if length(s1)<length(s) then
               begin
                 Flag:=True;
                 FActiveNodesList.Exchange(i,j);
               end
             else
              if (length(s1)=length(s)) and
                 (s>s1) then
               begin
                 Flag:=True;
                 FActiveNodesList.Exchange(i,j);
               end;
           end;
      end;
  end;

 procedure  TBPDFDGraph.DrawSS(sx,sy,dx,dy:Integer;color:TColor); { Checked }
  Var oldColor:TColor;
      hw:Integer;
      x1,y1,x2,y2:Integer;
      zx,zy:Integer;
      f1,f2:Double;
      normaz:Integer;
      sizex,sizey:Integer;
  begin
   { Draws SS link from point to caption }
    with FOwner.Canvas do
     begin
       oldColor:=Pen.Color;
       Pen.Color:=color;
       zx:=(dx-sx) div 2;
       zy:=(dy-sy) div 2;
       normaz:=Round(Sqrt(zx*zx+zy*zy));
       f1:=3.14/2;
       f2:=-3.14/2;
       sizex:=MinLabelX div 4;
       sizey:=sizex;
       if (normaz=0) then normaz:=1;
       if (sizex=0) then sizex:=1;
       if (sizey=0) then sizey:=1;
       x1:=Round((cos(f1)*zx+sin(f1)*zy)/normaz*sizex)+sx+zx;
       y1:=Round((cos(f1)*zy-sin(f1)*zx)/normaz*sizey)+sy+zy;
       x2:=Round((cos(f2)*zx+sin(f2)*zy)/normaz*sizex)+sx+zx;
       y2:=Round((cos(f2)*zy-sin(f2)*zx)/normaz*sizey)+sy+zy;
       MoveTo(sx,sy);
       LineTo(x1,y1);
       LineTo(x2,y2);
       LineTo(dx,dy);
       Pen.Color:=oldColor;
     end;
  end;

 function   TBPDFDGraph.GetDGraphNumberedNode(num:DWORD;TopBottom:Boolean):PDDFDGraphNode;
 var flag:Boolean;
  begin
    Result:=nil;
    if (FDNodesCount=0) then Exit;
    Result:=FDGraphNodes;
    flag:=True;
    while (Result<>nil) and flag do
     begin
       if (Result^.BPDNode.NodeNumber=num) and
          (Result^.TopBottom=TopBottom)  then
         begin
           Flag:=False;
         end
       else
       Result:=Result^.next;
     end;
  end;

 procedure  TBPDFDGraph.SetDefaultConstants; { Checked }
 Var dc:HDC;
  begin
   FDoOverrideFS:=False;
   dc:=GetDC(FOwner.Handle);
   FFontDPI:=96;{GetDeviceCaps(dc,LOGPIXELSX);}
   ReleaseDC(FOwner.Handle,dc);
   FFontSize:=8;
   FLabelFontSize:=8;
   FDNodesFontSize:=8;
   FDProjectionFontSize:=8;
   FMinLineStep:=StartMinLineStep;
   FNodeLineWidth:=1;
   FNodeDefWidth:=100;
   FNodeDefHeight:=100;
   FNodeHSpacing:=1;
   FNodeVSpacing:=1;
   FGlobalLeftSize:=80;
   FGlobalRightSize:=80;
   FGlobalTopSize:=80;
   FGlobalBottomSize:=80;
   FMinArcRadius:=StartMinArcRadius;
   FMinLabelX:=StartMinLabelX;
   FMinLabelY:=StartMinLabelY;
   FMinLabelY1:=StartMinLabelY1;
   FMinGlobalLabel:=StartMinGlobalLabel;
   FNodeShadowDepth:=4;
   FMinLineEndPoint:=StartMinLineEndPoint;
  end;

 procedure  TBPDFDGraph.SetScaledConstants(ratiox,ratioy,ratio:Double;fontSizeRatio:Double;LabelFontSizeRatio:Double); { Checked }

 function GetMinLabelY1(Value:Integer):Integer;
 Var  dc:HDC;
     ppi:Integer;
  begin
    Result:=Value;
    if not(FDoOverrideFS and FOverrideLabelsFS) then Exit;
    dc:=GetDC(0);
    ppi:=GetDeviceCaps(dc,LOGPIXELSY);
    ReleaseDC(0,dc);
    if FOwner.FPreviewOrPrint then
      Result:=Round(1.2*FLabelsFontSize*ppi*FOwner.FFOntCoof/72)
    else
      Result:=Round(1.2*FLabelsFontSize*ppi*FScaled2Ratio/100/72);
  end;

  begin
   FDoOverrideFS:=True;
   FFontDPI:=Round(FFontDPI*ratio);
   FFontSize:=Round(FFontSize*fontSizeRatio);
   if FFOntSize=0 then FFontSize:=1;
   FDNodesFontSize:=Round(FDNodesFontSize*fontSizeRatio);
   if FDNodesFontSize=0 then FDNodesFontSize:=1;
   FDProjectionFontSize:=Round(FDProjectionFontSize*fontSizeRatio);
   if FDProjectionFontSize=0 then FDProjectionFontSize:=1;
   FLabelFontSize:=Round(FLabelFontSize*LabelfontSizeRatio);
   if FLabelFontSize=0 then FLabelFontSize:=1;
   if FLabelFontSize>FRealMaxFontSize then FLabelFontSize:=FRealMaxFontSize;
   if FFontSize>FRealMaxFontSize then FFontSize:=FRealMaxFontSize;
{   FMinLineStep:=(FNodeWidth div 4) div StartMaxLines;}
   FMinLineStep:=FNodeHeight div 8;
   FNodeLineWidth:=Round(FNodeLineWidth*ratio);
   if FNodeLineWidth=0 then FNodeLineWidth:=1;
   FNodeDefWidth:=Round(FNodeDefWidth*ratiox);
   FNodeDefHeight:=Round(FNodeDefHeight*ratioy);
   FNodeHSpacing:=Round(FNodeHSpacing*ratiox);
   FNodeVSpacing:=Round(FNodeVSpacing*ratioy);
   FGlobalLeftSize:=Round(FGlobalLeftSize*ratiox);
   FGlobalRightSize:=Round(FGlobalRightSize*ratiox);
   FGlobalTopSize:=Round(FGlobalTopSize*ratioy);
   FGlobalBottomSize:=Round(FGlobalBottomSize*ratioy);
   FMinArcRadius:=Round(FMinArcRadius*ratio);
   FMinLabelX:=Round(FMinLabelX*ratiox);
   FMinLabelY:=Round(FMinLabelY*ratioy);
   FMinLabelY1:=Round(FMinLabelY1*fontSizeRatio);
   FMinLabelY1:=GetMinLabelY1(FMinLabelY1);
   FMinGlobalLabel:=Round(FMinGlobalLabel*ratio);
   FNodeShadowDepth:=Round(FNodeShadowDepth*ratio);
   if FNodeShadowDepth=0 then FNodeShadowDepth:=1;
   FMinLineEndPoint:=Round(FMinLineEndPoint*ratio);
  end;



 procedure  TBPDFDGraph.CalcDNodesMaxWidthHeight; { Checked }
 Var nodeP:PDDFDGraphNode;
     i:Integer;
  begin
  if FDNodesCount=0 then Exit;
   FDMaxWidth:=0;
   FDMaxHeight:=0;
   FDPrjMaxHeight:=0;
   nodeP:=FDGraphNodes;
    for i:=0 to (FDNodesCount-1) do
     begin
       nodeP^.BPDNode.AutoHeight:=True;
       nodeP^.BPDNode.AutoWidth:=True;
       nodeP^.BPDNode.Repaint;
       if nodeP^.BPDNode.MaxWidth>FDMaxWidth then
               FDMaxWidth:=nodeP^.BPDNode.MaxWidth;
       if nodeP^.BPDNode.MaxHeight>FDMaxHeight then
               FDMaxHeight:=nodeP^.BPDNode.MaxHeight;
       if nodeP^.BPDNode.PrjMaxHeight>FDPrjMaxHeight then
               FDPrjMaxHeight:=nodeP^.BPDNode.PrjMaxHeight;
       nodeP^.BPDNode.AutoHeight:=False;
       nodeP^.BPDNode.AutoWidth:=False;
       nodeP^.BPDNode.Repaint;
       nodeP:=nodeP^.next;
     end;
  end;

 procedure  TBPDFDGraph.CalcMaxWidthHeight;  { Checked }
 Var nodeP:PDFDGraphNode;
     i:Integer;
  begin
   if (FGraphNodes=nil) then Exit;
   FMaxWidth:=0;
   FMaxHeight:=0;
   nodeP:=FGraphNodes;
   nodeP^.BPNode.AutoHeight:=True;
   nodeP^.BPNode.AutoWidth:=True;
   nodeP^.BPNode.Repaint;
   if nodeP^.BPNode.MaxWidth>FMaxWidth then
               FMaxWidth:=nodeP^.BPNode.MaxWidth;
   if nodeP^.BPNode.MaxHeight>FMaxHeight then
               FMaxHeight:=nodeP^.BPNode.MaxHeight;
   nodeP^.BPNode.AutoHeight:=False;
   nodeP^.BPNode.AutoWidth:=False;
   nodeP^.BPNode.Repaint;
   nodeP:=nodeP^.next;
  end;

procedure   TBPDFDGraph.PresetupFrame(widthcoof,heightcoof:Double); { Checked }
  begin
   FCalcWidthHeight:=True;
   FMaxWidth:=0;
   FMaxHeight:=0;
   FDMaxWidth:=0;
   FDMaxHeight:=0;
   FDPrjMaxHeight:=0;
   CalcMaxWidthHeight;
   CalcDNodesMaxWidthHeight;
   FCalcWidthHeight:=False;
  { FDiscardDrags:=True;}
   FRatioWC:=widthcoof;
   FRatioHC:=heightcoof;
  end;

function  TBPDFDGraph.GetLevelFromNodeNumber(NodeNum:ShortString):ShortString;
Var lev:Integer;
 begin
   Result:=Trim(NodeNum);
   Result:=copy(FSSNodeNumber,2,length(FSSNodeNumber)-1);
   lev:=StrToIntDef(Result,-2);
   if (lev<>-2) then
      begin
       if Result='-0' then Exit;
       if lev=0 then Result:='-1' else Result:='0';
       Exit;
      end;
   while (length(Result)>0) and (Result[length(Result)]>='0')
          and (Result[length(Result)]<='9') do
      Result:=copy(Result,1,length(Result)-1);
   if (length(Result)>0) and (Result[length(Result)]='.') then
      Result:=copy(Result,1,length(Result)-1);
{   Result:=copy(Result,1,length(Result)-1);}
 end;


 procedure TBPDFDGraph.SetMaxFontSize(Value:Integer);
 Var oldPosX,oldPosY:Integer;
 begin
   FMaxFontSize:=Value;
   FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenNode(FSSNodeNumber);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;


procedure TBPDFDGraph.OpenNode(NodeNum:ShortString);
 Var tmpTree:PBPTree;
     Flag:Boolean;
     lev:ShortString;
 begin
   if (FTree=nil) then Exit;
   FSSNodeNumber:=Trim(NodeNum);
   lev:=GetLevelFromNodeNumber(FSSNodeNumber);
   tmpTree:=FTree;
   Flag:=True;
     while (tmpTree<>nil) and (flag) do
      begin
       if (tmpTree^.ssLevel=Lev) then
         begin
          FNodesCount:=tmpTree^.dwNodesCount;
          FLinksCount:=tmpTree^.dwLinksCount;
          FDNodesCount:=0;
          FDLinksCount:=0;
          FNodes:=tmpTree^.lpNodes;
          FLinks:=tmpTree^.lpLinks;
          FLevel:=tmpTree^.dwLevel;
          FSSLevel:=tmpTree^.ssLevel;
          FParentLevel:=tmpTree^.dwParent;
          FLevelNotes:=tmpTree^.ssNotes;
          FLevelRevision:=tmpTree^.dwRevision;
          FLevelDraftStatus:=tmpTree^.dwStatus;
          FNodesFontSize:=tmpTree^.dwNodesFontSize;
          FDNodesFontSize:=tmpTree^.dwDNodesFontSize;
          FDProjectionFontSize:=tmpTree^.dwDProjectionFontSize;
          FInProcessFontSize:=tmpTree^.dwInProcessFontSize;
          FLabelsFontSize:=tmpTree^.dwLabelsFontSize;
          FOverrideNodesFS:=tmpTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=tmpTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=tmpTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=tmpTree^.dbOverrideLabelsFS;
          Flag:=False;
         end;
       tmpTree:=tmpTree^.next;
      end;

    if (Flag) then
     begin
          FNodesCount:=0;
          FLinksCount:=0;
          FDNodesCount:=0;
          FDLinksCount:=0;
          FNodes:=FTree^.lpNodes;
          FLinks:=FTree^.lpLinks;
          FLevel:=FTree^.dwLevel;
          FSSLevel:=FTree^.ssLevel;
          FParentLevel:=FTree^.dwParent;
          FNodesFontSize:=FTree^.dwNodesFontSize;
          FDNodesFontSize:=FTree^.dwDNodesFontSize;
          FDProjectionFontSize:=FTree^.dwDProjectionFontSize;
          FInProcessFontSize:=FTree^.dwInProcessFontSize;
          FLabelsFontSize:=FTree^.dwLabelsFontSize;
          FOverrideNodesFS:=FTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=FTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=FTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=FTree^.dbOverrideLabelsFS;
          Flag:=False;
     end;
    SetDefaultConstants;
    CreateGraphNodes(1,1);
    CreateGraphLinks(1,1);
    CreateDGraphNodes(1,1);
    Scaled:=Scaled;
    if (not(FScaled)) then PresetupFrame(1,1);
    if (BPViewMainForm.BPNavigator.Height>1) and
       (BPViewMainForm.PageControl1.ActivePage=BPViewMainForm.TabSheet2) then
      begin
       AnalizeStringsFonts;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
 end;

procedure TBPDFDGraph.ClearModel;
 begin
   FTree:=nil;
   FNTTree:=nil;
   FLTTree:=nil;
   FOPTree:=nil;
   FHeader.dwNodesTypesCount:=0;
   FHeader.dwLinksTypesCount:=0;
   FHeader.dwOpEntries:=0;
 end;


procedure TBPDFDGraph.AssignModel(Tree:PBPTree;NTTree:PBPNodeTypes;LTTree:PBPLinkTypes;
                                OPTree:PBPOpTree;Header:TBPHeader);
 begin
   FTree:=Tree;
   FNTTree:=NTTree;
   FLTTree:=LTTree;
   FOPTree:=OPTree;
   FHeader:=Header;
   ClearGraphNodes;
   ClearDGraphNodes;
   ClearGraphLinks;
   CreateActiveNodesList;
   if (FActiveNodesList.Count>0) then
    begin
     OpenNode(FActiveNodesList.Names[0]);
     TraceRoute;
     FOwner.Invalidate;
    end;
 end;


procedure  TBPDFDGraph.TraceNodes; { Checked }
 Var i:DWORD;
     gnode:TBPGraphNode;
     gdnode:PDDFDGraphNode;
     w1,h1:Integer;
     w2,h2,h3:Integer;
     nc:Integer;
     tc,bc:Integer;
     yt,yb:Integer;
     hnt,hnb:Integer;
     mnc:Integer;
  begin
    FMaxNodesCount:=0;
    if (FNodesCount=0) then Exit;
    { We get max node width & height for drawing text, but }
    if (FDTopNodesCount>FDBottomNodesCount) then
        nc:=FDTopNodesCount
    else
        nc:=FDBottomNodesCount;
    if (FDTopNodesCount>0) then
      begin
        hnt:=(FDTopNodesCount div 2)+1;
      end
    else
      hnt:=0;
    if (FDBottomNodesCOunt>0) then
      begin
        hnb:=(FDBottomNodesCount div 2)+1;
      end
    else
      hnb:=0;
   { MaxNodesCount Calc }
    if (nc>3) then FMaxNodesCount:=nc
    else
     begin
       mnc:=1;
       if (FDTopNodesCount>0) then inc(mnc);
       if (FDBottomNodesCount>0) then inc(mnc);
       if (mnc>nc) then FMaxNodesCount:=mnc else FMaxNodesCount:=nc;
     end;
   { dec(nc);}
    w1:=Round(FMaxWidth*1.1);
    h1:=Round(FMaxHeight*1.1);
    w2:=Round(FDMaxWidth*1.1);
    h2:=Round(FDMaxHeight*1.1);
    h3:=Round(FDPrjMaxHeight*1.1);
    if w1>h1 then h1:=Round(w1/NodeRatio) else
     w1:=Round(h1*NodeRatio);
    { Printing ! }
     if FPrinting then
     begin
      if (nc>0) then
       w2:=Round((FDefWidth - FGlobalLeftSize-FGlobalRightSize)/(nc)/1.5);
       if w1>w2 then w1:=w2;
      { h1:=(FDefHeight-4*(h2+h3)-FGlobalTopSize-FGlobalBottomSize) div 3;}
     end
      else
     begin
      if (nc>0) then
       begin
        FDefWidth:=Round(1.5*nc*w2)+FGlobalLeftSize+FGlobalRightSize;
        FDefHeight:=FGlobalTopSize+FGlobalBottomSize+3*h1;
        if (FDTopNodesCount>0) then
         FDefHeight:=FDefHeight+Round(1.5*(h2+h3));
        if (FDBottomNodesCount>0) then
         FDefHeight:=FDefHeight+Round(1.5*(h2+h3));
       end
      else
       begin
        FDefWidth:=FOwner.ClientWidth;
        FDefHeight:=FOwner.ClientHeight;
       end;
     end;
      FAcceptDragRect.Left:=FGlobalLeftSize;
      FAcceptDragRect.Top:=FGlobalTopSize;
      FAcceptDragRect.Bottom:=FDefHeight-FGlobalBottomSize;
      FAcceptDragRect.Right:=FDefWidth-FGlobalRightSize;
      if Parent.HorzScrollBar.Range<>FDefWidth then
       Parent.HorzScrollBar.Range:=FDefWidth;
      if Parent.VertScrollBar.Range<>FDefHeight then
       Parent.VertScrollBar.Range:=FDefHeight;
    FNodeWidth:=w1;
    FNodeHeight:=h1;
    if (FGraphNodes<>nil) then
      begin
        FGraphNodes^.BPNode.DefWidth:=w1;
        FGraphNodes^.BPNode.DefHeight:=h1;
        FGraphNodes^.BPnode.TopLinksCount:=0;
        FGraphNodes^.BPnode.BottomLinksCount:=0;
        FGraphNodes^.BPnode.LeftLinksCount:=0;
        FGraphNodes^.BPnode.RightLinksCount:=0;
        FGraphNodes^.BPnode.FromUpLinksCount:=0;
        FGraphNodes^.BPnode.FromDownLinksCount:=0;
        FGraphNodes^.BPnode.ToUpLinksCount:=0;
        FGraphNodes^.BPnode.ToDownLinksCount:=0;
        if ((FDiscardDrags) or (not(FGraphNodes^.BPnode.AcceptPosition))) then
        begin
        if (FDTopNodesCount=0) then
         if (FDBottomNodesCount=0) then
         begin
          { Top & Bottom = 0 }
          FGraphNodes^.BPnode.Top:=FOwner.ClientRect.Top+((FDefHeight-FGraphNodes^.BPnode.Height) div 2)-Parent.VertScrollBar.Position;
         end
        else
         begin
          { Top=0 }
          FGraphNodes^.BPnode.Top:=FOwner.ClientRect.Top+FGlobalTopSize{+FGraphNodes^.BPnode.Height}-Parent.VertScrollBar.Position;
         end
        else
         if (FDBottomNodesCount=0) then
         begin
          { Bottom=0}
          FGraphNodes^.BPnode.Top:=FOwner.ClientRect.Top+FDefHeight-FGlobalBottomSize-FGraphNodes^.BPnode.Height-Parent.VertScrollBar.Position;
         end
        else
         begin
          { Top & Bottom <>0 }
          FGraphNodes^.BPnode.Top:=FOwner.ClientRect.Top+((FDefHeight-FGraphNodes^.BPnode.Height) div 2)-Parent.VertScrollBar.Position;
         end;
        FGraphNodes^.BPnode.Left:=FOwner.ClientRect.Left+((FDefWidth-FGraphNodes^.BPnode.Width) div 2)-Parent.HorzScrollBar.Position;
        FGraphNodes^.BPNode.AcceptPosition:=False;
        end;
      end;
   if (FGraphNodes<>nil) then
    begin
     FMinYTop:=FGraphNodes^.BPNode.Top;
     FMinYBottom:=FGraphNodes^.BPNode.Top+FGraphNodes^.BPNode.Height;
    end;
   gdnode:=FDGraphNodes;
   tc:=0;
   bc:=0;
   for i:=0 to (FDNodesCount-1) do
    begin
      gdnode^.BPDNode.DefWidth:=w2;
      gdnode^.BPDNode.DefHeight:=h2;
      gdnode^.BPDNode.DefPrjHeight:=h3;
      gdnode^.BPDNode.TopLinksCount:=0;
      gdnode^.BPDNode.BottomLinksCount:=0;
      if gdnode^.TopBottom then
       begin
        if ((FDiscardDrags) or (not(gdnode^.BPDNode.AcceptPosition))) then
        begin
        if (FDTopNodesCount<nc) then
         begin
          if (FDTopNodesCount=1) then
           gdnode^.BPDNode.Left:=FOwner.ClientRect.Left+FGlobalLeftSize
                  +Round((1.5*w2*nc-gdnode^.BPDNode.Width)/2)-Parent.HorzScrollBar.Position
          else
           gdnode^.BPDNode.Left:=FOwner.ClientRect.Left+FGlobalLeftSize
                  +Round(1.5*tc*w2+(1.5*(nc-FDTopNodesCount+1)*w2)/FDTopNodesCount/2*(tc+1))-Parent.HorzScrollBar.Position;
         end
        else
        gdnode^.BPDNode.Left:=FOwner.ClientRect.Left+FGlobalLeftSize
                  +Round(1.5*tc*w2+(1.5*w2-gdnode^.BPDNode.Width)/2)-Parent.HorzScrollBar.Position;
        gdnode^.BPDNode.Top:=FOwner.ClientRect.Top+FGlobalTopSize
                {+((h2+h3) div 4)}-Parent.VertScrollBar.Position;
        gdnode^.BPDNode.AcceptPosition:=False;
        end;
        yt:=gdNode^.BPDNode.Top+gdNode^.BPDNode.Height;
        inc(tc);
        if (tc<=hnt) then
          gdNode^.BPDNode.LinkCount:=tc
        else
          gdNode^.BPDNode.LinkCount:=FDTopNodesCount-tc+1;
       end
      else
       begin
        if ((FDiscardDrags) or (not(gdnode^.BPDNode.AcceptPosition))) then
        begin
        if (FDBottomNodesCount<nc) then
         begin
        if (FDBottomNodesCount=1) then
           gdnode^.BPDNode.Left:=FOwner.ClientRect.Left+FGlobalLeftSize
                   +Round((1.5*w2*nc-gdnode^.BPDNode.Width)/2)-Parent.HorzScrollBar.Position
          else
           gdnode^.BPDNode.Left:=FOwner.ClientRect.Left+FGlobalLeftSize
                   +Round(1.5*bc*w2+(1.5*(nc-FDBottomNodesCount+1)*w2)/FDBottomNodesCount/2*(bc+1))-Parent.HorzScrollBar.Position;
         end
        else
        gdnode^.BPDNode.Left:=FOwner.ClientRect.Left+FGlobalLeftSize
                   +Round(1.5*bc*w2+(1.5*w2-gdnode^.BPDNode.Width)/2)-Parent.HorzScrollBar.Position;
        gdnode^.BPDNode.Top:=FOwner.ClientRect.Top+FDefHeight-FGlobalBottomSize
         {-((h2+h3) div 4)-(h2+h3)}-gdnode^.BPDNode.Height
         -Parent.VertScrollBar.Position;
        gdnode^.BPDNode.AcceptPosition:=False;
        end;
        yb:=gdNode^.BPDNode.Top;
        inc(bc);
        if (bc<=hnb) then
          gdNode^.BPDNode.LinkCount:=bc
        else
          gdNode^.BPDNode.LinkCount:=FDBottomNodesCount-bc+1;
       end;

      gdnode:=gdnode^.next;
    end;
    if tc>0 then FMinYTop:=Round((FMinYTop-yt)/(tc+3)) else FMinYTop:=0;
    if bc>0 then FMinYBottom:=Round((yb-FMinYBottom)/(bc+3)) else FMinYBottom:=0;
  end;

procedure TBPDFDGraph.TraceRoute;
 begin
   if (FCalcWidthHeight) then Exit;
   TraceNodes; { 1 }
   TraceLinksToNodeCounters; { 2 }
   TraceLocalStartEndPoints; { 3 }
   CalcLabelSizes; { 4 }
   TraceLinks; { 5 }
   DrawLinks; { 6 }
   FOwner.ReadWrite(FGlobalLeftSize,DefWidth-FGlobalRightSize,FGlobalTopSize,DefHeight-FGlobalBottomSize);
   FDiscardDrags:=False;
 end;

procedure TBPDFDGraph.TraceLinks;
 Var linkP:PDFDGraphLink;
     nodeP:PDDFDGraphNode;
         i:Integer;
       mmm:Integer;
begin
 if (FDLinksCount=0) then Exit;
 if (FGraphNodes=nil) then Exit;
 if (FDNodesCount=0) then Exit;
 linkP:=FGraphLinks;
 for i:=0 to (FDLinksCount-1) do
   begin
     if ((linkP^.FromNodeNumber and BPGlobalNodeOperation)<>0) then
      begin
       if ((abs(LinkP^.EndPoint.x-LinkP^.StartPoint.x))<FMinLabelY1) then
          begin { Direct Link }
           linkP^.EndPoint.x:=LinkP^.StartPoint.x;   { Cheked }
           linkP^.EndPoint.y:=LinkP^.EndPoint.y;
           linkP^.LineArrayX[0]:=linkP^.StartPoint.x;
           linkP^.LineArrayY[0]:=linkP^.StartPoint.y;
           linkP^.LineArrayX[1]:=LinkP^.StartPoint.x;
           linkP^.LineArrayY[1]:=LinkP^.EndPoint.y;
           linkP^.LinePointCount:=2;
          end   { End Direct Link }
       else
       begin { Normal Link }
        nodeP:=GetDGraphNumberedNode(linkP^.FromNodeNumber and BPNotGlobalMask,True);
        linkP^.LineArrayX[0]:=linkP^.StartPoint.x;
        linkP^.LineArrayY[0]:=linkP^.StartPoint.y;
        linkP^.LineArrayX[1]:=linkP^.StartPoint.x;
        linkP^.LineArrayY[1]:=linkP^.EndPoint.y-FMinYTop*(nodeP^.BPDNode.LinkCount+1);
        linkP^.LineArrayX[2]:=linkP^.EndPoint.x;
        linkP^.LineArrayY[2]:=linkP^.EndPoint.y-FMinYTop*(nodeP^.BPDNode.LinkCount+1);
        linkP^.LineArrayX[3]:=linkP^.EndPoint.x;
        linkP^.LineArrayY[3]:=linkP^.EndPoint.y;
        linkP^.LinePointCount:=4;
       end; { Normal Link }
      end
      else
      begin
       if ((abs(LinkP^.EndPoint.x-LinkP^.StartPoint.x))<FMinLabelY1) then
          begin { Direct Link }
           linkP^.EndPoint.x:=LinkP^.StartPoint.x;   { Cheked }
           linkP^.EndPoint.y:=LinkP^.EndPoint.y;
           linkP^.LineArrayX[0]:=linkP^.StartPoint.x;
           linkP^.LineArrayY[0]:=linkP^.StartPoint.y;
           linkP^.LineArrayX[1]:=LinkP^.StartPoint.x;
           linkP^.LineArrayY[1]:=LinkP^.EndPoint.y;
           linkP^.LinePointCount:=2;
          end   { End Direct Link }
       else
       begin { Normal Link }
        nodeP:=GetDGraphNumberedNode(linkP^.ToNodeNumber and BPNotGlobalMask,False);
        linkP^.LineArrayX[0]:=linkP^.StartPoint.x;
        linkP^.LineArrayY[0]:=linkP^.StartPoint.y;
        linkP^.LineArrayX[1]:=linkP^.StartPoint.x;
        linkP^.LineArrayY[1]:=linkP^.StartPoint.y+FMinYBottom*(nodeP^.BPDNode.LinkCount+1);
        linkP^.LineArrayX[2]:=linkP^.EndPoint.x;
        linkP^.LineArrayY[2]:=linkP^.StartPoint.y+FMinYBottom*(nodeP^.BPDNode.LinkCount+1);
        linkP^.LineArrayX[3]:=linkP^.EndPoint.x;
        linkP^.LineArrayY[3]:=linkP^.EndPoint.y;
        linkP^.LinePointCount:=4;
       end; { Normal Link }
      end;
      linkP:=linkP^.next;
   end;
end;

procedure  TBPDFDGraph.TraceLocalStartEndPoints; { Checked }
 Var linkP:PDFDGraphLink;
       ws,hs,we,he:Integer;
       ic:Integer;
       i:Integer;
     tmpNode:PDDFDGraphNode;
  begin
   { SetUp Start & End points of Links }
   if (FDLinksCount=0) then Exit;
   if (FGraphNodes=nil) then Exit;
   if (FDNodesCount=0) then Exit;
   linkP:=FGraphLinks;
   for i:=0 to (FDLinksCount-1) do
    begin

      if ((linkP^.FromNodeNumber and BPGlobalNodeOperation)<>0) then
       begin
         tmpNode:=GetDGraphNumberedNode(linkP^.FromNodeNumber and BPNotGlobalMask,True);
         ws:=tmpNode^.BPDNode.Left+(tmpNode^.BPDNode.Width div 2);
         hs:=tmpNode^.BPDNode.Top+tmpNode^.BPDNode.Height;
         ic:=FGraphNodes^.BPNode.TopLinksCount+1;
         we:=FGraphNodes^.BPNode.Left+
             (FGraphNodes^.BPNode.Width div ic)*
             linkP^.ToLinkNumber;
         he:=FGraphNodes^.BPNode.Top;
       end;
       if ((linkP^.ToNodeNumber and BPGlobalNodeOperation)<>0) then
       begin
         tmpNode:=GetDGraphNumberedNode(linkP^.ToNodeNumber and BPNotGlobalMask,False);         we:=tmpNode^.BPDNode.Left+(tmpNode^.BPDNode.Width div 2);
         he:=tmpNode^.BPDNode.Top;
         ic:=FGraphNodes^.BPNode.BottomLinksCount+1;
         ws:=FGraphNodes^.BPNode.Left+
             (FGraphNodes^.BPNode.Width div ic)*
             linkP^.FromLinkNumber;
         hs:=FGraphNodes^.BPNode.Top+FGraphNodes^.BPNode.Height;
       end;
       linkP^.StartPoint.x:=ws;
       linkP^.StartPoint.y:=hs;
       linkP^.EndPoint.x:=we;
       linkP^.EndPoint.y:=he;
      linkP:=linkP^.next;
    end; { for i }
  end;

 procedure  TBPDFDGraph.DrawLinks; { Checked }
  Var linkP:PDFDGraphLink;
         i,j:Integer;
         fx,fy,lx,ly:Integer;
         dx,dy,dx1,dy1,tx,ty:Integer;
         oldColor,cl:TColor;
         k:Integer;
         mls:Integer;
         lineWidth:Integer;
         s:Integer;
         ops,ps:TPenStyle;
         nodep:PDDFDGraphNode;
         NewMinArcRadius:Integer;
         NDelta,nd1,nd2:Integer;
         ox,oy,nx,ny:Integer;
  begin
   if (FDLinksCount=0) then Exit;
   oldColor:=FOwner.Canvas.Pen.Color;
   ops:=FOwner.Canvas.Pen.Style;
    mls:=MinLineStep div 2;
    linkP:=FGraphLinks;
    for i:=0 to (FDLinksCount-1) do
     begin
       cl:=LinkP^.Color;
       FOwner.Canvas.Pen.Color:=cl;
       ps:=LinkP^.PenStyle;
       FOwner.Canvas.Pen.Style:=ps;
       DrawArrowY(linkP^.EndPoint.x,linkP^.EndPoint.y,False);
       FOwner.Canvas.Pen.Color:=cl;
       FOwner.Canvas.Pen.Style:=ps;
       if ((linkP^.FromNodeNumber and BPGlobalNodeOperation)<>0) then
         nodeP:=GetDGraphNumberedNode(linkP^.FromNodeNumber and BPNotGlobalMask,True)
       else
         nodeP:=GetDGraphNumberedNode(linkP^.ToNodeNumber and BPNotGlobalMask,False);

                  if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                      (linkP^.BPFromLabel<>nil) then
                   begin
                    if nodeP^.TopBottom then
                    begin
                      if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                       linkP^.BPFromLabel.Top:=linkP^.StartPoint.y+MinLabelY1*(nodep^.BPDNode.LinkCount-1)+MinLabelY;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.StartPoint.x+1,linkP^.StartPoint.y+MinLabelY+MinLabelY1*(nodep^.BPDNode.LinkCount-1)+(linkP^.BPFromLabel.Height div 2),
                          linkP^.StartPoint.x+MinLabelX-1,linkP^.StartPoint.y+MinLabelY+MinLabelY1*(nodep^.BPDNode.LinkCount-1)+(linkP^.BPFromLabel.Height div 2),cl);
                      end
                     else
                      DrawSS(linkP^.StartPoint.x+1,
                             linkP^.StartPoint.y+MinLabelY+MinLabelY1*(nodeP^.BPDNode.LinkCount-1)+(linkP^.BPFromLabel.Height div 2),
                          linkP^.BPFromLabel.Left-1,
                          linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                          cl);
                    end
                    else
                    begin
                      if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.EndPoint.x+MinLabelX;
                       linkP^.BPFromLabel.Top:=linkP^.EndPoint.y-MinLabelY-MinLabelY1*(nodeP^.BPDNode.LinkCount-1)-linkP^.BPFromLabel.Height;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.EndPoint.x+1,linkP^.EndPoint.y-MinLabelY-MinLabelY1*(nodeP^.BPDNode.LinkCount-1)-(linkP^.BPFromLabel.Height div 2),
                          linkP^.EndPoint.x+MinLabelX-1,linkP^.EndPoint.y-MinLabelY-MinLabelY1*(nodeP^.BPDNode.LinkCount-1)-(linkP^.BPFromLabel.Height div 2),cl);
                      end
                     else
                       DrawSS(linkP^.EndPoint.x+1,
                          linkP^.EndPoint.y-MinLabelY-MinLabelY1*(nodeP^.BPDNode.LinkCount-1)-(linkP^.BPFromLabel.Height div 2),
                          linkP^.BPFromLabel.Left-1,
                          linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),cl);
                    end;
                   end;




         if ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
            (linkP^.BPToLabel<>nil) then
                begin
                   if nodeP^.TopBottom then
                    begin
                      {?}
                      if FDiscardDrags or (not(linkP^.BPToLabel.AcceptPosition)) then
                      begin
                       linkP^.BPToLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                       linkP^.BPToLabel.Top:=linkP^.StartPoint.y+MinLabelY1*(nodep^.BPDNode.LinkCount-1)+MinLabelY;
                       linkP^.BPToLabel.AcceptPosition:=False;
                       DrawSS(linkP^.StartPoint.x+1,linkP^.StartPoint.y+MinLabelY+MinLabelY1*(nodep^.BPDNode.LinkCount-1)+(linkP^.BPToLabel.Height div 2),
                          linkP^.StartPoint.x+MinLabelX-1,linkP^.StartPoint.y+MinLabelY+MinLabelY1*(nodep^.BPDNode.LinkCount-1)+(linkP^.BPToLabel.Height div 2),cl);
                      end
                     else
                      DrawSS(linkP^.StartPoint.x+1,
                             linkP^.StartPoint.y+MinLabelY+MinLabelY1*(nodep^.BPDNode.LinkCount-1)+(linkP^.BPToLabel.Height div 2),
                          linkP^.BPToLabel.Left-1,
                          linkP^.BPToLabel.Top+(linkP^.BPToLabel.Height div 2),
                          cl);
                    end
                   else
                    begin
                      {?}
                      if FDiscardDrags or (not(linkP^.BPToLabel.AcceptPosition)) then
                      begin
                       linkP^.BPToLabel.Left:=linkP^.EndPoint.x+MinLabelX;
                       linkP^.BPToLabel.Top:=linkP^.EndPoint.y-MinLabelY-MinLabelY1*(nodep^.BPDNode.LinkCount-1)-linkP^.BPToLabel.Height;
                       linkP^.BPToLabel.AcceptPosition:=False;
                       DrawSS(linkP^.EndPoint.x+1,linkP^.EndPoint.y-MinLabelY-MinLabelY1*(nodep^.BPDNode.LinkCount-1)-(linkP^.BPToLabel.Height div 2),
                          linkP^.EndPoint.x+MinLabelX-1,linkP^.EndPoint.y-MinLabelY-MinLabelY1*(nodep^.BPDNode.LinkCount-1)-(linkP^.BPToLabel.Height div 2),cl);
                      end
                     else
                       DrawSS(linkP^.EndPoint.x+1,
                           linkP^.EndPoint.y-MinLabelY-MinLabelY1*(nodep^.BPDNode.LinkCount-1)-(linkP^.BPToLabel.Height div 2),
                          linkP^.BPToLabel.Left-1,
                          linkP^.BPToLabel.Top+(linkP^.BPToLabel.Height div 2),cl);
                    end;
                end;
        FOwner.Canvas.Pen.Color:=cl;
        FOwner.Canvas.Pen.Style:=ps;
        for j:=0 to (linkP^.LinePointCount-1) do
         begin
          tx:=linkP^.LineArrayX[j];
          ty:=linkP^.LineArrayY[j];
          NewMinArcRadius:=MinArcRadius;
          if j=0 then FOwner.Canvas.MoveTo(tx,ty);
          if (j=(linkP^.LinePointCount-1)) then FOwner.Canvas.LineTo(tx,ty);
          if (j<>0) and (j<>(linkP^.LinePointCount-1)) then
           begin
            ox:=linkP^.LineArrayX[j-1];
            oy:=linkP^.LineArrayY[j-1];
            nx:=linkP^.LineArrayX[j+1];
            ny:=linkP^.LineArrayY[j+1];
            if nx=tx then
              nd1:=ABS(ny-ty)
            else
              nd1:=ABS(nx-tx);
            if ox=tx then
              nd2:=ABS(ty-oy)
            else
              nd2:=ABS(tx-ox);
            if nd1<nd2 then nDelta:=nd1 else nDelta:=nd2;
            if (NewMinArcRadius>(nDelta div 2)) then NewMinArcRadius:=nDelta div 2;
            dx:=SignedVector(linkP^.LineArrayX[j+1]-tx,NewMinArcRadius);
            dy:=SignedVector(linkP^.LineArrayY[j+1]-ty,NewMinArcRadius);
            dx1:=SignedVector(linkP^.LineArrayX[j-1]-tx,NewMinArcRadius);
            dy1:=SignedVector(linkP^.LineArrayY[j-1]-ty,NewMinArcRadius);
            if (dx*dy1-dx1*dy)>0 then
             begin
            fx:=tx+dx;
            fy:=ty+dy;
            lx:=tx+dx1;
            ly:=ty+dy1;
             end
            else
             begin
            fx:=tx+dx1;
            fy:=ty+dy1;
            lx:=tx+dx;
            ly:=ty+dy;
             end;
            FOwner.Canvas.Arc(tx+2*dx,ty+2*dy,tx+2*dx1,ty+2*dy1,fx,fy,lx,ly);
             if (dx*dy1-dx1*dy)<0 then
              begin
                 FOwner.Canvas.LineTo(fx,fy);
                 FOwner.Canvas.MoveTo(lx,ly);
              end
              else
              begin
                 FOwner.Canvas.LineTo(lx,ly);
                 FOwner.Canvas.MoveTo(fx,fy);
              end;
           end;
         end;
      linkP:=linkP^.next;
    end; { For }
    FOwner.Canvas.Pen.Color:=oldColor;
    FOwner.Canvas.Pen.Style:=ops;
  end;


 procedure  TBPDFDGraph.CalcLabelSizes; { Checked }
  Var i,j:Integer;
      maxlch:Integer;
      FSize:Integer;
      linkP:PDFDGraphLink;
  begin
   if (FTree=nil) then Exit;
   if (FDLinksCount=0) then Exit;
   if (FGraphNodes=nil) then Exit;
   maxlch:=0;
   if (maxlch<FGraphNodes^.BPNode.TopLinksCount) then maxlch:=FGraphNodes^.BPNode.TopLinksCount;
   if (maxlch<FGraphNodes^.BPNode.BottomLinksCount) then maxlch:=FGraphNodes^.BPNode.BottomLinksCount;
    if (maxlch<8) then
     begin
      FMaxCH:=1.0;
      FSize:=FLabelFontSize;
     end
    else
     begin
      FMaxCH:=8/maxlch;
      FSize:=Round(FLabelFontSize*8/maxlch)+1;
     end;
    if FPrinting then Exit;
    if FScaled then Exit;
    linkP:=FGraphLinks;
    for j:=0 to (FDLinksCount-1) do
        begin
          if linkP<>nil then
            begin
              if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) then
               begin
                 linkP^.BPFromLabel.Font.Size:=FSize;
               end;
              if ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) then
               begin
                 linkP^.BPToLabel.Font.Size:=FSize;
               end;
            end;
          linkP:=linkP^.next;
        end;

  end;

procedure TBPDFDGraph.SetDiscardDrags(Value:Boolean);
var i:Integer;
    nodePtr:PBPNode;
    linkPtr:PBPLink;
 begin
   FDiscardDrags:=True;
   FOwner.Repaint;
   if FNodesCount=0 then Exit;
   nodePtr:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       nodePtr^.AcceptPosition[1]:=False;
       FModified:=True;
       inc(nodePtr);
     end;
   if FLinksCount=0 then Exit;
   linkPtr:=FLinks;
   for i:=0 to (FLinksCount-1) do
     begin
       LinkPtr^.FromAcceptPosition[1]:=False;
       linkPtr^.ToAcceptPosition[1]:=False;
       linkPtr^.DNodeAcceptPosition:=False;
       FModified:=True;
       inc(linkPtr);
     end;
 end;

procedure TBPDFDGraph.SetScaled2(Value:Boolean);
  begin
   {}
    FScaled2:=Value;
  end;

procedure TBPDFDGraph.SetScaled2Ratio(Value:Extended);
 Var posx,posy:Double;
  begin
   {}
{!} posx:=FScaled2Ratio;
{!} posy:=FScaled2Ratio;
{!} if (FOwner.HorzScrollBar.Range>0) and
       (FOwner.HorzScrollBar.Visible) then
     posx:=Value/(posx+0.01)*FOwner.HorzScrollBar.Position
    else
     posx:=0;
{!} if (FOwner.VertScrollBar.Range>0) and
       (FOwner.VertScrollBar.Visible) then
     posy:=Value/(posy+0.01)*FOwner.VertScrollBar.Position
    else
     posy:=0;
    FScaled2Ratio:=Value;
    FOwner.Visible:=False;
    Scaled:=Scaled;
    FOwner.Invalidate;
{!} if (FOwner.HorzScrollBar.Range>0) then
        FOwner.HorzScrollBar.Position:=Round(posx);
{!} if (FOwner.VertScrollBar.Range>0) then
        FOwner.VertScrollBar.Position:=Round(posy);
    FOwner.Visible:=True;
  end;

procedure TBPDFDGraph.UpdateMaxFontSize(Coof:Extended);
Var hca3:Extended;
    aSize:Integer;
    tmpi:TQRPaperSize;
 begin
  { Update & calc real max font size }
  hca3:=1.0;
  if MainUnit.HasPrnDevice then
   begin
    aSize:=Printer.PaperSize;
    for tmpi:= Default to Custom do
      begin
       if aSize=cQRPaperTranslate[tmpI] then
        begin
         hca3:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A3,0];
        end;
      end;
   end;
  if FScaled then
    begin
      if FScaled2 then
       begin { if FScaled2 }
        FRealMaxFontSize:=Round(FMaxFontSize*hca3*FScaled2Ratio/100.0);
       end
      else
       begin
        FRealMaxFontSize:=Round(FMaxFontSize/coof*hca3);
       end;
    end
   else
    begin
      FRealMaxFontSize:=Round(FMaxFontSize*FOwner.FFontCoof*hca3);
    end;
 end;


procedure  TBPDFDGraph.SetScaled(Value:Boolean);
Var r1,r2,ratio,fontRatio,labelFontRatio:Double;
    nw,nh,mw,mh:Integer;
    rw,rh:Double;
    dc:HDC;
    ws2,hs2:Extended;
    pgAlg:TBPPgAlg;
    {New}
    wca3,hca3:Extended;
    aSize:Integer;
    tmpi:TQRPaperSize;
 begin
   FScaled:=Value;
   if FTree=nil then Exit;
   if FScaled then
    begin
    if FOwner.VertScrollBar.Visible then FOwner.VertScrollBar.Position:=0;
    if FOwner.HorzScrollBar.Visible then FOwner.HorzScrollBar.Position:=0;
    Repaint;
    SetDefaultConstants;
    Printing:=False;
    SetDefaultConstants;
    CreateGraphNodes(1,1); { read x,y,acceptposition }
    CreateGraphLinks(1,1); { read x,y,acceptposition }
    CreateDGraphNodes(1,1);
    PresetupFrame(1,1); { Scale x,y to widthcoof,heightcoof }
    TraceRoute;
    if FMaxNodesCount>FOwner.FNodesValue[0] then
     begin
       if FMaxNodesCount>FOwner.FNodesValue[1] then
         pgAlg:=pg_Max
       else
         pgAlg:=pg_Middle;
     end
    else pgAlg:=pg_Min;
    FOwner.Invalidate;
   end;
   if FScaled2 then
    begin { if FScaled2 }
     wca3:=1.0;
     hca3:=1.0;
     if MainUnit.HasPrnDevice then
      begin
       aSize:=Printer.PaperSize;
       for tmpi:= Default to Custom do
        begin
         if aSize=cQRPaperTranslate[tmpI] then
           begin
            hca3:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A3,0];
            wca3:=cQRPaperSizeMetrics[tmpI,1]/cQRPaperSizeMetrics[A3,1];
           end;
        end;
       end;
      dc:=GetDC(0);
      ws2:=GetDeviceCaps(dc,LOGPIXELSX)*A3Width*wca3*FScaled2Ratio/100.0;
      hs2:=GetDeviceCaps(dc,LOGPIXELSY)*A3Height*hca3*FScaled2Ratio/100.0;
      UpdateMaxFontSize(1);
      ReleaseDC(0,dc);
      if (FOwner.HorzScrollBar.Range>0) and
         (FOwner.HorzScrollBar.Visible) then
       begin
        FOwner.HorzScrollBar.Position:=0;
        r1:=ws2/FOwner.HorzScrollBar.Range;
       end
      else r1:=ws2/FOwner.ClientWidth;
      if (FOwner.VertScrollBar.Visible) and
         (FOwner.VertScrollBar.Range>0) then
       begin
         FOwner.VertScrollBar.Position:=0;
         r2:=hs2/FOwner.VertScrollBar.Range;
       end
      else r2:=hs2/FOwner.ClientHeight;
    end { if FScaled2 }
   else
   begin { if not FScaled2 }
   if (FOwner.HorzScrollBar.Range>0) then
    begin
     FOwner.HorzScrollBar.Position:=0;
     r1:=FOwner.ClientWidth/FOwner.HorzScrollBar.Range;
    end
   else r1:=1;
   if (FOwner.VertScrollBar.Range>0) then
    begin
     FOwner.VertScrollBar.Position:=0;
     r2:=FOwner.ClientHeight/FOwner.VertScrollBar.Range;
    end
   else r2:=1;
   UpdateMaxFontSize(r2);
   end; { if not FScaled2 }
   if FScaled then
    begin
     case pgAlg of
      pg_Min:     ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[0]);
      pg_Middle:  ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[1]);
      pg_Max:     ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[2]);
     end;
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,ratio,ratio);
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     Printing:=True;
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     CreateDGraphNodes(r1,r2);
     PresetupFrame(r1,r2); { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
     while FOwner.FPainting do;
     nw:=NodeWidth;
     nh:=NodeHeight;
     mw:=MaxWidth;
     mh:=MaxHeight;
     rw:=ratio*nw/(mw+1);
     rh:=ratio*nh/(mh+1);
     case pgAlg of
       pg_Min:    fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[0]);
       pg_Middle: fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[1]);
       pg_Max:    fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[2]);
     end;
     if fontRatio>ratio then fontRatio:=ratio;
     LabelFontRatio:=fontRatio*FMaxCH;
     FOwner.Canvas.FillRect(FOwner.Canvas.ClipRect);
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,fontRatio,labelFontRatio);
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     CreateDGraphNodes(r1,r2);
     PresetupFrame(r1,r2);   { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
    end
   else
    begin
     UpdateMaxFontSize(1);
     SetDefaultConstants;
     Printing:=False;
     SetDefaultConstants;
     CreateGraphNodes(1,1); { read x,y,acceptposition }
     CreateGraphLinks(1,1); { read x,y,acceptposition }
     CreateDGraphNodes(1,1);
     PresetupFrame(1,1); { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
    end;

 end;

procedure  TBPDFDGraph.SetFontSize(Value:Integer);  { Checked }
  begin
   if Value=FFontSize then Exit;
   FFontSize:=Value;
   CreateGraphNodes(FRatioWC,FRatioHC);
   CreateGraphLinks(FRatioWC,FRatioHC);
   CreateDGraphNodes(FRatioWC,FRatioHC);
  end;


procedure  TBPDFDGraph.CreateGraphNodes(wc,hc:Double);
 Var nodeP:PBPNode;
     nodeG:PDFDGraphNode;
     curNodeG:PDFDGraphNode;
     i:Integer;
     tmp:TBPNodeTypes;
     s:String;
 begin
   if (FGraphNodes<>nil) then ClearGraphNodes;
   if (FNodes=nil) then Exit;
   FDLinksCount:=0;
   nodeP:=FNodes;
   for i:=0 to (FNodesCount-1) do
    begin { fori }
      tmp:=GetNTFromIndex(nodeP^.dwNodeIndex);
      s:=Trim(NodeP^.ssNodeNumber);
      if (s=FSSNodeNumber) then
          begin { if }
            curNodeG:=PDFDGraphNode(AllocMem(sizeof(TDFDGraphNode)));
            curNodeG^.BPNode:=TBPGraphNode.Create(Parent);
            curNodeG^.BPNode.Parent:=Parent as TWinControl;
            curNodeG^.BPNode.Caption:=MyUtils.MyReplaceNodeCaption(nodeP^.ssCaption,FMaxWordLength,FMaxWordCount,FReplaceNodes);
            curNodeG^.BPNode.FullCaption:=nodeP^.ssCaption;
            FNodeCaption:=nodeP^.ssCaption;
            curNodeG^.BPNode.NodeNumber:=nodeP^.dwNodeNumber;
            curNodeG^.BPNode.SNodeNumber:=nodeP^.ssNodeNumber;
            curNodeG^.BPNode.AutoHeight:=False;
            curNodeG^.BPNode.AutoWidth:=False;
            if not(FScaled2) then
            begin
            s:=Format('%f',[nodeP^.fABCValue]);
            curNodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
            end
            else
            begin
            if (Length(nodeP^.ssComment)>0) then
              curNodeG^.BPNode.Hint:=nodeP^.ssComment
            else
             begin
              s:=Format('%f',[nodeP^.fABCValue]);
              curNodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
             end;
            end;
            curNodeG^.BPNode.ShowHint:=True;
            curNodeG^.BPNode.ABCValue:=nodeP^.fABCValue;
            { New }
            curNodeG^.BPNode.Font.Color:=tmp.dwFontColor;
            curNodeG^.BPNode.Font.Charset:=FLang;
            curNodeG^.BPNode.PaintColor:=tmp.dwPaintColor;
            curNodeG^.BPNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
            curNodeG^.BPNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
            curNodeG^.BPNode.ShadowColor:=tmp.dwShadowColor;
            curNodeG^.BPNode.RectColor:=tmp.dwDrawColor;
            { End New }
            curNodeG^.BPNode.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideNodesFS then
             if FOwner.FPreviewOrPrint then
               curNodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FOwner.FFOntCoof)
             else
               curNodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FScaled2Ratio/100)
            else
            curNodeG^.BPNode.Font.Size:=FFontSize;
            curNodeG^.BPNode.Font.Style:=[fsBold];
            curNodeG^.BPNode.TopToLeftCount:=0;
            curNodeG^.BPNode.BottomToLeftCount:=0;
            curNodeG^.BPNode.LeftToTopCount:=0;
            curNodeG^.BPNode.RightToTopCount:=0;
            curNodeG^.BPNode.TopToRightCount:=0;
            curNodeG^.BPNode.BottomToRightCount:=0;
            curNodeG^.BPNode.LeftToBottomCount:=0;
            curNodeG^.BPNode.RightToBottomCount:=0;
            curNodeG^.BPNode.TopLinksCount:=0;
            curNodeG^.BPNode.BottomLinksCount:=0;
            curNodeG^.BPNode.LeftLinksCount:=0;
            curNodeG^.BPNode.RightLinksCount:=0;
            curNodeG^.BPNode.ShadowDepth:=FNodeShadowDepth;
            curNodeG^.BPNode.SetFontDPI(FFontDPI);
            curNodeG^.BPNode.LineWidth:=FNodeLineWidth;
            curNodeG^.BPNode.DefWidth:=FNodeDefWidth;
            curNodeG^.BPNode.DefHeight:=FNodeDefHeight;
            curNodeG^.BPNode.HSpacing:=FNodeHSpacing;
            curNodeG^.BPNode.VSpacing:=FNodeVSpacing;
            curNodeG^.CorrectNode:=True;
            if nodeP^.AcceptPosition[1] then
            begin
            curNodeG^.BPNode.Top:=Round(nodeP^.Top[1]*hc);
            curNodeG^.BPNode.Left:=Round(nodeP^.Left[1]*wc);
            end;
            curNodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition[1];
            curNodeG^.BPNode.DragMode:=dmManual;
            curNodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
          {  curNodeG^.BPNode.OnDblClick:=MyNodeDblClick;}
            curNodeG^.BPNode.PopupMenu:=BPViewMainForm.DFDNodesPopupMenu;
            curNodeG^.BPNode.Tag:=i;
            curNodeG^.llNode:=nodep;
            curNodeG^.next:=nil;
            FGraphNodes:=curNodeG;
          end; { if }
     Inc(nodeP);
   end; { fori }

 end;

procedure  TBPDFDGraph.CreateGraphLinks(wc,hc:Double);
 Var linkP:PBPLink;
     linkG:PDFDGraphLink;
     curLinkG:PDFDGraphLink;
     i:Integer;
     tmp:TBPLinkTypes;
     tnnd,fnnd:Boolean;
     linkVisible:Boolean;
     tn:Boolean;
     MyNodeNum:Integer;
     lfc,ltc:String;
     ffc,ftc:String;
 begin
  {}
  if (FGraphLinks<>nil) then ClearGraphLinks;
  if (FLinks=nil) then Exit;
  if (FGraphNodes=nil) then Exit;
  FDLinksCount:=0;
  linkP:=FLinks;
  curLinkG:=nil;
  MyNodeNum:=0;
   for i:=0 to (FLinksCount-1) do
    begin
      tmp:=GetLTFromIndex(linkP^.dwLinkIndex);
      fnnd:=((linkp^.dwFromNodeNumber and BPGlobalNodeOperation)<>0);
      tnnd:=((linkp^.dwToNodeNumber and BPGlobalNodeOperation)<>0);
      linkVisible:=(fnnd or tnnd);
      tn:=(FGraphNodes^.BPNode.NodeNumber = linkP^.dwFromNodeNumber)
         or (FGraphNodes^.BPNode.NodeNumber = linkP^.dwToNodeNumber);
      linkVisible:=linkVisible and tn;
      if linkVisible then
      begin
      ffc:=linkP^.ssFromCaption;
      ftc:=linkP^.ssToCaption;
      lfc:=MyUtils.MyReplaceLabelCaption(linkP^.ssFromCaption,FMaxLabelLength,FReplaceLabels);
      ltc:=MyUtils.MyReplaceLabelCaption(linkP^.ssToCaption,FMaxLabelLength,FReplaceLabels);
      if (curLinkG=nil) then
          begin
            curLinkG:=PDFDGraphLink(AllocMem(sizeof(TDFDGraphLink)));
            curLinkG^.llLink:=linkP;
            inc(FDLinksCount);
            if (((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and linkVisible) then
            begin
            begin
            curLinkG^.BPFromLabel:=TBPLabel.Create(Parent);
            curLinkG^.BPFromLabel.Parent:=Parent as TWinControl;
            curLinkG^.BPFromLabel.Caption:=lfc;
            curLinkG^.BPFromLabel.FullCaption:=ffc;
            curLinkG^.BPFromLabel.ParentFont:=False;
            curLinkG^.BPFromLabel.Hint:=linkP^.ssFromCaption;
            curLinkG^.BPFromLabel.ShowHint:=True;
            curLinkG^.BPFromLabel.Path:=linkP^.ssFromPath;
            curLinkG^.BPFromLabel.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            curLinkG^.BPFromLabel.Font.Size:=FLabelFontSize;
            curLinkG^.BPFromLabel.Font.Color:=tmp.dwColor;
            curLinkG^.BPFromLabel.Font.Charset:=FLang;
            curLinkG^.BPFromLabel.SetFontDPI(FFontDPI);
            curLinkG^.BPFromLabel.Transparent:=True;
            curLinkG^.BPFromLabel.AutoSize:=True;
            curLinkG^.BPFromLabel.Color:=clWhite;
            curLinkG^.BPFromLabel.WordWrap:=False;
            curLinkG^.BPFromLabel.AcceptPosition:=False;
            curLinkG^.BPFromLabel.Top:=Round(linkP^.FromTop[1]*hc);
            curLinkG^.BPFromLabel.Left:=Round(linkP^.FromLeft[1]*wc);
            curLinkG^.BPFromLabel.AcceptPosition:=linkP^.FromAcceptPosition[1];
            curLinkG^.BPFromLabel.DragMode:=dmManual;
            curLinkG^.BPFromLabel.Cursor:=crHandPoint;
            curLinkG^.BPFromLabel.OnMouseDown:=MyLabelMouseDown;
            curLinkG^.BPFromLabel.PopupMenu:=BPViewMainForm.DFDLinksPopupMenu;
            curLinkG^.BPFromLabel.SendToBack;
            end;

            end
             else
            curLinkG^.BPFromLabel:=nil;
            if (((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and linkVisible) then
            begin
            begin
            curLinkG^.BPToLabel:=TBPLabel.Create(Parent);
            curLinkG^.BPToLabel.Parent:=Parent as TWinControl;
            curLinkG^.BPToLabel.Caption:=ltc;
            curLinkG^.BPToLabel.FullCaption:=ftc;
            curLinkG^.BPToLabel.ParentFont:=False;
            curLinkG^.BPToLabel.Hint:=linkP^.ssToCaption;
            curLinkG^.BPToLabel.ShowHint:=True;
            curLinkG^.BPToLabel.Path:=linkP^.ssToPath;
            curLinkG^.BPToLabel.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            curLinkG^.BPToLabel.Font.Size:=FLabelFontSize;
            curLinkG^.BPToLabel.Font.Color:=tmp.dwColor;
            curLinkG^.BPToLabel.Font.Charset:=FLang;
            curLinkG^.BPToLabel.SetFontDPI(FFontDPI);
            curLinkG^.BPToLabel.Transparent:=True;
            curLinkG^.BPToLabel.AutoSize:=True;
            curLinkG^.BPToLabel.Color:=clWhite;
            curLinkG^.BPToLabel.WordWrap:=False;
            curLinkG^.BPToLabel.AcceptPosition:=False;
            curLinkG^.BPToLabel.Top:=Round(linkP^.ToTop[1]*hc);
            curLinkG^.BPToLabel.Left:=Round(linkP^.ToLeft[1]*wc);
            curLinkG^.BPToLabel.AcceptPosition:=linkP^.ToAcceptPosition[1];
            curLinkG^.BPToLabel.DragMode:=dmManual;
            curLinkG^.BPToLabel.Cursor:=crHandPoint;
            curLinkG^.BPToLabel.OnMouseDown:=MyLabelMouseDown;
            curLinkG^.BPToLabel.PopupMenu:=BPViewMainForm.DFDLinksPopupMenu;
            curLinkG^.BPToLabel.SendToBack;
            end;
            end
             else
            curLinkG^.BPToLabel:=nil;
            if fnnd then
            curLinkG^.FromNodeNumber:=MyNodeNum or BPGlobalNodeOperation
            else
            curLinkG^.FromNodeNumber:=linkP^.dwFromNodeNumber;
            if tnnd then
            curLinkG^.ToNodeNumber:=MyNodeNum or BPGlobalNodeOperation
            else
            curLinkG^.ToNodeNumber:=linkP^.dwToNodeNumber;
            curLinkG^.dwFlags:=linkP^.dwFlags;
            curLinkG^.FromLinkNumber:=linkP^.dwFromLinkNumber;
            curLinkG^.ToLinkNumber:=linkP^.dwToLinkNumber;
            curLinkG^.StartPoint.x:=0;
            curLinkG^.StartPoint.y:=0;
            curLinkG^.EndPoint.x:=0;
            curLinkG^.EndPoint.y:=0;
            curLinkG^.LinkFromCount:=0;
            curLinkG^.LinkToCount:=0;
            curLinkG^.LinkFromUpCount:=0;
            curLinkG^.LinkFromDownCount:=0;
            curLinkG^.LinkToUpCount:=0;
            curLinkG^.LinkToDownCount:=0;
            curLinkG^.MinimalXFrom:=0;
            curLinkG^.MinimalXTo:=0;
            curLinkG^.MinimalYFrom:=0;
            curLinkG^.MinimalYTo:=0;
            FillChar(curLinkG^.LineArrayX,sizeof(curLinkG^.LineArrayX),0);
            FillChar(curLinkG^.LineArrayY,sizeof(curLinkG^.LineArrayY),0);
            curLinkG^.LinePointCount:=0;
            curLinkG^.Color:=tmp.dwColor;
            curLinkG^.PenStyle:=tmp.dwPenStyle;
            curLinkG^.next:=nil;
            FGraphLinks:=curLinkG;
          end
       else
          begin
            linkG:=PDFDGraphLink(AllocMem(sizeof(TDFDGraphLink)));
            linkG^.llLink:=linkP;
            inc(FDLinksCount);
            if (((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and linkVisible) then
            begin
            begin
            LinkG^.BPFromLabel:=TBPLabel.Create(Parent);
            LinkG^.BPFromLabel.Parent:=Parent as TWinControl;
            LinkG^.BPFromLabel.Caption:=lfc;
            LinkG^.BPFromLabel.FullCaption:=ffc;
            LinkG^.BPFromLabel.ParentFont:=False;
            LinkG^.BPFromLabel.Hint:=linkP^.ssFromCaption;
            LinkG^.BPFromLabel.ShowHint:=True;
            LinkG^.BPFromLabel.Path:=linkP^.ssFromPath;
            LinkG^.BPFromLabel.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            LinkG^.BPFromLabel.Font.Size:=FLabelFontSize;
            LinkG^.BPFromLabel.Font.Color:=tmp.dwColor;
            LinkG^.BPFromLabel.Font.Charset:=FLang;
            LinkG^.BPFromLabel.SetFontDPI(FFontDPI);
            LinkG^.BPFromLabel.Transparent:=True;
            LinkG^.BPFromLabel.AutoSize:=True;
            LinkG^.BPFromLabel.Color:=clWhite;
            LinkG^.BPFromLabel.WordWrap:=False;
            LinkG^.BPFromLabel.AcceptPosition:=False;
            LinkG^.BPFromLabel.Top:=Round(linkP^.FromTop[1]*hc);
            LinkG^.BPFromLabel.Left:=Round(linkP^.FromLeft[1]*wc);
            LinkG^.BPFromLabel.AcceptPosition:=linkP^.FromAcceptPosition[1];
            LinkG^.BPFromLabel.DragMode:=dmManual;
            LinkG^.BPFromLabel.Cursor:=crHandPoint;
            LinkG^.BPFromLabel.OnMouseDown:=MyLabelMouseDown;
            LinkG^.BPFromLabel.PopupMenu:=BPViewMainForm.DFDLinksPopupMenu;
            LinkG^.BPFromLabel.SendToBack;
            end;
            end
             else
            LinkG^.BPFromLabel:=nil;
            if (((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and LinkVisible) then
            begin
            begin
            LinkG^.BPToLabel:=TBPLabel.Create(Parent);
            LinkG^.BPToLabel.Parent:=Parent as TWinControl;
            LinkG^.BPToLabel.Caption:=ltc;
            LinkG^.BPToLabel.FullCaption:=ftc;
            LinkG^.BPToLabel.ParentFont:=False;
            LinkG^.BPToLabel.Hint:=linkP^.ssToCaption;
            LinkG^.BPToLabel.ShowHint:=True;
            LinkG^.BPToLabel.Path:=linkP^.ssToPath;
            LinkG^.BPToLabel.Font.Name:=FPrinterFontName;
            LinkG^.BPToLabel.Font.Charset:=FLang;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            LinkG^.BPToLabel.Font.Size:=FLabelFontSize;
            LinkG^.BPToLabel.Font.Color:=tmp.dwColor;
            LinkG^.BPToLabel.SetFontDPI(FFontDPI);
            LinkG^.BPToLabel.Transparent:=True;
            LinkG^.BPToLabel.AutoSize:=True;
            LinkG^.BPToLabel.Color:=clWhite;
            LinkG^.BPToLabel.WordWrap:=False;
            LinkG^.BPToLabel.AcceptPosition:=False;
            LinkG^.BPToLabel.Top:=Round(linkP^.ToTop[1]*hc);
            LinkG^.BPToLabel.Left:=Round(linkP^.ToLeft[1]*wc);
            LinkG^.BPToLabel.AcceptPosition:=linkP^.ToAcceptPosition[1];
            LinkG^.BPToLabel.DragMode:=dmManual;
            LinkG^.BPToLabel.Cursor:=crHandPoint;
            LinkG^.BPToLabel.OnMouseDown:=MyLabelMouseDown;
            LinkG^.BPToLabel.PopupMenu:=BPViewMainForm.DFDLinksPopupMenu;
            LinkG^.BPToLabel.SendToBack;
            end;
            end
             else
            LinkG^.BPToLabel:=nil;
            if fnnd then
            linkG^.FromNodeNumber:=MyNodeNum or BPGlobalNodeOperation
            else
            linkG^.FromNodeNumber:=linkP^.dwFromNodeNumber;
            if tnnd then
            LinkG^.ToNodeNumber:=MyNodeNum or BPGlobalNodeOperation
            else
            linkG^.ToNodeNumber:=linkP^.dwToNodeNumber;
            LinkG^.dwFlags:=linkP^.dwFlags;
            LinkG^.FromLinkNumber:=linkP^.dwFromLinkNumber;
            LinkG^.ToLinkNumber:=linkP^.dwToLinkNumber;
            linkG^.StartPoint.x:=0;
            linkG^.StartPoint.y:=0;
            linkG^.EndPoint.x:=0;
            linkG^.EndPoint.y:=0;
            linkG^.LinkFromCount:=0;
            linkG^.LinkToCount:=0;
            linkG^.LinkFromUpCount:=0;
            linkG^.LinkFromDownCount:=0;
            linkG^.LinkToUpCount:=0;
            linkG^.LinkToDownCount:=0;
            linkG^.MinimalXFrom:=0;
            linkG^.MinimalXTo:=0;
            linkG^.MinimalYFrom:=0;
            linkG^.MinimalYTo:=0;
            FillChar(linkG^.LineArrayX,sizeof(linkG^.LineArrayX),0);
            FillChar(linkG^.LineArrayY,sizeof(linkG^.LineArrayY),0);
            linkG^.LinePointCount:=0;
            LinkG^.Color:=tmp.dwColor;
            LinkG^.PenStyle:=tmp.dwPenStyle;
            linkG^.next:=nil;
            curLinkG^.next:=linkG;
            curLinkG:=linkG;
          end;
         end; { linkVisible}
          Inc(linkP);
          Inc(MyNodeNum);
    end;
 end;

function   TBPDFDGraph.CreateDNodeFieldsList(dnode:PBPOpTree;EnTruncate:Boolean):ShortString;
Var i:Integer;
    ic:Integer;
    tmp:PBPOpDetail;
    s:String;
    nc:String;
 begin
   Result:='';
   FPH:='';
   if (dnode=nil) then Exit;
   ic:=dnode^.dwOpDetailCount;
   tmp:=dnode^.lpOpDetail;
   for i:=0 to (ic-1) do
    begin
      if EnTruncate then
       s:=MyUtils.MyReplaceNodeCaption(Trim(tmp^.ssCaption),FMaxWordLength,FMaxWordCount,FReplaceNodes)
      else
       s:=Trim(tmp^.ssCaption);
      if (s<>'') then
       begin
        Result:=Result+s+#13;
        FPH:=FPH+Trim(tmp^.ssCaption)+#13;
       end;
      inc(tmp);
    end;
 end;


procedure  TBPDFDGraph.AddDNode(num:DWORD;Cap:String;Prj,HintPrj:String;sindex:DWORD;TopBottom:Boolean;
                                ATop,ALeft:Integer;APos:Boolean;hc,wc:Double;ln:Integer;llNode:PBPOpTree;
                                fullcap,fullprj:String);
 Var nodeG:PDDFDGraphNode;
     curNodeG:PDDFDGraphNode;
     tmp:TBPNodeTypes;
 begin
  if (TopBottom) then
     inc(FDTopNodesCount)
  else
     inc(FDBottomNodesCount);
   tmp:=GetNTFromIndex(sindex);
   if (FDNodesCount=0) then
       begin
                   curNodeG:=PDDFDGraphNode(AllocMem(sizeof(TDDFDGraphNode)));
                   curNodeG^.TopBottom:=TopBottom;
                   curNodeG^.BPDNode:=TBPDGraphNode.Create(Parent);
                   curNodeG^.BPDNode.Parent:=Parent as TWinControl;
                   curNodeG^.BPDNode.Text:=cap;
                   curNodeG^.BPDNode.Projection:=prj;
                   curNodeG^.BPDNode.FullCaption:=fullcap;
                   curNodeG^.BPDNode.FullProjection:=fullprj;
                   curNodeG^.BPDNode.NodeNumber:=num;
                   curNodeG^.BPDNode.AutoHeight:=False;
                   curNodeG^.BPDNode.AutoWidth:=False;
                   curNodeG^.BPDNode.Hint:=cap+#13+HintPrj;
                   curNodeG^.BPDNode.ShowHint:=True;
                   curNodeG^.BPDNode.Font.Color:=tmp.dwFontColor;
                   curNodeG^.BPDNode.Font.Charset:=FLang;
                   curNodeG^.BPDNode.Font.Style:=[fsBold];
                   curNodeG^.BPDNode.PrjFont.Charset:=FLang;
                   curNodeG^.BPDNode.PrjFont.Color:=tmp.dwFontColor;
                   curNodeG^.BPDNode.PaintColor:=tmp.dwPaintColor;
                   curNodeG^.BPDNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
                   curNodeG^.BPDNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
                   curNodeG^.BPDNode.ShadowColor:=tmp.dwShadowColor;
                   curNodeG^.BPDNode.RectColor:=tmp.dwDrawColor;
                   curNodeG^.BPDNode.Font.Name:=FPrinterFontName;
                   curNodeG^.BPDNode.PrjFont.Name:=FPrinterFontName;
                   if FDoOverrideFS and FOverrideDNodesFS then
                    if FOwner.FPreviewOrPrint then
                     curNodeG^.BPDNode.Font.Size:=Round(FDNodesFontSize*FOwner.FFOntCoof)
                    else
                     curNodeG^.BPDNode.Font.Size:=Round(FDNodesFontSize*FScaled2Ratio/100)
                   else
                   curNodeG^.BPDNode.Font.Size:=FFontSize;
                   curNodeG^.BPDNode.Font.Style:=[];
                   if FDoOverrideFS and FOverrideDNodesFS then
                    if FOwner.FPreviewOrPrint then
                     curNodeG^.BPDNode.PrjFont.Size:=Round(FDProjectionFontSize*FOwner.FFOntCoof)
                    else
                     curNodeG^.BPDNode.PrjFont.Size:=Round(FDProjectionFontSize*FScaled2Ratio/100)
                   else
                   curNodeG^.BPDNode.PrjFont.Size:=FFontSize;
                   curNodeG^.BPDNode.PrjFont.Style:=[];
                   curNodeG^.BPDNode.ShadowDepth:=FNodeShadowDepth;
                   curNodeG^.BPDNode.SetFontDPI(FFontDPI);
                   curNodeG^.BPDNode.LineWidth:=FNodeLineWidth;
                   curNodeG^.BPDNode.DefWidth:=FNodeDefWidth;
                   curNodeG^.BPDNode.DefHeight:=FNodeDefHeight;
                   curNodeG^.BPDNode.HSpacing:=FNodeHSpacing;
                   curNodeG^.BPDNode.VSpacing:=FNodeVSpacing;
                   curNodeG^.CorrectNode:=True;
                   if APos then
                    begin
                     curNodeG^.BPDNode.Top:=Round(ATop*hc);
                     curNodeG^.BPDNode.Left:=Round(ALeft*wc);
                    end;
                   curNodeG^.BPDNode.AcceptPosition:=APos;
                   curNodeG^.BPDNode.DragMode:=dmManual;
                   curNodeG^.BPDNode.OnMouseDown:=MyNodeMouseDown;
                  { curNodeG^.BPNode.OnDblClick:=MyNodeDblClick;}
                   curNodeG^.BPDNode.PopupMenu:=BPViewMainForm.DFDDNodesPopupMenu;
                   curNodeG^.BPDNode.Tag:=ln;
                   curNodeG^.llNode:=llnode;
                   curNodeG^.next:=nil;
                   FDGraphNodes:=curNodeG;
                   FDLastNode:=curNodeG;
                 end
               else
                 begin
                   nodeG:=PDDFDGraphNode(AllocMem(sizeof(TDDFDGraphNode)));
                   nodeG^.TopBottom:=TopBottom;
                   nodeG^.BPDNode:=TBPDGraphNode.Create(Parent);
                   nodeG^.BPDNode.Parent:=Parent as TWinControl;
                   nodeG^.BPDNode.Text:=cap;
                   nodeG^.BPDNode.Projection:=prj;
                   nodeG^.BPDNode.FullCaption:=fullcap;
                   nodeG^.BPDNode.FullProjection:=fullprj;
                   nodeG^.BPDNode.NodeNumber:=num;
                   nodeG^.BPDNode.AutoHeight:=False;
                   nodeG^.BPDNode.AutoWidth:=False;
                   nodeG^.BPDNode.Hint:=cap+#13+HintPrj;
                   nodeG^.BPDNode.ShowHint:=True;
                   nodeG^.BPDNode.Font.Color:=tmp.dwFontColor;
                   nodeG^.BPDNode.PrjFont.Color:=tmp.dwFontColor;
                   NodeG^.BPDNode.Font.Charset:=FLang;
                   NodeG^.BPDNode.Font.Style:=[fsBold];
                   NodeG^.BPDNode.PrjFont.Charset:=FLang;
                   nodeG^.BPDNode.PaintColor:=tmp.dwPaintColor;
                   nodeG^.BPDNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
                   nodeG^.BPDNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
                   nodeG^.BPDNode.ShadowColor:=tmp.dwShadowColor;
                   nodeG^.BPDNode.RectColor:=tmp.dwDrawColor;
                  { End New }
                   nodeG^.BPDNode.Font.Name:=FPrinterFontName;
                   nodeG^.BPDNode.PrjFont.Name:=FPrinterFontName;
                   if FDoOverrideFS and FOverrideDNodesFS then
                    if FOwner.FPreviewOrPrint then
                     NodeG^.BPDNode.Font.Size:=Round(FDNodesFontSize*FOwner.FFOntCoof)
                    else
                     NodeG^.BPDNode.Font.Size:=Round(FDNodesFontSize*FScaled2Ratio/100)
                   else
                   nodeG^.BPDNode.Font.Size:=FFontSize;
                   if FDoOverrideFS and FOverrideDNodesFS then
                    if FOwner.FPreviewOrPrint then
                     NodeG^.BPDNode.PrjFont.Size:=Round(FDProjectionFontSize*FOwner.FFOntCoof)
                    else
                     NodeG^.BPDNode.PrjFont.Size:=Round(FDProjectionFontSize*FScaled2Ratio/100)
                   else
                   nodeG^.BPDNode.PrjFont.Size:=FFontSize;
                   nodeG^.BPDNode.Font.Style:=[];
                   nodeG^.BPDNode.PrjFont.Style:=[];
                   nodeG^.BPDNode.ShadowDepth:=FNodeShadowDepth;
                   nodeG^.BPDNode.SetFontDPI(FFontDPI);
                   nodeG^.BPDNode.LineWidth:=FNodeLineWidth;
                   nodeG^.BPDNode.DefWidth:=FNodeDefWidth;
                   nodeG^.BPDNode.DefHeight:=FNodeDefHeight;
                   nodeG^.BPDNode.HSpacing:=FNodeHSpacing;
                   nodeG^.BPDNode.VSpacing:=FNodeVSpacing;
                   nodeG^.CorrectNode:=True;
                   if APos then
                     begin
                      nodeG^.BPDNode.Top:=Round(ATop*hc);
                      nodeG^.BPDNode.Left:=Round(ALeft*wc);
                     end;
                   nodeG^.BPDNode.AcceptPosition:=APos;
                   nodeG^.BPDNode.DragMode:=dmManual;
                   nodeG^.BPDNode.OnMouseDown:=MyNodeMouseDown;
{                   nodeG^.BPNode.OnDblClick:=MyNodeDblClick;}
                   nodeG^.BPDNode.PopupMenu:=BPViewMainForm.DFDDNodesPopupMenu;
                   nodeG^.BPDNode.Tag:=ln;
                   nodeG^.llNode:=llNode;
                   nodeG^.next:=nil;
                   FDLastNode^.next:=nodeG;
                   FDLastNode:=nodeG;
                 end;
        inc(FDNodesCount);
 end;


procedure  TBPDFDGraph.CreateDGraphNodes(wc,hc:Double);
 Var i,j:Integer;
     s,s1,s2:String;
     tmplink:PBPLink;
     tmpNode:PDFDGraphNode;
     tmpDNode:PBPOpTree;
     MyNodeNum:Integer;
     ph:String;
 begin
 {}
   if (FDGraphNodes<>nil) then ClearDGraphNodes;
   if (FOPTree=nil) then Exit;
   FDNodesCount:=0;
   FDTopNodesCount:=0;
   FDBottomNodesCount:=0;
   if (FGraphNodes=nil) then Exit;
   if (FLinks=nil) then Exit;
   tmpNode:=FGraphNodes;
   tmpLink:=FLinks;
   MyNodeNum:=0;
   for j:=0 to (FLinksCount-1) do
        begin { forj }
          if (tmpLink^.dwFromNodeNumber=tmpNode^.BPNode.NodeNumber) and
             ((tmpLink^.dwToNodeNumber and BPGlobalNodeOperation)<>0) then
             begin
              tmpDNode:=GetDNode(tmpLink^.dwToNodeNumber and BPNotGlobalMask);
              s:=CreateDNodeFieldsList(tmpDNode,True);
              s2:=CreateDNodeFieldsList(tmpDNode,False);
              AddDNode(MyNodeNum,MyUtils.MyReplaceNodeCaption(tmpDNode^.ssCaption,FMaxWordLength,FMaxWordCount,FReplaceNodes),s,FPH,tmpDnode^.dwNodeIndex,False,
                tmpLink^.DNodeTop,tmpLink^.DNodeLeft,tmpLink^.DNodeAcceptPosition,hc,wc,tmpLink^.dwToLinkNumber,tmpDNode,
                tmpDNode^.ssCaption,s2);
             end;
          if (tmpLink^.dwToNodeNumber=tmpNode^.BPNode.NodeNumber) and
             ((tmpLink^.dwFromNodeNumber and BPGlobalNodeOperation)<>0) then
             begin
              tmpDNode:=GetDNode(tmpLink^.dwFromNodeNumber and BPNotGlobalMask);
              s:=CreateDNodeFieldsList(tmpDNode,True);
              s2:=CreateDNodeFieldsList(tmpDNode,False);
               AddDNode(MyNodeNum,MyUtils.MyReplaceNodeCaption(tmpDNode^.ssCaption,FMaxWordLength,FMaxWordCount,FReplaceNodes),s,Fph,tmpDnode^.dwNodeIndex,True,
                       tmpLink^.DNodeTop,tmpLink^.DNodeLeft,tmpLink^.DNodeAcceptPosition,hc,wc,tmpLink^.dwFromLinkNumber,tmpDNode,
                       tmpDNode^.ssCaption,s2);
             end;
          inc(tmpLink);
          inc(MyNodeNum);
        end;  { forj }

end;

function TBPDFDGraph.GetDNode(num:DWORD):PBPOpTree;
Var nodeP:PBPOpTree;
    Flag:Boolean;
 begin
  Result:=nil;
 {}
  if (FHeader.dwOpEntries=0) then Exit;
  nodeP:=FOpTree;
  Flag:=True;
  while ((nodeP<>nil) and flag) do
   begin
     if (nodeP^.dwLevel=num) then
        begin
          Result:=nodeP;
          Flag:=False;
        end;
     nodeP:=nodeP^.next;
   end;
 end;

procedure TBPDFDGraph.TraceLinksToNodeCounters;
Var tmpL:PDFDGraphLink;
       i:Integer;
 begin
   if (FDLinksCount=0) then Exit;
   if (FGraphNodes=nil) then Exit;
   tmpL:=FGraphLinks;
   for i:=0 to (FDLinksCount-1) do
    begin
      if ((tmpL^.FromNodeNumber and BPGlobalNodeOperation)<>0) then
       begin
         FGraphNodes^.BPNode.TopLinksCount:=FGraphNodes^.BPNode.TopLinksCount+1;
         tmpL^.ToLinkNumber:=FGraphNodes^.BPNode.TopLinksCount;
         tmpL^.FromLinkNumber:=1;
         tmpL^.LinkToCount:=FGraphNodes^.BPNode.TopLinksCount;
         tmpL^.LinkFromCount:=1;
         tmpL^.dwFlags:=tmpL^.dwFlags and BP_FROMTOMASK_INVERT;
         tmpL^.dwFlags:=tmpL^.dwFlags or BP_BOTTOM_TOP;
       end;
      if ((tmpL^.ToNodeNumber and BPGlobalNodeOperation)<>0) then
       begin
         FGraphNodes^.BPNode.BottomLinksCount:=FGraphNodes^.BPNode.BottomLinksCount+1;
         tmpL^.FromLinkNumber:=FGraphNodes^.BPNode.BottomLinksCount;
         tmpL^.ToLinkNumber:=1;
         tmpL^.LinkToCount:=1;
         tmpL^.LinkFromCount:=FGraphNodes^.BPNode.BottomLinksCount;
         tmpL^.dwFlags:=tmpL^.dwFlags and BP_FROMTOMASK_INVERT;
         tmpL^.dwFlags:=tmpL^.dwFlags or BP_BOTTOM_TOP;
       end;
      tmpL:=tmpL^.next;
    end;
 end;

function  TBPDFDGraph.GetNTFromIndex(index:DWORD):TBPNodeTypes; { Checked }
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPNodeTypes;
  begin
     flag:=True;
     tmpPtr:=FNTTree;
     ic:=FHeader.dwNodesTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwNodeIndex=index then
                 begin
                   flag:=False;
                   Result:=tmpPtr^;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result.dwNodeIndex:=index;
      Result.ssCaption:='Default';
      Result.dwFontColor:=clBlack;
      Result.dwPaintColor:=clWhite;
      Result.dwDrawColor:=clBlack;
      Result.dwShadowColor:=clBlack;
      Result.dwShadowStyle:=6;
      Result.dwRectStyle:=2;
  end;

function  TBPDFDGraph.GetLTFromIndex(index:DWORD):TBPLinkTypes; { Checked }
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPLinkTypes;
  begin
     flag:=True;
     tmpPtr:=FLTTree;
     ic:=FHeader.dwLinksTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwLinkIndex=index then
                 begin
                   flag:=False;
                   Result:=tmpPtr^;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result.dwLinkIndex:=index;
      Result.ssCaption:='Default';
      Result.dwPenStyle:=psSolid;
      Result.dwColor:=clBlack;
  end;

  constructor TBPDFDGraph.Create(AOwner: TComponent); { Checked }
  begin
    inherited Create(AOwner);
    FOwner:=AOwner as TBPDFDFrame;
    FNodes:=nil;
    FLinks:=nil;
    FNodesCount:=0;
    FLinksCount:=0;
    FGraphNodes:=nil;
    FGraphLinks:=nil;
    FDGraphNodes:=nil;
    FDNodesCount:=0;
    FLang:=RUSSIAN_CHARSET;
    FTree:=nil;
    FOpTree:=nil;     { CurrentWork ! }
    FLTTree:=nil;
    FNTTree:=nil;
    FLevel:=-1;
    FSSLevel:='-1';   { CurrentWork ! }
    FParentLevel:=-2; { Disabled }
    FSSNodeNumber:='';
    FLevelNotes:='';
    FLevelRevision:=0;
    FLevelDraftStatus:=[];
    FNodeCaption:='';
    FillChar(FHeader,sizeof(FHeader),0);
    FMaxWidth:=0;
    FMaxHeight:=0;
    FDMaxWidth:=0;
    FDMaxHeight:=0;
    FDPrjMaxHeight:=0;
    FGlobalLeftSize:=80;
    FGlobalRightSize:=80;
    FGlobalTopSize:=80;
    FGlobalBottomSize:=80;
    FFontDPI:=96;
    FFontSize:=8;
    FLabelFontSize:=8;
    FMinLineStep:=StartMinLineStep;
    FNodeLineWidth:=1;
    FNodeDefWidth:=100;
    FNodeDefHeight:=100;
    FNodeHSpacing:=8;
    FNodeVSpacing:=8;
    FNodeShadowDepth:=4;
    FMinArcRadius:=StartMinArcRadius;
    FMinLabelX:=StartMinLabelX;
    FMinLabelY:=StartMinLabelY;
    FMinLabelY1:=StartMinLabelY1;
    FMinGlobalLabel:=StartMinGlobalLabel;
    FMinLineEndPoint:=StartMinLineEndPoint;
    FNodeWidth:=0;
    FNodeHeight:=0;
    FCalcWidthHeight:=False;
    FDebug:=False;
    FScaled:=False;
    FScreenFontName:='Times New Roman';
    FPrinterFontName:='Times New Roman';
    FDiscardDrags:=False;
    FRatioWC:=1;
    FRatioHC:=1;
    FModified:=False;
    FLinksPosRelative:=True;
    FActiveNodesList:=TStringList.Create;
    FScaled2Ratio:=100;
    FScaled2:=True;
    FReplaceNodes:=False;
    FReplaceLabels:=False;
    FMaxWordLength:=8;
    FMaxWordCount:=5;
    FMaxLabelLength:=32;
    FMaxFontSize:=DefMaxLabelFontSize;
    FRealMaxFontSize:=DefMaxLabelFontSize;
    Scaled:=True;
  end;

 destructor  TBPDFDGraph.Destroy;  { Checked }
  begin
    if (FActiveNodesList<>nil) then begin
                                      FActiveNodesList.Clear;
                                      FActiveNodesList.Free;
                                    end;
    if (FGraphNodes<>nil) then ClearGraphNodes;
    if (FDGraphNodes<>nil) then ClearDGraphNodes;
    if (FGraphLinks<>nil) then ClearGraphLinks;
    if (FTree<>nil) then FTree:=nil;
    if (FNTTree<>nil) then FNTTree:=nil;
    if (FLTTree<>nil) then FLTTree:=nil;
    if (FOPTree<>nil) then FOpTree:=nil; { CurrentWork ! }
    inherited Destroy;
  end;

 procedure  TBPDFDGraph.ClearDGraphNodes; { Checked }
 Var tmpN,tmpN1:PDDFDGraphNode;
  begin
   if FGraphNodes=nil then Exit;
   tmpN:=FDGraphNodes;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
        { tmpN1^.BPDNode.OnDblClick:=nil;}
         tmpN1^.BPDNode.OnMouseDown:=nil;
         tmpN1^.BPDNode.PopupMenu:=nil;
         tmpN1^.BPDNode.Destroy;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
        { tmpN1^.BPDNode.OnDblClick:=nil;}
         tmpN1^.BPDNode.OnMouseDown:=nil;
         tmpN1^.BPDNode.PopupMenu:=nil;
         tmpN1^.BPDNode.Destroy;
         FreeMem(tmpN1);
       end;
   FDGraphNodes:=nil;
   FDNodesCount:=0;
   FDMaxWidth:=0;
   FDMaxHeight:=0;
   FDPrjMaxHeight:=0;
  end;


 procedure  TBPDFDGraph.ClearGraphNodes; { Checked }
 Var tmpN,tmpN1:PDFDGraphNode;
  begin
   if FGraphNodes=nil then Exit;
   tmpN:=FGraphNodes;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
{         tmpN1^.BPNode.OnDblClick:=nil;}
         tmpN1^.BPNode.OnMouseDown:=nil;
         tmpN1^.BPNode.PopupMenu:=nil;
         tmpN1^.BPNode.Destroy;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
{         tmpN1^.BPNode.OnDblClick:=nil;}
         tmpN1^.BPNode.OnMouseDown:=nil;
         tmpN1^.BPNode.PopupMenu:=nil;
         tmpN1^.BPNode.Destroy;
         FreeMem(tmpN1);
       end;
   FGraphNodes:=nil;
   FMaxWidth:=0;
   FMaxHeight:=0;
  end;

 procedure  TBPDFDGraph.ClearGraphLinks; { Checked }
  Var tmpN,tmpN1:PDFDGraphLink;
  begin
   { Clears graphics links list }
   if FGraphLinks=nil then Exit;
   tmpN:=FGraphLinks;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
         if ((tmpN1^.dwFlags and BP_SHOW_FROMCAPTION)<>0)  and (tmpN1^.BPFromLabel<>nil) and (tmpN1^.BPFromLabel<>nil) then
           begin
            tmpN1^.BPFromLabel.OnMouseDown:=nil;
            tmpN1^.BPFromLabel.PopupMenu:=nil;
            tmpN1^.BPFromLabel.Destroy;
           end;
         if ((tmpN1^.dwFlags and BP_SHOW_TOCAPTION)<>0) and (tmpN1^.BPToLabel<>nil) and (tmpN1^.BPToLabel<>nil) then
           begin
            tmpN1^.BPToLabel.OnMouseDown:=nil;
            tmpN1^.BPToLabel.PopupMenu:=nil;
            tmpN1^.BPToLabel.Destroy;
           end;
         tmpN1^.llLink:=nil;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
         if ((tmpN1^.dwFlags and BP_SHOW_FROMCAPTION)<>0)  and (tmpN1^.BPFromLabel<>nil) then
           begin
            tmpN1^.BPFromLabel.OnMouseDown:=nil;
            tmpN1^.BPFromLabel.PopupMenu:=nil;
            tmpN1^.BPFromLabel.Destroy;
           end;
         if ((tmpN1^.dwFlags and BP_SHOW_TOCAPTION)<>0)  and (tmpN1^.BPToLabel<>nil) then
           begin
            tmpN1^.BPToLabel.OnMouseDown:=nil;
            tmpN1^.BPToLabel.PopupMenu:=nil;
            tmpN1^.BPToLabel.Destroy;
           end;
         tmpN1^.llLink:=nil;
         FreeMem(tmpN1);
       end;
   FGraphLinks:=nil;
   FDLinksCount:=0;
  end;

{ TBPDFDFrame }

procedure TBPDFDFrame.MyDragDrop(Sender, Source: TObject; X, Y: Integer); { Checked }
var p:TPoint;
    vpos,hpos:Integer;
begin
 if HorzScrollBar.Visible then hpos:=HorzScrollBar.Position;
 if VertScrollBar.Visible then vpos:=VertScrollBar.Position;
 if (Sender is TBPDFDFrame) and (Source is TBPGraphCustomNode) then
  begin
    with Source as TBPGraphNode do
    begin
      p.x:=X-Left;
      p.y:=Y-Top;
      Left:=X;
      Top:=Y;
      if VertScrollBar.Visible then
       TopDragPos:=Y+VertScrollBar.Position
      else
       TopDragPos:=Y;
      if HorzScrollBar.Visible then
       LeftDragPos:=X+HorzScrollBar.Position
      else
       LeftDragPos:=X;
      AcceptPosition:=True;
      FBPDFDGraph.UpdateNodesModel(LeftDragPos,TopDragPos,Source as TBPGraphNode);
      if FBPDFDGraph.FLinksPosRelative then FBPDFDGraph.CorrectLinksModel(p,(Source as TBPGraphNode).NodeNumber,FBPDFDGraph.AcceptDragRect,False);
      BringToFront;
    end;
    with (Sender as TBPDFDFrame) do
      begin
       Visible:=False;
       FBPDFDGraph.TraceRoute;
       Repaint;
       Visible:=True;
       if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
       if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
  end;
 if (Sender is TBPDFDFrame) and (Source is TBPDGraphNode) then
  begin
   with Source as TBPDGraphNode do
    begin
      p.x:=X-Left;
      p.y:=Y-Top;
      Left:=X;
      Top:=Y;
      if VertScrollBar.Visible then
       TopDragPos:=Y+VertScrollBar.Position
      else
       TopDragPos:=Y;
      if HorzScrollBar.Visible then
       LeftDragPos:=X+HorzScrollBar.Position
      else
       LeftDragPos:=X;
       AcceptPosition:=True;
       FBPDFDGraph.UpdateDNodesModel(LeftDragPos,TopDragPos,Source as TBPDGraphNode);
      if FBPDFDGraph.FLinksPosRelative then FBPDFDGraph.CorrectLinksModel(p,(Source as TBPDGraphNode).NodeNumber,FBPDFDGraph.AcceptDragRect,True);
      BringToFront;
    end;
    with (Sender as TBPDFDFrame) do
      begin
       Visible:=False;
       FBPDFDGraph.TraceRoute;
       Repaint;
       Visible:=True;
       if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
       if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
  end;
 if (Sender is TBPDFDFrame) and (Source is TBPLabel) then
  begin
    with Source as TBPLabel do
    begin
      Left:=X;
      Top:=Y;
      if VertScrollBar.Visible then
       TopDragPos:=Y+VertScrollBar.Position
      else
       TopDragPos:=Y;
      if HorzScrollBar.Visible then
       LeftDragPos:=X+HorzScrollBar.Position
      else
       LeftDragPos:=X;
      AcceptPosition:=True;
    end;
     with (Sender as TBPDFDFrame) do
      begin
       FBPDFDGraph.UpdateLinksModel((Source as TBPLabel).LeftDragPos,
               (Source as TBPLabel).TopDragPos,Source as TBPLabel);
       Visible:=False;
       FBPDFDGraph.TraceRoute;
       Repaint;
       Visible:=True;
       if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
       if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
   end;
end;

procedure TBPDFDFrame.MyDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean); { Checked }
Var tmpn:TBPGraphNode;
    tmpd:TBPDGraphNode;
    tmpl:TBPLabel;
    xnew,ynew:Integer;
begin
 if VertScrollBar.Visible then
   ynew:=y+VertScrollBar.Position
 else
   ynew:=y;
 if HorzScrollBar.Visible then
   xnew:=x+HorzScrollBar.Position
 else
   xnew:=x;
 { Check for Source }
 Accept:=(Source is TBPGraphCustomNode);
 { Check coordinates }
 if Accept then
    begin
      tmpn:=Source as TBPGraphNode;
      if   (Xnew<FBPDFDGraph.AcceptDragRect.Left)
       or  (Ynew<FBPDFDGraph.AcceptDragRect.Top)
       or  ((Xnew+tmpn.Width)>FBPDFDGraph.AcceptDragRect.Right)
       or  ((Ynew+tmpn.Height)>FBPDFDGraph.AcceptDragRect.Bottom)
        then
         Accept:=False;
    end;
 if not(Accept) then
  begin
   Accept:=Source is TBPLabel;
   if Accept then
     begin
       tmpl:=Source as TBPLabel;
       if   (Xnew<FBPDFDGraph.AcceptDragRect.Left)
       or  (Ynew<FBPDFDGraph.AcceptDragRect.Top)
       or  ((Xnew{+tmpl.Width})>FBPDFDGraph.AcceptDragRect.Right)
       or  ((Ynew{+tmpl.Height})>FBPDFDGraph.AcceptDragRect.Bottom)
        then
         Accept:=False;
     end;
     if not(Accept) then
      begin
        Accept:=(Source is TBPDGraphNode);
       { Check coordinates }
        if Accept then
          begin
          tmpd:=Source as TBPDGraphNode;
         if   (Xnew<FBPDFDGraph.AcceptDragRect.Left)
          or  (Ynew<FBPDFDGraph.AcceptDragRect.Top)
          or  ((Xnew+tmpd.Width)>FBPDFDGraph.AcceptDragRect.Right)
          or  ((Ynew+tmpd.Height)>FBPDFDGraph.AcceptDragRect.Bottom)
          then
           Accept:=False;
          end;
      end;
  end;
end;



constructor TBPDFDFrame.Create(AOwner: TComponent); { Checked }
begin
 inherited Create(AOwner);
 FPainting:=False;
 FPrinting:=False;
 FAborting:=False;
 FPreviewOrPrint:=False;
 FFontCoof:=1;
 FBPDFDGraph:=TBPDFDGraph.Create(self);
 FBPDFDGraph.Parent:=self;
 FCanvas := TControlCanvas.Create;
 TControlCanvas(FCanvas).Control := Self;
 Canvas.Brush.Color:=clWhite;
 DragCursor:=crMyCursor;
 OnDragDrop:=MyDragDrop;
 OnDragOver:=MyDragOver;
{ DragMode:=dmAutomatic;}
 FPageTop:=15;
 FPageBottom:=15;
 FPageLeft:=25;
 FPageRight:=15;
 FHorzPageCount:=1;
 FVertPageCount:=1;
 FRamkaFontRatio:=1.0;
 FPSizeH:=21;
 FPSizeW:=29.7;
 FRamkaH:=0;
 TabStop:=True;
 Enabled:=True;
 FUpdatingNavigator:=False;
 FFormatAlg[0]:=fa_Min;
 FFormatAlg[1]:=fa_Sqrt;
 FFormatAlg[2]:=fa_Max;
 FNodesValue[0]:=4;
 FNodesValue[1]:=6;
 if MainUnit.HasPrnDevice then SetPageParam(FPageTop,FPageBottom,FPageLeft,FPageRight,False);
end;

destructor TBPDFDFrame.Destroy; { Checked }
begin
 OnDragDrop:=nil;
 OnDragOver:=nil;
 if (FPrinter<>nil) then FPrinter.Free;
 if (FCanvas<>nil) then FCanvas.Free;
 if (FBPDFDGraph<>nil) then FBPDFDGraph.Destroy; { +-+ +- }
 inherited Destroy;
end;

procedure TBPDFDFrame.WMPaint(var Message: TWMPaint); { Checked }
begin
   PaintHandler(Message);
end;

procedure TBPDFDFrame.PaintWindow(DC: HDC); { Checked }
begin
  if FPainting then Exit;
  FPainting:=True;
  inherited PaintWindow(DC);
  FCanvas.Lock;
  try
    FCanvas.Handle := DC;
    try
      Paint;
    finally
      FCanvas.Handle := 0;
    end;
  finally
    FCanvas.Unlock;
    FPainting:=False;
  end;
end;

procedure TBPDFDFrame.Paint; { Checked }
Var oldcr:TCursor;
begin
  oldcr:=Cursor;
  Cursor:=crHourGlass;
  Canvas.FillRect(ClientRect);
  FBPDFDGraph.TraceRoute;
  if (not(FUpdatingNavigator)) and
     (BPViewMainFOrm.PageControl1.ActivePage=BPViewMainFOrm.TabSheet2)
     then {BPViewMainForm.BPNavTimer.Enabled:=True;}
     if (BPViewMainFOrm.BPNavigator.Height>1) then
      BPViewMainFOrm.BPNavigator.ScrollBarChanged(self);
  Cursor:=oldcr;
end;

procedure TBPDFDFrame.PaintTo(DC: HDC; X, Y: Integer); { Checked }
var
  SaveIndex: Integer;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X, Y);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;

procedure TBPDFDFrame.PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect); { Checked }
var
  SaveIndex: Integer;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X-PageClipRect.Left, Y-PageClipRect.Top);
  IntersectClipRect(DC, PageClipRect.Left, PageClipRect.Top, PageClipRect.Right, PageClipRect.Bottom);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;


procedure  TBPDFDFrame.ReadWrite(left,right,top,bottom:Integer);
Var oldFontSize:Integer;
    oldFontName:String;
    d:TSize;
    s:String;
    posx:Integer;
    posy:Integer;
 begin
   if HorzScrollBar.Visible then posx:=HorzScrollBar.Position else posx:=0;
   if VertScrollBar.Visible then posy:=VertScrollBar.Position else posy:=0;
   with Canvas do
    begin
     oldFontSize:=Font.Size;
     oldFontName:=Font.Name;
     Font.Name:=FBPDFDGraph.FPrinterFontName;
     Font.Size:=FBPDFDGraph.FFontSize*2;
     s:='';
     d:=TextExtent(s);
     TextOut((left+(right-left-d.cx) div 2)-posx,top-Round(1.5*d.cy)-posy,s);
     s:='';
     d:=TextExtent(s);
     TextOut((left+(right-left-d.cx) div 2)-posx,bottom+Round(1.5*d.cy)-posy,s);
     Font.Name:=oldFontName;
     Font.Size:=oldFontSize;
    end;
 end;

procedure  TBPDFDFrame.PreviewReadWrite(left,right,top,bottom:Integer);
Var oldFontSize:Integer;
    oldFontName:TFontName;
    d:TSize;
    s:String;
 begin
   with FPrinter.Canvas do
    begin
     oldFontName:=Font.Name;
     oldFontSize:=Font.Size;
     Font.Name:=FBPDFDGraph.FPrinterFontName;
     Font.Size:=14;
     s:='';
     d:=TextExtent(s);
     TextOut(left+(right-left-d.cx) div 2,top+Round(0.5*d.cy),s);
     s:='';
     d:=TextExtent(s);
     TextOut(left+(right-left-d.cx) div 2,bottom-Round(1.5*d.cy),s);
     Font.Name:=OldFontName;
     Font.Size:=oldFontSize;
    end;
 end;

procedure  TBPDFDFrame.PrintReadWrite(left,right,top,bottom:Integer);
Var oldFontSize:Integer;
    oldFontName:TFontName;
    d:TSize;
    s:String;
 begin
    with Printer.Canvas do
    begin
     oldFontSize:=Font.Size;
     oldFontName:=Font.Name;
     Font.Name:=FBPDFDGraph.FPrinterFontName;
     Font.Size:=14;
     s:='';
     d:=TextExtent(s);
     TextOut(left+(right-left-d.cx) div 2,top+Round(0.5*d.cy),s);
     s:='';
     d:=TextExtent(s);
     TextOut(left+(right-left-d.cx) div 2,bottom-Round(1.5*d.cy),s);
     Font.Name:=OldFontName;
     Font.Size:=oldFontSize;
    end;
 end;

procedure TBPDFDFrame.PrintRect(left,right,top,bottom:Integer); { Checked }
Var oldStyle:TPenStyle;
begin
 oldStyle:=Printer.Canvas.Pen.Style;
 Printer.Canvas.Pen.Style:=psDot;
 Printer.Canvas.MoveTo(Left,Top);
 Printer.Canvas.LineTo(Right,Top);
 Printer.Canvas.LineTo(Right,Bottom);
 Printer.Canvas.LineTo(Left,Bottom);
 Printer.Canvas.LineTo(Left,Top);
 Printer.Canvas.Pen.Style:=oldStyle;
end;

function  TBPDFDGraph.GetMaxPagesCount:Integer;
 begin
   Result:=FActiveNodesList.Count;
 end;

procedure TBPDFDFrame.PrintAll(pb:TFlatProgressBar;Lbl:TLabel;StartP,EndP:Integer); { Checked }
Var  oldNode:ShortString;
     i:Integer;
     prnppi,scrppi:Integer;
     w,h:Integer;
     prnx,prny:Integer;
     dc:HDC;
     ratio,fontRatio,LabelFontRatio:Double;
     rw,rh:Double;
     ramkaH:Integer;
     nw,nh,mw,mh:Integer;
     oldScaled:Boolean;
     oldScaled2:Boolean;
     clRect:TRect;
     px,py:Integer;
     pw,ph:Double;
     tmpI:TQRPaperSize;
     asize:Integer;
     wc,hc:Double;
     anc,canc:Integer;
     pgalg:TBPPgAlg;
begin
  { Print All Pages }
  oldScaled:=BPDFDGraph.Scaled;
  oldScaled2:=BPDFDGraph.Scaled2;
  oldNode:=BPDFDGraph.FSSNodeNumber;
  if FBPDFDGraph.FTree=nil then Exit;
  FUpdatingNavigator:=True;
  FPreviewOrPrint:=True;
  if FBPDFDGraph.FActiveNodesList.Count=0 then Exit;
  FBPDFDGraph.Scaled2:=False;
  if FBPDFDGraph.FScaled then FBPDFDGraph.Scaled:=False;
  try
   FPrinting:=True;
  { Store old viewing level }
   oldNode:=BPDFDGraph.FSSNodeNumber;
   anc:=FBPDFDGraph.FActiveNodesList.Count;
   canc:=0;
   i:=0;
   prnppi:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
   ramkaH:=Round(prnppi/2.54);
   FRamkaH:=ramkaH;
   dc:=GetDC(self.Handle);
   scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
   FFontCoof:=GetDeviceCaps(Printer.Handle,LOGPIXELSY)/GetDeviceCaps(dc,LOGPIXELSY);
   FBPDFDGraph.UpdateMaxFontSize(1);
   ReleaseDC(self.Handle,dc);
   aSize:=Printer.PaperSize;
   FRamkaFontRatio:=1.0;
   FPSizeH:=21;
   FPSizeW:=29.7;
   for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
   { New Code }
   pw:= GetDeviceCaps(Printer.Handle,VERTRES);
   ph:= GetDeviceCaps(Printer.Handle,HORZRES);
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
    ph:=ph - ramkaH;
   { End New Code }
  { ratio:=(prnppi*FHorzPageCount) / scrppi;}
   Printer.BeginDoc;
   while (canc<anc) and (not(FAborting)) do
    begin
     if (canc>=StartP) and (canc<=EndP) then
     begin
     FBPDFDGraph.OpenNode(FBPDFDGraph.FActiveNodesList.Names[canc]);
     FBPDFDGraph.TraceRoute;
     if (FBPDFDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPDFDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
     if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
     if VertScrollBar.Visible then VertScrollBar.Position:=0;
     Repaint;
     inc(i);
     pb.Position:=Round((i)*100/(EndP-StartP+1));
     pb.Update;
     Lbl.Caption:=IntToStr(pb.Position);
     lbl.Update;
     Application.ProcessMessages;
     if FAborting then break;
     while (FPainting) do;
     { New Code }
     rw:=(pw*FHorzPageCount)/FBPDFDGraph.DefWidth;
     rh:=(ph*FVertPageCount)/FBPDFDGraph.DefHeight;
     wc:=FBPDFDGraph.DefWidth;
     hc:=FBPDFDGraph.DefHeight;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
    { End New Code }
     FBPDFDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
     FBPDFDGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPDFDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPDFDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     wc:=FBPDFDGraph.DefWidth/wc;
     hc:=FBPDFDGraph.DefHeight/hc;
     FBPDFDGraph.Printing:=True;
     FBPDFDGraph.CreateGraphNodes(wc,hc);
     FBPDFDGraph.CreateGraphLinks(wc,hc);
     FBPDFDGraph.CreateDGraphNodes(wc,hc);
     FBPDFDGraph.PresetupFrame(wc,hc);
     FBPDFDGraph.TraceRoute;
     Repaint;
     while FPainting do;
     nw:=FBPDFDGraph.NodeWidth;
     nh:=FBPDFDGraph.NodeHeight;
     mw:=FBPDFDGraph.MaxWidth;
     mh:=FBPDFDGraph.MaxHeight;
     rw:=ratio*nw/mw;
     rh:=ratio*nh/mh;
     case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
     end;
     if fontRatio>ratio then fontRatio:=ratio;
     LabelFontRatio:=fontRatio*FBPDFDGraph.FMaxCH;
     FBPDFDGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPDFDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPDFDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     FBPDFDGraph.SetDefaultConstants;
     FBPDFDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
     FBPDFDGraph.CreateGraphNodes(wc,hc);
     FBPDFDGraph.CreateGraphLinks(wc,hc);
     FBPDFDGraph.CreateDGraphNodes(wc,hc);
     FBPDFDGraph.PresetupFrame(wc,hc);
     FBPDFDGraph.TraceRoute;
     Repaint;
     while FPainting do;
    for px:=1 to FHorzPageCount do
    begin
     clRect.Left:=(px-1)*(Printer.PageWidth-FPageRight-FPageLeft);
     clRect.Right:=px*(Printer.PageWidth-FPageRight-FPageLeft);
    for py:=1 to FVertPageCount do
     begin
     clRect.Top:=(py-1)*(Printer.PageHeight-FPageTop-FPageBottom);
     clRect.Bottom:=py*(Printer.PageHeight-FPageTop-FPageBottom);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
        PaintTo(Printer.Handle,FPageLeft,FPageTop+ramkaH);
   {     PrintReadWrite(FPageLeft,Printer.PageWidth-FPageRight,FPageTop+ramkaH,Printer.PageHeight-FPageBottom);}
        PrintStandartRectangle;
       end
      else
       begin
        PaintPageTo(Printer.Handle,FPageLeft,FPageTop,clRect);
{        PrintReadWrite(FPageLeft,Printer.PageWidth-FPageRight,FPageTop+ramkaH,Printer.PageHeight-FPageBottom);}
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end;
       if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
        Printer.NewPage;
     end;
    end;
     FBPDFDGraph.SetDefaultConstants;
     FBPDFDGraph.Printing:=False;
     FBPDFDGraph.CreateGraphNodes(1,1);
     FBPDFDGraph.CreateGraphLinks(1,1);
     FBPDFDGraph.CreateDGraphNodes(1,1);
     FBPDFDGraph.PresetupFrame(1,1);
     FBPDFDGraph.TraceRoute;
     Invalidate;
     if ((canc+1)<anc) and (canc<EndP) then Printer.NewPage;
     end; { StartP,EndP}
     inc(canc);
    end;
   if FAborting then Printer.Abort
   else Printer.EndDoc;
  finally
   { Restore old viewing level}
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FPreviewOrPrint:=False;
   FBPDFDGraph.SetDefaultConstants;
   FBPDFDGraph.Printing:=False;
   FBPDFDGraph.CreateGraphNodes(1,1);
   FBPDFDGraph.CreateGraphLinks(1,1);
   FBPDFDGraph.CreateDGraphNodes(1,1);
   FBPDFDGraph.SetScaled2(oldScaled2);
   FBPDFDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPDFDGraph.PresetupFrame(1,1);
   FBPDFDGraph.TraceRoute;
   Invalidate;
   pb.Position:=100;
   pb.Update;
   lbl.Caption:=IntToStr(pb.Position);
   lbl.Update;
   FBPDFDGraph.OpenNode(oldNode);
   FBPDFDGraph.TraceRoute;
   Invalidate;
  end;
 end;

procedure TBPDFDFrame.Print; { Checked }
Var  prnppi,scrppi:Integer;
     w,h:Integer;
     prnx,prny:Integer;
     dc:HDC;
     ratio,fontRatio,labelFontRatio:Double;
     rw,rh:Double;
     pw,ph:Double;
     ramkaH:Integer;
     nw,nh,mw,mh:Integer;
     oldScaled:Boolean;
     oldScaled2:Boolean;
     clRect:TRect;
     px,py:Integer;
     tmpI:TQRPaperSize;
     asize:Integer;
     wc,hc:Double;
     pgalg:TBPPgAlg;
begin
 try
  oldScaled:=BPDFDGraph.Scaled;
  oldScaled2:=BPDFDGraph.Scaled2;
  FUpdatingNavigator:=True;
  FPreviewOrPrint:=True;
  if (FBPDFDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPDFDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
  FBPDFDGraph.Scaled2:=False;
  if FBPDFDGraph.FScaled then FBPDFDGraph.Scaled:=False;
  FPrinting:=True;
  if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
  if VertScrollBar.Visible then VertScrollBar.Position:=0;
  prnppi:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
  dc:=GetDC(self.Handle);
  scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
  FFontCoof:=GetDeviceCaps(Printer.Handle,LOGPIXELSY)/GetDeviceCaps(dc,LOGPIXELSY);
  FBPDFDGraph.UpdateMaxFontSize(1);
  ReleaseDC(self.Handle,dc);
  aSize:=Printer.PaperSize;
  FRamkaFontRatio:=1.0;
  FPSizeH:=21;
  FPSizeW:=29.7;
  for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
  ramkaH:=Round(prnppi/2.54);
  FRamkaH:=ramkaH;
  { New Code }
  pw:= GetDeviceCaps(Printer.Handle,VERTRES);
  ph:= GetDeviceCaps(Printer.Handle,HORZRES);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   ph:= ph-ramkaH;
  { End New Code }
{  ratio:=(prnppi*FHorzPageCount) / scrppi;}
  { New Code }
  rw:=(pw*FHorzPageCount)/FBPDFDGraph.DefWidth;
  rh:=(ph*FVertPageCount)/FBPDFDGraph.DefHeight;
  wc:=FBPDFDGraph.DefWidth;
  hc:=FBPDFDGraph.DefHeight;
  case pgAlg of
     pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
     pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
     pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
  end; {case pgAlg }
  { End New Code }
  Printer.BeginDoc;
  FBPDFDGraph.SetDefaultConstants;
  FBPDFDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
  FBPDFDGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPDFDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPDFDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
   wc:=FBPDFDGraph.DefWidth/wc;
   hc:=FBPDFDGraph.DefHeight/hc;
  FBPDFDGraph.Printing:=True;
  FBPDFDGraph.CreateGraphNodes(wc,hc);
  FBPDFDGraph.CreateGraphLinks(wc,hc);
  FBPDFDGraph.CreateDGraphNodes(wc,hc);
  FBPDFDGraph.PresetupFrame(wc,hc);
  FBPDFDGraph.TraceRoute;
  Repaint;
  while FPainting do;
  nw:=FBPDFDGraph.NodeWidth;
  nh:=FBPDFDGraph.NodeHeight;
  mw:=FBPDFDGraph.MaxWidth;
  mh:=FBPDFDGraph.MaxHeight;
  rw:=ratio*nw/mw;
  rh:=ratio*nh/mh;
  case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
  end;
  if fontRatio>ratio then fontRatio:=ratio;
  LabelFontRatio:=fontRatio*FBPDFDGraph.FMaxCH;
  FBPDFDGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPDFDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPDFDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
  FBPDFDGraph.SetDefaultConstants;
  FBPDFDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
  FBPDFDGraph.CreateGraphNodes(wc,hc);
  FBPDFDGraph.CreateGraphLinks(wc,hc);
  FBPDFDGraph.CreateDGraphNodes(wc,hc);
  FBPDFDGraph.PresetupFrame(wc,hc);
  FBPDFDGraph.TraceRoute;
  Repaint;
  while FPainting do;
   for px:=1 to FHorzPageCount do
    begin
     clRect.Left:=(px-1)*(Printer.PageWidth-FPageRight-FPageLeft);
     clRect.Right:=px*(Printer.PageWidth-FPageRight-FPageLeft);
    for py:=1 to FVertPageCount do
     begin
     clRect.Top:=(py-1)*(Printer.PageHeight-FPageTop-FPageBottom);
     clRect.Bottom:=py*(Printer.PageHeight-FPageTop-FPageBottom);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
        PaintTo(Printer.Handle,FPageLeft,FPageTop+ramkaH);
{        PrintReadWrite(FPageLeft,Printer.PageWidth-FPageRight,FPageTop+ramkaH,Printer.PageHeight-FPageBottom);}
        PrintStandartRectangle;
       end
      else
       begin
        PaintPageTo(Printer.Handle,FPageLeft,FPageTop,clRect);
{        PrintReadWrite(FPageLeft,Printer.PageWidth-FPageRight,FPageTop+ramkaH,Printer.PageHeight-FPageBottom);}
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end;
       if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
        Printer.NewPage;
     end;
    end;
  finally
   Printer.EndDoc;
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FPreviewOrPrint:=False;
   FBPDFDGraph.SetDefaultConstants;
   FBPDFDGraph.Printing:=False;
   FBPDFDGraph.CreateGraphNodes(1,1);
   FBPDFDGraph.CreateGraphLinks(1,1);
   FBPDFDGraph.CreateDGraphNodes(1,1);
{   FBPDFDGraph.CheckLinksAndNodes;}
   FBPDFDGraph.SetScaled2(oldScaled2);
   FBPDFDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPDFDGraph.PresetupFrame(1,1);
   FBPDFDGraph.TraceRoute;
   Invalidate;
  end;
end;


function   TBPDFDFrame.CalcNewString(s:String;Const outCanvas:TCanvas;MaxWidth:Integer):String; { Checked }
Var ss:String;
 begin
   ss:=s;
   while ((outCanvas.TextExtent(ss).cx>MaxWidth)  and (length(ss)>0)) do
    begin
     ss:=copy(ss,1,length(ss)-1);
    end;
  Result:=ss;
 end;

procedure TBPDFDFrame.CreatePreviewAll(pb:TFlatProgressBar;Lbl:TLabel); { Checked }
Var savedOrd:TPrinterOrientation;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    ratio,fontRatio,LabelFontRatio:Double;
    rw,rh:Double;
    dc:HDC;
    scrppi:LongInt;
    ramkaH:Integer;
    nw,nh,mw,mh:Integer;
    oldNode:ShortString;
    i:Integer;
    oldScaled:Boolean;
    oldScaled2:Boolean;
    px,py:Integer;
    clrect:TRect;
    aSize:Integer;
    tmpi:TQRPaperSize;
    wc,hc:Double;
    canc,anc:Integer;
    pgalg:TBPPgAlg;
begin
 { Create QRPreview Model }
   oldScaled:=BPDFDGraph.Scaled;
   oldScaled2:=BPDFDGraph.Scaled2;
   if FBPDFDGraph.FTree=nil then Exit;
   if (FBPDFDGraph.FActiveNodesList.Count=0) then Exit;
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   FBPDFDGraph.Scaled2:=False;
   if FBPDFDGraph.FScaled then FBPDFDGraph.Scaled:=False;
   anc:=FBPDFDGraph.FActiveNodesList.Count;
   canc:=0;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   oldNode:=FBPDFDGraph.FSSNodeNumber;
   FPrinter:=TQRPrinter.Create;
   try
    FPrinting:=True;
    FPrinter.Cleanup;
    FPrinter.BeginDoc;
    FPrinter.Orientation:=savedOrd;
    Printer.Orientation:=savedOrd;
    FPrinter.PrinterIndex:=Printer.PrinterIndex;
    aSize:=Printer.PaperSize;
    FPrinter.PaperSize:=Default;
    FRamkaFontRatio:=1.0;
    FPSizeH:=21;
    FPSizeW:=29.7;
    for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FPrinter.PaperSize := tmpI;
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
    FPrinter.PaperLength:=Printer.PaperLength;
    FPrinter.PaperWidth:=Printer.PaperWidth;
    dc:=GetDC(0);
    scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
    FFontCoof:=1;
    FBPDFDGraph.UpdateMaxFontSize(1);
    ReleaseDC(0,dc);
    ramkaH:=Round(scrppi/2.54);
    FRamkaH:=ramkaH;
    FPrinter.NewPage;
   if SavedOrd=poPortrait then
   begin
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     ph:=ph - ramkaH;
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   while (canc<anc) and (not(FAborting)) do
    begin
     FBPDFDGraph.OpenNode(FBPDFDGraph.FActiveNodesList.Names[canc]);
     FBPDFDGraph.TraceRoute;
     if (FBPDFDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPDFDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
     Repaint;
     pb.Position:=Round((canc)*100/anc);
     pb.Update;
     lbl.Caption:=IntToStr(pb.Position);
     lbl.Update;
     Application.ProcessMessages;
     if FAborting then break;
     while (FPainting) do;
     if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
     if VertScrollBar.Visible then VertScrollBar.Position:=0;
     rw:=(pw*FHorzPageCount)/FBPDFDGraph.DefWidth;
     rh:=(ph*FVertPageCount)/FBPDFDGraph.DefHeight;
     wc:=FBPDFDGraph.DefWidth;
     hc:=FBPDFDGraph.DefHeight;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
     FBPDFDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
     FBPDFDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPDFDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
     else
      FBPDFDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
     wc:=FBPDFDGraph.DefWidth/wc;
     hc:=FBPDFDGraph.DefHeight/hc;
     FBPDFDGraph.Printing:=True;
     FBPDFDGraph.CreateGraphNodes(wc,hc);
     FBPDFDGraph.CreateGraphLinks(wc,hc);
     FBPDFDGraph.CreateDGraphNodes(wc,hc);
     FBPDFDGraph.PresetupFrame(wc,hc);
     FBPDFDGraph.TraceRoute;
     Repaint;
    while FPainting do;
    nw:=FBPDFDGraph.NodeWidth;
    nh:=FBPDFDGraph.NodeHeight;
    mw:=FBPDFDGraph.MaxWidth;
    mh:=FBPDFDGraph.MaxHeight;
    rw:=ratio*nw/mw;
    rh:=ratio*nh/mh;
    case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
    end;
    if fontRatio>ratio then fontRatio:=ratio;
    LabelFontRatio:=fontRatio*FBPDFDGraph.FMaxCH;
    FBPDFDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPDFDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
    FBPDFDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    FBPDFDGraph.SetDefaultConstants;
    FBPDFDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
    FBPDFDGraph.CreateGraphNodes(wc,hc);
    FBPDFDGraph.CreateGraphLinks(wc,hc);
    FBPDFDGraph.CreateDGraphNodes(wc,hc);
    FBPDFDGraph.PresetupFrame(wc,hc);
    FBPDFDGraph.TraceRoute;
    Repaint;
    while FPainting do;
    for px:=1 to FHorzPageCount do
     begin
      clRect.Left:=(px-1)*(pw-fpl-fpr);
      clRect.Right:=px*(pw-fpl-fpr);
      for py:=1 to FVertPageCount do
       begin
        clRect.Top:=(py-1)*(ph-fpt-fpb);
        clRect.Bottom:=py*(ph-fpt-fpb);
        if ((FHorzPageCount=1) and (FVertPageCount=1)) then
         begin
          PaintTo(FPrinter.Canvas.Handle,fpl,fpt+ramkaH);
{          PreviewReadWrite(fpl,pw-fpr,fpt+ramkaH,ph-fpb);}
          PreviewStandartRectangle(pw-FPageRight,ph-FPageBottom+ramkaH);
         end
        else
         begin
          PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt,clRect);
{          PreviewReadWrite(fpl,pw-fpr,fpt+ramkaH,ph-fpb);}
          PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
         end;
         if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
          FPrinter.NewPage;
       end;
     end;
    inc(canc);
    if (canc<anc) then FPrinter.NewPage;
    FBPDFDGraph.SetDefaultConstants;
    FBPDFDGraph.Printing:=False;
    FBPDFDGraph.CreateGraphNodes(1,1);
    FBPDFDGraph.CreateGraphLinks(1,1);
    FBPDFDGraph.CreateDGraphNodes(1,1);
    FBPDFDGraph.PresetupFrame(1,1);
    FBPDFDGraph.TraceRoute;
    Invalidate;
   end;
   finally
    if FAborting then FPrinter.AbortDoc else
    FPrinter.EndDoc;
    FPrinting:=False;
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    FBPDFDGraph.SetDefaultConstants;
    FBPDFDGraph.Printing:=False;
    FBPDFDGraph.CreateGraphNodes(1,1);
    FBPDFDGraph.CreateGraphLinks(1,1);
    FBPDFDGraph.CreateDGraphNodes(1,1);
    FBPDFDGraph.SetScaled2(oldScaled2);
    FBPDFDGraph.SetScaled(oldScaled);
    if (not(oldScaled)) then FBPDFDGraph.PresetupFrame(1,1);
    FBPDFDGraph.TraceRoute;
    Invalidate;
    pb.Position:=100;
    pb.Update;
    lbl.Caption:=IntToStr(pb.Position);
    lbl.Update;
    FBPDFDGraph.OpenNode(oldNode);
    FBPDFDGraph.TraceRoute;
    Invalidate;
   end;
end;

procedure TBPDFDFrame.PreviewPrintRect(left,right,top,bottom:Integer);  { Checked }
Var oldStyle:TPenStyle;
begin
 if FPrinter = nil then Exit;
 oldStyle:=FPrinter.Canvas.Pen.Style;
 FPrinter.Canvas.Pen.Style:=psDot;
 FPrinter.Canvas.MoveTo(Left,Top);
 FPrinter.Canvas.LineTo(Right,Top);
 FPrinter.Canvas.LineTo(Right,Bottom);
 FPrinter.Canvas.LineTo(Left,Bottom);
 FPrinter.Canvas.LineTo(Left,Top);
 FPrinter.Canvas.Pen.Style:=oldStyle;
end;

procedure TBPDFDFrame.CreatePreview; { Checked }
Var savedOrd:TPrinterOrientation;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    ratio,fontRatio,LabelFontRatio:Double;
    dc:HDC;
    rw,rh:Double;
    scrppi:LongInt;
    ramkaH:Integer;
    nw,nh,mw,mh:Integer;
    oldScaled:Boolean;
    oldScaled2:Boolean;
    px,py:Integer;
    clRect:TRect;
    aSize:Integer;
    tmpi:TQRPaperSize;
    FTmp:Double;
    wc,hc:Double;
    pgalg:TBPPgAlg;
begin
 { Create QRPreview }
   oldScaled:=BPDFDGraph.Scaled;
   oldScaled2:=BPDFDGraph.Scaled2;
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   if (FBPDFDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPDFDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   FBPDFDGraph.Scaled2:=False;
   if FBPDFDGraph.FScaled then FBPDFDGraph.Scaled:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   FPrinter:=TQRPrinter.Create;
   try
    FPrinting:=True;
    FPrinter.Cleanup;
    FPrinter.BeginDoc;
    FPrinter.Orientation:=savedOrd;
    Printer.Orientation:=savedOrd;
    FPrinter.PrinterIndex:=Printer.PrinterIndex;
    aSize:=Printer.PaperSize;
    FPrinter.PaperSize:=Default;
    FRamkaFontRatio:=1.0;
    FPSizeH:=21;
    FPSizeW:=29.7;
    for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FPrinter.PaperSize := tmpI;
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
     FPrinter.PaperLength:=Printer.PaperLength;
     FPrinter.PaperWidth:=Printer.PaperWidth;
   dc:=GetDC(0);
   scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
   FFontCoof:=1;
   FBPDFDGraph.UpdateMaxFontSize(1);
   ReleaseDC(0,dc);
   ramkaH:=Round(scrppi/2.54);
   FRamkaH:=ramkaH;
    FPrinter.NewPage;
   if SavedOrd=poPortrait then
   begin
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
    ph:=ph-ramkaH;
   rw:=(pw*FHorzPageCount)/FBPDFDGraph.DefWidth;
   rh:=(ph*FVertPageCount)/FBPDFDGraph.DefHeight;
{   wc:=rw;
    hc:=rh; }
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   wc:=FBPDFDGraph.DefWidth;
   hc:=FBPDFDGraph.DefHeight;
   FBPDFDGraph.SetDefaultConstants;
   FBPDFDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
   FBPDFDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPDFDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
   else
     FBPDFDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
   wc:=FBPDFDGraph.DefWidth/wc;
   hc:=FBPDFDGraph.DefHeight/hc;
   FBPDFDGraph.Printing:=True;
   FBPDFDGraph.CreateGraphNodes(wc,hc);
   FBPDFDGraph.CreateGraphLinks(wc,hc);
   FBPDFDGraph.CreateDGraphNodes(wc,hc);
   FBPDFDGraph.PresetupFrame(wc,hc);
   FBPDFDGraph.TraceRoute;
   Repaint;
   while FPainting do;
    nw:=FBPDFDGraph.NodeWidth;
    nh:=FBPDFDGraph.NodeHeight;
    mw:=FBPDFDGraph.MaxWidth;
    mh:=FBPDFDGraph.MaxHeight;
    rw:=ratio*nw/mw;
    rh:=ratio*nh/mh;
    case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
    end;
    if fontRatio>ratio then fontRatio:=ratio;
    LabelFontRatio:=fontRatio*FBPDFDGraph.FMaxCH;
    FBPDFDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPDFDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
     FBPDFDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    FBPDFDGraph.SetDefaultConstants;
    FBPDFDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
    FBPDFDGraph.CreateGraphNodes(wc,hc);
    FBPDFDGraph.CreateGraphLinks(wc,hc);
    FBPDFDGraph.CreateDGraphNodes(wc,hc);
    FBPDFDGraph.PresetupFrame(wc,hc);
    FBPDFDGraph.TraceRoute;
    Repaint;
    while FPainting do;
    for px:=1 to FHorzPageCount do
    begin
     clrect.Left:=(px-1)*(pw-fpl-fpr);
     clRect.Right:=px*(pw-fpl-fpr);
     for py:=1 to FVertPageCount do
     begin
      clrect.Top:=(py-1)*(ph-fpt-fpb);
      clrect.Bottom:=py*(ph-fpt-fpb);
      if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
         PaintTo(FPrinter.Canvas.Handle,fpl,fpt+ramkaH);
{         PreviewReadWrite(fpl,pw-fpr,fpt+ramkaH,ph-fpb);}
         PreviewStandartRectangle(pw-FPageRight,ph+ramkaH-FPageBottom);
       end
       else
        begin
         PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt{+ramkaH},clrect);
{         PreviewReadWrite(fpl,pw-fpr,fpt+ramkaH,ph-fpb);}
         PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
        end;
      if ((px<>FHorzPageCount) or (py<>FVertPageCount)) then FPrinter.NewPage;
     end;
    end;
   finally
    FPrinter.EndDoc;
    FPrinting:=False;
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    FHorzPageCount:=1;
    FVertPageCount:=1;
    FBPDFDGraph.SetDefaultConstants;
    FBPDFDGraph.Printing:=False;
    FBPDFDGraph.CreateGraphNodes(1,1);
    FBPDFDGraph.CreateGraphLinks(1,1);
    FBPDFDGraph.CreateDGraphNodes(1,1);
{    FBPDFDGraph.CheckLinksAndNodes;}
    FBPDFDGraph.SetScaled2(oldScaled2);
    FBPDFDGraph.SetScaled(oldScaled);
    if (not(oldScaled)) then FBPDFDGraph.PresetupFrame(1,1);
    FBPDFDGraph.TraceRoute;
    Invalidate;
   end;
end;

procedure TBPDFDFrame.CreateBitmap(var value:TBitmap;pf:TPixelFormat); { Checked }
 begin
  try
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   FFontCoof:=1;
   FBPDFDGraph.UpdateMaxFontSize(1);
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=FBPDFDGraph.FDefWidth;
   value.Height:=FBPDFDGraph.FDefHeight;
   Repaint;
   while FPainting do;
   value.Canvas.Lock;
   PaintTo(value.Canvas.Handle,0,0);
   Value.Canvas.Unlock;
  finally
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    Visible:=True;
  end;
 end;

procedure TBPDFDFrame.CreateBitmapWithSize(var value:TBitmap;pf:TPixelFormat;iw,ih:Integer); { scaled bitmap } { Checked }
Var oldScaled:Boolean;
    oldScaled2:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio,LabelFontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    wc,hc:Double;
    pgalg:TBPPgAlg;
 begin
  try
   FUpdatingNavigator:=True;
   if (FBPDFDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPDFDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   oldScaled:=FBPDFDGraph.Scaled;
   oldScaled2:=FBPDFDGraph.Scaled2;
   oldPrinting:=FBPDFDGraph.Printing;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   if FBPDFDGraph.Scaled2 then FBPDFDGraph.Scaled2:=False;
   if FBPDFDGraph.Scaled then FBPDFDGraph.Scaled:=False;
   FPrinting:=True;
   rw:=iw/FBPDFDGraph.DefWidth;
   rh:=ih/FBPDFDGraph.DefHeight;
   wc:=rw;
   hc:=rh;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
   FBPDFDGraph.SetDefaultConstants;
   FBPDFDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
   FBPDFDGraph.DefHeight:=ih;
   FBPDFDGraph.DefWidth:=iw;
   FBPDFDGraph.Printing:=True;
   FBPDFDGraph.CreateGraphNodes(wc,hc);
   FBPDFDGraph.CreateGraphLinks(wc,hc);
   FBPDFDGraph.CreateDGraphNodes(wc,hc);
   FBPDFDGraph.PresetupFrame(wc,hc);
   FBPDFDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   nw:=FBPDFDGraph.NodeWidth;
   nh:=FBPDFDGraph.NodeHeight;
   mw:=FBPDFDGraph.MaxWidth;
   mh:=FBPDFDGraph.MaxHeight;
   rw:=ratio*nw/mw;
   rh:=ratio*nh/mh;
   case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
   end;
   if fontRatio>ratio then fontRatio:=ratio;
   LabelFontRatio:=fontRatio*FBPDFDGraph.FMaxCH;
   FBPDFDGraph.DefHeight:=ih;
   FBPDFDGraph.DefWidth:=iw;
   FBPDFDGraph.SetDefaultConstants;
   FBPDFDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
   FBPDFDGraph.CreateGraphNodes(wc,hc);
   FBPDFDGraph.CreateGraphLinks(wc,hc);
   FBPDFDGraph.CreateDGraphNodes(wc,hc);
   FBPDFDGraph.PresetupFrame(wc,hc);
   FBPDFDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=iw;
   value.Height:=ih;
   while FPainting do;
   value.Canvas.Lock;
   PaintTo(value.Canvas.Handle,0,0);
   value.Canvas.Unlock;
  finally
   FPrinting:=False;
   FBPDFDGraph.SetDefaultConstants;
   FBPDFDGraph.Printing:=oldPrinting;
   FBPDFDGraph.CreateGraphNodes(1,1);
   FBPDFDGraph.CreateGraphLinks(1,1);
   FBPDFDGraph.CreateDGraphNodes(1,1);
{   FBPDFDGraph.CheckLinksAndNodes;}
   FBPDFDGraph.SetScaled2(oldScaled2);
   FBPDFDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPDFDGraph.PresetupFrame(1,1);
   FUpdatingNavigator:=False;
   FBPDFDGraph.TraceRoute;
   Invalidate;
   Visible:=True;
  end;
 end;

procedure TBPDFDFrame.DrawNode(l,t,w,h:Integer;Canvas:TCanvas;PaintColor,DrawColor:TColor);
Var r1:TRect;
  oldPenColor:TColor;
  oldBrushColor:TColor;
 begin
    oldBrushColor:=Canvas.Brush.Color;
    oldPenColor:=Canvas.Pen.Color;
    Canvas.Brush.Color:=PaintColor;
    r1.Left:=l;
    r1.Top:=t;
    r1.Right:=l+w;
    r1.Bottom:=t+h;
    Canvas.FillRect(r1);
    Canvas.Pen.Color:=DrawColor;
    Canvas.MoveTo(l,t);
    Canvas.LineTo(l+w,t);
    Canvas.LineTo(l+w,t+h);
    Canvas.LineTo(l,t+h);
    Canvas.LineTo(l,t);
    Canvas.Brush.Color:=oldBrushColor;
    Canvas.Pen.Color:=oldPenColor;
end;

procedure TBPDFDFrame.DrawLink(pl:PDFDGraphLink;Canvas:TCanvas;RatioX,RatioY:Double;Wpos,Hpos:Integer);
Var i,cnt:Integer;
    oldPenColor:TColor;
    oldPenStyle:TPenStyle;
begin
{}
  if pl=nil then Exit;
  oldPenColor:=Canvas.Pen.Color;
  oldPenStyle:=Canvas.Pen.Style;
  Canvas.Pen.Color:=pl^.Color;
  Canvas.Pen.Style:=pl^.PenStyle;
  cnt:=pl^.LinePointCount-1;
  Canvas.MoveTo(Round((pl^.LineArrayX[0]+wpos)*RatioX),Round((pl^.LineArrayY[0]+hpos)*RatioY));
  for i:=1 to cnt do
   begin
      Canvas.LineTo(Round((pl.LineArrayX[i]+wpos)*RatioX),Round((pl^.LineArrayY[i]+hpos)*RatioY));
    end;
  Canvas.Pen.Color:=oldPenColor;
  Canvas.Pen.Style:=oldPenStyle;
end;


procedure TBPDFDFrame.GetBitmapWithSize(value:TBitmap;iw,ih:Integer); { scaled bitmap } { Checked }
Var rw,rh:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    wc,hc:Double;
    i:Integer;
    wl,wt,ww,wh:Integer;
    node:PDFDGraphNode;
    nodeD:PDDFDGraphNode;
    link:PDFDGraphLink;
    hpos,vpos:Integer;
 begin
  try
   FUpdatingNavigator:=True;
   if HorzScrollBar.Visible then hpos:=HorzScrollBar.Position;
   if VertScrollBar.Visible then vpos:=VertScrollBar.Position;
   Visible:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   while FPainting do;
   rw:=iw/(FBPDFDGraph.DefWidth+1);
   rh:=ih/(FBPDFDGraph.DefHeight+1);
   value.Canvas.Lock;
   Value.Canvas.FillRect(Value.Canvas.ClipRect);
   { Draw DFDNode}
     node:=FBPDFDGraph.FGraphNodes;
     wl:=Round(node^.BPNode.Left*rw);
     wt:=Round(node^.BPNode.Top*rh);
     ww:=Round(node^.BPNode.Width*rw);
     wh:=Round(node^.BPNode.Height*rh);
     DrawNode(wl,wt,ww,wh,Value.Canvas,node^.BPNode.PaintColor,node^.BPNode.RectColor);
   { Draw DDfdNodes}
    nodeD:=BPDFDGraph.FDGraphNodes;
    for i:=0 to (BPDFDGraph.FDNodesCount-1) do
     begin
      wl:=Round(nodeD^.BPDNode.Left*rw);
      wt:=Round(nodeD^.BPDNode.Top*rh);
      ww:=Round(nodeD^.BPDNode.Width*rw);
      wh:=Round(nodeD^.BPDNode.Height*rh);
      DrawNode(wl,wt,ww,wh,Value.Canvas,nodeD^.BPDNode.PaintColor,nodeD^.BPDNode.RectColor);
      nodeD:=nodeD^.next;
     end;
     { Draw Links}
    link:=BPDFDGraph.FGraphLinks;
    for i:=0 to(BPDFDGraph.FDLinksCount-1) do
    begin
     DrawLink(link,value.Canvas,rw,rh,hpos,vpos);
     link:=link^.next;
    end;
   value.Canvas.Unlock;
  finally
   if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
   if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
   Visible:=True;
   FUpdatingNavigator:=False;
  end;
 end;


procedure TBPDFDFrame.CreateBitmapForOneShit(var value:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer); { Checked }
Var oldScaled:Boolean;
    oldScaled2:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio,LabelFontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    clRect:TRect;
    wc,hc:Double;
    pgalg:TBPPgAlg;
 begin
    try
   FUpdatingNavigator:=True;
   if (FBPDFDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPDFDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   oldScaled:=FBPDFDGraph.Scaled;
   oldScaled2:=FBPDFDGraph.Scaled2;
   oldPrinting:=FBPDFDGraph.Printing;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   If FBPDFDGraph.Scaled2 then FBPDFDGraph.Scaled2:=False;
   If FBPDFDGraph.Scaled then FBPDFDGraph.Scaled:=False;
   FPrinting:=True;
   rw:=(iw*maxshitw)/FBPDFDGraph.DefWidth;
   rh:=(ih*maxshith)/FBPDFDGraph.DefHeight;
   wc:=rw;
   hc:=rh;
    case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
   FBPDFDGraph.SetDefaultConstants;
   FBPDFDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
   FBPDFDGraph.DefHeight:=ih*maxshith;
   FBPDFDGraph.DefWidth:=iw*maxshitw;
   FBPDFDGraph.Printing:=True;
   FBPDFDGraph.CreateGraphNodes(wc,hc);
   FBPDFDGraph.CreateGraphLinks(wc,hc);
   FBPDFDGraph.CreateDGraphNodes(wc,hc);
   FBPDFDGraph.PresetupFrame(wc,hc);
   FBPDFDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   nw:=FBPDFDGraph.NodeWidth;
   nh:=FBPDFDGraph.NodeHeight;
   mw:=FBPDFDGraph.MaxWidth;
   mh:=FBPDFDGraph.MaxHeight;
   rw:=ratio*nw/mw;
   rh:=ratio*nh/mh;
   case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
   end;
   if fontRatio>ratio then fontRatio:=ratio;
   LabelFontRatio:=fontRatio*FBPDFDGraph.FMaxCH;
   FBPDFDGraph.DefHeight:=ih*maxshith;
   FBPDFDGraph.DefWidth:=iw*maxshitw;
   FBPDFDGraph.SetDefaultConstants;
   FBPDFDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
   FBPDFDGraph.CreateGraphNodes(wc,hc);
   FBPDFDGraph.CreateGraphLinks(wc,hc);
   FBPDFDGraph.CreateDGraphNodes(wc,hc);
   FBPDFDGraph.PresetupFrame(wc,hc);
   FBPDFDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=iw;
   value.Height:=ih;
   while FPainting do;
   clrect.Left:=shitw*iw;
   clRect.Right:=(shitw+1)*iw;
   clrect.Top:=shith*ih;
   clrect.Bottom:=(shith+1)*ih;
   value.Canvas.Lock;
   PaintPageTo(Value.Canvas.Handle,0,0,clrect);
   value.Canvas.Unlock;
  finally
   FPrinting:=False;
   FBPDFDGraph.SetDefaultConstants;
   FBPDFDGraph.Printing:=oldPrinting;
   FBPDFDGraph.CreateGraphNodes(1,1);
   FBPDFDGraph.CreateGraphLinks(1,1);
   FBPDFDGraph.CreateDGraphNodes(1,1);
   FBPDFDGraph.SetScaled2(oldScaled2);
   FBPDFDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPDFDGraph.PresetupFrame(1,1);
   FUpdatingNavigator:=False;
   FBPDFDGraph.TraceRoute;
   Invalidate;
   Visible:=True;
  end;
 end;

procedure TBPDFDFrame.SetPageParam(Var PageTop,PageBottom,PageLeft,PageRight:Integer;ShowWarning:Boolean); { Checked }
Var px,py,plofs,ptofs,pbofs,profs:Integer;
    pw,ph,hw,hh:Integer;
    po:TPrinterOrientation;
    s:String;
Const   es='      .    ';
        se=' ';
begin
 po:=Printer.Orientation;
 case po of
 poPortrait:
   begin
    px:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
    py:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
    plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
    ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
    pw:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);
    hw:=GetDeviceCaps(Printer.Handle,HORZRES);
    ph:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);
    hh:=GetDeviceCaps(Printer.Handle,VERTRES);
   end;
  poLandscape:
   begin
    py:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
    px:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
    ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
    plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
    ph:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);
    hh:=GetDeviceCaps(Printer.Handle,HORZRES);
    pw:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);
    hw:=GetDeviceCaps(Printer.Handle,VERTRES);
   end;
 end;
 pbofs:=ph-hh-ptofs;
 profs:=pw-hw-plofs;
 FPageTop:=Round(PageTop*py/25.4)-ptofs;
 FPageBottom:=Round(PageBottom*py/25.4)-pbofs;
 FPageLeft:=Round(PageLeft*px/25.4)-plofs;
 FPageRight:=Round(PageRight*px/25.4)-profs;
 if ShowWarning then
 begin
 if FPageTop<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageTop:=0;
   PageTop:=Round(ptofs*25.4/py)+1;
   end;
  if FPageBottom<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageBottom:=0;
   PageBottom:=Round(pbofs*25.4/py)+1;
   end;
  if FPageLeft<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageLeft:=0;
   PageLeft:=Round(plofs*25.4/px)+1;
   end;
  if FPageRight<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageRight:=0;
   PageRight:=Round(profs*25.4/px)+1;
   end;
  end;
end;

procedure TBPDFDFrame.SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer); { Checked }
Var px,py:Integer;
begin
 FPageTop:=PageTop;
 FPageBottom:=PageBottom;
 FPageLeft:=PageLeft;
 FPageRight:=PageRight;
end;

procedure  TBPDFDFrame.PrintStandartRectangle; { Checked }
Var oldColor:TColor;
    w,h:Integer;
    ppsmh:Integer;
    ppsmh2:Integer;
    ppsmw:Integer;
    ppsmw2:Integer;
    oldFontSize:Integer;
    oldFontName:TFontName;
    oldFontStyle:TFontStyles;
    oldFontColor:TColor;
    oldFontCharset:TFontCharset;
    s:String;
    lev:Integer;
 begin
  { Print Rect for Document }
   with Printer.Canvas do
    begin
     oldFontSize:=Font.Size;
     oldFontName:=Font.Name;
     oldFontStyle:=Font.Style;
     oldFontColor:=Font.Color;
     oldFontCharset:=Font.Charset;
     Font.Size:=Round(10*FRamkaFontRatio);
     Font.Name:='Times New Roman';
     Font.Charset:=RUSSIAN_CHARSET;
     oldColor:=Pen.Color;
     Pen.Color:=clBlack;
     w:=Printer.PageWidth;
     h:=Printer.PageHeight;
     ppsmh:=Round((h*1.5)/FPSizeH*FRamkaFontRatio);
{     ppsmh:=Round(GetDeviceCaps(Printer.Handle,LOGPIXELSX)*1.5/2.54);}
     ppsmh2:=ppsmh div 2;
      ppsmw:=Round(w/FPSizeW*FRamkaFontRatio);
{     ppsmw:=Round(GetDeviceCaps(Printer.Handle,LOGPIXELSX)/2.54);}
     ppsmw2:=ppsmw div 2;
     { Draw Ramka }
     MoveTo(FPageLeft,FPageTop);
     LineTo(w-FPageRight,FPageTop);
     LineTo(w-FPageRight,h-FPageBottom);
     LineTo(FPageLeft,h-FPageBottom);
     LineTo(FPageLeft,FPageTop);
     { Draw foother}
     MoveTo(FPageLeft,h-FPageBottom-ppsmh2);
     LineTo(w-FPageRight,h-FPageBottom-ppsmh2);
     MoveTo(FPageLeft+5*ppsmw,h-FPageBottom-ppsmh2);
     LineTo(FPageLeft+5*ppsmw,h-FPageBottom);
     MoveTo(w-FPageRight-6*ppsmw,h-FPageBottom-ppsmh2);
     LineTo(w-FPageRight-6*ppsmw,h-FPageBottom);
     MoveTo(w-FPageRight,h-FPageBottom-Round(ppsmh*0.35));
     LineTo(w-FPageRight-2*ppsmw,h-FPageBottom-Round(ppsmh*0.35));
     LineTo(w-FPageRight-2*ppsmw,h-FPageBottom);
     { Draw header }
     MoveTo(FPageLeft,FPageTop+ppsmh);
     LineTo(w-FPageRight,FPageTop+ppsmh);
     MoveTo(FPageLeft+Round(4.5*ppsmw),FPageTop);
     LineTo(FPageLeft+Round(4.5*ppsmw),FPageTop+ppsmh);
     MoveTo(w-FPageRight-5*ppsmw,FPageTop);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-11*ppsmw,FPageTop);
     LineTo(w-FPageRight-11*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-14*ppsmw,FPageTop);
     LineTo(w-FPageRight-14*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop);
     LineTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+ppsmh);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+(ppsmh2 div 2));
     LineTo(w-FPageRight-5*ppsmw,FPageTop+(ppsmh2 div 2));
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+ppsmh2);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+ppsmh2);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+(ppsmh2 div 2)+ppsmh2);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+(ppsmh2 div 2)+ppsmh2);
     { DrawText }
       { Foother text }
     s:=':';
     TextOut(FPageLeft+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     s:=BPDFDGraph.FSSNodeNumber+'/C'+IntToStr(Printer.PageNumber);
     TextOut(FPageLeft+ppsmw2+ppsmw,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     s:=':';
     TextOut(FPageLeft+5*ppsmw+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     s:=BPDFDGraph.FSSNodeNumber+': '+BPDFDGraph.FNodeCaption;
{!!!} s:=CalcNewString(s,Printer.Canvas,(w-FPageRight-Round(6.5*ppsmw))-(FPageLeft+5*ppsmw+5*ppsmw2));
     TextOut(FPageLeft+5*ppsmw+5*ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
      s:=':';
     TextOut(w-FPageRight-6*ppsmw+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
      s:='. '+IntToStr(Printer.PageNumber);
     TextOut(w-FPageRight-6*ppsmw+4*ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     { header text }
      s:=' :';
     TextOut(FPageLeft+ppsmw2,FPageTop-(Font.Height div 2),s);
      s:=BPDFDGraph.FHeader.ssCompany;
{!!!} TextRect(Rect(FPageLeft+ppsmw2,FPageTop+ppsmh2+(Font.Height div 2),FPageLeft+4*ppsmw,FPageTop+ppsmh+(Font.Height div 2))
               ,FPageLeft+ppsmw2,FPageTop+ppsmh2+(Font.Height div 2),s);
      s:=':';
     TextOut(FPageLeft+5*ppsmw,FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=BPDFDGraph.FHeader.ssAuthor;
{!!!} s:=CalcNewString(s,Printer.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
     TextOut(FPageLeft+7*ppsmw,FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(FPageLeft+5*ppsmw,FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=BPDFDGraph.FHeader.ssModel;
{!!!} s:=CalcNewString(s,Printer.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
     TextOut(FPageLeft+7*ppsmw,FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(FPageLeft+5*ppsmw,FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=BPDFDGraph.FLevelNotes;
{!!!} s:=CalcNewString(s,Printer.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
     TextOut(FPageLeft+7*ppsmw,FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=DateToStr(BPDFDGraph.FHeader.dfDateTime);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=IntToStr(BPDFDGraph.FLevelRevision);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=TimeToStr(BPDFDGraph.FHeader.dfDateTime);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
     Font.Size:=Round(8*FRamkaFontRatio);
      s:=' ';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+ppsmh2-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+3*(ppsmh2 div 2)-(Font.Height div 5),s);
     Font.Style:=[fsBold];
      s:='';
     TextOut(w-FPageRight-Round(10.8*ppsmw),FPageTop-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(7.0*ppsmw),FPageTop-(Font.Height div 5),s);
     Font.Style:=[];
      s:=':';
     TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop-(Font.Height div 5),s);
     { Draw context }
      s:=BPDFDGraph.FSSNodeNumber;
      Font.Size:=Round(16*FRamkaFontRatio);
      Font.Style:=[fsBold];
      TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      { Draw Draft Status }
      Font.Size:=Round(8*FRamkaFontRatio);
      Font.Style:=[fsBold];
      s:='x';
      if dsWorking in BPDFDGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop-(Font.Height div 5),s);
      if dsDraft in BPDFDGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      if dsRecomended in BPDFDGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+ppsmh2-(Font.Height div 5),s);
      if dsPublication in BPDFDGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+3*(ppsmh2 div 2)-(Font.Height div 5),s);
     {EndDrawText}
     Pen.Color:=oldColor;
     Font.Size:=oldFontSize;
     Font.Name:=oldFontName;
     Font.Style:=oldFontStyle;
     Font.Color:=oldFontColor;
     Font.Charset:=oldFontCharset;
    end;
 end;

procedure  TBPDFDFrame.PreviewStandartRectangle(pw,ph:Integer); { Checked }
Var oldColor:TColor;
    w,h:Integer;
    ppsmh:Integer;
    ppsmh2:Integer;
    ppsmw:Integer;
    ppsmw2:Integer;
    oldFontSize:Integer;
    oldFontName:TFontName;
    oldFontStyle:TFontStyles;
    oldFontColor:TColor;
    oldFontCharset:TFontCharset;
    s:String;
    lev:Integer;
 begin
  { Print Rect for Document }
   if FPrinter = nil then Exit;
   with FPrinter.Canvas do
    begin
     oldFontSize:=Font.Size;
     oldFontName:=Font.Name;
     oldFontStyle:=Font.Style;
     oldFontColor:=Font.Color;
     oldFontCharset:=Font.Charset;
     Font.Size:=Round(10*FRamkaFontRatio); {  A4,      !!!! }
     Font.Name:='Times New Roman';
     Font.Charset:=RUSSIAN_CHARSET;
     oldColor:=Pen.Color;
     Pen.Color:=clBlack;
     w:=pw;
     h:=ph;
{     ppsmh:=Round(GetDeviceCaps(FPrinter.Canvas.Handle,LOGPIXELSX)*1.5/2.54);}
     ppsmh:=Round(((h+FPageBottom-FRamkaH)*1.5)/FPSizeH*FRamkaFontRatio);
     ppsmh2:=ppsmh div 2;
{     ppsmw:=Round(GetDeviceCaps(FPrinter.Canvas.Handle,LOGPIXELSX)/2.54);}
     ppsmw:=Round((w+FPageRight)/FPSizeW*FRamkaFontRatio);
     ppsmw2:=ppsmw div 2;
     { Draw Ramka }
     MoveTo(FPageLeft,FPageTop);
     LineTo(w-FPageRight,FPageTop);
     LineTo(w-FPageRight,h-FPageBottom);
     LineTo(FPageLeft,h-FPageBottom);
     LineTo(FPageLeft,FPageTop);
     { Draw foother}
     MoveTo(FPageLeft,h-FPageBottom-ppsmh2);
     LineTo(w-FPageRight,h-FPageBottom-ppsmh2);
     MoveTo(FPageLeft+5*ppsmw,h-FPageBottom-ppsmh2);
     LineTo(FPageLeft+5*ppsmw,h-FPageBottom);
     MoveTo(w-FPageRight-6*ppsmw,h-FPageBottom-ppsmh2);
     LineTo(w-FPageRight-6*ppsmw,h-FPageBottom);
     MoveTo(w-FPageRight,h-FPageBottom-Round(ppsmh*0.35));
     LineTo(w-FPageRight-2*ppsmw,h-FPageBottom-Round(ppsmh*0.35));
     LineTo(w-FPageRight-2*ppsmw,h-FPageBottom);
     { Draw header }
     MoveTo(FPageLeft,FPageTop+ppsmh);
     LineTo(w-FPageRight,FPageTop+ppsmh);
     MoveTo(FPageLeft+Round(4.5*ppsmw),FPageTop);
     LineTo(FPageLeft+Round(4.5*ppsmw),FPageTop+ppsmh);
     MoveTo(w-FPageRight-5*ppsmw,FPageTop);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-11*ppsmw,FPageTop);
     LineTo(w-FPageRight-11*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-14*ppsmw,FPageTop);
     LineTo(w-FPageRight-14*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop);
     LineTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+ppsmh);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+(ppsmh2 div 2));
     LineTo(w-FPageRight-5*ppsmw,FPageTop+(ppsmh2 div 2));
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+ppsmh2);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+ppsmh2);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+(ppsmh2 div 2)+ppsmh2);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+(ppsmh2 div 2)+ppsmh2);
     { DrawText }
       { Foother text }
     s:=':';
     TextOut(FPageLeft+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     s:=BPDFDGraph.FSSNodeNumber+'/C'+IntToStr(FPrinter.PageNumber);
     TextOut(FPageLeft+ppsmw2+ppsmw,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     s:=':';
     TextOut(FPageLeft+5*ppsmw+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
      s:=BPDFDGraph.FSSNodeNumber+': '+BPDFDGraph.FNodeCaption;
{!!!} s:=CalcNewString(s,FPrinter.Canvas,(w-FPageRight-Round(6.5*ppsmw))-(FPageLeft+5*ppsmw+5*ppsmw2));
      TextOut(FPageLeft+5*ppsmw+5*ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
      s:=':';
     TextOut(w-FPageRight-6*ppsmw+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
      s:='. '+IntToStr(FPrinter.PageNumber);
     TextOut(w-FPageRight-6*ppsmw+4*ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     { header text }
      s:=' :';
      TextOut(FPageLeft+ppsmw2,FPageTop-(Font.Height div 2),s);
      s:=BPDFDGraph.FHeader.ssCompany;
{!!!} TextRect(Rect(FPageLeft+ppsmw2,FPageTop+ppsmh2+(Font.Height div 2),FPageLeft+4*ppsmw,FPageTop+ppsmh+(Font.Height div 2))
               ,FPageLeft+ppsmw2,FPageTop+ppsmh2+(Font.Height div 2),s);
      s:=':';
      TextOut(FPageLeft+5*ppsmw,FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=BPDFDGraph.FHeader.ssAuthor;
{!!!} s:=CalcNewString(s,FPrinter.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
      TextOut(FPageLeft+7*ppsmw,FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=':';
      TextOut(FPageLeft+5*ppsmw,FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=BPDFDGraph.FHeader.ssModel;
{!!!} s:=CalcNewString(s,FPrinter.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
      TextOut(FPageLeft+7*ppsmw,FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(FPageLeft+5*ppsmw,FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=BPDFDGraph.FLevelNotes;
{!!!} s:=CalcNewString(s,FPrinter.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
      TextOut(FPageLeft+7*ppsmw,FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=DateToStr(BPDFDGraph.FHeader.dfDateTime);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=IntToStr(BPDFDGraph.FLevelRevision);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=TimeToStr(BPDFDGraph.FHeader.dfDateTime);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
     Font.Size:=Round(8*FRamkaFontRatio);
      s:=' ';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+ppsmh2-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+3*(ppsmh2 div 2)-(Font.Height div 5),s);
     Font.Style:=[fsBold];
      s:='';
     TextOut(w-FPageRight-Round(10.8*ppsmw),FPageTop-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(7.0*ppsmw),FPageTop-(Font.Height div 5),s);
     Font.Style:=[];
      s:=':';
     TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop-(Font.Height div 5),s);
     { Draw context }
      s:=BPDFDGraph.FSSNodeNumber;
      Font.Size:=Round(16*FRamkaFontRatio);
      Font.Style:=[fsBold];
      TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      { Draw Draft Status }
      Font.Size:=Round(8*FRamkaFontRatio);
      Font.Style:=[fsBold];
      s:='x';
      if dsWorking in BPDFDGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop-(Font.Height div 5),s);
      if dsDraft in BPDFDGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      if dsRecomended in BPDFDGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+ppsmh2-(Font.Height div 5),s);
      if dsPublication in BPDFDGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+3*(ppsmh2 div 2)-(Font.Height div 5),s);
     {EndDrawText}
     Pen.Color:=oldColor;
     Font.Size:=oldFontSize;
     Font.Name:=oldFontName;
     Font.Style:=oldFontStyle;
     Font.Color:=oldFontColor;
     Font.Charset:=oldFontCharset;
    end;
 end;

function TBPDFDFrame.GetCoof(rw,rh:Double;Alg:TBPFormatAlg):Double;
 begin
   case Alg of
     fa_Min:  if rw>=rh then Result:=rh else Result:=rw;
     fa_Max:  if rw>=rh then Result:=rw else Result:=rh;
     fa_Sqrt: Result:=Sqrt(rw*rh);
     fa_Sum:  Result:=(rw+rh)/2;
     fa_Width:  Result:=rw;
     fa_Height: Result:=rh;
   end;
 end;


procedure Register; { Checked }
begin
  RegisterComponents('DeadSouls', [TBPDFDFrame]);
end;

end.